	PROGRAM BATCHPROC
	IMPLICIT NONE
C
C	Request required include files
C
	INCLUDE 'SYS_CMTLIB:ITEMDEF.INC'
	INCLUDE '($SJCDEF)'
	INCLUDE '($SSDEF)'
	INCLUDE '($RMSDEF)'
C
	RECORD /ITEM/ JBCLIST(10)
C
C	CLI stuff
C
	INTEGER*4 CLI$GET_VALUE,CLI$PRESENT,CLI$DCL_PARSE
	EXTERNAL CLI$_PRESENT,CLI$_NEGATED,CLI$_DEFAULTED,CLI$_ABSENT,
	1 CLI$_LOCPRES,CLI$_LOCNEG,CLI$_COMMA,CLI$_CONCAT,CLI$_NOCOMD,
	2 CLI$_NORMAL
	INTEGER*4 CLI_PRESENT,CLI_NEGATED,CLI_DEFAULTED,CLI_ABSENT,
	1 CLI_LOCPRES,CLI_LOCNEG,CLI_COMMA,CLI_CONCAT,CLI_NOCOMD,CLI_NORMAL
	INTEGER*4 ISTAT,SYS$SNDJBCW,IOSB(2),LIB$GET_COMMAND
	INTEGER*4 SS_NORMAL,RMS_EOF
	PARAMETER (SS_NORMAL=SS$_NORMAL)
	PARAMETER (RMS_EOF=RMS$_EOF)
C
	CHARACTER*32 UIC
	INTEGER*2 L_UIC
	CHARACTER*256 LOGFILE,JOBFILE
	INTEGER*2 L_LF,L_JF
	DATA L_LF/0/
	CHARACTER*256 COMMAND,LINE,JOB_STATUS
	INTEGER*2 LC,L,L_JS
	CHARACTER*39 XCMD
	INTEGER*2 LXC
	VOLATILE JOB_STATUS,L_JS
	CHARACTER*20 BATCHQUEUE
	INTEGER*2 L_BQ
	LOGICAL*1 GET_MORE_INPUT,VERIFY_ON,NOTIFY_ME
	INTEGER*4 IJBC,I
	CHARACTER*1 C
C
C	Initialize CLI status values
C
	CLI_PRESENT=%LOC(CLI$_PRESENT)
	CLI_NEGATED=%LOC(CLI$_NEGATED)
	CLI_DEFAULTED=%LOC(CLI$_DEFAULTED)
	CLI_ABSENT=%LOC(CLI$_ABSENT)
	CLI_LOCPRES=%LOC(CLI$_LOCPRES)
	CLI_LOCNEG=%LOC(CLI$_LOCNEG)
	CLI_COMMA=%LOC(CLI$_COMMA)
	CLI_CONCAT=%LOC(CLI$_CONCAT)
	CLI_NOCOMD=%LOC(CLI$_NOCOMD)
	CLI_NORMAL=%LOC(CLI$_NORMAL)
C
C	Get the command that is being submitted
C
	ISTAT=CLI$GET_VALUE('COMMAND',COMMAND,LC)
	IF(ISTAT.NE.SS_NORMAL)GOTO90
	IF(LC.LE.0)GOTO90
C
C	Get the log file specification, if any
C
	ISTAT=CLI$PRESENT('LOG')
	IF(ISTAT.EQ.CLI_PRESENT)THEN
	   ISTAT=CLI$GET_VALUE('LOG',LOGFILE,L_LF)
	   IF(ISTAT.NE.SS_NORMAL)THEN
	      L_LF=0
	   ELSE
	      OPEN(UNIT=2,NAME=LOGFILE(1:L_LF),TYPE='NEW',ERR=93)
	      INQUIRE(UNIT=2,NAME=LOGFILE)
	      CLOSE(UNIT=2,DISPOSE='DELETE')
	      CALL STR$TRIM(LOGFILE,LOGFILE,L_LF)
	      I=INDEX(LOGFILE(1:L_LF),';')
	      IF(I.GT.0)L_LF=I-1
	   ENDIF
	ELSE IF(ISTAT.EQ.CLI_NEGATED)THEN
	   L_LF=-1
	ENDIF
C
C	Determine if a priority level was specified
C
	IF(CLI$PRESENT('LOW'))THEN
	   BATCHQUEUE(1:16)='DCL_LOW_BATCHQUE'
	   L_BQ=16
	ELSE IF(CLI$PRESENT('HIGH'))THEN
	   BATCHQUEUE(1:17)='DCL_HIGH_BATCHQUE'
	   L_BQ=17
	ELSE
	   BATCHQUEUE(1:19)='DCL_MEDIUM_BATCHQUE'
	   L_BQ=19
	ENDIF
C
C	Determine if further input will be required
C
	ISTAT=CLI$PRESENT('INPUT')
	GET_MORE_INPUT=(ISTAT.EQ.CLI_PRESENT)
C
C	Determine if batch job should run with VERIFY
C
	ISTAT=CLI$PRESENT('VERIFY')
	VERIFY_ON=(ISTAT.EQ.CLI_PRESENT)
C
C	Determine if user should be notified of completion
C
	ISTAT=CLI$PRESENT('NOTIFY')
	NOTIFY_ME=(ISTAT.NE.CLI_NEGATED)
C
C	Open command procedure file in SYS$SCRATCH:
C
	OPEN(UNIT=1,NAME='SYS$SCRATCH:BATCH_JOB.TMP',TYPE='NEW',
	1 CARRIAGECONTROL='LIST',RECORDSIZE=256,ERR=91)
C
C	Get actual filename
C
	INQUIRE(UNIT=1,NAME=JOBFILE)
	CALL STR$TRIM(JOBFILE,JOBFILE,L_JF)
C
C	Start out with SET NOON
C
	CALL PUT_JOBFILE('$ SET NOON')
C
C	Process logical name definitions
C
	CALL LOGNAM
C
C	Process information from SHOW PROCESS
C
	CALL SHPROC(UIC,L_UIC)
C
C	Process global symbol definitions
C
	CALL SYMBOL
C
C	Set the UIC that original process had
C
	CALL PUT_JOBFILE('$ SET UIC '//UIC(1:L_UIC))
C
C	Transform command into name string for job
C
	LXC=0
	DO I=1,LC
	   C=COMMAND(I:I)
	   IF(C.GE.'0'.AND.C.LE.'9')GOTO7
	   IF(C.GE.'A'.AND.C.LE.'Z')GOTO7
	   IF(C.GE.'a'.AND.C.LE.'z')GOTO7
	   IF(C.EQ.'$'.OR.C.EQ.'-')GOTO7
	   IF(LXC.GT.0)THEN
	      IF(XCMD(LXC:LXC).EQ.'_')GOTO8
	   ELSE
	      GOTO8
	   ENDIF
	   C='_'
7	   LXC=LXC+1
	   XCMD(LXC:LXC)=C
	   IF(LXC.GE.39)GOTO9
8	   CONTINUE
	ENDDO
C
9	IF(LXC.GT.0)THEN
	   IF(XCMD(LXC:LXC).EQ.'_')LXC=LXC-1
	ELSE
	   XCMD(1:5)='BATCH'
	   LXC=5
	ENDIF
C
C	Write code to execute the command, send the log file
C	to a spooled null printer LOG: (created with NULDRIVER)
C
	IF(L_LF.EQ.0)THEN
 	   CALL PUT_JOBFILE('$ CALL/OUT=LOG:'//XCMD(1:LXC)//
	1   '.LOG DO_THE_GOOD_STUFF')
	   CALL PUT_JOBFILE('$ LOGOFF')
C
C	Write the DCL subroutine that executes the command
C
	   CALL PUT_JOBFILE('$DO_THE_GOOD_STUFF: SUBROUTINE')
	ENDIF
C
C	If VERIFY requested, set it now
C
	IF(VERIFY_ON)CALL PUT_JOBFILE('$ SET VERIFY')
C
C	Write the command into the procedure
C
	CALL PUT_JOBFILE('$ '//COMMAND(1:LC))
C
C	If more input required, get it and write it
C
	IF(GET_MORE_INPUT)THEN
11	   ISTAT=LIB$GET_COMMAND(LINE,'BATCH> ',L)
	   IF(ISTAT.NE.RMS_EOF)THEN
	      CALL PUT_JOBFILE(LINE(1:L))
	      GOTO11
	   ENDIF
	ENDIF
C
C	Turn off verify if on
C
	IF(VERIFY_ON)CALL PUT_JOBFILE('$ SET NOVERIFY')
C
C	End the subroutine
C
	IF(L_LF.EQ.0)CALL PUT_JOBFILE('$ ENDSUBROUTINE')
C
C	Close the command procedure
C
	CLOSE(UNIT=1)
C
C	Build the $SNDJBC item list to submit the job
C
	JBCLIST(1).BUFLEN=L_BQ
	JBCLIST(1).ITEMCODE=SJC$_QUEUE
	JBCLIST(1).BUFADR=%LOC(BATCHQUEUE)
	JBCLIST(1).RETLENADR=0
	JBCLIST(2).BUFLEN=L_JF
	JBCLIST(2).ITEMCODE=SJC$_FILE_SPECIFICATION
	JBCLIST(2).BUFADR=%LOC(JOBFILE)
	JBCLIST(2).RETLENADR=0
	JBCLIST(3).BUFLEN=0
	JBCLIST(3).ITEMCODE=SJC$_DELETE_FILE
	JBCLIST(3).BUFADR=0
	JBCLIST(3).RETLENADR=0
	JBCLIST(4).BUFLEN=LXC
	JBCLIST(4).ITEMCODE=SJC$_JOB_NAME
	JBCLIST(4).BUFADR=%LOC(XCMD)
	JBCLIST(4).RETLENADR=0
	IF(L_LF.GT.0)THEN
	   JBCLIST(5).BUFLEN=L_LF
	   JBCLIST(5).ITEMCODE=SJC$_LOG_SPECIFICATION
	   JBCLIST(5).BUFADR=%LOC(LOGFILE)
	   JBCLIST(5).RETLENADR=0
	   JBCLIST(6).BUFLEN=0
	   JBCLIST(6).ITEMCODE=SJC$_NO_LOG_DELETE
	   JBCLIST(6).BUFADR=0
	   JBCLIST(6).RETLENADR=0
	   JBCLIST(7).BUFLEN=0
	   JBCLIST(7).ITEMCODE=SJC$_NO_LOG_SPOOL
	   JBCLIST(7).BUFADR=0
	   JBCLIST(7).RETLENADR=0
	   IJBC=7
	ELSE
	   JBCLIST(5).BUFLEN=0
	   JBCLIST(5).ITEMCODE=SJC$_NO_LOG_SPECIFICATION
	   JBCLIST(5).BUFADR=0
	   JBCLIST(5).RETLENADR=0
	   IJBC=5
	ENDIF
	IF(NOTIFY_ME)THEN
	   IJBC=IJBC+1
	   JBCLIST(IJBC).BUFLEN=0
	   JBCLIST(IJBC).ITEMCODE=SJC$_NOTIFY
	   JBCLIST(IJBC).BUFADR=0
	   JBCLIST(IJBC).RETLENADR=0
	ENDIF
	IJBC=IJBC+1
	JBCLIST(IJBC).BUFLEN=256
	JBCLIST(IJBC).ITEMCODE=SJC$_JOB_STATUS_OUTPUT
	JBCLIST(IJBC).BUFADR=%LOC(JOB_STATUS)
	JBCLIST(IJBC).RETLENADR=%LOC(L_JS)
	IJBC=IJBC+1
	JBCLIST(IJBC).TERMINATOR=0
C
C	Submit the job
C
	ISTAT=SYS$SNDJBCW(,%VAL(SJC$_ENTER_FILE),,%REF(JBCLIST),IOSB,,)
C
C	See if job was submitted correctly
C
	IF((ISTAT.AND.1).EQ.0)THEN
	   WRITE(JOB_STATUS(1:64),88)ISTAT
88	   FORMAT('%BATCH-F-SNDJBCW, Failed to submit batch job, status: %X',
	1   Z8.8)
	   L_JS=64
	ELSE IF((IOSB(1).AND.1).EQ.0)THEN
	   WRITE(JOB_STATUS(1:61),89)IOSB(1)
89	   FORMAT('%BATCH-F-IOSB, Failed to submit batch job, status: %X',
	1   Z8.8)
	   L_JS=61
	   ISTAT=IOSB(1)
	ENDIF
C
C	Output job status line, similar to what SUBMIT prints
C
	CALL LIB$PUT_OUTPUT(JOB_STATUS(1:L_JS))
	GOTO99
C
C	Various error handling
C
90	CALL LIB$PUT_OUTPUT('%BATCH-F-BADCMD, Missing or invalid command')
	ISTAT='2C'X
	GOTO99
91	CALL LIB$PUT_OUTPUT(
	1 '%BATCH-F-OPENFAIL, Failed to open temporary job file')
	ISTAT='2C'X
	GOTO99
93	CALL LIB$PUT_OUTPUT('%BATCH-F-BADLOGFIL, Invalid log file specified')
	ISTAT='2C'X
99	CALL SYS$EXIT(%VAL(ISTAT))
	END
