	PROGRAM GETSERVER
C
C	GETSERVER -- Permanent DECnet object to provide some of the $GETxxI
C			system services over a network link
C
C	Version V01.00
C
C	Written:  23-Nov-1987 by John Osudar
C
C	Modification history:
C
C	1.00 23-Nov-1987 Wrote initial version of GETSERVER
C
C	This program should be run as a detached process that has SYSNAM,
C	WORLD, and SYSPRV privileges, so that it can declare itself to be a 
C	network object, and can obtain the necessary information.
C
	IMPLICIT NONE
	INCLUDE '($IODEF)'
	LOGICAL*4 ISTAT,LIB$ASN_WTH_MBX,SYS$QIOW,SYS$ASSIGN
C
C	Declare NET: channel, associated mailbox channel
C
	INTEGER*2 NETCHN,MBXCHN
	COMMON /CHANNELS/NETCHN,MBXCHN
C
C	Status block for I/O operations
C
	INTEGER*2 IOSB(4)
C
C	Binary-to-hex conversion routine for error reporting
C
	CHARACTER*8 HEXIT
C
C	Descriptors need to be built in R/W storage
C
C	(DSC_NFB(1) is length of NFB, always 5; 
C	 DSC_OBJNAME(1) is length of object name)
C
	INTEGER*4 DSC_NFB(2),DSC_OBJNAME(2)
	DATA DSC_NFB(1)/5/,DSC_OBJNAME(1)/9/
C
C	Object name (fill in length above)
C
	CHARACTER*12 OBJNAME
	DATA OBJNAME/'GETSERVER'/
C
C	Set up the NFB (note that the first byte's value is
C	NFB$C_DECLNAME, from $NFBDEF in SYS$LIBRARY:LIB.MLB; currently 21)
C
	BYTE NFB(5)
	DATA NFB/21,0,0,0,0/
C
C	Start of main program code
C
C	Assign a channel to NET: and a mailbox channel to go with it
C
	ISTAT=LIB$ASN_WTH_MBX(%DESCR('_NET:'),%REF(128),%REF(256),
	1 %REF(NETCHN),%REF(MBXCHN))
	IF(.NOT.ISTAT)GOTO90
C
C	Build the descriptors for the NFB and object name
C
	DSC_NFB(2)=%LOC(NFB)
	DSC_OBJNAME(2)=%LOC(OBJNAME)
C
C	Declare our object name
C
	ISTAT=SYS$QIOW(,%VAL(NETCHN),%VAL(IO$_ACPCONTROL),%REF(IOSB),,,
	1 %REF(DSC_NFB),%REF(DSC_OBJNAME),,,,)
	IF(.NOT.ISTAT)GOTO91
	IF(IOSB(1).NE.1)GOTO92
C
C	Post the initial mailbox QIO, and hibernate until we need to exit
C
10	CALL POST_MBXQIO
	CALL SYS$HIBER
C
C	When we need to exit, we will be awakened; then, simply exit.
C
	CALL SYS$EXIT(%VAL(1))
C
C	Error reporting and exit code
C
90	CALL LIB$PUT_OUTPUT('Status from LIB$ASN_WTH_MBX %X'//
	1 HEXIT(%VAL(ISTAT)))
	GOTO99
91	CALL LIB$PUT_OUTPUT('Status from $QIOW ACPCONTROL %X'//
	1 HEXIT(%VAL(ISTAT)))
	GOTO99
92	CALL LIB$PUT_OUTPUT('IOSB from $QIOW ACPCONTROL %X'//
	1 HEXIT(%VAL(IOSB(1))))
	CALL SYS$EXIT(%VAL(IOSB(1)))
99	CALL SYS$EXIT(%VAL(ISTAT))
	END
C
C	Binary-to-hex conversion function for error reporting
C
	CHARACTER*8 FUNCTION HEXIT(VALVAL)
	IMPLICIT NONE
	BYTE VALVAL
	INTEGER*4 VALUE
	VALUE=%LOC(VALVAL)
	CALL SYS$FAO(%DESCR('!8XL'),,%DESCR(HEXIT),%VAL(VALUE))
	RETURN
	END
C
C	Subroutine to post QIO read to mailbox
C
	SUBROUTINE POST_MBXQIO
	IMPLICIT NONE
	INCLUDE '($IODEF)'
	INTEGER*2 NETCHN,MBXCHN,NJECHN
	COMMON /CHANNELS/NETCHN,MBXCHN,NJECHN
	STRUCTURE /MBXMSG/
	   INTEGER*2 MSGTYPE
	   INTEGER*2 UNITNO
	   UNION
	      MAP
	         BYTE MSGBYTE(124)
	      ENDMAP
	      MAP
	         CHARACTER*124 MSGCHAR
	      ENDMAP
	   END UNION
	END STRUCTURE
	RECORD /MBXMSG/ MSG
	INTEGER*2 IOSB(4)
	COMMON /MBXSTUFF/ MSG,IOSB
	LOGICAL*4 ISTAT,SYS$QIO
	EXTERNAL MBXAST
	CHARACTER*8 HEXIT
	ISTAT=SYS$QIO(,%VAL(MBXCHN),%VAL(IO$_READVBLK),%REF(IOSB),MBXAST,,
	1 %REF(MSG),%VAL(128),,,,)
	IF(.NOT.ISTAT)GOTO90
	RETURN
90	CALL LIB$PUT_OUTPUT('Status from $QIO MBX READ %X'//
	1 HEXIT(%VAL(ISTAT)))
	CALL SYS$EXIT(%VAL(ISTAT))
	END
C
C	Mailbox AST routine -- does the work of setting up the logical link
C	and posting the read QIO to the other side
C
	SUBROUTINE MBXAST
	IMPLICIT NONE
	INCLUDE '($IODEF)'
	INCLUDE '($MSGDEF)'
	INTEGER*2 NETCHN,MBXCHN,NJECHN
	COMMON /CHANNELS/NETCHN,MBXCHN,NJECHN
	STRUCTURE /MBXMSG/
	   INTEGER*2 MSGTYPE
	   INTEGER*2 UNITNO
	   UNION
	      MAP
	         BYTE MSGBYTE(124)
	      ENDMAP
	      MAP
	         CHARACTER*124 MSGCHAR
	      ENDMAP
	   END UNION
	END STRUCTURE
	RECORD /MBXMSG/ MSG
	INTEGER*2 IOSB(4)
	COMMON /MBXSTUFF/ MSG,IOSB
	LOGICAL*4 ISTAT,SYS$QIOW,SYS$ASSIGN,LIB$GET_VM,SYS$QIO,SYS$DASSGN
	EXTERNAL NETAST
	CHARACTER*8 HEXIT
	INTEGER*4 NCBDESC(2)
	INTEGER*2 I,TSKCHN,IX,J
	INTEGER*4 BLKADR
C
C	Declare and define valid DECnet node list (nodes that can send us
C	messages)
C
	INTEGER*4 N_VALID_NODES
	PARAMETER (N_VALID_NODES=3)
	CHARACTER*6 VALID_NODES(N_VALID_NODES)
	DATA VALID_NODES/'ANLCMT','ANCMT1','ANCMT2'/
C
C	If the mailbox QIO failed, process the error
C
	IF(IOSB(1).NE.1)GOTO90
C
C	Check message type
C
C	If NETSHUT (shutdown), wake main program so it will exit
C
	IF(MSG.MSGTYPE.EQ.MSG$_NETSHUT)THEN
	   CALL SYS$WAKE(,)
	   RETURN
C
C	Anything else, other than CONNECT, gets ignored (repost read and return)
C
	ELSE IF(MSG.MSGTYPE.NE.MSG$_CONNECT)THEN
	   GOTO89
C
C	Otherwise it's a CONNECT request.  Process it.
C
	ELSE
C
C	Find the length of the NCB in the message text, and build a
C	descriptor for the NCB in R/W memory
C
	   I=MSG.MSGBYTE(1)+2
	   NCBDESC(1)=MSG.MSGBYTE(I)
	   NCBDESC(2)=%LOC(MSG.MSGBYTE(I+1))
C
C	Assign a channel to the NET: device again, this time for this link only
C
	   ISTAT=SYS$ASSIGN('_NET:',%REF(TSKCHN),,)
	   IF(.NOT.ISTAT)GOTO93
C
C	Validate DECnet nodename of requestor
C
	   IX=INDEX(MSG.MSGCHAR(I+1:124),'::')-1
	   IF(IX.LE.0)GOTO96
	   DO J=1,N_VALID_NODES
	      IF(VALID_NODES(J).EQ.MSG.MSGCHAR(I+1:I+IX))GOTO3
	   ENDDO
	   GOTO96
C
C	Allocate a buffer to hold the message, channel number, IOSB.
C	(1024+2+8 = 1034 bytes required)
C
3	   ISTAT=LIB$GET_VM(%REF(1034),%REF(BLKADR))
	   IF(.NOT.ISTAT)GOTO94
C
C	Insert the channel number and username
C
	   CALL LIB$MOVC3(%REF(2),%REF(TSKCHN),%VAL(BLKADR))
C
C	Accept the connect request, passing the NCB
C
	   ISTAT=SYS$QIOW(,%VAL(TSKCHN),%VAL(IO$_ACCESS),%REF(IOSB),,,,
	1   %REF(NCBDESC),,,,)
	   IF(.NOT.ISTAT)GOTO91
	   IF(IOSB(1).NE.1)GOTO92
C
C	Post the read QIO to the network link
C
	   ISTAT=SYS$QIO(,%VAL(TSKCHN),%VAL(IO$_READVBLK),%VAL(BLKADR+2),
	1   NETAST,%VAL(BLKADR),%VAL(BLKADR+10),%VAL(1024),,,,)
	   IF(.NOT.ISTAT)GOTO95
	ENDIF
	GOTO89
88	ISTAT=SYS$DASSGN(%VAL(TSKCHN))
	IF(.NOT.ISTAT)GOTO97
C
C	Done with this part; the rest gets done in NETAST.  Re-post mailbox 
C	read and return
C
89	CALL POST_MBXQIO
	RETURN
C
C	Error reporting and recovery code
C
90	CALL LIB$PUT_OUTPUT('IOSB from $QIO READ MBX '//HEXIT(%VAL(IOSB(1))))
	GOTO89
91	CALL LIB$PUT_OUTPUT('Status from $QIOW ACCESS '//HEXIT(%VAL(ISTAT)))
	GOTO88
92	CALL LIB$PUT_OUTPUT('IOSB from $QIOW ACCESS '//HEXIT(%VAL(IOSB(1))))
	GOTO88
93	CALL LIB$PUT_OUTPUT('Status from $ASSIGN '//HEXIT(%VAL(ISTAT)))
	GOTO89
94	CALL LIB$PUT_OUTPUT(
	1 'Failed to get buffer for connect request; rejecting request.')
C
C	Reject the connect request, passing the NCB
C
945	ISTAT=SYS$QIOW(,%VAL(TSKCHN),%VAL(IO$_ACCESS+IO$M_ABORT),
	1 %REF(IOSB),,,,%REF(NCBDESC),,,,)
	IF(.NOT.ISTAT)GOTO91
	IF(IOSB(1).NE.1)GOTO92
	GOTO88
95	CALL LIB$PUT_OUTPUT('Status from $QIO NET READ %X'//
	1 HEXIT(%VAL(ISTAT)))
	GOTO89
96	CALL LIB$PUT_OUTPUT('Request from invalid node rejected')
	GOTO945
97	CALL LIB$PUT_OUTPUT('Status from $DASSGN %X'//HEXIT(%VAL(ISTAT)))
	GOTO89
	END
C
C	NET read AST routine   
C
	SUBROUTINE NETAST(BUF)
	CALL DO_NETAST(BUF)
	RETURN
	END
C
	SUBROUTINE DO_NETAST(BUF)
	IMPLICIT NONE
	INCLUDE '($IODEF)'
	INCLUDE '($SSDEF)'
	INCLUDE 'SYS_CMTLIB:ITEMDEF.INC'
C
C	Define structure of block buffer
C
	STRUCTURE /BLKBUF/
	   INTEGER*2 CHANNEL
	   INTEGER*2 IOSTAT
	   INTEGER*2 L
	   INTEGER*4 %FILL
	   INTEGER*2 REQTYP
	   INTEGER*2 ITEM(2,255)
	   INTEGER*2 %FILL
	END STRUCTURE
	RECORD /BLKBUF/ BUF
	INTEGER*2 NETCHN,MBXCHN
	COMMON /CHANNELS/NETCHN,MBXCHN
	CHARACTER*8 HEXIT
	LOGICAL*4 ISTAT,SYS$QIOW,LIB$FREE_VM,SYS$DASSGN,REPEAT,SYS$QIO
	INTEGER*2 IX,NITEMS,I
	INTEGER*4 PID
C
	RECORD /ITEM/ LIST(256)
	INTEGER*4 DATA(1024),SYS$GETJPIW,SYS$GETTIM,SYS$GETSYIW
	EXTERNAL NETAST
C
C	Check IOSB to see if completed successfully; if not, process error
C
	IF(BUF.IOSTAT.NE.1)GOTO90
C
C	Check request type:
C
C		type 0 = close the connection
C		type 1 = GETTIM (no items)
C		type 2 = GETJPI
C		type 3 = GETSYI
C
	IX=%LOC(DATA)+4
	IF(BUF.REQTYP.EQ.0)GOTO19
	IF(BUF.REQTYP.LT.0.OR.BUF.REQTYP.GT.3)GOTO91
	NITEMS=(BUF.L-4)/4
	DO I=1,NITEMS
	   LIST(I).ITEMCODE=BUF.ITEM(1,I)
	   IF(BUF.ITEM(2,I).LT.0)THEN
	      LIST(I).RETLENADR=IX
	      IX=IX+2
	      BUF.ITEM(2,I)=-BUF.ITEM(2,I)
	   ELSE
	      LIST(I).RETLENADR=0
	   ENDIF
	   LIST(I).BUFADR=IX
	   LIST(I).BUFLEN=BUF.ITEM(2,I)
	   IX=IX+BUF.ITEM(2,I)
	ENDDO
	LIST(NITEMS+1).TERMINATOR=0
	IF(BUF.REQTYP.EQ.1)THEN
	   DATA(1)=SYS$GETTIM(DATA(2))
	   IX=IX+8
	   REPEAT=.FALSE.
	   GOTO12
	ENDIF
10	PID=-1
11	IF(BUF.REQTYP.EQ.2)THEN
	   DATA(1)=SYS$GETJPIW(,%REF(PID),,%REF(LIST),%REF(BUF.IOSTAT),,)
	   REPEAT=.TRUE.
	   IF(DATA(1).EQ.SS$_NOMOREPROC)GOTO14
	   IF(DATA(1).EQ.SS$_SUSPENDED)GOTO12
	   IF((DATA(1).AND.1).EQ.0)REPEAT=.FALSE.
	   DATA(1)=BUF.IOSTAT
	   IF(DATA(1).EQ.SS$_NOMOREPROC)GOTO14
	   IF(DATA(1).EQ.SS$_SUSPENDED)GOTO12
	   IF((DATA(1).AND.1).EQ.0)REPEAT=.FALSE.
	ELSE IF(BUF.REQTYP.EQ.3)THEN
	   DATA(1)=SYS$GETSYIW(,,,%REF(LIST),%REF(BUF.IOSTAT),,)
	   REPEAT=.FALSE.
	ENDIF
12	ISTAT=SYS$QIOW(,%VAL(BUF.CHANNEL),%VAL(IO$_WRITEVBLK),
	1 %REF(BUF.IOSTAT),,,%REF(DATA),%VAL(IX-%LOC(DATA)),,,,)
	IF(.NOT.ISTAT)GOTO92
  	IF(REPEAT)GOTO11
14	DATA(1)=-1             
	ISTAT=SYS$QIOW(,%VAL(BUF.CHANNEL),%VAL(IO$_WRITEVBLK),
	1 %REF(BUF.IOSTAT),,,%REF(DATA),%VAL(4),,,,)
	IF(.NOT.ISTAT)GOTO92
18	ISTAT=SYS$QIO(,%VAL(BUF.CHANNEL),%VAL(IO$_READVBLK),
	1 %REF(BUF.IOSTAT),NETAST,%REF(BUF),%REF(BUF.REQTYP),
	2 %VAL(1024),,,,)
	IF(.NOT.ISTAT)GOTO97
	RETURN
C
C	Deassign the channel
C
19	ISTAT=SYS$DASSGN(%VAL(BUF.CHANNEL))
	IF(.NOT.ISTAT)GOTO93
C
C	Deallocate the memory and return
C
89	ISTAT=LIB$FREE_VM(%REF(1034),%REF(%LOC(BUF)))
	IF(.NOT.ISTAT)GOTO94
	RETURN
C
C	Error reporting and recovery
C
90	CALL LIB$PUT_OUTPUT('IOSB from NET READ %X'//HEXIT(%VAL(BUF.IOSTAT)))
	ISTAT=SYS$DASSGN(%VAL(BUF.CHANNEL))
	IF(.NOT.ISTAT)GOTO93
  	GOTO89
91	DATA(1)=0
	REPEAT=.FALSE.
	GOTO12
92   	CALL LIB$PUT_OUTPUT('Status from $QIOW WRITE %X'//
	1 HEXIT(%VAL(ISTAT)))
	GOTO19
93	CALL LIB$PUT_OUTPUT('Status from $DASSGN %X'//HEXIT(%VAL(ISTAT)))
	GOTO89
94	CALL LIB$PUT_OUTPUT('Status from LIB$FREE_VM %X'//HEXIT(%VAL(ISTAT)))
	RETURN
97	CALL LIB$PUT_OUTPUT('Status from $QIO READ %X'//
	1 HEXIT(%VAL(ISTAT)))
	GOTO19
	END
