$save_verify_image=f$environment("verify_image")
$save_verify_procedure=f$verify(0)
$ on control_y then goto DONE           ! So user can abort printing form.
$ on error then goto DONE               ! IF any major errors, procedure will abort.
$!***********************************************
$! Define flags and other symbols for processing.
$ p2_flag := "0000000"                   ! Define Form flag
$ p3_flag := "0000"                      ! Define Laser location flag
$ legal_flag := "0"                      ! Define legal size paper flag
$ comp_flag := "0"                       ! Define compressed print flag
$ form_flag := "0"                       ! Define form(PCLine Char. Set) flag
$ elite_flag :== "0"                     ! Define elite print flag
$ form_input = ""                        ! Define form input as null
$ form_list = "P/L/G/C/F/E/M/"           ! P)ortrait,L)andscape,G)Legal,C)ompressed,F)(PC Line),E)lite & M)argins
$ form_def = ""                          ! Define output form defin. as null
$ put :== write sys$output               ! Re-define command WRITE SYS$OUTPUT
$ put "  Laser Printer Program - version 2.0"
$ if p1 .eqs. "H" then goto V2_HELP      ! They require on-line help
$!****************************************************************************
$CHECK_PARAMS:                           ! Check to see if command line has input; if not, prompt user for parameters.
$ if p1 .eqs. "" then gosub GET_P1       ! Get file_name.
$ if p2 .eqs. "" then gosub GET_P2       ! Get form specs.
$ if p2 .nes. "" then gosub P2_CHK_INPUT ! User provided form desc., chk it.
$ gosub CHECK_OPTIONS                    ! Lets Check Form Options, if ok, print file.
$ if p3 .eqs. "" then gosub GET_P3       ! Get laser location.
$ if p3 .nes. "" then gosub USER_PROVIDED_LASER ! User provided laser location, lets check it.
$ if p4 .nes. "" then gosub DO_P4        ! Process other print switches
$ goto FILE_OUTPUT
$!******************************************************************************
$GET_P1:                                                                                
$ inquire  p1 "_File:"                    ! Ask for file name
$ if p1 .eqs. "" then goto GET_P1         ! If null, ask again
$ current_dir = f$environment("default")  ! Get current directory name
$ filefind = f$search("''p1'")            ! Search directory for file
$ if filefind .eqs. "" then goto NO_FIND  ! If file not find, notify user, exit.
$ return                                  ! Return to Main routine
$!******************************************************************************
$GET_P2:
$ gosub FORM_MENU                         ! If called from Main routine, get options
$ P2_CHK_INPUT:                           ! Subroutine to check if valid form options
$ str_len = f$length(p2)                  ! Get number of characters provided
$ x = 0                                   ! Define 1st offset as "0"
$ y =1                                    ! Define 2nd offset as "1"
$ tmp = f$extract(0,str_len,p2)           ! Extract length of string to temporary symbol
$!******************************************************************************
$ P2_CHK_LOOP:                            ! Start of form option check loop
$  str_cnt = 0                            ! Define element list offset as "0"
$  form_type  = f$extract(x,y,tmp)        ! Extract character for comparsion
$!******************************************************************************
$  FORM_LOOP:
$   form_input = f$element(str_cnt,"/",form_list)       ! Get character from pre-defined form
$   if form_input .eqs. "/" then goto FORM_ERROR        ! If invalid form option, abort & notify user
$   if form_input .eqs. form_type then goto FORM_CONT   ! If valid form option, set bit in p2_flag
$   str_cnt = str_cnt + 1                               ! Increment element list offset
$   goto FORM_LOOP                                      ! loop
$!******************************************************************************
$   FORM_CONT:                                          ! Subroutine, set p2_flag values
$    if form_input .eqs. "P" then P2_flag[0,1] := 1     ! If Portrait, set Portrait bit
$    if form_input .eqs. "L" then P2_flag[1,1] := 1     ! If Landscape, set Landscape bit
$    if form_input .eqs. "G" then P2_flag[2,1] := 1     ! If Legal, set Legal bit
$    if form_input .eqs. "G" then  legal_flag := "1"    ! If legal, set laser flag for legal paper
$    if form_input .eqs. "C" then P2_flag[3,1] := 1     ! If compressed, set compressed bit
$    if form_input .eqs. "C" then   comp_flag := "1"    ! If compressed, set laser flag for compressed print
$    if form_input .eqs. "F" then P2_flag[4,1] := 1     ! If PCLine, set Forms bit
$    if form_input .eqs. "F" then   form_flag := "1"    ! If PCLine, set laser flag for forms printing
$    if form_input .eqs. "E" then P2_flag[5,1] := 1     ! If elite pitch, set elite bit
$    if form_input .eqs. "E" then  elite_flag := "1"    ! If elite pitch, set elite flag for laser printing
$    if form_input .eqs. "M" then P2_flag[6,1] := 1     ! If Margins, set margins bit
$  x = x + 1                                            ! End subroutine, increment offset
$  if x .eq. str_len then return                        ! Reached end of provided input, return to calling routine
$  goto P2_CHK_LOOP                                     ! Haven't reached end of input, loop
$ return                                                ! Return to main routine
$!******************************************************************************
$CHECK_OPTIONS:                                         ! Subroutine checks in user request portrait & landscape.
$! P2_FLAG is define as PLGCFEM
$ if f$extract(0,2,p2_flag) .eqs. "11" then goto CHECK_ORIENT
$ if f$extract(0,2,p2_flag) .eqs. "00" then goto CHECK_ORIENT
$ if f$extract(3,1,p2_flag) .eqs. "1" .and. f$extract(5,1,p2_flag) .eqs. "1" then goto CHECK_PITCH
$ return                                                ! Must be a valid form specification. Return.
$!******************************************************************************
$CHECK_ORIENT:                                                                           
$ type sys$input            

        You have specified an illegal laser form orientation.
        Please re-selection your form's orientation.

$! Clear Form Orientation from parameter flag.
$ p2_flag[0,1] := 0                        
$ p2_flag[1,1] := 0
$ type sys$input

                Laser Form Orientation:
                                                             
                    P = Portrait
                    L = Landscape

$ASK_ORIENT:
$ inquire/nopun ori "                    Enter orientation selection: "                              
$ if ori .eqs. "P" then p2_flag[0,1] := 1                   ! Reset portrait bit
$ if ori .eqs. "L" then p2_flag[1,1] := 1                   ! Reset landscape bit
$ return
$!******************************************************************************
$CHECK_PITCH:
$ type sys$input

        You have specified an incompatible laser font option.
        Please re-selection your output font option.

$! Clear Compressed and Elite from parameter flag.
$ p2_flag[3,1] := 0                        
$ p2_flag[5,1] := 0
$ type sys$input

                Laser Font Option:
                                                             
                    C = Compressed
                    E = Elite    
 
$ASK_ORIENT:
$ inquire/nopun orr "                    Enter font option: "                              
$ if orr .eqs. "C" then p2_flag[3,1] := 1                 ! Reset Compressed bit
$ if orr .eqs. "E" then p2_flag[5,1] := 1                 ! Reset Elite bit
$ return
$!******************************************************************************
$FORM_MENU:
$ typ sys$input

                 Laser Printer Form Options:

                    P = Portrait Orientation
                    L = Landscape Orientation
                    G = Legal size paper
                    C = Compressed print
                    E = Elite print
                    F = Form PCLine character set
                    M = Margins: Left=8 characters, Top=3 Lines, Bottom=3 lines
         
$ASK_FORM:
$ inquire/nopun p2 "                    Enter your form selection: "
$ if p2 .eqs. "" then goto ask_form
$ return
$!******************************************************************************
$GET_P3:
$LASER_LOCATION:
$ type sys$input

                      Laser Location Options:

                        D)  Downstairs 
                        U)  Upstairs

$ASK_LOCATION:
$ inquire/nopun P3  "                  Enter your laser location selection: "
$ p3_flag[0,1] := "1"                          ! Set Laser flag for HP Laserjet, can't do forms,elite or compressed.
$ p3=f$extract(0,1,p3)
$ if p3 .eqs. "" then goto ASK_LOCATION
$ if p3 .eqs. "U" then p3_flag[2,1] := "1"     ! Set Laser flag for HP Laserjet+
$! p3 = f$extract(0,2,p3)
$! if p3 .eqs. "UE" then p3_flag[2,1] := "1"   ! Multiple lasers located on our 2nd floor.
$! if p3 .eqs. "UW" then p3_flag[3,1] := "1"   ! Multiple lasers located on our 2nd floor.
$ if p3 .eqs. "D"  then p3_flag[1,1] := "1"    ! Multiple lasers located on our 2nd floor.
$ return
$!******************************************************************************
$DO_P4:
$ if p4 .eqs. "" then return
$ if p4 .nes. "" then p4 = "''p4'"             ! Take all other VMS print switches provided
$ return
$!******************************************************************************
$FILE_OUTPUT:
$ if f$extract(0,1,p2_flag) .eqs. "1" then goto POR   ! Split form parameter between Portrait and Landscape
$ if f$extract(1,1,p2_flag) .eqs. "1" then goto LAN
$ POR:                                                !  All Portrait form combinations
$ if p2 .eqs. "P5" then form_def = 11
$ if p2_flag .eqs. "0000000" then form_def = 1
$ if p2_flag .eqs. "1000001" then form_def = 1
$ if p2_flag .eqs. "1000000" then form_def = 4
$ if p2_flag .eqs. "1001001" then form_def = 8
$ if form_def .nes. "" then goto CHK_P3_FLAG         ! Found a form_def, jump to end of subroutine
$ if p2_flag .eqs. "1001000" then form_def = 7
$ if p2_flag .eqs. "1001100" then form_def = 51
$ if p2_flag .eqs. "1001101" then form_def = 50
$ if p2_flag .eqs. "1010000" then form_def = 36 
$ if form_def .nes. "" then goto CHK_P3_FLAG         ! Found a form_def, jump to end of subroutine
$ if p2_flag .eqs. "1011000" then form_def = 37  
$ if p2_flag .eqs. "1011100" then form_def = 38 
$ if p2_flag .eqs. "1011101" then form_def = 39 
$ if p2_flag .eqs. "1011001" then form_def = 40 
$ if form_def .nes. "" then goto CHK_P3_FLAG         ! Found a form_def, jump to end of subroutine
$ if p2_flag .eqs. "1010001" then form_def = 41 
$ if p2_flag .eqs. "1010101" then form_def = 43 
$ if p2_flag .eqs. "1010100" then form_def = 42
$ if p2_flag .eqs. "1000100" then form_def = 44
$ if form_def .nes. "" then goto CHK_P3_FLAG         ! Found a form_def, jump to end of subroutine
$ if p2_flag .eqs. "1000101" then form_def = 45
$ if p2_flag .eqs. "1000010" then form_def = 60
$ if p2_flag .eqs. "1000011" then form_def = 61
$ if p2_flag .eqs. "1010010" then form_def = 62
$ if form_def .nes. "" then goto CHK_P3_FLAG         ! Found a form_def, jump to end of subroutine
$ if p2_flag .eqs. "1000110" then form_def = 66
$ if p2_flag .eqs. "1010011" then form_def = 64
$ if p2_flag .eqs. "1000111" then form_def = 67
$ if p2_flag .eqs. "1010110" then form_def = 63
$ if p2_flag .eqs. "1010111" then form_def = 65
$ if form_def .nes. "" then goto CHK_P3_FLAG         ! Found a form_def, jump to end of subroutine
$ LAN:                                               ! All Landscape form definitions
$ if p2_flag .eqs. "0100000" then form_def = 2
$ if p2_flag .eqs. "0100001" then form_def = 5  
$ if p2_flag .eqs. "0101000" then form_def = 3
$ if p2_flag .eqs. "0101001" then form_def = 6
$ if form_def .nes. "" then goto CHK_P3_FLAG         ! Found a form_def, jump to end of subroutine
$ if p2_flag .eqs. "0101100" then form_def = 46 
$ if p2_flag .eqs. "0101101" then form_def = 47 
$ if p2_flag .eqs. "0110000" then form_def = 34
$ if p2_flag .eqs. "0110001" then form_def = 31
$ if form_def .nes. "" then goto CHK_P3_FLAG         ! Found a form_def, jump to end of subroutine
$ if p2_flag .eqs. "0111001" then form_def = 32
$ if p2_flag .eqs. "0111000" then form_def = 33
$ if p2_flag .eqs. "0111100" then form_def = 48
$ if p2_flag .eqs. "0111101" then form_def = 49
$ if form_def .nes. "" then goto CHK_P3_FLAG         ! Found a form_def, jump to end of subroutine
$ if p2_flag .eqs. "0100010" then form_def = 68
$ if p2_flag .eqs. "0100011" then form_def = 69
$ if p2_flag .eqs. "0110010" then form_def = 70
$ if p2_flag .eqs. "0110011" then form_def = 71
$ if form_def .nes. "" then goto CHK_P3_FLAG         ! Found a form_def, jump to end of subroutine
$ if p2_flag .eqs. "0110110" then form_def = 72
$ if p2_flag .eqs. "0110111" then form_def = 73
$ if p2_flag .eqs. "0100110" then form_def = 74
$ if p2_flag .eqs. "0100111" then form_def = 75
$ if form_def .nes. "" then goto CHK_P3_FLAG         ! Found a form_def, jump to end of subroutine
$ if p2_flag .eqs. "0100101" then form_def = 76
$ if p2_flag .eqs. "0100100" then form_def = 77
$ if p2_flag .eqs. "0110100" then form_def = 78
$ if p2_flag .eqs. "0110101" then form_def = 79
$ CHK_P3_FLAG:
$ if p3_flag .eqs. "0100" then goto SKIP_QUEUE
$ if p3_flag .eqs. "0010" then goto SKIP_QUEUE
$ if p3_flag .eqs. "0001" then goto SKIP_QUEUE
$ if p3_flag .eqs. "1100" then goto SKIP_QUEUE
$ if p3_flag .eqs. "1010" then goto SKIP_QUEUE
$ if p3_flag .eqs. "1001" then goto SKIP_QUEUE
$ if p3_flag .eqs. "0000" then goto USER_PROVIDED_LASER    ! User provided laser specs, still must check.
$ goto USER_PROVIDED_LASER                                 ! In case I blew the programming.
$!******************************************************************************
$ PROMPT_VALID_LASER:
$  put "_Invalid laser location "
$  gosub LASER_LOCATION                       
$!******************************************************************************
$ USER_PROVIDED_LASER:
$! pp3=f$extract(0,1,p3)
$! if pp3 .eqs. "U" then $ pp3 = f$extract(0,2,p3)
$! if pp3 .eqs. "U " then gosub OLD_LASER_PARAMS
$! if pp3 .eqs. "U"  then gosub OLD_LASER_PARAMS
$! if p3 .eqs. "UE" then p3_flag[2,1] := "1"
$! if p3 .eqs. "UW" then p3_flag[3,1] := "1"
$! if p3 .eqs. "" then gosub LASER_LOCATION
$ if p3 .eqs. "U"  then p3_flag[2,1] := "1"
$ if p3 .eqs. "D"  then p3_flag[1,1] := "1"
$ if p3_flag .eqs. "0000" then goto PROMPT_VALID_LASER
$ return
$!******************************************************************************
$ OLD_LASER_PARAMS:
$ type sys$input

        You specified an Upstairs Laser, but you must specify which one.
                       
                      Upstair's Laser Location Options:

                        UE) Upstairs, East Corner Laser
                        UW) Upstairs, West Corner Laser

$ASK_OLD_LOCATION:
$ inquire/nopun po "                  Enter your laser location selection: "
$ if po .eqs. "" then goto ASK_OLD_LOCATION
$ if po .eqs. "UW" then goto KICK_OUT
$ if po .eqs. "UE" then goto KICK_OUT
$ goto ASK_OLD_LOCATION
$ KICK_OUT:
$ p3 = po
$ return
$!******************************************************************************
$SKIP_QUEUE:                                          ! Skip to right queue
$ if form_def .eqs. "" then goto CALL_SOFTWARE        ! Dumps error to error file
$ if p3 .eqs. "U"  then goto HIGH_VOLUME$HP           ! HPLaserjet+ or HP 2000
$! if p3 .eqs. "UE" then goto HIGH_VOLUME$HP          ! HPLaserjet+ or HP 2000
$! if p3 .eqs. "UW" then goto LOW_VOLUME$HP           ! HPLaserjet
$ if p3 .eqs. "D" then goto  DOWN_STAIRS$HP           ! HPLaserjet
$!******************************************************************************
$DOWN_STAIRS$HP:                                      ! Downstairs Laser
$ if legal_flag .eqs. "1" then gosub DIS_MSG          ! User wants to print on legal paper
$ if comp_flag  .eqs. "1" then goto NO_GO             ! Can't do Compressed on HP Laserjet
$ if form_flag  .eqs. "1" then goto NO_GO             ! Can't do PCline on HP Laserjet
$ if elite_flag .eqs. "1" then goto NO_GO             ! Can't do Elite on HP Laserjet
$ print/queue=sys$laser1/flag/form='form_def' 'p1' 'p4'
$ save_verify_image = f$verify(save_verify_procedure,save_verify_image)
$ exit
$!******************************************************************************
$HIGH_VOLUME$HP:                   
$ if legal_flag .eqs. "1" then gosub DIS_MSG
$ print/queue=sys$laser2/flag/form='form_def' 'p1' 'p4'
$ save_verify_image = f$verify(save_verify_procedure,save_verify_image)
$ exit
$!******************************************************************************
$SOFT_DOC:                         
$ put "This form type can only be printed on the Upstairs Laser."
$ print/queue=sys$laser2/flag/form=11 'p1' 'p4'
$ save_verify_image = f$verify(save_verify_procedure,save_verify_image)
$ exit
$!******************************************************************************
$LOW_VOLUME$HP:
$ if legal_flag .eqs. "1" then gosub DIS_MSG
$ if comp_flag  .eqs. "1" then goto NO_GO
$ if form_flag  .eqs. "1" then goto NO_GO
$ if elite_flag .eqs. "1" then goto NO_GO
$ print/queue=sys$laser3/flag/form='form_def' 'p1' 'p4'
$ save_verify_image = f$verify(save_verify_procedure,save_verify_image)
$ exit
$!******************************************************************************
$DIS_MSG:
$ put " "
$ put "You must insert the legal paper tray when the printer flashes LL."
$ put " "
$ return
$!  User wants help about LPRINT
$!******************************************************************************
$V2_help:
$ define/user sys$input sys$command
$ help lprint
$ exit
$! Error messages......
$!******************************************************************************
$FORM_ERROR:
$ put ""
$ put "The form type you specified, ''form_type', is unrecognized."
$ put "Please re-specify all form options that you require."
$ p2 = ""
$ goto CHECK_PARAMS
$!******************************************************************************
$NO_GO:
$ put ""
$ put "The Laser you have selected is unable to print your selection."
$ put "The Upstairs Laser can print your selected form."
$ inquire/nopun yesno "Direct output to laser print locatated upstairs? (Y/N) "
$ if yesno .eqs. "Y" then goto CHG_PRT_QUE
$ if yesno .eqs. "N" then goto ABORT_WRONG_QUE
$ goto SKIP_QUEUE
$!******************************************************************************
$CHG_PRT_QUE:
$ p3 = "UE"
$ return
$!******************************************************************************
$NO_FIND:
$ put "Error opening ''current_dir'''p1'; as input."
$ put "File not found"
$ save_verify_image = f$verify(save_verify_procedure,save_verify_image)
$!******************************************************************************
$CALL_SOFTWARE:
$ put "The form you specified, ''P2', has not be defined." 
$ put "Please call the Software Manager to correct this problem."
$ time = f$time()
$ open/append outf sys$manager:lprint.err
$ write outf " ''time'   ''p2'    ''p2_flag' "
$ close outf  
$ goto DONE
$!******************************************************************************
$ABORT_WRONG_QUE:        
$ put " Laser Printer Program Aborting.  The printer you have selected cannot print your form."
$!******************************************************************************
$DONE:
$ save_verify_image = f$verify(save_verify_procedure,save_verify_image)
$ EXIT
$!=============================================================================
$!  The Comments and Acknowledgement Section:
$!  This Command Procedure allows users to print VAX files
$!  on any one of three HP Laser Printers (soon to be four)
$!  at our facility.  The command procedure
$!  is the interface the pick the approiate form and setup
$!  to produce the desired results.  To accomplish this, HP
$!  Laser command sequences are defined in text files and
$!  inserted into the SYS$LIBRARY:SYSDEVCTL.TLB.  Then a form
$!  is defined to use a perticlure setup.  In addition to
$!  VAX terminal queues being connected to the HP Laserjet's,
$!  PC's are also connected via a print spooler device, so we can download
$!  HP soft fonts to the laser printer and access them via
$!  the setup in the SYS$LIBRARY:SYSDEVCTL.TLB
$!
$!  Files that accompany this command procedure are:
$!  Laser Printer escapes codes, defined forms and
$!  a .HLP file for VMS HELP.
$!
$!  Designed by:       Steven MacNeil
$!                     Access Research Corp.
$!                     9655 Towne Centre Drive
$!                     San Diego, CA  92121
$!                     (619) 535-1070 x209
$!
$!  Dated:             10/08/87  
$!
$!  Improvements:      The next step is to make this
$!                     a .EXE file and run it from DCLTABLES.
$!                     The ability to download soft fonts
$!                     from the VAX.
