        program kill
*-----------------------------------------------------------------------
*       Program forces an image exit for a specified process by $FORCEX
*       system service or program deletes a specified process by $DELPRC 
*       system service.
*       It asks the user to supply the PID of the process. 
*       The program must be INSTALLED with WORLD and OPER privileges .
*
*	WORLD is needed to examine and delete other process.
*	OPER  is needed to send a message to a terminal that is killed
*
*-----------------------------------------------------------------------
        implicit integer (a-z)
*
*	 	define externally the error messages
*
	external msg_nosame,msg_nothex,msg_noauth,msg_notuic
        character*3 all_access(4)  /'001','002','105','110'/
        character*3 sel_group(1)   /'310'/
        character*3 sel_member(1)  /'000'/
        character*3 no_access_min  /'200'/
        character*3 no_access_max  /'700'/
        integer all_grp(4), sel_grp(1), sel_mem(1), min_no_access, 
     1          max_no_access
        integer itmlst(23)
	logical force,silent
        character command*256, imagname*128, prcnam*15, terminal*7,
     1            username*12, uic*9, account*20,imag*128
* 
       include '($jpidef)'
*
*		convert octal uic to decimal
*
        call ots$cvt_to_l(%descr(no_access_min),%ref(min_no_access))
        call ots$cvt_to_l(%descr(no_access_max),%ref(max_no_access))
	do idx = 1,1
        call ots$cvt_to_l(%descr(sel_group(idx)),%ref(sel_grp(idx)))
        call ots$cvt_to_l(%descr(sel_member(idx)),%ref(sel_mem(idx)))
	end do
	do idx = 1,4
        call ots$cvt_to_l(%descr(all_access(idx)),%ref(all_grp(idx)))
	end do
*
*		See if there is a PID waiting
	l = 0
	if (cli$present('p1').and.1) then
	   call cli$get_value('p1',command)
	   call str$trim(command,command,l)
	end if
*
*		check force or stopid qualifiers
*
	if (cli$present('STOPID').and.1) then
		force = .false.
	else
		force = .true.
	endif
*
*	check for silent qualifier
*
	if (cli$present('SILENT').and.1) then
		silent = .true.
	else
		silent = .false.
	endif
*
*               Set up item list for $GETJPI
*
        itmlst(1) = jpi$_grp *2**16 + 4
        itmlst(2) = %loc(grp)
        itmlst(3) = 0
        itmlst(4) = jpi$_mem *2**16 + 4
        itmlst(5) = %loc(mem)
        itmlst(6) = 0
        itmlst(7) = jpi$_terminal *2**16 + len(terminal)
        itmlst(8) = %loc(terminal)
        itmlst(9) = %loc(l_terminal)
        itmlst(10) = jpi$_username *2**16 + len(username)
        itmlst(11) = %loc(username)
        itmlst(12) = %loc(l_username)
        itmlst(13) = jpi$_prcnam *2**16 + len(prcnam)
        itmlst(14) = %loc(prcnam)
        itmlst(15) = %loc(l_prcnam)
        itmlst(16) = jpi$_imagname *2**16 + len(imagname)
        itmlst(17) = %loc(imagname)
        itmlst(18) = %loc(l_imagname)
	itmlst(19) = jpi$_account *2**16 + len(account)
	itmlst(20) = %loc(account)
	itmlst(21) = %loc(l_account)
        itmlst(22) = 0
        itmlst(23) = 0
*
*               Get an event flag
*
        call lib$get_ef(ef)
*
*               Find UIC of current user
*
        ownpid = 0
        ier = sys$getjpi(%val(ef),ownpid,,itmlst,,,)
        if (ier.ne.1) call exit(ier)
        call sys$waitfr(%val(ef))
        owngrp = grp
        ownmem = mem
*
*		check authorization
*
        do idx = 1,1
           if (owngrp.eq.sel_grp(idx).and.ownmem.eq.sel_mem(idx)) 
     1     goto 19
        end do
	if (owngrp.ge.min_no_access.and.owngrp.le.max_no_access) then
	    call lib$signal(msg_noauth)
	    call exit
	endif
*
*               Get the PID of the process to be killed
*
19      continue
20      if (l.lt.1) call exit
        if (command(1:l).eq.' ') call exit
        read (command(1:l),'(Z20)',iostat=ios) pid
	if (ios .ne. 0) then
	    call lib$signal(msg_nothex)
	    call exit	
	endif
*
*               Get information about the process
*
        ier = sys$getjpi(%val(ef),pid,,itmlst,,,)
        call sys$waitfr(%val(ef))
        if (ier.ne.1) then
            call sys$getmsg(%val(ier),l,command,,)
	    if (index (command(1:l),'uspended') .ne. 0) then
		imagname(1:13) = '[a]Suspended '
		l_imagname = 13
	        goto 145
	    endif
            call lib$put_output(command(1:l))
            call exit
        end if
145     continue
*
*        check authorization
*
        do idx = 1,4
           if (owngrp.eq.all_grp(idx)) goto 55
        end do
        do idx = 1,1
           if (owngrp.eq.sel_grp(idx).and.ownmem.eq.sel_mem(idx))
     1     goto 55
        end do
*
*       check for own group
*
        if (.not.(grp.eq.owngrp .and. mem.eq.ownmem)) then
	    call lib$signal(msg_notuic)
            call exit
        end if
*
*       check for current process (the dummy)
*
55	continue
        if (pid.eq.ownpid) then
	   call lib$signal(msg_nosame) 
           call exit
        end if
*
*               Display process and ask for confirmation
*
	if (silent) goto 240
*
        write (uic,'(1H[,O3.3,1H,O3.3,1H])') grp,mem
*
	altpath = index(imagname,'>') + 1
	skipath = index(imagname,']') + 1
	if (altpath.gt.skipath) skipath = altpath
	if (skipath.lt.l_imagname) then
	   imag = imagname(skipath:l_imagname)
	   l_imag = l_imagname - skipath
	else
	   l_imag = l_imagename+1
	   imag = imagname(1:l_imagname)
	endif

*
	call lib$put_output(' ')
        call lib$put_output('- Process name: '//prcnam(1:l_prcnam))
        call lib$put_output('- User name:    '//username(1:l_username))
	call lib$put_output('- Department:   '//account(1:l_account))
        call lib$put_output('- UIC:          '//uic)
        call lib$put_output('- Terminal:     '//terminal(1:l_terminal))
        call lib$put_output('- Image:        '//imag(1:l_imag))
	call lib$put_output(' ')
*
	if (force) then
	    call lib$get_input(command,
     1			'Is this the correct process to force? ',l)
	else
	    call lib$get_input(command,
     1			'Is this the correct process to kill? ',l)
	endif
*
	if (command(1:1).ne.'y' .and. command(1:1).ne.'Y') then
	    call lib$put_output('KILL aborted')
	    call exit
	end if
*
240	continue
*
*               Send a message to the terminal (if
*               there is a terminal attached)

*
	if (force) then
           command = char(7)//'*** Process '//prcnam(1:l_prcnam)//', '//
     1            terminal(1:l_terminal)//' - Image forced by KILL ***\'
	else
           command = char(7)//'*** Process '//prcnam(1:l_prcnam)//', '//
     1            terminal(1:l_terminal)//' - Aborted by KILL ***\'
	end if
        l_command = index(command,'\') - 1
        if (.not.silent) call lib$put_output(command(1:l_command))
        if ((l_terminal.gt.0).and.(.not.silent)) then
          call sys$brdcst(command(1:l_command),terminal(1:l_terminal),,)
        end if
*
*               Attempt to delete or force the process
*
	if (force) then
	   ier = sys$setpri(pid,,%val(4),)
	   ier = sys$forcex( pid,,%val(44))
	else
*	   set the prio to 4 in case he is hung computable at a lower pri
	   ier = sys$setpri(pid,,%val(4),)
           ier = sys$delprc(pid,)
	endif
        if (.not.ier) call lib$signal(%val(ier))
*
        call exit
        end
