c******************************************************************************
c
c  Program: Menu
c  Author : Joseph P. Celia
c  Date   : Sept. 1985
c
c
c   Rev		Date             	Who	 	    Reason
c----------------------------------------------------------------------------- 
c   1.0       Pre-March 1985         Rand Hall           Initial Development 
c
c   2.0       Aug. 1985  	     Joseph P. Celia     Revised vers. 1.0
c
c   2.1       Sept. 1985             Regis McEwen        Get_User_count
c
c   2.2       Oct. 1985		     Joseph P. Celia     Maintenance Subroutine
c
c   2.3       Nov. 1985              Regis McEwen 	 Changed Password to
c							 Noecho
c   2.4.2     Nov. 19,1985           Joseph P. Celia     Text change in Maint.
c							 Subroutine
c   2.4.2     Nov. 19,1985	     Joseph P. Celia     Integer change in 
c						 	 Maint. Subroutine
c   2.5	      Nov. 26,1985	     Joseph P. Celia     Setting Password
c
c   2.5.1     Sept. 1986	     Fred Bassett	 Scrolling
c   
c  Menu Driver:
c              
c******************************************************************************
c
c

	Program menu

	implicit	none
	include		'($clidef)'
	include		'($iodef)'
	include		'($smgdef)'
	include		'($ssdef)'
	include		'($trmdef)'
	include		'($strdef)'
	include		'($jpidef)'

	integer*4	lib$spawn,status,mask,smg$create_pasteboard,
	1		smg$create_virtual_display,smg$paste_virtual_display,
	2		lib$signal,pbid,vdid,rows,cols,smg$label_border,
	3		smg$put_line,i,smg$home_cursor,advance1,
	4		smg$set_cursor_abs,smg$set_cursor_rel,modifiers,
	5		smg$create_virtual_keyboard,smg$read_string,
	6		kid,vdid_directions,smg$erase_display,str$upcase
	integer*4	smg$read_from_display,smg$change_rendition,smg$change_virtual_display
	integer*4	lib$getjpi,smg$delete_virtual_display,smg$delete_pasteboard
	integer*4	smg$put_with_scroll,smg$set_display_scroll_region
        integer*4       ci,smg$scroll_display_area
	integer*2	term,proc_vta_lth,proc_length
	integer		column,row,x,z,total_users,get_user_count,snoopy_lth
        integer         user_num,proc_num,user_count,cr,cc
	character	command*255,buff*76,choice*19,file_name*36,proc_name*15
	character	at_sign,snoopy*8,proc_vta*12,subprc*5,passwordrtn*6,cp
	character       proc_count,current_pas*6,pr*6,com_dir*15
	parameter	smg$m_border = 1
	parameter	smg$k_trm_cr = 13
	parameter	smg$k_trm_enter = 270
	parameter	smg$k_trm_ctrlp = 16
	parameter	smg$k_trm_ctrle = 5
	parameter	smg$k_trm_up = 274                    
	parameter	smg$k_trm_down = 275
	parameter	smg$k_trm_right = 277                          
	parameter	smg$k_trm_left = 276
	parameter	smg$m_down = 2
	parameter	smg$m_up = 1
	parameter	sb = 6
	parameter	se = 23
 
	structure /line_76/
	 character*19 option(4)
	end structure
	record /line_76/ menu_line(50)

c
c
c
c   
c******************************************************************************
c
c       Program Menu: Calls Function get_user_count() which in turn
c       returns the number of users on the system to the variable
c       total_users.
c******************************************************************************
c

	total_users=get_user_count()
c
c
c******************************************************************************
c
c	Program Menu: Open file menu_com.dat, which contains all the names of
c	the .com files. All names in menu_opt.dat have to be 18 characters long
c	or less. But 18 spaces must be filled. 
c
                            
     	open(unit=1,file='menu$options_file',readonly,
     *  status='old',err=999)

	open(unit=2,file='menu$prc_count_file',readonly,
     *  status='old',err=999)

	open(unit=3,file='menu$passwords_file',readonly,
     *  status='old',err=999)

c
c
c******************************************************************************
c
c	Program Menu: Calls subroutine user_check to compare number of 
c	interactive users:(total_users), against the maximum number of alotted
c	users:(user_num). If to many users are logged on, a message shall appear
c	then go to exit routines.
c
	read(2,*,err=999)user_count
	read(3,10,err=999)current_pas

10	format(a6)
	call user_check(total_users,user_count,user_num)

        if (user_num.eq.1)goto 500

150	status=smg$create_pasteboard(pbid,'sys$output',rows,cols)
	if (.not.status) call lib$signal(%val(status))

	status=smg$create_virtual_display(18,76,vdid,smg$m_border,,)
	if (.not.status) call lib$signal(%val(status))

	status=smg$set_display_scroll_region(vdid,1,18)
	if (.not.status) call lib$signal(%val(status))

	status=smg$create_virtual_display(3,76,vdid_directions,smg$m_border,,)
	if (.not.status) call lib$signal(%val(status))

	status=smg$label_border(vdid_directions,'MENU')
	if (.not.status) call lib$signal(%val(status))

	status=smg$paste_virtual_display(vdid_directions,pbid,2,2)
	if (.not.status) call lib$signal(%val(status))
                                                   
	status=smg$paste_virtual_display(vdid,pbid,6,2)
	if (.not.status) call lib$signal(%val(status))

c
c******************************************************************************
c
c	Program Menu: Reading file menu_opt.dat into an array. Variable name 
c	menu_line(x).option(z) comprises of a 50 by 4 array to hold the names
c	of the options.

	column = 50
	row    = 4
	cc    = 1
	do  x = 1,column
	       	do  z = 1,row
		   read(1,15,end=24)menu_line(x).option(z)
15		   format(a19)
		enddo
	enddo


24	advance1=1                                         
	status=smg$set_cursor_abs(vdid_directions,2,1)
	status=smg$put_line(vdid_directions,
	1		    ' Use the arrow keys to select an option,',
	2		    advance1)
	status=smg$put_line(vdid_directions,
	1		    ' press RETURN to start play.',)

	status=smg$set_cursor_abs(vdid,1,1)
	if (.not.status) call lib$signal(%val(status))

	do i=1,18
	buff=menu_line(i).option(1)//menu_line(i).option(2)//
	1menu_line(i).option(3)//menu_line(i).option(4) 
	status=smg$put_line(vdid,buff,advance1,,0)
	if (.not.status) call lib$signal(%val(status))
	enddo

	status=smg$set_cursor_abs(vdid,1,1)
	if (.not.status) call lib$signal(%val(status))

	status=smg$change_rendition(vdid,1,1,1,19,,1)
	if (.not.status) call lib$signal(%val(status))

	rows=1                                            
	cols=1

	status=smg$create_virtual_keyboard(kid)
	if (.not.status) call lib$signal(%val(status))

	modifiers=trm$m_tm_escape.or.trm$m_tm_noecho.or.trm$m_tm_purge

	status=smg$read_string(kid,choice,,6,modifiers,60,,,term)

	do while((status).and.((term.ne.smg$k_trm_cr).and.(term.ne.smg$k_trm_enter)))

        if (term.eq.smg$k_trm_ctrle) then 
	   call exit(status) 
	end if
 	
        if (term.eq.smg$k_trm_ctrlp) then
	status=smg$set_cursor_abs(vdid_directions,4,10)
c	if (.not.status) call lib$signal(%val(status))
	status=smg$erase_display(vdid_directions)
	status=smg$read_string(kid,passwordrtn,'|Password>',,io$m_noecho)
!	status=str$upcase(pr,passwordrtn)
          if (passwordrtn.eq.current_pas) then
c
c   call statement to maint. subroutine
c
		call control(user_count,vdid_directions,kid,current_pas)
		
	   else
		status=smg$set_cursor_abs(vdid_directions,4,4)
 	        status=smg$put_line(vdid_directions,'Invalid Password',
	1             advance1)
	
	  endif
	endif           

	  if (term.eq.smg$k_trm_up) then             
	  	if (rows.ne.1) then 
	           status=smg$change_rendition(vdid,cc,cols,1,19,,0)
	           rows=rows-1                   
	  	   if (cc.eq.1) then 
		     buff=menu_line(rows).option(1)//menu_line(rows).option(2)//
	1	     menu_line(rows).option(3)//menu_line(rows).option(4)
		     status=smg$scroll_display_area(vdid,1,,,,smg$m_down,1)
		     status=smg$set_cursor_abs(vdid,1,1)
		     status=smg$put_line(vdid,buff,,,0)
		     status=smg$set_cursor_abs(vdid,cc,cols)
		     status=smg$set_cursor_rel(vdid,-1,0)
c		     status=smg$put_with_scroll(vdid,buff,smg$m_down,,0)
		   else
		     status=smg$set_cursor_rel(vdid,-1,0)
		     cc=cc-1 
		   end if
  	           status=smg$change_rendition(vdid,cc,cols,1,19,,1)
		end if
	  else if (term.eq.smg$k_trm_down) then
	  	if (rows.ne.50) then 
	           status=smg$change_rendition(vdid,cc,cols,1,19,,0)
	           rows=rows+1
	  	   if (cc.eq.18) then 
		     buff=menu_line(rows).option(1)//menu_line(rows).option(2)//
	1	     menu_line(rows).option(3)//menu_line(rows).option(4)
		     status=smg$scroll_display_area(vdid,18,,,,smg$m_up,1)
		     status=smg$set_cursor_abs(vdid,18,1)
		     status=smg$put_line(vdid,buff,,,0)
		     status=smg$set_cursor_abs(vdid,cc,cols)
c		     status=smg$put_with_scroll(vdid,buff,smg$m_up,,0)
		   else
    	             status=smg$set_cursor_rel(vdid,1,0)
		     cc=cc+1 
	           end if
	           status=smg$change_rendition(vdid,cc,cols,1,19,,1)
	         end if
	  else if (term.eq.smg$k_trm_left) then
		    if (cols.ge.20) then
		      status=smg$change_rendition(vdid,cc,cols,1,19,,0)
	  	      status=smg$set_cursor_rel(vdid,0,-19)
	    	      cols=cols-19
	    	      status=smg$change_rendition(vdid,cc,cols,1,19,,1)
	    	    end if
	  else if (term.eq.smg$k_trm_right) then
		    if (cols.lt.58) then
		      status=smg$change_rendition(vdid,cc,cols,1,19,,0)
	  	      status=smg$set_cursor_rel(vdid,0,19)
	    	      cols=cols+19
	    	      status=smg$change_rendition(vdid,cc,cols,1,19,,1)
	    	    end if
	  end if
	  status=smg$read_string(kid,choice,,6,modifiers,60,,,term)

	enddo
                     
	if ((term.eq.smg$k_trm_cr).or.(term.eq.smg$k_trm_enter)) then
	  status=smg$read_from_display(vdid,choice)
	  if (.not.status) call lib$signal(%val(status))
	  status=smg$erase_display(vdid_directions)
	  if (.not.status) call lib$signal(%val(status))
	  status=smg$put_line(vdid_directions,choice)
	  if (.not.status) call lib$signal(%val(status))
	endif
	if(choice.eq.'                   ') goto 500
	at_sign='@'
	com_dir='appl$root:[com]'
	subprc='MENU$'
        proc_num=0
	proc_name=subprc//proc_vta(1:proc_vta_lth)
	proc_length=len(proc_name)
	file_name= at_sign//com_dir//choice 
	mask=cli$m_noclisym.or.cli$m_nokeypad
	status=lib$spawn(file_name,,,mask,proc_name(1:proc_length))     
	
	do while(status.ne.1)
	if (status .ne. ss$_duplnam) call exit
	proc_num=proc_num+1
	proc_count=char(proc_num+48)
	proc_name=subprc//proc_vta(1:proc_vta_lth)//'_'//proc_count
	proc_length=len(proc_name)
	if (proc_length .gt. 15) then
		proc_name=subprc//proc_vta(1:8)//'_'//proc_count
		proc_length=len(proc_name)
	endif
	status=lib$spawn(file_name,,,mask,proc_name(1:proc_length))
	enddo

        status=smg$delete_virtual_display(vdid)
	status=smg$delete_pasteboard(pbid)

	status=smg$read_string(kid,cp,' Enter "Y" to select another option:')
        if (cp.eq.'y'.or.cp.eq.'Y') rewind 1
	if (cp.eq.'y'.or.cp.eq.'Y') goto 150
	call exit(status)
500     close (unit=1)
c	close (unit=2)
c	close(unit=3)
	call exit
999	close (unit=1)
	close (unit=2)
	close(unit=3)
	type*,'Error openning data.  Please notify system manager'
	end
