$ !
$ !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$ !
$ !	autodial.com
$ !
$ !	Connect to autodial (and dial) modem on a Vax port
$ !
$ !	This procedure expects system logicals to be defined with the
$ !	value of the ports that have modems on them.
$ !	Logical names:		modem_1
$ !				modem_2
$ !				modem_3
$ !	This procedure checks for system logicals to be defined with the
$ !	value of the speed (baud) that the modems should run.
$ !	If logical is not defined a default of 1200 baud will be used.
$ !	Logical names:		modem_1_speed
$ !				modem_2_speed
$ !				modem_3_speed
$ !	This procedure checks for system logicals to be defined with the
$ !	value of the modem type on the port.
$ !	If logical is not defined a default of df03 will be used.
$ !	Logical names:		modem_1_type
$ !				modem_2_type
$ !				modem_3_type
$ !	This procedure checks for a file to be defined with the
$ !	name as the one for the df03 - sys$library:dte_df03.exe
$ !	or df112 - sys$library:dte_df112.exe
$ !	If no file is found the /dial qualifier will not be used.
$ !
$ !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$ !
$	set output_rate=0:1:00
$	on control_y then goto exit
$	on error then goto exit
$	who = "Unknown"
$	priv = "''f$getjpi("","curpriv")'"
$	priv = "''f$edit(priv,"trim")'"
$	count = 0
$ 	if "''f$trnlnm("modem_1")'" .eqs. "" then goto skip_over
$ 	if "''f$getdvi(f$trnlnm("modem_1"),"all")'" .eqs. "FALSE" then use_port = "''f$trnlnm("modem_1")'"
$ 	if "''f$getdvi(f$trnlnm("modem_1"),"all")'" .eqs. "FALSE" then use_modem = "modem_1"
$ 	if "''f$getdvi(f$trnlnm("modem_1"),"all")'" .eqs. "FALSE" then goto get_speed
$	count = count + 1
$	if "''f$locate("WORLD",priv)'" .nes. "''f$length(priv)'" then  -
		who = "''f$edit(f$getjpi(f$getdvi("modem_1","pid"),"username"),"trim")'"
$ 	if "''f$trnlnm("modem_2")'" .eqs. "" then goto skip_over
$ 	if "''f$getdvi(f$trnlnm("modem_2"),"all")'" .eqs. "FALSE" then use_port = "''f$trnlnm("modem_2")'"
$ 	if "''f$getdvi(f$trnlnm("modem_2"),"all")'" .eqs. "FALSE" then use_modem = "modem_2"
$ 	if "''f$getdvi(f$trnlnm("modem_2"),"all")'" .eqs. "FALSE" then goto get_speed
$	count = count + 1
$	if "''f$locate("WORLD",priv)'" .nes. "''f$length(priv)'" then  -
		who = "''who',''f$edit(f$getjpi(f$getdvi("modem_2","pid"),"username"),"trim")'"
$ 	if "''f$trnlnm("modem_3")'" .eqs. "" then goto skip_over
$ 	if "''f$getdvi(f$trnlnm("modem_3"),"all")'" .eqs. "FALSE" then use_port = "''f$trnlnm("modem_3")'"
$ 	if "''f$getdvi(f$trnlnm("modem_2"),"all")'" .eqs. "FALSE" then use_modem = "modem_3"
$ 	if "''f$getdvi(f$trnlnm("modem_3"),"all")'" .eqs. "FALSE" then goto get_speed
$	count = count + 1
$	if "''f$locate("WORLD",priv)'" .nes. "''f$length(priv)'" then  -
		who = "''who',''f$edit(f$getjpi(f$getdvi("modem_3","pid"),"username"),"trim")'"
$ skip_over:
$ 	write sys$output ""
$ 	write sys$output "All ''count' autodial modems are currently in use"
$ 	write sys$output "by user(s) ''who' or are unavailable,"
$ 	write sys$output "Please try again later..."
$	goto exit                                            
$ get_speed:
$	speed_symbol = "''use_modem'_speed"
$	if "''f$trnlnm(speed_symbol)'" .eqs. "" then use_speed = 1200
$	if "''f$type(use_speed)'" .nes. "INTEGER" then use_speed = f$trnlnm(speed_symbol)
$	set message/nofacility/noident/noseverity/notext
$	set term/speed='use_speed' 'use_port'
$	alloc 'use_port'
$	on control_y then goto deallocate
$	on error then goto error
$	set message/facility/ident/severity/text
$ get_type:                      
$	type_symbol = "''use_modem'_type"
$	if "''f$trnlnm(type_symbol)'" .eqs. "" then use_type = "df03"
$	if "''f$type(use_type)'" .eqs. "" then use_type = "''f$trnlnm(type_symbol)'"
$ get_pgm:                      
$	use_pgm = "N"
$	pgm_symbol = "sys$library:dte_''use_type'.exe"
$	if "''f$search(pgm_symbol)'" .nes. "" then use_pgm = "Y"
$	if "''use_pgm'" .eqs. "Y" then write sys$output " "
$	if "''use_pgm'" .eqs. "Y" then write sys$output "A program exists for the ''use_type' modem type,"
$ 	if "''use_pgm'" .eqs. "Y" then inquire/nopunctuation use_pgm "Do you want to use it (Y/N, default=Y, exit=exit)? "
$	if "''use_pgm'" .eqs. "EXIT" then goto deallocate
$	if "''use_pgm'" .nes. "N" then use_pgm = "Y"
$ get_log:
$	write sys$output " "
$ 	write sys$output "Do you want the session logged to a file"
$ 	inquire/nopunctuation do_log "(Y/N, default=Y with a file name of modem.log, exit=exit)? "
$	if "''do_log'" .eqs. "EXIT" then goto deallocate
$	if "''do_log'" .eqs. "" then log_name = "modem.log"
$	if "''do_log'" .eqs. "" then do_log = "Y"
$	if "''do_log'" .eqs. "N" then param_log = "/nolog"
$	if "''do_log'" .eqs. "N" then goto get_number
$	if "''f$type(log_name)'" .nes. "" then param_log = "/log=''log_name'"
$	if "''f$type(param_log)'" .nes. "" then goto get_number
$	write sys$output " "
$ 	inquire/nopunctuation log_name "Enter filename.ext for session log (default=modem.log, exit=exit): "
$	if "''log_name'" .eqs. "EXIT" then goto deallocate
$	if "''log_name'" .eqs. "" then log_name = "modem.log"
$	param_log = "/log=''log_name'"
$ get_number:
$	write sys$output " "
$	if "''use_pgm'" .eqs. "Y" then -
 	write sys$output "Enter the phone number to dial, keyword,"
$	if "''use_pgm'" .eqs. "Y" then -
 	inquire/nopunctuation phone_number "or HELP for help, (nodefault, exit=exit): "
$	if "''use_pgm'" .eqs. "Y" .and. "''phone_number'" .eqs. "EXIT" then goto deallocate
$	if "''use_pgm'" .eqs. "Y" .and. "''phone_number'" .eqs. "" then goto get_number
$	if "''use_pgm'" .eqs. "Y" .and. "''phone_number'" .eqs. "HELP" then help_return = "get_number"
$	if "''use_pgm'" .eqs. "Y" .and. "''phone_number'" .eqs. "HELP" then goto help
$	if "''use_pgm'" .eqs. "Y" .and. "''phone_number'" .eqs. "STORE" then phone_number = "18003323366"
$	if "''use_pgm'" .eqs. "Y" .and. "''phone_number'" .eqs. "SIN" then phone_number = "13035901600"
$	if "''use_pgm'" .eqs. "Y" .and. "''f$type(phone_number)'" .nes. "INTEGER" then goto get_number
$	if "''use_pgm'" .eqs. "Y" then param_dial = "/dial=(number:''phone_number',modem_type=''use_type')" 
$	if "''use_pgm'" .eqs. "N" then param_dial = ""
$	if "''use_pgm'" .eqs. "N" then help_return = "connect"
$	if "''use_pgm'" .eqs. "N" then goto help
$ connect:
$	if "''use_pgm'" .eqs. "N" then -
	write sys$output " "
$	if "''use_pgm'" .eqs. "N" then -
	write sys$output "Please type <ctrl>B phonenumber <ret>"
$	if "''use_pgm'" .eqs. "Y" then -
	write sys$output "Dialing phone number ''phone_number'"
$	assign/user sys$command sys$input
$	set host/dte'param_log''param_dial' 'use_port'
$	goto deallocate                                          
$ help:
$	write sys$output " "
$	write sys$output "Examples to specify the phone number:"
$	if "''use_pgm'" .eqs. "Y" then -
		write sys$output "Local number				:	9922141"
$	if "''use_pgm'" .eqs. "Y" then -
		write sys$output "Long distance, same area code		:	19922141"
$	if "''use_pgm'" .eqs. "Y" then -
		write sys$output "Long distance, different area code	:	12099922141"
$	if "''use_pgm'" .eqs. "Y" then -
		write sys$output " "
$	if "''use_pgm'" .eqs. "Y" then -
		write sys$output "Some commonly used phone numbers may be referenced by keyword:"
$	if "''use_pgm'" .eqs. "Y" then -
		write sys$output "Dec store 1-(800)332-3366, keyword is		STORE"
$	if "''use_pgm'" .eqs. "Y" then -
		write sys$output "Dec sin 1-(303)590-1600, keyword is		SIN"
$	if "''use_pgm'" .eqs. "N" then -
		write sys$output "Local number				:	<ctrl>B9922141<ret>"
$	if "''use_pgm'" .eqs. "N" then -
		write sys$output "Long distance, same area code		:	<ctrl>B19922141<ret>"
$	if "''use_pgm'" .eqs. "N" then -
		write sys$output "Long distance, different area code	:	<ctrl>B12099922141<ret>"
$	goto 'help_return'
$ error:
$	write sys$output " "
$	write sys$output "Error has occured..."
$!
$ deallocate:
$	deallocate 'use_port'
$ exit:
$	exit
