$!
$ define/system news$dir sys$sysdevice:[news]
$ set default news$dir
$!
$!     check to see if the required files are here
$!
$ if  f$search("NEWS.EXE").nes."" .and.-
      f$search("NEWSINIT.EXE").nes."" .and.-
      f$search("NEWSUPD.EXE").nes."" .and.-
      f$search("NEWSDIS.EXE").nes."" .and.-
      f$search("NEWSUSERS.FDL").nes."" .and.-
      f$search("NEWSTEXT.FDL").nes."" then goto okins
$!
$     Type SYS$INPUT

        ERROR:  The following files must be in this directory (NEWS$DIR) for
                This installation to run.

        NEWS.EXE      NEWSINIT.EXE    NEWSUPD.EXE  NEWSDIS.EXE
        NEWSTEXT.FDL  NEWSUSERS.FDL
$!
$ exit
$ okins:
$ set prot=(g,w) news$dir:*.exe
$ set prot=w:re news$dir:news.exe
$!
$!
$ WRITE SYS$OUTPUT "Installing NEWS.CLD"
$!
$ SET COMMAND/TABLES=SYS$LIBRARY:DCLTABLES.EXE-
   /OUTPUT=SYS$LIBRARY:DCLTABLES.EXE-
   SYS$INPUT
!
!                         management program to disable specific users
!                         from news
!
define syntax dis_syntax
	image NEWS$DIR:newsdis
!
!                         Management program to add, remove, and replace
!                         news items
!
define syntax mod_syntax
	image NEWS$DIR:newsupd
!
!                        Management program to initialize the news system
!                        (This program requires NEWSUSERS.FDL and NEWSTEXT.FDL)
!
!
define syntax init_syntax
	image NEWS$DIR:newsinit

define verb news
!
!
!                         General news program run by users
!
	image NEWS$DIR:news

	parameter p1,		label=itemnum

	qualifier all
	qualifier brief
	qualifier full, default
	qualifier init, syntax=init_syntax
	qualifier login
	qualifier unseen
	qualifier disable, syntax=dis_syntax,
                     value(required),
                     placement=positional
	qualifier add, syntax=mod_syntax,
		     placement=positional
	qualifier delete,
		     syntax=mod_syntax, 
                     placement=positional
	qualifier update,
                     syntax=mod_syntax, 
                     value(required),
                     placement=positional
	qualifier extract, 
                     syntax=mod_syntax,
                     value(required),
                     placement=positional
$!
$!
$ RUN SYS$SYSTEM:INSTALL
SYS$LIBRARY:DCLTABLES.EXE/REPLACE
NEWS$DIR:NEWS.EXE/PRIV=(SYSLCK,SYSPRV)/OPEN/SHARE
$!
$ write sys$output "initializing news files (answer "Y")
$!
$ define/user sys$input sys$command
$ RUN newsinit
$ SET NOON
$ WRITE SYS$OUTPUT "Installing news help entry"
$!
$ LIB/HELP	SYS$HELP:HELPLIB.HLB SYS$INPUT
1 NEWS
 NEWS is a message facility  which informs  a user of  current  system
 news and  information.    At login  time, each  user is automatically
 shown a list of new items that have been entered since  the user last
 viewed the news.  Once a full read of the news has been executed, the
 login message is removed.

 Format:

     $ NEWS [item_#]
2 Parameters
 You may specify the number of a single news item to be shown in FULL.
 A list of all item numbers can be obtained by entering: $ NEWS/ALL
2 Qualifiers
/ALL
 This qualifier causes NEWS to process all items in the news file,
 whether or not they have been previously viewed.
/BRIEF
 Causes NEWS to show only the topic line of each news item.
/FULL (D)
 When specified, the entire contents of each news item is displayed.
 This is the default and need not be specified.
/LOGIN
 Used by the system during login.  Forces an extra message to be printed
 explaining how unseen news items can be removed.
/UNSEEN (D)
 Causes those items which have not been viewed to be reported.
$!
$!
$ TYPE SYS$INPUT
 
                        Place the following lines in 
                         SYS$MANAGER:SYSTARTUP.COM

*               $ DEFINE/SYSTEM NEWS$DIR SYS$SYSDEVICE:[NEWS]
*               $ RUN SYS$SYSTEM:INSTALL
*               NEWS$DIR:NEWS.EXE/PRIV=(SYSLCK,SYSPRV)/OPEN/SHARE

                       Place the following line in
                         SYS$MANAGER:SYLOGIN.COM

*               $ if f$mode().nes."INTERACTIVE" then NEWS/LOGIN/BRIEF
*
                you can now use "NEWS/ADD" to add news messages
                Look at AAAREADME.TXT for management commands and
                (after you log out and back in to get the new
                 DCL tables)
