	program newsmaint

	external msg_bad_num, msg_aborted

	logical conv_int, cli$present, add
	character*10 itemno, filename*72
	integer*2 maxitem, item, get_textmax, error

	common /status/ error

	error = 1


*  Enqueue on the files and then open them

	call enqopen
	if (error .ne. 1) call lib$stop(msg_aborted)


*  Get maximum news item number

	maxitem = get_textmax()


	if (cli$present('ADD')) then

	    if (cli$present('ITEMNUM')) then
		call cli$get_value('itemnum',filename)
	    else
		call lib$get_input(filename,'$_Filename: ',)
	    end if

	    item = maxitem + 1
	    if (add(item,filename)) then
		call set_textmax(item)
	    else
		error = 0
	    end if


	else if (cli$present('DELETE')) then

	    if (cli$present('ITEMNUM')) then
		call cli$get_value('ITEMNUM',itemno)
	    else
		call lib$get_input(itemno,'$_Item number: ',)
	    end if

	    if (conv_int(itemno,item) .and. item .le. maxitem) then
		call delete(item)
	    else
		error = 0
		call lib$signal(msg_bad_num)
	    end if


	else if (cli$present('UPDATE')) then

	    if (cli$present('ITEMNUM')) then
		call cli$get_value('ITEMNUM',filename)
	    else
		call lib$get_input(filename,'$_Filename: ',)
	    end if

	    call cli$get_value('UPDATE',itemno)
	    if (conv_int(itemno,item) .and. item .le. maxitem) then
		call delete(item)
		call add(item,filename)
	    else
		error = 0
		call lib$signal(msg_bad_num)
	    end if


	else if (cli$present('EXTRACT')) then

	    if (cli$present('ITEMNUM')) then
		call cli$get_value('ITEMNUM',filename)
	    else
		call lib$get_input(filename,'$_Filename: ',)
	    end if

	    call cli$get_value('EXTRACT',itemno)
	    if (conv_int(itemno,item) .and. item .le. maxitem) then
		call extract(item,filename)
	    else
		error = 0
		call lib$signal(msg_bad_num)
	    end if

	else

	    print *,'Nothing to do!  Something is wierd!!'

	end if

	call closedeq
	if (error .ne. 1) call lib$stop(msg_aborted)

	end

	subroutine delete(number)

	external msg_deleted

	integer*2 number, key, lastnum
	integer error
	common /status/ error

	key = 0
	read (100,key=key) key, lastnum

	if (number .gt. lastnum .or. number .lt. 1)  goto 10010

	key = number
	read (100,key=key,err=10010) key

	do while (number .eq. key)
	    delete (100)
	    read (100) key
	end do

	return

10010	call lib$signal(msg_deleted)
	error = 0
	return

	end

	logical function add(number,filename)

	external msg_open_err,msg_recs_added
	integer*2 countkey, number
	integer count, error
	character*(*) filename, fullfile*72
	character*72 text, LFCHAR*2 

	common /status/ error

	parameter (LFCHAR=char(13)//char(10))

	open (unit=10, file=filename, status='old', err=10000)

	count = 0
	countkey = number


*  Write the whole file out to the news file.  Do a specific check for
*  RUNOFF files by looking for carriage return - line feed sequences and
*  replacing them with blanks.

	do while (1 .eq. 1)
	    read (10,20,end=1) text
	    loc_crlf = index(text,LFCHAR)
	    if (loc_crlf.ge.1) then
		text(loc_crlf:loc_crlf+1) = '  '
	    end if
	    write (100) countkey, text
	    count = count + 1
	end do

1	call lib$signal(msg_recs_added,%val(2),%val(count),
     1                  %val(number))
	add = .true.

	return

10000   inquire (file=filename,name=fullfile,err=10001)
10001	call lib$signal(msg_open_err,%val(2),
     1                 fullfile(1:lenc(fullfile)),'read')
	add = .false.
	error = 0
	return

20	format(a72)
	end


	subroutine extract(number,filename)

	integer*2 number, tmp_number
	character*(*) filename
	character*72 text, fullfile
	integer error

	common /status/ error

	
	read (100,err=100,key=number) tmp_number, text

	open (unit=10, file=filename, status='new', carriagecontrol='list',
     *        err=200)

	do while (tmp_number .eq. number)
	    write (10,20) text(1:lenc(text))
	    read (100) tmp_number, text
	end do

	close (unit=10)
	return

100	call lib$signal(msg_deleted)
	error = 0
	return

200     inquire (file=filename,name=fullfile,err=201)
201	call lib$signal(msg_open_err,%val(2),
     1                 fullfile(1:max(lenc(fullfile),1)),'write')
	error = 0
	return

20	format (a<lenc(text)>)
	end


	subroutine enqopen

	parameter NEWSUSERS = 'NEWS$DIR:NEWSUSERS'
	parameter NEWSTEXT  = 'NEWS$DIR:NEWSTEXT'
	parameter RESOURCE  = 'RIT_NEWSUSERS_LCK'

	include 'lckdef.inc'

	integer error

	common /status/ error
	common /lock/ lksb(2)

	call sys$enqw(,%val(LCK$K_EXMODE),lksb,%val(LCK$M_SYSTEM),
     *                RESOURCE,,,,,,)

	open (unit=100, file=NEWSTEXT, status='old',
     *        form='unformatted', access='keyed', recordtype='variable',
     *        carriagecontrol='none', organization='indexed', err=10000)

	open (unit=101, file=NEWSUSERS, status='old', form='formatted',
     *        access='keyed',key=(1:12:character),recordtype='variable',
     *        carriagecontrol='none', organization='indexed', err=10000)

	return

10000	error = 0
	return

	end


	subroutine closedeq

	integer error

	common /lock/ lksb(2)
	common /status/ error

	close (unit=100)
	close (unit=101)

	call sys$deq(%val(lksb(2)),,,)

	return
	end


	logical function conv_int(char,int)

	character*(*) char
	integer*2 int

	conv_int = .FALSE.
	read (char,10,err=1000) int
10	format (i<lenc(char)>)
	if (int .gt. 0 .and. int .lt. 9999) conv_int = .TRUE.

1000	return
	end


	integer function lenc(string)

*******************************************************************************
*
*  This routine returns the REAL (not FORTRAN REAL either!) length of a
*  character string, not including trailing blanks.
*
*******************************************************************************

	character*(*) string

	lenc = len(string)
	do while (string(lenc:lenc) .eq. ' ' .and. lenc .gt. 1)
	    lenc = lenc - 1
	end do

	return

	end


	integer function get_textmax()

	integer*2 key, lastnum
	integer error

	common /status/ error

	key = 0
	read (100,key=key) key, lastnum

	get_textmax = lastnum

	return
	end

	subroutine set_textmax(number)

	integer*2 number, dummyint, key
	integer error
	character*12 textmax_key /'DEFAULT'/, dummy

	common /status/ error

*  Write the record to the NEWSUSERS

	key = 0
	read (100,key=key) key
	delete(100)
	write (100) key, number


*  Write or rewrite the record in USERS file since 2 could exist

	read (101,10,err=1,key=textmax_key)dummy,dummyint

	rewrite (101,10) textmax_key, number
	return

1	write (101,10) textmax_key, number

	return
10	format (a12,i4)
	end
