C+
C  Display_Users
C
C	Subroutine to display all current users in the VAX account
C	file.  No check is made as to whether or not the users can
C	receive mail (ie they have adequate disk quota) or that the
C	'user' is not a phantom account present to let accounting work
C	more smoothly.  If the account file can not be opened, Ier=-1
C	is returned.  Otherwise, Ier=0
C
C		CALL Display_Users(Ier)
C-
	SUBROUTINE Display_Users(Ier)
	CHARACTER*12	Cname			! User name
	CHARACTER*80	Outline			! Output line
	CHARACTER*256	CSTRING			! Data buffer
	INTEGER*2	Igrp(2),Imem(2)		! Group, member of uic
	INTEGER*4	Igroup,Imember		! Group, member of UIC
	EQUIVALENCE	(Igroup,Igrp(1))	! make equivalent
	EQUIVALENCE	(Imember,Imem(1))	!
C
C .. Implied FORM='UNFORMATTED'
C
	OPEN(UNIT=1,				! Open the System Account
     -		     NAME='SYS$SYSTEM:SYSUAF.DAT',! file
     -		     STATUS='OLD',		! It must exit
     -		     READONLY,			! we can only read it
     -		     SHARED,			!   as a shared file
     -		     ORGANIZATION='INDEXED',	! It is indexed with
     -		     RECORDTYPE='VARIABLE',	!  variable length records
     -		     ACCESS='KEYED',		!  access it by keys
     -		     KEY=(1:12:CHARACTER),	! First key is user name
     -		     ERR=9900)			! In case we can't open file
	Idx=1					!
	Outline=' '				! Fill line with blanks
10	READ(UNIT=1,END=9020)CSTRING		! Read till end of file
 	Ipos=INDEX(CSTRING(1:12),'NETPRIV')	! Skip DECNET
 	IF(Ipos.GT.0)			GOTO 10	!   "    "
 	Ipos=INDEX(Cstring(1:12),'NETNONPRIV')	!   "    "
	IF(Ipos.GT.0)			GOTO 10	!   "    "
	Igrp(1)=ICHAR(CSTRING(31:31))		!
	Igrp(2)=ICHAR(CSTRING(32:32))		!
	IF(Igroup.LE.10)		GOTO 10	! No display if system
	Imem(1)=ICHAR(CSTRING(29:29))		!
	Imem(2)=ICHAR(CSTRING(30:30))		!
	Iptr=1+(Idx-1)*15			!
	Outline(Iptr:Iptr+12)=CString(1:12)	!
	IF(Idx.EQ.5)			THEN	!
	   WRITE(*,30)OUTLINE			!
30	   FORMAT(' 'A)				!
	   Outline=' '				!
	   Idx=0				!
	END IF					!
	Idx=Idx+1				!
	GOTO 10					!
9020	IF(Idx.GT.1) WRITE(*,30)Outline		!
	CLOSE(UNIT=1)				! Always close file
	Ier=0					! Show success
	RETURN					!
9900	Ier=-1					! Fatal, can't open acnt file
	RETURN					!
	END					!

