$ ! SET VERIFY
$ !--------------------------------------------------------------------------
$ !
$ !	    S Y S _ U T I L I T Y : W A T C H D O G . C O M
$ !
$ !	Purpose:
$ ! 		Start Watchdog Program Detached
$ !
$ !	Original:	unknown
$ !	Modification:
$ !		Add Documentation,Correct Spacing and Rewrote
$ !				04/08/85	G. H. Walrod III
$ !
$ !--------------------------------------------------------------------------
$ !
$ !	Check Privileges
$ !
$ required_privileges = "WORLD,OPER,DETACH,PSWAPM"
$ previous_privileges = F$SETPRV(required_privileges)
$ IF .NOT. F$PRIVILEGE(required_privileges) THEN $goto no_privileges
$ !
$ !	Start WATCHDOG as a Detach Process
$ !
$ RUN	SYS$SYSTEM:WATCHDOG 		-
	/UIC=[1,4]			-
	/NOSWAP				-
	/PRIVILEGES=(WORLD,OPER)	-
	/ERROR=_OPA0:			-
	/PRIORITY=4
$ GOTO NORMAL_EXIT
$ !
$ !	No Privileges To Start WATCHDOG
$ !
$NO_PRIVILEGES:
$ WRITE SYS$OUTPUT "Insufficient privileges to start Watchdog"
$ WRITE SYS$OUTPUT "Requires ",REQUIRED_PRIVILEGES," privileges."
$ !
$ !	Reinstate Previous Privileges on Any Type of Exit
$ !
$NORMAL_EXIT:
$ previous_privileges = F$SETPRV(previous_privileges)
$ EXIT
