	PROGRAM PWD
C++
C
C Title:
C	PWD.FOR - Save/restore a users password.
C
C Version:
C	1.0
C
C Facility:
C	System management.
C
C Abstract:
C	This program saves and/or restored the hashed password of
C	a user. This might be useful if you wish to "move" a users
C	account to another machine (UAF), or use that users account
C	without having to know the password.
C
C Environment:
C	Required access to SYSUAF.DAT.
C
C Author:
C	Mark Oakley	Battelle Memorial Institute	29-Jul-1987
C
C Modified:
C	
C
C--

	INCLUDE		'($SYSSRVNAM)/NOLIST'	! Get the system service defs.
	INCLUDE		'($UAIDEF)/NOLIST'	! For SYS$GETUAI, SYS$SETUAI.

	STRUCTURE	/ITEM_LIST_3/		! 3-longword item list for 
		UNION				! calls to SYS$GETUAI,
		  MAP				! SYS$SETUAI.
		    INTEGER*2	BUFF
		    INTEGER*2	CODE
		    INTEGER*4	ADDR
		    INTEGER*4	RETL
		    ENDMAP
		  MAP
		    INTEGER*4	TERM
		    ENDMAP
		  ENDUNION
		ENDSTRUCTURE

	RECORD		/ITEM_LIST_3/	UAI(2)

	INTEGER*4	STATUS			! Return status variables.
	INTEGER*4	IOSB(2)

	CHARACTER	USERNAME*12		! Username stored here.
	INTEGER*4	USERNAME_LEN		! Length goes here.
	CHARACTER	RESPONSE*1		! Answer to prompts.

	INTEGER*4	HPWD(2)			! Hashed password.

C
C  Init the item list.
C
	UAI(1).BUFF = 8
	UAI(1).CODE = UAI$_PWD
	UAI(1).ADDR = %LOC (HPWD)
	UAI(1).RETL = 0
	UAI(2).TERM = 0
C
C  See if we are doing a Save or Restore.
C
	WRITE (6, '(/, 1H$, A)') 
	2 'Do you wish to Save or Restore a password [Save]? '
	READ  (5, '(A1)') RESPONSE
	CALL STR$UPCASE (RESPONSE, RESPONSE)
	IF (RESPONSE .EQ. ' ') RESPONSE = 'S'

	IF (RESPONSE .EQ. 'S') THEN
C
C  We are doing a Save. Get the username.
C
		WRITE (6, '(/,1H$, A)') 'Enter the username: '
		READ  (5, '(A)') USERNAME
		CALL STR$TRIM (USERNAME, USERNAME, USERNAME_LEN)
C
C  Get the hashed password.
C
		STATUS = SYS$GETUAI ( , , USERNAME, UAI, , , )
		IF (.NOT. STATUS) CALL SYS$EXIT (%VAL (STATUS))
C
C  Save the password in a file.
C
		OPEN (UNIT=1, FILE=USERNAME//'.PWD', STATUS='NEW',
	2	      CARRIAGECONTROL='LIST')
		WRITE (1, '(Z8.8, 1X, Z8.8)') HPWD
		CLOSE (UNIT=1)
C
C  Let the user know what we did.
C
		WRITE (6, '(/, 1H , A, Z8.8, 1X, Z8.8, 2A, /)') 
	2	  'The hashed password ', HPWD, ', has been stored in ',
	3	  USERNAME(1:USERNAME_LEN)//'.PWD'

C
C  See if we should do a Restore.
C
	 ELSE IF (RESPONSE .EQ. 'R') THEN
C
C  We are doing a Restore. Get the username.
C
		WRITE (6, '(/,1H$, A)') 'Enter the username: '
		READ  (5, '(A)') USERNAME
		CALL STR$TRIM (USERNAME, USERNAME, USERNAME_LEN)
C
C  See if there is a file for this user.
C
		OPEN (UNIT=1, FILE=USERNAME//'.PWD', STATUS='OLD',
	2	      ERR=40)
		READ (1, '(Z8.8, 1X, Z8.8)') HPWD
		CLOSE (UNIT=1)
		GOTO 60
C
C  We did not find a file. Prompt the user for the hased password.
C
40		WRITE (6, '(/, 1H , A)')
	2	 'A hashed password file for this user was not found.'
		WRITE (6, '(1H$, A)')
	2	 'Do you wish to enter the hashed password? '
		READ  (5, '(A)') RESPONSE
		CALL STR$UPCASE (RESPONSE, RESPONSE)
		IF (RESPONSE .EQ. 'Y') THEN 
			WRITE (6, '(/, 1H$, A)') 
	2		 'Enter the first 8 hex digits: '
			READ  (5, '(Z8)') HPWD(1)
			WRITE (6, '(/, 1H$, A)') 
	2		 'Enter the last 8 hex digits: '
			READ  (5, '(Z8)') HPWD(2)
		  ELSE 
			GOTO 99
		  ENDIF
C
C  We have a hashed password for this user, so restore it.
C
60		STATUS = SYS$SETUAI ( , , USERNAME, UAI, , , )
		IF (.NOT. STATUS) CALL SYS$EXIT (%VAL (STATUS))
C
C  Let the user know.
C
		WRITE (6, '(/, 1H , A, /)')
	2	 'Password successfully restored.'
C
		ENDIF
C
99	CONTINUE
C
	END
