c READ_TAPE - read a tape, write a disk image file of it.
c
c Calling Sequence:
c	call read_tape (tape_name, file_name)
c
c Where:
c	tape_name - device name of tape drive
c	file_name - file specification string for disk file
c

	subroutine read_tape (tape_name, file_name)

	character*(*)	tape_name, file_name
	integer		mschan
	integer*4	prl (6)
	integer*2	iosb (4)
	integer		status
	character*80 	message
	integer*4	sys$qiow, sys$assign
	common		/buf/ buffer
	byte		buffer (32766)
	logical		end_of_tape, tape_mark
	include		'($iodef)'
	include		'($ssdef)'

c Open disk file for output 
	open (unit=1, name=file_name, type='new', form='unformatted', 
	1	access='sequential', recordsize=8191, recordtype='variable',
	2	initialsize=1000, extendsize=500)

c Assign a channel to the tape drive
	ids = sys$assign (tape_name, mschan, , )
	if (ids .ne. ss$_normal) then
		type *, 'TPC - directive error on assign: ids =', ids
		call sys$getmsg (%val (ids), , message, ,)
		type *, message
	end if

c Read tape blocks, write them to the disk file
	end_of_tape = .false.
	do while (.not. end_of_tape)

c Read tape record - handle errors
		ids = sys$qiow (, %val (mschan), %val (io$_readvblk), iosb, , ,
	1		buffer, %val (32766), , , , )
		if (ids .ne. ss$_normal) then
			type *, 'TPC - directive error on read: ids =', ids
			call sys$getmsg (%val (ids), , message, ,)
			type *, message
		end if
		if (iosb (1) .eq. ss$_normal) then
			tape_mark = .false.
		else if (iosb (1) .eq. ss$_endoffile) then
			type *, 'tape mark encountered'
			if (tape_mark) then
				end_of_tape = .true.
			end if
			tape_mark = .true.
		else if (iosb (1) .eq. ss$_endofvolume) then
			end_of_tape = .true.
		else if (iosb (1) .eq. ss$_endoftape) then
			end_of_tape = .true.
		else
			tape_mark = .false.
			type *, 'TPC - i/o error: iosb =', iosb
		end if

		write (1) (buffer (i), i = 1, iosb (2))
	end do

c close disk file
	close (unit=1)

	end
