	INTEGER*4 Function Lib_Assemble_LNMs(Table, Logs, Cnt)

C++
C Author:
c	Jonathan Welch		Creation Date:	8-Jun-1987 13:31
c
C Functional description:
c	Converts a stream of counted strings into an array of string
c	descriptors.
c
C Calling sequence:
c	Sts = Lib_Assemble_LNMs(Table, Logs, Cnt)
c
C Formal arguments:
c	Table
c	  VMS Usage : char_string
c	  type      : character string
c	  access    : read only
c	  mechanism : by descriptor
c
c	Name of logical name table to return all logical names from.
c	Allowed tables currently are LNM$PROCESS_TABLE and LNM$PROCESS_DIRECTORY
c
c	Logs
c	  VMS Usage : char_string
c	  type      : longword (unsigned)
c	  access    : write only
c	  mechanism : by reference, array reference
c
c	Array of strings to receive the logical names from the requested table.
c
c	Cnt
c	  VMS Usage : longword_unsigned
c	  type      : longword (unsigned)
c	  access    : write only
c	  mechanism : by reference
c
c	Count of logical names written into Logs().
c
C Implicit Inputs:
c	none
c
C Implicit Outputs:
c	none

C Completion status:
c	SS$_INSFARG	Insufficient arguments were passed to Lib_Return_LNMs.
c
c	SS$_IVLOGTAB	An invalid logical name table was specified in the
c			call to Lib_Return_LNMs.
c
c	SS$_NORMAL	Procedure completed successfully.
c
c	SS$_OVRMAXARG	Too many arguments were passed to Lib_Return_LNMs.
c
c	Any return status from STR$UPCASE.


C Side effects:
c	none
C--
	INCLUDE '($SSDEF)'

	BYTE Names(255000)

	CHARACTER*(*) Logs(1024)
	CHARACTER*(*) Table

	INTEGER*4 Cnt
	INTEGER*4 Loop
	INTEGER*4 Pos
	INTEGER*4 Start
	INTEGER*4 Sts

	INTEGER*4 Lib_Return_LNMs

	Lib_Assemble_LNMs = SS$_NORMAL

	Sts = Lib_Return_LNMs(Table, Names)
	IF(.NOT. Sts .AND. Sts .NE. 0)THEN
	  Lib_Assemble_LNMs = Sts
	  RETURN
	END IF

	Cnt = 1
	Start = 1

	DO WHILE(Names(Start) .NE. 0)
	  Pos = 0
	  DO Loop = 1, Names(Start)
	    Pos = Pos + 1
	    Logs(Cnt)(Pos:Pos) = CHAR(Names(Loop + Start))
	  END DO

	  DO Loop = Pos + 1, LEN(Logs(Cnt))
	    Logs(Cnt)(Loop:Loop) = ' '
	  END DO

	Cnt = Cnt + 1
	Start = Start + Names(Start) + 1

	END DO

	Cnt = Cnt - 1

	RETURN
	END
