$!.. GLOBAL.COM -- Compute global section and page values
$	ON WARNING THEN GOTO ON_ERR
$	TYPO = "WRITE SYS$OUTPUT"
$	T$LF[0,8] = 10
$	NODE = F$GETSYI ("NODENAME") +"::"
$	TYPO T$LF, "[GLOBAL sections & pages on ", NODE, F$TIME(), " ]"
$	F1X = 0		!flag for existance of file 1
$	F1O = 0		!flag for file 1 open
$	F2X = 0		!flag for existance of file 2
$	F2O = 0		!flag for file 2 open
$
$	IF P1 .EQS. "" THEN READ SYS$COMMAND P1 -
		/PROMPT="   GBLSECTIONS needed> "/END=ZIP1
$	IF P2 .EQS. "" THEN READ SYS$COMMAND P2 -
		/PROMPT="   GBLPAGES needed> "/END=ZIP2
$	GOTO PARAMS_OK
$ ZIP1:		P1 = 0
$ ZIP2:		P2 = 0
$ PARAMS_OK:
$	P1 = F$INTEGER (P1)
$	P2 = F$INTEGER (P2)
$
$	TYPO T$LF, "-- from INSTALL/GLOBALS :"
$	ASSIGN/USER   GBL_INSTALL.TMP   SYS$OUTPUT
$	F1X = 1		!file 1 exists
$	RUN SYS$SYSTEM:INSTALL
		/GLOBAL
		/EXIT
$	OPEN/READ   F1   GBL_INSTALL.TMP
$	F1O = 1		!file 1 open
$ LOOP1:
$	READ/END_OF_FILE=ERR1   F1   LINE
$	PTR2 = F$LOCATE ("Global Sections Used", LINE)
$	LEN = F$LENGTH (LINE)
$	IF PTR2 .GE. LEN THEN GOTO LOOP1
$
$ !--when we get here LINE contains the summary: "nnn Global Sections...
$	CLOSE F1
$	F1O = 0		!file 1 not open
$	TYPO LINE
$
$	PTR1 = 2
$	GS_USED = F$INTEGER (F$EXTRACT (PTR1, PTR2-PTR1-1, LINE))
$	PTR1 = F$LOCATE (",", LINE)	!"...nnn/nnn Global Pages Used/Unused"
$	PTR2 = F$LOCATE ("/", LINE)
$	IF PTR1 .GE. LEN THEN GOTO ERR2
$	IF PTR2 .GE. LEN THEN GOTO ERR2
$	GP_USED = F$INTEGER (F$EXTRACT (PTR1+1, PTR2-PTR1-1, LINE))
$	LINE = F$EXTRACT (PTR2+1, LEN-PTR2, LINE)
$	PTR2 = F$LOCATE (" ", LINE)
$	GP_UNUSED = F$INTEGER (F$EXTRACT (0, PTR2, LINE))
$
$	TYPO T$LF, "-- from SYSGEN :"
$	ASSIGN/USER   GBL_SYSGEN.TMP   SYS$OUTPUT
$	F2X = 1		!file 2 exists
$	RUN SYS$SYSTEM:SYSGEN
		SHOW GBLSECTIONS
		SHOW GBLPAGES
		EXIT
$	TYPO T$LF, "Parameter                  Current   Default", -
		"   Minimum   Maximum Unit"
$	TYPE GBL_SYSGEN.TMP
$	OPEN/READ   F2   GBL_SYSGEN.TMP
$	F2O = 1		!file 2 open
$	READ F2 LINE
$	CLOSE F2
$	F2O = 0		!file 2 not open
$	PTR1 = F$LOCATE (" ", LINE)
$	PTR2 = 34
$	GS_TOT = F$INTEGER (F$EXTRACT (PTR1, PTR2-PTR1, LINE))
$
$	TYPO T$LF, "-- calculated values :"
$	TYPO T$LF, "        GBLSECTIONS    GBLPAGES      (", NODE, ")"
$	FMT = "!6AS !2(12SL)"
$	GS_UNUSED = GS_TOT - GS_USED
$	GP_TOT = GP_USED + GP_UNUSED
$	GS_ADD = 0
$	IF GS_UNUSED .LT. P1 THEN GS_ADD = P1 -GS_UNUSED
$	GP_ADD = 0
$	IF GP_UNUSED .LT. P2 THEN GP_ADD = P2 -GP_UNUSED
$	TYPO F$FAO (FMT, "TOTAL", GS_TOT, GP_TOT)
$	TYPO F$FAO (FMT, "USED", GS_USED, GP_USED)
$	TYPO F$FAO (FMT, "UNUSED", GS_UNUSED, GP_UNUSED)
$	IF P1 +P2 .LT. 1 THEN GOTO END_CALC
$	TYPO F$FAO (FMT, "NEEDED", P1, P2)
$	IF GS_ADD +GP_ADD .LT. 1 THEN GOTO SUFFICIENT
$		TYPO F$FAO (FMT, "add", GS_ADD, GP_ADD)
$		GS_NEW = GS_TOT +GS_ADD
$		GP_NEW = GP_TOT +GP_ADD
$		TYPO T$LF, F$FAO (FMT, "new", GS_NEW, GP_NEW)
$		GOTO END_CALC
$	SUFFICIENT: TYPO "  Current settings are sufficient."
$ END_CALC:
$
$DONE:
$	IF .NOT. (F1X .OR. F2X) THEN GOTO END_GLOBAL
$	IF F1O THEN CLOSE   F1
$	IF F1X THEN DELETE/NOLOG   GBL_INSTALL.TMP;*
$	IF F2O THEN CLOSE   F2
$	IF F2X THEN DELETE/NOLOG   GBL_SYSGEN.TMP;*
$END_GLOBAL:
$	TYPO T$LF, "[end of GLOBAL]"
$ EXIT
$
$ ERR1:	TYPO "%GLOBAL, no summary line found"
$	CLOSE F2
$	EXIT
$
$ ERR2: TYPO "%GLOBAL, summary parsing error"
$	EXIT
$
$ON_ERR:
$	XSTAT = $STATUS
$	DEASSIGN   SYS$OUTPUT
$	TYPO "%GLOBAL, error trap, $STATUS=", XSTAT
$	TYPO "         """, F$MESSAGE (XSTAT), """"
$	GOTO DONE

Abstract:
This procedure performs the steps needed to determine current counts of global
sections and pages.  INSTALL.EXE shows the number of global sections used and
global pages used and unused.  SYSGEN.EXE reveals the current settings of
parameters GBLPAGES and GBLSECTIONS.  With that data, TOTAL, USED, and UNUSED
can be calculated for both pages and sections.  In addition, the procdure will
compare the current values to needed counts and suggest required adjustments or
indicate that current values are sufficient.

	$ @GLOBAL [needed-sections] [needed-pages]
If the optional parameters are omitted, the procedure will prompt.  Answers to
the prompts are optional also; <CR> will indicate zero needed.
