$!..RECORD_USER.COM -- record user access
$!..	@RECORD_USER   file_spec   [remark]
$
$	IF P1 .EQS. "" THEN GOTO NOP1	!no file given?
$	USPEC = F$SEARCH (P1)
$	CREATED = "FALSE"
$	IF USPEC .NES. "" THEN GOTO FILEXISTS	!does the file exist?
$	CREATE/FDL=SYS$INPUT   'P1'		! no -- create it
		FILE
		 ORGANIZATION indexed
		 PROTECTION (SYSTEM=R,OWNER=RWED,WORLD=RWE)
		RECORD
		 SIZE 80
		KEY 0
		 SEG0_LENGTH 12
$	CREATED = "TRUE"		!set a flag to include creation date
$	USPEC = F$SEARCH (P1)
$FILEXISTS:
$	REMARK = F$EXTRACT (0, 45, P2)
$
$	FMT = "!12AS^!10AS^!10SL^!AS"  !format: username, date, count, remark
$	OPEN/READ/WRITE/SHARE=WRITE   UFIL   'USPEC'
$	ON CONTROL_Y THEN GOTO DONE
$	ON WARNING THEN GOTO DONE
$	DAT = F$CVTIME ("", "COMPARISON", "DATE")
$	!--if just created, insert creation date
$	IF CREATED THEN WRITE UFIL F$FAO (FMT, "", DAT, 0, "Created")
$
$	!--If we don't find this user, add it
$	USERNAME = F$EDIT (F$GETJPI ("", "USERNAME"), "TRIM")
$	READ/INDEX=0/MATCH=EQ/KEY='USERNAME'/ERROR=NEW_USR   UFIL   ULINE
$	USR = F$EDIT (F$ELEMENT (0, "^", ULINE), "TRIM")
$	IF USR .NES. USERNAME THEN GOTO NEW_USR
$
$	!--increment access count, update user file
$	COUNT = F$INTEGER (F$ELEMENT (2, "^", ULINE)) +1
$	ULINE = F$FAO (FMT, USERNAME, DAT, COUNT, "''REMARK'")
$	WRITE/UPDATE   UFIL   ULINE
$	GOTO DONE
$
$NEW_USR:	!no record found for this username
$	ULINE = F$FAO (FMT, USERNAME, DAT, 1, "''REMARK'")
$	WRITE   UFIL   ULINE		!write new entry
$
$DONE:
$	CLOSE   UFIL
$	EXIT
$
$NOP1:
$	WRITE SYS$OUTPUT "%RECUSR-F-NOP1, No file spec given in P1"
$	EXIT
$!============================================================================
	RECORD_USER.COM -- record user access
	see also RECORD_USER.FDL to create suitable files for use herein.

RECORD_USER maintains an indexed file of usernames along with date, count and an
optional remark.  The current username, from F$GETJPI, is used as a key in the
file.  Only one entry per username will be recorded.  Each time the same
username runs RECORD_USER again, a count is incremented and stored in the file.
The current date is included with the user record.  The result is a list of
usernames, each showing a count of acesses and the date of last use.
 
The format of the command to invoke RECORD_USER is:

	@RECORD_USER   file_spec   [remark]

Where 	"file_spec" is the specification for the file that is to be used.

	"[remark]" is an optional string that can be stored in the file with the
record for the current user.  If the string contains blanks or tabs, enclose it
in quotation marks.  The remark is trimmed to 45 characters.

To create a file for use with RECORD_USER.COM, issue this command:

	$ CREATE/FDL=RECORD_USER.FDL   file_spec
