$!.. VTCLOCK.COM -- display time on VTxxx -- D.J.Maus 25-MAR-1987
$
$	ALARMTIME = F$EXTRACT (0,5, P1)		!get alarm parameter
$	TYPO = "WRITE SYS$OUTPUT"	!define output command
$	DING[0,8] = 7		!define ASCII BELL character
$	ESC[0,8] = 27		!define ASCII <escape> character
$	L22 = ESC +"[22H"	!VT command string to position cursor at line 22
$	TMOLIM = 10		!timeout limit (seconds) for READ
$	TMOADJ = 0		!subtracted from TMOLIM
$	DBLW = ESC +"#6"	!escape sequence to make line double width
$	IDSTR = ESC +"[7mVTclock" +ESC +"[m"	!procedure identifier, rev-video
$	IDPOS = ESC +"[23;10H"	!define ID position on line 23
$	TMPOS = ESC +"[23;33H"	!define time position on line 23
$	ALPOS = ESC +"[23;18H"	!define alarm position on line 23
$	EXPOS = ESC +"[23;3H"	!define exit position on line 23
$	ALARMRING = 0		!init ding counter to zero
$	CMD = ""		!init command string to null
$	MM1 = -1		!init previous minute to a non-value
$
$	TYPO ESC, "[23H", ESC, "[2K"	!position cursor and erase line
$	IF ALARMTIME .EQS. "" THEN GOTO TOP
$		ALARMSTR = "alarm " +ALARMTIME
$		TYPO ALPOS, ALARMSTR
$TOP:
$	TYPO IDPOS, DBLW, IDSTR	!identify procedure
$	STIM = F$EXTRACT (0,8, F$CVTIME (,,"TIME"))	!get current system time
$	TYPO TMPOS, STIM, L22			!display it
$
$!adjust time to even multiple of 10 sec
$	IF ALARMRING .NES. 0 THEN GOTO NOADJ
$	SECS = F$CVTIME (STIM,, "SECOND")	!seconds portion of time
$	TMOADJ = SECS -((SECS /10) *10)		!units digit
$NOADJ:
$
$!Chime every hour (twice) and half hour (once)
$	MM = F$CVTIME (STIM,, "MINUTE")		!extract the minute
$	IF MM .EQ. MM1 THEN GOTO NOBEEP		!prevent bell repeats
$		MM1 = MM			!remember the minute
$		IF MM .EQ. 30 THEN TYPO DING, L22		!half hour [1]
$		IF MM .EQ.  0 THEN TYPO DING, DING, L22		!hour [2]
$NOBEEP:
$
$!time for alarm?
$	IF ALARMRING .GE. 1 THEN GOTO ALARM_DING	!yes, repeat 3 dings
$	IF ALARMTIME .EQS. "" THEN GOTO READ1		!no alarm parameter?
$		IF ALARMTIME .NES. F$EXTRACT (0,5, STIM) THEN GOTO READ1
$			TMOADJ = 9		!change READ timeout to 1 sec
$		TYPO ESC, "[1;5;7m", ALPOS, ALARMSTR, -
			ESC, "[m", L22	!display alarm time bold, blinking, rev
$ALARM_DING:
$	TYPO DING, DING, DING, L22	!sound three bells
$	ALARMRING = ALARMRING +1	!count trips thru here
$	IF ALARMRING .LT. 5 THEN GOTO READ1	!limit to 5 trips (15 bells)
$		ALARMRING = 0		!reset counter
$		ALARMTIME = ""		!disable timer
$		TMOADJ = 0		!put READ timeout back to 10 sec
$
$READ1:		!here to input a command -- timeout after 10 (or 1) sec
$	TMO = TMOLIM -TMOADJ
$	READ/PROMPT="$ "/END=DONE/ERROR=TOP/TIME_OUT='TMO' SYS$COMMAND CMD
$	IF CMD .EQS. "" THEN GOTO TOP	!if nothing typed, do it all again
$
$DONE:		!here to exit
$	TYPO EXPOS, "exit  "		!mark the display
$	ASSIGN/USER/NOLOG   SYS$COMMAND   SYS$INPUT	!for terminal input
$!issue the CMD to VMS/DCL
$	'CMD'
$
$EXIT !VTCLOCK
$
	@VTCLOCK [hh:mm]

VTCLOCK.COM uses the bottom line of a VTxxx display to show the current
system time.  If the optional parameter is given, an alarm will be sounded
when the system time (hours and minutes) matches the parameter.

On the time display line (bottom), a dollar sign prompt is given to indicate
that anything typed at the terminal will be issued to VMS as a command and
VTCLOCK will exit.
