	PROGRAM WHO
C--Revision history
C 30-SEP-1987	4.8 DJM
C			enabled lists on qualifiers and parameter
C  3-DEC-1987	4.9 DJM
C			1) added /CPU qualifier; revised .CLD
C			2) modified /IO qualifier extra line output
C			3) /INTERVAL implied by /INCR, /CPU, /IO
C			4) fixed bug with WHO "."
C--futures
C --Ctrl-Z exit
C --/SSSTAT = ([NO]ALL,[NO]EXIT)
C	value omitted, default /SSSTAT = (NOALL,EXIT)
C	qualifier omitted, default /SSSTAT = (NOALL,NOEXIT)
C --get terminal page length and use it for scrolling region
C --put values on /CPU and /IO to be used for process selection based on CPU
C	time and/or I/O counts

	IMPLICIT INTEGER (A-Z)
	INCLUDE '($IODEF)'
	INCLUDE '($JPIDEF)'
	INCLUDE '($SYIDEF)'

	PARAMETER	(CLI$_NEGATED='381F8'X)
	PARAMETER	(CC_STATUS='18000001'X)
	PARAMETER	(DVI$_TT_PHYDEVNAM=274)
	PARAMETER	(TIMER_EFN=1)
	PARAMETER	(MAXPROCESSCNT=70)
	PARAMETER	(SUSP='3A4'X)	!return status for suspended process

	REAL*8		INT_Q
	INTEGER*4	BIO(MAXPROCESSCNT), DIO(MAXPROCESSCNT),
     +				CPU(MAXPROCESSCNT)
	LOGICAL*1	MULTI_LINE
	CHARACTER	UNM*12, IMAGE_128*128, WORK_128*128, IMAGE*9
	CHARACTER	PRCNAM*15, TIMBUF*23, INT_C*10, OUT_LN*80
	CHARACTER	VTERM*9, PTERM*9, TERM*9, IO_C*6, NODE*15, NULL*1

!Storage for selection qualifiers
	CHARACTER	CMD_TERM(10)*9, CMD_PROC(10)*15,
     &		CMD_UNM(10)*12, CMD_IMAGE(10)*9, CMD_STATE(10)*5,
     &		CMD_MODE(10)*1, ENTITY*9, CMD_PID_C*8
	INTEGER*4	CMD_PID(10)
	INTEGER*4	CMD_PROC_L(10), CMD_IMAGE_L(10), CMD_STATE_L(10)
	INTEGER*4	CMD_TERM_L(10), CMD_UNM_L(10)
	LOGICAL*1	CMD_PID_FOUND(10), CMD_MODE_FOUND(10),
     &		CMD_PROC_FOUND(10), CMD_IMAGE_FOUND(10), CMD_STATE_FOUND(10),
     &		CMD_TERM_FOUND(10), CMD_UNM_FOUND(10), SHOW_THIS_ONE

!Scrolling region parameters, $GETJPI return code, #proc's
	COMMON		/WHOCOM/	TOP, BOTTOM, LINE, JPISTAT,
     &					PROC_COUNT, SEL_TARGET

	EXTERNAL	SYS$EXIT	!control-C trap
	EXTERNAL	WHO_EXIT	!exit handler
	INTEGER*4	EXH_BLK(5)

!Storage for cycle time and /CPU calculations
	REAL*8		CYCTHIS_Q,    CYCPREV_Q,    CYCELAP_Q
	REAL*4		CYCSEC, CPUSEC, PCT
	INTEGER*4	CYCTHIS_L(2), CYCPREV_L(2), CYCELAP_L(2)
	EQUIVALENCE	(CYCTHIS_Q, CYCTHIS_L), (CYCPREV_Q, CYCPREV_L),
     &		(CYCELAP_Q, CYCELAP_L)
	INTEGER*2	CYCNUMTIM(7)
	CHARACTER	CYCSEC_C*9, CPUSEC_C*9, PCT_C*9

C--$GETJPI(CPUTIM) returns 10ms quantums -- WHO puts out ASCII hh:mm:ss.cc.
C  All this crap is needed to make the conversion.
	REAL		CVT_TIM
	PARAMETER	(CVT_TIM=1E5/2**16)	!10ms to 100ns in word 2
	CHARACTER	CPUT16*16, CPUT6*6
	REAL*8		TIM_Q
	INTEGER*2	TIM_W(4)
	INTEGER*4	TIM_W2N3	!equiv'd with TIM_Q words 2 & 3
	EQUIVALENCE	(TIM_W,TIM_Q), (TIM_W2N3,TIM_W(2))

C--Create the process state table
	PARAMETER	(STATE_MAX=14)
	CHARACTER*5	SCH$STATE(0:STATE_MAX), STATE
	DATA		SCH$STATE	/
     +			'?',
     +			'COLPG',
     +			'MWAIT',
     +			'CEF',
     +			'PFW',
     +			'LEF',
     +			'LEFO',
     +			'HIB',
     +			'HIBO',
     +			'SUSP',
     +			'SUSPO',
     +			'FPG',
     +			'COM',
     +			'COMO',
     +			'CUR'		/

C--Create the process mode table
	PARAMETER	(PRC_MODE_MAX=3)
	CHARACTER*11	PRC_MODE(0:PRC_MODE_MAX), MODE
	DATA		PRC_MODE	/
     +			' ',
     +			'NETWORK',
     +			'BATCH',
     +			'INTERACTIVE'	/

C--Arrays for item lists
	INTEGER*4	JPI_IL(3,13) 
	INTEGER*2	JPI_ILW(6,13)
	EQUIVALENCE	(JPI_IL, JPI_ILW)

	INTEGER		DVI_IL(3,2)
	INTEGER*2	DVI_ILW(6,2)
	EQUIVALENCE	(DVI_IL, DVI_ILW)

	STRUCTURE /ITEM_LIST/
		INTEGER*2	LEN, COD
		INTEGER*4	BUF, RLN
	END STRUCTURE
	RECORD	/ITEM_LIST/	SYI(2)

C--Item list for GETJPI
	JPI_ILW(1,1)=4
	JPI_ILW(2,1)=JPI$_PID
	JPI_IL(2,1)=%LOC(PID)
C	JPI_IL(3,1)=%LOC(PID_L)

	JPI_ILW(1,2)=12
	JPI_ILW(2,2)=JPI$_USERNAME
	JPI_IL(2,2)=%LOC(UNM)
C	JPI_IL(3,2)=%LOC(UNM_L)

	JPI_ILW(1,3)=9
	JPI_ILW(2,3)=JPI$_TERMINAL
	JPI_IL(2,3)=%LOC(VTERM)
	JPI_IL(3,3)=%LOC(VTERM_L)

	JPI_ILW(1,4)=128
	JPI_ILW(2,4)=JPI$_IMAGNAME
	JPI_IL(2,4)=%LOC(IMAGE_128)
	JPI_IL(3,4)=%LOC(IMAGE_L)

	JPI_ILW(1,5)=4
	JPI_ILW(2,5)=JPI$_PRI
	JPI_IL(2,5)=%LOC(PRIO)
C	JPI_IL(3,5)=%LOC(PRIO_L)

	JPI_ILW(1,6)=4
	JPI_ILW(2,6)=JPI$_STATE
	JPI_IL(2,6)=%LOC(STATE_IDX)
C	JPI_IL(3,6)=%LOC(STATE_L)

	JPI_ILW(1,7)=15
	JPI_ILW(2,7)=JPI$_PRCNAM
	JPI_IL(2,7)=%LOC(PRCNAM)
	JPI_IL(3,7)=%LOC(PRCNAM_L)

	JPI_ILW(1,8)=4
	JPI_ILW(2,8)=JPI$_CPUTIM
	JPI_IL(2,8)=%LOC(CPUTIM)
C	JPI_IL(3,8)=%LOC(CPUTIM_L)

	JPI_ILW(1,9)=4
	JPI_ILW(2,9)=JPI$_MODE
	JPI_IL(2,9)=%LOC(MODE_IDX)
C	JPI_IL(3,9)=%LOC(MODE_L)

	JPI_ILW(1,10)=4
	JPI_ILW(2,10)=JPI$_BUFIO
	JPI_IL(2,10)=%LOC(BUFIO)
C	JPI_IL(3,10)=%LOC(BUFIO_L)

	JPI_ILW(1,11)=4
	JPI_ILW(2,11)=JPI$_DIRIO
	JPI_IL(2,11)=%LOC(DIRIO)
C	JPI_IL(3,11)=%LOC(DIRIO_L)

	JPI_ILW(1,12)=4
	JPI_ILW(2,12)=JPI$_PROC_INDEX
	JPI_IL(2,12)=%LOC(PROC_IDX)
C	JPI_IL(3,12)=%LOC(PROC_IDX_L)

C--Item list for GETDVI
	DVI_ILW(1,1)=9
	DVI_ILW(2,1)=DVI$_TT_PHYDEVNAM
	DVI_IL(2,1)=%LOC(PTERM)
	DVI_IL(3,1)=%LOC(PTERM_L)

C--Item list for GETSYI
	SYI(1).LEN = 15
	SYI(1).COD = SYI$_NODENAME
	SYI(1).BUF = %LOC (NODE)
	SYI(1).RLN = NODE_L		!GETSYI returns length of node as zero

	SYI(2).LEN = 0

C--Init
	EXH_BLK(1)=%LOC(FWD_LINK)	!Declare exit handler
	EXH_BLK(2)=%LOC(WHO_EXIT)
	EXH_BLK(3)=1
	EXH_BLK(4)=%LOC(STATUS)
	CALL SYS$DCLEXH (EXH_BLK)

	CALL SYS$ASSIGN ('TT',TTCHAN,,)		!Trap ^C
	CALL SYS$QIO (,%VAL(TTCHAN),
     +		%VAL(IO$_SETMODE.OR.IO$M_CTRLCAST), ,,,
     +		SYS$EXIT, %VAL(CC_STATUS), ,,,)

	JPI_SAVE = JPI_IL(1,2)		!Get pid for self
	JPI_IL(1,2) = 0			!this makes item list 1 item long
	CALL SYS$GETJPIW (,,,JPI_IL,,,)
	MY_PID = PID
	JPI_IL(1,2) = JPI_SAVE		!restore item list

	CALL SYS$GETSYIW (,,, SYI,,,)	!Get nodename
	NULL = CHAR (0)
	NODE_L = INDEX (NODE, NULL) -1	!length of nodename

C--Set up scrolling region
	TOP=3
	BOTTOM=24
	CALL LIB$SET_SCROLL (TOP,BOTTOM)

C--Screen heading
	CALL LIB$ERASE_PAGE (1,1)
	CALL LIB$PUT_SCREEN ('WHO v4.9 on ' // NODE(:NODE_L) // '::' ,1,1)
	CALL LIB$PUT_SCREEN ('PID----- Username---- Term--- Process-name---
     & Image---- M State Pr ---I/O ---Cpu',2,1)
	LINE=TOP
	PROC_COL = 31
	INTV_COL = 40
	INCR_COL = 50
	TIME_COL = 58

C--Get /PID selection qualifier
	CMD_PID_N =0
	PID_PRESENT = CLI$PRESENT ('PID')
	IF (PID_PRESENT) THEN
	  DO N = 1, 10
	    CMD_PID_FOUND(N) = .FALSE.
	    RET = CLI$GET_VALUE ('PID', CMD_PID_C, L)
	    IF (RET) THEN
	      CMD_PID_N = N
	      CALL OTS$CVT_TZ_L (CMD_PID_C, CMD_PID(N),,)
	    END IF
	  END DO
	END IF

C--Get USERNAME selection parameter or qualifier
	CMD_UNM_N = 0
	UNM_QUAL = CLI$PRESENT ('USER_QUAL')
	IF (UNM_QUAL) ENTITY = 'USER_QUAL'
	UNM_PARM = CLI$PRESENT ('USER_PARM')
	IF (UNM_PARM) ENTITY = 'USER_PARM'
	IF (UNM_QUAL .OR. UNM_PARM) THEN
	  UNM_PRESENT = .TRUE.
	  DO N = 1, 10
	    CMD_UNM_FOUND(N) = .FALSE.
	    RET = CLI$GET_VALUE (ENTITY, CMD_UNM(N), CMD_UNM_L(N))
	    IF (RET) CMD_UNM_N = N
	  END DO
	END IF

C--Get /TERMINAL selection qualifier
C  /TERM	-- display any nonblank terminal
C  /TERM=string -- display when string=terminal
C  /NOTERM	-- display any blank terminal
	CMD_TERM_N =0
	TERM_PRESENT = CLI$PRESENT ('TERMINAL')
	IF (TERM_PRESENT) THEN
	  DO N = 1, 10
	    CMD_TERM_FOUND(N) = .FALSE.
	    RET = CLI$GET_VALUE ('TERMINAL', CMD_TERM(N), CMD_TERM_L(N))
	    IF (N .EQ. 1) TERM_V_PRESENT = RET
	    IF (RET) CMD_TERM_N = N
	  END DO
	ELSE
	  IF (TERM_PRESENT .EQ. CLI$_NEGATED) THEN
	    TERM_PRESENT=.TRUE.
	    TERM_V_PRESENT=.TRUE.
	    CMD_TERM_N = 1
	    CMD_TERM(1) = ' '
	    CMD_TERM_L(1) = 1
	  END IF
	END IF

C--Get /PROCESS_NAME selection qualifier
	CMD_PROC_N =0
	PROC_PRESENT = CLI$PRESENT ('PROCESS_NAME')
	IF (PROC_PRESENT) THEN
	  DO N = 1, 10
	    CMD_PROC_FOUND(N) = .FALSE.
	    RET = CLI$GET_VALUE ('PROCESS_NAME', CMD_PROC(N), CMD_PROC_L(N))
	    IF (RET) CMD_PROC_N = N
	  END DO
	END IF

C--Get /IMAGE selection qualifier
	CMD_IMAGE_N =0
	IMAGE_PRESENT = CLI$PRESENT ('IMAGE')
	IF (IMAGE_PRESENT) THEN
	  DO N = 1, 10
	    CMD_IMAGE_FOUND(N) = .FALSE.
	    RET = CLI$GET_VALUE ('IMAGE', CMD_IMAGE(N), CMD_IMAGE_L(N))
	    IF (RET) CMD_IMAGE_N = N
	  END DO
	END IF

C--Get /MODE selection qualifier
	CMD_MODE_N =0
	MODE_PRESENT = CLI$PRESENT ('MODE')
	IF (MODE_PRESENT) THEN
	  DO N = 1, 10
	    CMD_MODE_FOUND(N) = .FALSE.
	    RET = CLI$GET_VALUE ('MODE', CMD_MODE(N))
	    IF (RET) CMD_MODE_N = N
	  END DO
	END IF

C--Get /STATE selection qualifier
	CMD_STATE_N =0
	STATE_PRESENT = CLI$PRESENT ('STATE')
	IF (STATE_PRESENT) THEN
	  DO N = 1, 10
	    CMD_STATE_FOUND(N) = .FALSE.
	    RET = CLI$GET_VALUE ('STATE', CMD_STATE(N), CMD_STATE_L(N))
	    IF (RET) CMD_STATE_N = N
	  END DO
	END IF

C--Set QUALS_PRESENT true if any output selection qualifier exists
	QUALS_PRESENT=.FALSE.
	QUALS_PRESENT=
     +		PID_PRESENT	.OR.
     +		UNM_PRESENT	.OR.
     +		TERM_PRESENT	.OR.
     +		PROC_PRESENT	.OR.
     +		IMAGE_PRESENT	.OR.
     +		MODE_PRESENT	.OR.
     +		STATE_PRESENT

C--If no selection qualifiers, show all processes
	IF (QUALS_PRESENT) THEN
		SHOW_THIS_ONE = .FALSE.
	ELSE
		SHOW_THIS_ONE = .TRUE.
	END IF

C--Get /INTERVAL=n repetition qualifier
	REPEAT=CLI$GET_VALUE ('INTERVAL',INT_C)

C--Get /INCREMENTAL display modification qualifier
	INCR_PRESENT = CLI$PRESENT ('INCR')
	IF (INCR_PRESENT) REPEAT = .TRUE.	!/INCREMENTAL implies /INTERVAL

C--Get /CPU extra line qualifier
	CPU_PRESENT = CLI$PRESENT ('CPU')
	IF (CPU_PRESENT) REPEAT = .TRUE.	!/CPU implies /INTERVAL

C--Get /IO extra line qualifier (generate the I/O count line)
	IO_PRESENT = CLI$PRESENT ('IO')
	IF (IO_PRESENT) REPEAT = .TRUE.		!/IO implies /INTERVAL

C--Get /FULL extra line qualifier (full image file-spec)
	FULL_PRESENT=CLI$PRESENT ('FULL')

C--Check for /SSSTAT extra line qualifier
C show system service ($GETJPI) return status code
	SSSTAT = CLI$PRESENT ('SSSTAT')

C--Get /PHYSICAL and /VIRTUAL display modification qualifiers
C  /NOVIRT or /PHYS -- display physical terminal (from GETDVI) * default *
C  /VIRT or /NOPHYS -- display virtual terminal (from GETJPI)
	PHYS_PRESENT=CLI$PRESENT ('PHYSICAL')
	VIRT_PRESENT=CLI$PRESENT ('VIRTUAL')
	IF (PHYS_PRESENT) THEN				!/PHYS
		DISP_PT = .TRUE.
	ELSE IF (PHYS_PRESENT .EQ. CLI$_NEGATED) THEN	!/NOPHYS
		DISP_PT = .FALSE.
	ELSE IF (VIRT_PRESENT) THEN			!/VIRT
		DISP_PT = .FALSE.
	ELSE						!/NOVIRT
		DISP_PT = .TRUE.
	END IF

C--Get /SCROLL operational qualifier
	NOSCROLL=CLI$PRESENT ('SCROLL') .EQ. CLI$_NEGATED

C--Get /OKNONE operational qualifier
	OKNONE=CLI$PRESENT ('OKNONE')

C--Put interval time in heading
	IF (REPEAT) THEN
		STAT=OTS$CVT_TI_L (INT_C, INT, %VAL(4), %VAL(3))
		IF (.NOT. STAT) CALL EXIT (STAT)
		IF (INT .EQ. 0) INT = 10
		TIM_W(1)=0
		TIM_W2N3=-INT*100 *CVT_TIM
		TIM_W(4)=-1
		INT_Q=TIM_Q
		WRITE (OUT_LN, FMT='(I5, '' sec'')') INT
		CALL LIB$PUT_SCREEN (OUT_LN(1:9), 1, INTV_COL)
	END IF

C--Put incremental note in heading
	IF (INCR_PRESENT) CALL LIB$PUT_SCREEN ('Incr', 1, INCR_COL)

C--Set SEL_TARGET to the number of processes selected
	SEL_TARGET = CMD_PROC_N +CMD_PID_N +CMD_MODE_N +CMD_IMAGE_N
     &		+CMD_STATE_N +CMD_TERM_N +CMD_UNM_N

C--/INTERVAL loop starts here (return here if REPEAT is true)
	CYCLE = -1	!first interval is cycle zero
1000	IF (CYCLE .GE. '7FFFFFFF'X) CYCLE = -1		!prevent overflow
	CYCLE = CYCLE +1
	CALL SYS$SETIMR (%VAL(TIMER_EFN), INT_Q, ,)
			!Set timer here, wait at bottom
	CALL SYS$ASCTIM (,TIMBUF,,)	!get current time
	CALL LIB$PUT_SCREEN (TIMBUF,1,TIME_COL)
	CALL LIB$SET_CURSOR (LINE, 1)

C--Calculate elapsed time of cycle (as a REAL count of seconds)
	CALL SYS$BINTIM (TIMBUF, CYCTHIS_Q)	!64 bit current cycle start time
	IF (CYCLE .GT. 0) THEN
	  RET = LIB$SUBX (CYCPREV_L, CYCTHIS_L, CYCELAP_L, )	!subtr from prev
	  IF (.NOT. RET) CALL EXIT(RET)
	  RET = SYS$NUMTIM (CYCNUMTIM, CYCELAP_Q)	!convert 64bit to 7word
	  IF (.NOT. RET) CALL EXIT (RET)
	  CYCSEC = CYCNUMTIM(4)*3600 +CYCNUMTIM(5)*60 +CYCNUMTIM(6)
     &		+CYCNUMTIM(7)/100.0	!calculate elapsed seconds & fraction
	  CALL REAL2ASCII (CYCSEC, CYCSEC_C, LS)
	  OUT_LN = ' '
	  CALL SYS$FAO (' - - - (!SL) !AS',, OUT_LN, %VAL(CYCLE),
     &		CYCSEC_C(:LS))
	  CALL PUT_LINE (OUT_LN)
	END IF
	CYCPREV_Q = CYCTHIS_Q	!remember this cycle's start time

C--GETJPI loop starts here
	PROC_COUNT=0
	SCAN=-1
2000	TERM=' '
	VTERM = ' '
	PTERM = ' '
	PRCNAM=' '
	IMAGE_128=' '
	JPISTAT = SYS$GETJPIW (, SCAN,, JPI_IL,,,)

C--Check for /SSSTAT qualifier -- show JPISTAT
	IF (SSSTAT) THEN
		OUT_LN = ' '
		CALL SYS$FAO ('  !8XL "',, OUT_LN(1:12), %VAL(JPISTAT))
		CALL SYS$GETMSG (%VAL(JPISTAT), L, OUT_LN(13:),,)
		OUT_LN(13+L:14+L) = '"'
		CALL PUT_LINE (OUT_LN)
	END IF

	!continue if the JPI call was successful (suspended processes cause
	! a fatal, -F-, return code -- ignore it).
	IF (JPISTAT   .OR.   JPISTAT .EQ. SUSP) THEN

C--Translate virtual terminal name to physical terminal name
	IF (DISP_PT) THEN	!are we displaying physical terminals?
	    IF (VTERM_L .GT. 0) THEN	!is there a terminal?
		!--GETJPI returns a 7 character virtual terminal name.  VTERM
		!--VTA1234: is returned as VTA1234 with no colon.  GETDVI chokes
		!--if there is no colon.
		IF (VTERM(VTERM_L:VTERM_L) .NE. ':') THEN    !is there a colon?
			VTERM_L = VTERM_L +1		     !add one
			VTERM(VTERM_L:) = ':'
		END IF
		DVI_RET=SYS$GETDVIW (,,VTERM,DVI_IL,,,,)
		IF (.NOT. DVI_RET) CALL LIB$STOP(%VAL(DVI_RET))
		IF (PTERM(1:1) .EQ. '_') THEN	!remove underscore
			PTERM = PTERM(2:PTERM_L)
			PTERM_L = PTERM_L -1
		END IF
	    ELSE			!no terminal for this process
		PTERM=' '
		PTERM_L=0
	    END IF
	    TERM = PTERM
	    TERM_L = PTERM_L
	ELSE
	    TERM = VTERM
	    TERM_L = VTERM_L
	END IF	

C--Clean up character stuff
	IF (ICHAR(UNM) .EQ. 0) UNM=' '		!change nulls to blanks
	TERM(TERM_L+1:)=' '			!change nulls to blanks
	PRCNAM(PRCNAM_L+1:)=' '			!change nulls to blanks
	IF (ICHAR(IMAGE_128) .NE. 0) THEN	!extract image file name
		WORK_128=IMAGE_128
		F1=LIB$LOCC (']', WORK_128) +1
		IF (F1 .EQ. 1) THEN
			F1=LIB$LOCC (':', WORK_128) +1
		ELSE
			WORK_128=WORK_128(F1:)
			F1=LIB$LOCC (']', WORK_128) +1
		END IF
		WORK_128=WORK_128(F1:)
		F1=MIN (9, LIB$LOCC ('.', WORK_128) -1)
		IMAGE=WORK_128(1:F1)
	ELSE
		IMAGE_128 = ' '
		IMAGE=' '			!change nulls to blanks
	END IF

C--Verify STATE_IDX
	IF (STATE_IDX .LT. 1   .OR.   STATE_IDX .GT. STATE_MAX)
     +		STATE_IDX=0
	STATE = SCH$STATE (STATE_IDX)

C--Verify MODE_IDX
	IF (MODE_IDX .LT. 1   .OR.   MODE_IDX .GT. PRC_MODE_MAX)
     +		MODE_IDX=0
	MODE=PRC_MODE(MODE_IDX)

C--/PID match test
	IF (PID_PRESENT) THEN
	  DO N = 1, CMD_PID_N
	    IF (PID .EQ. CMD_PID(N)) THEN
	      CMD_PID_FOUND(N) = .TRUE.		!mark it found
	      SEL_TARGET = SEL_TARGET -1
	      SHOW_THIS_ONE = .TRUE.
	    END IF
	  END DO
	END IF

C--/TERMINAL match test
	IF (TERM_PRESENT) THEN
	  IF (TERM_V_PRESENT) THEN
	    DO N = 1, CMD_TERM_N
	      IF (TERM(1:CMD_TERM_L(N)) .EQ. CMD_TERM(N)) THEN
		IF (.NOT. CMD_TERM_FOUND(N)) SEL_TARGET = SEL_TARGET -1
		CMD_TERM_FOUND(N) = .TRUE.
		SHOW_THIS_ONE = .TRUE.
	      END IF
	    END DO
	  ELSE
	    IF (TERM(1:1) .NE. ' ') SHOW_THIS_ONE = .TRUE. 
	  END IF
	END IF

C--/PROCESS_NAME match test
	IF (PROC_PRESENT) THEN
	  DO N = 1, CMD_PROC_N
	  IF (PRCNAM(1:CMD_PROC_L(N)) .EQ. CMD_PROC(N)) THEN
	    IF (.NOT. CMD_PROC_FOUND(N)) SEL_TARGET = SEL_TARGET -1
	    CMD_PROC_FOUND(N) = .TRUE.
	    SHOW_THIS_ONE = .TRUE.
	  END IF
	  END DO
	END IF

C--Username parameter or qualifier match test
	IF (UNM_PRESENT) THEN
	  DO N = 1, CMD_UNM_N
	    IF (CMD_UNM(N) .NE. '.') THEN
	      IF (UNM(1:CMD_UNM_L(N)) .EQ. CMD_UNM(N)) THEN
		IF (.NOT. CMD_UNM_FOUND(N)) SEL_TARGET = SEL_TARGET -1
		CMD_UNM_FOUND(N) = .TRUE.
		SHOW_THIS_ONE = .TRUE.
	      END IF
	    ELSE
	      IF (PID .EQ. MY_PID) SHOW_THIS_ONE = .TRUE.
	      IF (.NOT. CMD_UNM_FOUND(N)) SEL_TARGET = SEL_TARGET -1
	      CMD_UNM_FOUND(N) = .TRUE.
	    END IF
	  END DO
	END IF

C--/IMAGE match test
	IF (IMAGE_PRESENT) THEN
	  DO N = 1, CMD_IMAGE_N
	    IF (IMAGE(1:CMD_IMAGE_L(N)) .EQ. CMD_IMAGE(N)) THEN
	      IF (.NOT. CMD_IMAGE_FOUND(N)) SEL_TARGET = SEL_TARGET -1
	      CMD_IMAGE_FOUND(N) = .TRUE.
	      SHOW_THIS_ONE = .TRUE.
	    END IF
	  END DO
	END IF

C--/MODE match test
	IF (MODE_PRESENT) THEN
	  DO N = 1, CMD_MODE_N
	    IF (MODE(1:1) .EQ. CMD_MODE(N)) THEN
	      IF (.NOT. CMD_MODE_FOUND(N)) SEL_TARGET = SEL_TARGET -1
	      CMD_MODE_FOUND(N) = .TRUE.
	      SHOW_THIS_ONE = .TRUE.
	    END IF
	  END DO
	END IF

C--/STATE match test
	IF (STATE_PRESENT) THEN
	  DO N = 1, CMD_STATE_N
	    IF (STATE(1:CMD_STATE_L(N)) .EQ. CMD_STATE(N)) THEN
	      IF (.NOT. CMD_STATE_FOUND(N)) SEL_TARGET = SEL_TARGET -1
	      CMD_STATE_FOUND(N) = .TRUE.
	      SHOW_THIS_ONE = .TRUE.
	    END IF
	  END DO
	END IF

C--Was this process flagged to show?
	IF (.NOT. SHOW_THIS_ONE) GOTO 8000

C--Calc incremental I/O counts, if /INCREMENTAL or /IO
	IF (INCR_PRESENT  .OR.  IO_PRESENT) THEN
	  BIO_INCR = BUFIO -BIO(PROC_IDX)
	  BIO(PROC_IDX) = BUFIO
	  IF (BIO_INCR .LT. 0) BIO_INCR = 0
	  DIO_INCR = DIRIO -DIO(PROC_IDX)
	  DIO(PROC_IDX) = DIRIO
	  IF (DIO_INCR .LT. 0) DIO_INCR = 0
	END IF

C--Sum buffered and direct I/O counts
	TOT_IO = BUFIO +DIRIO
	TIO_INCR = BIO_INCR +DIO_INCR
	IF (INCR_PRESENT) THEN
		IO1 = TIO_INCR
	ELSE
		IO1 = TOT_IO
	END IF
	IF (IO1 .GT. 999999) THEN
		IO1 = FLOAT (IO1) /1000.0 +0.5
		WRITE (IO_C, FMT='(I5, 1Hk)') IO1
	ELSE
		WRITE (IO_C, FMT='(I6)') IO1
	END IF

C--Convert cumulative CPU time to ASCII (16 characters) for /CPU line
	IF (CPU_PRESENT) THEN
	  TIM_W(1)=0
	  TIM_W2N3=-CPUTIM *CVT_TIM
	  TIM_W(4)=-1
	  IF (CPUTIM .LT. 1) TIM_W2N3 = -1
	  CALL SYS$ASCTIM (, CPUT16, TIM_Q)
	END IF

C--Calc incremental CPU time, if /INCREMENTAL or /CPU
	IF (INCR_PRESENT  .OR.  CPU_PRESENT) THEN
	  CPU_INCR = CPUTIM -CPU(PROC_IDX)	!calc change
	  CPUSEC = CPU_INCR /100.0	!convert INTEGER 10ms count to REAL sec
	  CPU(PROC_IDX) = CPUTIM	!save cpu time for next cycle
	  IF (CPU_INCR .LT. 0) CPU_INCR = 0
	END IF

C--Convert CPU time from 10ms count to special 6 character format
	IF (INCR_PRESENT) THEN 
	  CPU10MS = CPU_INCR
	ELSE
	  CPU10MS = CPUTIM
	END IF
	TIM_W(1)=0
	TIM_W2N3=-CPU10MS *CVT_TIM
	TIM_W(4)=-1
	IF (CPU10MS .LT. 1) TIM_W2N3 = -1
	CALL TIME6 (TIM_Q, CPUT6)

C--Flag *self*
	IF (MY_PID .EQ. PID) IMAGE = ' *self*'

C--Output one line
	CALL SYS$FAO ('!8XL !12AS !7AS !15AS !9AS !1AS !5AS !2SB !6AS !6AS',
     &		,OUT_LN, %VAL(PID), UNM, TERM, PRCNAM, IMAGE, MODE,
     &		STATE, %VAL(PRIO), IO_C, CPUT6)
	CALL PUT_LINE (OUT_LN)
	PROC_COUNT=PROC_COUNT +1
	IF (QUALS_PRESENT) SHOW_THIS_ONE = .FALSE.

C--Output /CPU line
	IF (CPU_PRESENT) THEN
	  IF (CYCLE .GE. 1) THEN
	    PCT = CPUSEC *100.0 /CYCSEC
	    CALL REAL2ASCII (CPUSEC, CPUSEC_C, LC)
	    CALL REAL2ASCII (PCT, PCT_C, LP)
	    LL = 78 -LC -LS -LP	!position the % just under main line CPU time
	  END IF
	  OUT_LN = ' '
	  CALL SYS$FAO ('!8XL  cpu time: !16AS',, OUT_LN, %VAL(PID),
     &		CPUT16, CPU_INCR_T)
	  IF (CYCLE .GE. 1) CALL SYS$FAO ('!AS/!AS=!AS%',, OUT_LN(LL:),
     &			CPUSEC_C(:LC), CYCSEC_C(:LS), PCT_C(:LP))
	  CALL PUT_LINE (OUT_LN)
	  MULTI_LINE = .TRUE.
	END IF

C--Output /IO line
	IF (IO_PRESENT) THEN
		CALL SYS$ASCTIM (, CPUT16, TIM_Q,)
		WORK_128 = '!8XL  i/o:   buf !SL (!SL)' //
     &			'   dir !SL (!SL)   tot !SL (!SL!AS'
		OUT_LN = ' '
		CALL SYS$FAO (WORK_128,, OUT_LN,
     &			%VAL(PID), %VAL(BUFIO), %VAL(BIO_INCR),
     &			%VAL(DIRIO), %VAL(DIO_INCR),
     &			%VAL(TOT_IO), %VAL(TIO_INCR), ')')
		CALL PUT_LINE (OUT_LN)
		MULTI_LINE = .TRUE.
	END IF

C--Output /FULL imagename line
	IF (FULL_PRESENT) THEN
		CALL SYS$FAO ('!8XL  !70AS',, OUT_LN, %VAL(PID),
     &			IMAGE_128(1:IMAGE_L))
		CALL PUT_LINE (OUT_LN)
		MULTI_LINE = .TRUE.
	END IF

C--Separate multi-line output by 1 blank line
	IF (MULTI_LINE) CALL PUT_LINE (' ')

C--GETJPI loop ends here
8000	GOTO 2000
	END IF !JPISTAT (status return from $GETJPI)

C--Output count of processes
C  if zero, output "none" on current LINE, else output count in heading
	IF (PROC_COUNT .GT. 0) THEN
		WRITE (OUT_LN,8201) PROC_COUNT
8201		FORMAT (I3,' proc')
	ELSE
		OUT_LN='none'
		CALL PUT_LINE (OUT_LN)
		OUT_LN=' '
	END IF
	CALL LIB$PUT_SCREEN (OUT_LN(1:8) ,1,PROC_COL)
	CALL LIB$SET_CURSOR (LINE, 1)

C--Report non-existent processes
	IF (SEL_TARGET .GT. 0) THEN

	  IF (PID_PRESENT) THEN
	    DO N = 1, CMD_PID_N
	      IF (CMD_PID(N) .NE. 0) THEN
		OUT_LN = ' '
		CALL SYS$FAO ('  PID !XL not found',, OUT_LN,
     &			%VAL (CMD_PID(N)))
		CALL PUT_LINE (OUT_LN)
	      END IF
	    END DO
	  END IF

	  IF (UNM_PRESENT) THEN
	    DO N = 1, CMD_UNM_N
	      IF (.NOT. CMD_UNM_FOUND(N)) THEN
		OUT_LN = ' '
		CALL SYS$FAO ('  Process with username "!AS" not found',,
     &			OUT_LN, CMD_UNM(N)(1:CMD_UNM_L(N)))
		CALL PUT_LINE (OUT_LN)
	      END IF
	    END DO
	  END IF

	  IF (TERM_V_PRESENT) THEN
	    DO N = 1, CMD_TERM_N
	      IF (.NOT. CMD_TERM_FOUND(N)) THEN
		OUT_LN = ' '
		CALL SYS$FAO ('  Terminal "!AS" not found',, OUT_LN,
     &			CMD_TERM(N)(1:CMD_TERM_L(N)))
		CALL PUT_LINE (OUT_LN)
	      END IF
	    END DO
	  END IF

	  IF (PROC_PRESENT) THEN
	    DO N = 1, CMD_PROC_N
	      IF (.NOT. CMD_PROC_FOUND(N)) THEN
		OUT_LN = ' '
		CALL SYS$FAO ('  Process named "!AS" not found',, OUT_LN,
     &			CMD_PROC(N)(1:CMD_PROC_L(N)))
		CALL PUT_LINE (OUT_LN)
	      END IF
	    END DO
	  END IF

	  IF (IMAGE_PRESENT) THEN
	    DO N = 1, CMD_IMAGE_N
	      IF (.NOT. CMD_IMAGE_FOUND(N)) THEN
		OUT_LN = ' '
		CALL SYS$FAO ('  Process running image "!AS" not found',,
     &			OUT_LN, CMD_IMAGE(N)(1:CMD_IMAGE_L(N)))
		CALL PUT_LINE (OUT_LN)
	      END IF
	    END DO
	  END IF
	END IF

	  IF (MODE_PRESENT) THEN
	    DO N = 1, CMD_MODE_N
	      IF (.NOT. CMD_MODE_FOUND(N)) THEN
		OUT_LN = ' '
		CALL SYS$FAO ('  "!AS" mode process not found',, OUT_LN,
     &			CMD_MODE(N))
		CALL PUT_LINE (OUT_LN)
	      END IF
	    END DO
	  END IF

	  IF (STATE_PRESENT) THEN
	    DO N = 1, CMD_STATE_N
	      IF (.NOT. CMD_STATE_FOUND(N)) THEN
		OUT_LN = ' '
		CALL SYS$FAO ('  Process in state "!AS" not found',, OUT_LN,
     &			CMD_STATE(N)(1:CMD_STATE_L(N)))
		CALL PUT_LINE (OUT_LN)
	      END IF
	    END DO
	  END IF

	IF (PROC_COUNT .EQ. 0   .AND.   .NOT. OKNONE) CALL EXIT

C--/INTERVAL loop ends here
	IF (REPEAT) THEN
		IF (NOSCROLL) THEN
			CALL LIB$ERASE_PAGE (LINE, 1)
			LINE=TOP
		END IF
		!wait here for timer expiration
		CALL SYS$WAITFR (%VAL(TIMER_EFN))
		GOTO 1000
	END IF

	CALL EXIT

	END !--------------------------------------------WHO mainline--

	SUBROUTINE PUT_LINE (OUT_LN) 	!--Output line and increment counter
	IMPLICIT INTEGER (A-Z)
	CHARACTER	OUT_LN*(*)

	!Scrolling region parameters, $GETJPI return code, #proc's
	COMMON		/WHOCOM/	TOP, BOTTOM, LINE, JPISTAT,
     &					PROC_COUNT, SEL_TARGET

	CALL LIB$PUT_LINE (OUT_LN)
	LINE=MIN (BOTTOM, LINE +1)
	RETURN
	END !------------------------------------------------PUT_LINE--

	INTEGER*4 FUNCTION TIME6 (QTIME, ATIME)	!--convert times to 6 char form
	IMPLICIT INTEGER (A-Z)

	INTEGER*2	WTIME(7), WBRKT(7,5), WLIM(7)
	INTEGER*4	QTIME(2)
	CHARACTER	ATIME*6, FMT(4)*10

C--Time brackets
	DATA	WBRKT /
C1  "0000 00:00:00.00" thru "0000 00:00:59.99" >>> 	59.99s
     +		2*0,	     0000,00,00,59,99,
C2  "0000 00:01:00.00" thru "0000 00:59:59.99" >>> 	59m59s
     +		2*0,	     0000,00,59,59,99,
C3  "0000 01:00:00.00" thru "0000 23:59:59.99" >>> 	23h59m
     +		2*0,	     0000,23,59,59,99,
C4  "0001 00:00:00.00" thru "0099 23:59:59.99" >>> 	99d23h
     +		2*0,	     0099,23,59,59,99,
C5  "0100 00:00:00.00" thru "9999 23:59:59.99" >>> 	 9999d
     +		2*0,	     9999,23,59,59,99 /

C--Time component limits
	DATA	WLIM / 2*0, '7FFF'x, 24, 60, 60, 100 /

C--Output formats (FAO)
	DATA	FMT /
     +			'!2SW.!2ZWs',		!59.99s
     +			'!2SWm!2SWs',		!59m59s
     +			'!2SWh!2SWm',		!23h59m
     +			'!2SWd!2SWh' /		!99d23h
!bracket 5		'!5SWd' 		!99999d

C--Convert 64bit delta-time to 7 WORD integers
	RET = SYS$NUMTIM (WTIME, QTIME)
	IF (.NOT. RET) CALL LIB$SIGNAL (%VAL(RET))
	IF (WTIME(1)+WTIME(2) .NE. 0) GOTO 81000	!exit if not delta time

C--Find bracket
	T = 3
	BR = 1
	DO WHILE (
     +		(WTIME(T) .GE. WBRKT(T,BR))   .AND.
     +		(T .LE. 7)   .AND.   (BR .LT. 5)
     +		 )
	    IF (WTIME(T) .EQ. WBRKT(T,BR)) THEN
		T = T +1
	    ELSE
		T = 3
		BR = BR +1
	    END IF
	END DO

C--Format for output
	IF (BR .LT. 5) THEN
		T1 = 7 -BR
		T2 = T1 +1
		RET = SYS$FAO (FMT(BR), L, ATIME, 
     +			%VAL(WTIME(T1)), %VAL(WTIME(T2)))
	ELSE
		RET = SYS$FAO ('!5SWd', L, ATIME, %VAL(WTIME(3)))
	END IF

C--Normal exit
	TIME6 = 1
	RETURN

C--Error exit
81000	TIME6 = 4
	RETURN

	END !---------------------------------------------------TIME6--

	SUBROUTINE REAL2ASCII (RNUM, ANUM, LEN)
	IMPLICIT INTEGER (A-Z)

	REAL*4		RNUM
	CHARACTER	ANUM*(*)

	WHOLE = INT (RNUM)
	FRAC = INT ((RNUM -WHOLE) *100)
	ANUM = ' '
	RET = SYS$FAO ('!SL.!2ZL', LEN, ANUM, %VAL(WHOLE), %VAL(FRAC))
	IF (.NOT. RET) CALL EXIT (RET)

	RETURN
	END !----------------------------------------------REAL2ASCII--

	SUBROUTINE WHO_EXIT (STATUS)	!--Exit handler
	IMPLICIT INTEGER (A-Z)

	CHARACTER	OUT_LN*80, MSG*80

	!Scrolling region parameters, $GETJPI return code, #proc's
	COMMON		/WHOCOM/	TOP, BOTTOM, LINE, JPISTAT,
     &					PROC_COUNT, SEL_TARGET

	IF (LINE .GE. BOTTOM-1) THEN
		CALL LIB$SET_SCROLL (TOP,BOTTOM)
		CALL LIB$SET_CURSOR (LINE,1)
		CALL PUT_LINE (' ')
		CALL PUT_LINE (' ')
		CALL LIB$SET_CURSOR (LINE-2,1)
	END IF

	SEVERITY = 1
	IF (SEL_TARGET .GT. 0) SEVERITY = 4
	FINAL_STATUS = '10000000'X +PROC_COUNT *256 +SEVERITY
	IF (.NOT. FINAL_STATUS) THEN
	  OUT_LN = ' '
	  CALL SYS$FAO ('%WHO-F-NOTFND, !SL selected but not found.',,
     &		OUT_LN, %VAL(SEL_TARGET))
	  CALL PUT_LINE (OUT_LN)
	END IF

	IF (JPISTAT) THEN
		MSG = ' '
	ELSE
		CALL SYS$GETMSG (%VAL (JPISTAT), MSGLEN, MSG,,)
	ENDIF
	CALL SYS$FAO ('[WHO Exit !XL] !AS',, OUT_LN, %VAL (JPISTAT), MSG)
	CALL PUT_LINE (OUT_LN)
	CALL LIB$SET_SCROLL (1,24)
	CALL EXIT (FINAL_STATUS)
	END !------------------------------------------------WHO_EXIT--
