$! CONVERTER.COM	DECALC V3 CONVERT GRID
$
$! I created this procedure because the CALC$CONVERT_GRIDS.COM supplied with
$! DECALC V3 is difficult to convert all the users on a given pack and it aborts
$! when severe errors are detected.
$! 
$! WARNING:  1.	After you restore this command, edit it thoroughly. It is setup
$! 		in a test mode and deletes all the files in the test directory:
$! 
$! 			WORKA:[BAKER.CONVERTER_GRIDS]
$! 
$! 		You will find the delete following the label: DO_DIR:
$! 
$!	     2.	Only allow one version of this procedure to run at the same 
$!		time. It creates several files in the default directory which
$! 		is set at the beginning of the procedure.
$! 
$! The procedure can operate in several modes:
$!	
$!   1.	Test:	Mode as delivered. This allows you to determine which grids
$!		will not convert for several reasons. See ACTION.DOC.
$!	
$!   2.	Pre-conversion user action:
$!	
$!	Enable the GOSUB MAIL_LOG to send the ACTION.DOC AND USER.LOG to each 
$!	user. See DECAL2.COM for ideas on how to collect grid passwords.
$!		
$!   3. Conversion:
$!	
$!	Besure to follow and edit all the lines with "<-<<<":
$!
$!		ENABLE: RENAME CONVERTED TO .CON
$!		ENABLE: MAIL USER.LOG TO USER
$!		ENABLE: CREATE [<user>.DECALC_GRIDS]
$!		Define your password file.
$!
$! After the run:
$!
$!	Check for any errors in this commands log file.
$!
$!	Delete all *.CALC$LOG;* from out directories.
$!	
$! Restarts:
$!	
$!	The rename of *.GRD to *.CON is done to facilitate restarts and prevent
$!	the grid from being converted twice. This is very important because we
$!	want to keep the version=1 on the directories. See "CRE_OUT_DIR:".
$!	
$! Input parameter (P1):
$!
$!	Must be a wild card to locate decalc private or common directories:
$!
$!		WORKA:[*...]HOO*.DIR	 All user private directories on a pack
$!		
$!		WORKA:[DECALC...]*.DIR	 Our department commons
$!	
$!	Do not use a P1 as follows:
$!	
$!			WORKA:[000000]DECALC*.DIR	 
$!	
$!		If you have such a common directory modify the definition of
$!		DECALC$OUT logical and symbol for the correct value.
$!	
$! NOTE:	Our common directories are under directory [DECALC], so some
$!		logic tests for this directory. 
$!
$! Tip:	Rename the HOO*.DIR to WOO*.DIR to cause converter to bypass a user.
$!
$
$	SET NOVER
$
$ 	WTO	:== WRITE SYS$OUTPUT
$
$	SHO TIME
$
$	SET DEF [ directory where you put this command and DECALC_V3NAME.COM ]
$
$	DEF/NOLOG DECALC$PSWD NONE	! <---<<< PROD DEF PASSWORD FILE
$
$	DEF/NOLOG DECALC$FILE CALC$SELECT_GRID.TMP
$
$	GOSUB TOP_PAGE
$	WTO ""
$	WTO "*** START DISK: ''P1'"
$	WTO ""
$
$ 	ON ERROR THEN GOTO BOMBER
$
$	ON CONTROL_Y THEN GOTO CTRL_Y
$
$	DEF/NOLOG DECALC$OUT	WORKA:[BAKER.CONVERTER_GRIDS] ! <--<<< REM PROD
$	
$	DECALC$OUT = "WORKA:[BAKER.CONVERTER_GRIDS]"	      ! <--<<< REM PROD
$	
$ CHECK_HOO:
$	
$	T_PRIV_DIR = F$SEARCH("''P1'",1)
$
$	IF T_PRIV_DIR .EQS. "" THEN GOTO HOO_END
$
$	T_BRACKET = F$LOCATE("]",T_PRIV_DIR)
$	
$	PRIV_DIR_ROOT = F$EXTRACT(0, T_BRACKET, T_PRIV_DIR)
$
$	USER_NAME = F$EXTRACT(F$LOCATE("[",PRIV_DIR_ROOT) + 1,32,PRIV_DIR_ROOT)
$
$	T_PERIOD = F$LOCATE(".DIR",T_PRIV_DIR)
$
$	PRIV_DIR = PRIV_DIR_ROOT + "." + -
		   F$EXTRACT(T_BRACKET +1, T_PERIOD -T_BRACKET -1, T_PRIV_DIR) -
		   + "]"
$	
$	DEF/NOLOG  DECALC$IN	'PRIV_DIR'
$	
$	DECALC$IN = "''PRIV_DIR'"
$	
$	! CHECK FOR COMMON DIRECTORY VS. PRIVATE FOR DEFINING OUTPUT DIRECTORY:
$	
$	IF USER_NAME .EQS. "DECALC" THEN GOTO COMM_OUT
$	
$!	DEF/NOLOG DECALC$OUT	'PRIV_DIR_ROOT'.DECALC_GRIDS] !	<-<<< PROD 
$	
$!	DECALC$OUT = "''PRIV_DIR_ROOT'.DECALC_GRIDS]"	      ! <-<<< PROD
$	
$	GOTO START_USER
$	
$ COMM_OUT:	
$	
$!	DEF/NOLOG  DECALC$OUT	'PRIV_DIR'	! <-<<< PROD
$	
$!	DECALC$OUT = DECALC$IN			! <-<<< PROD
$	
$ START_USER:
$
$	GOSUB TOP_PAGE
$	WTO ""
$	WTO "*** START USER: ''PRIV_DIR'"
$	WTO ""
$	
$	T_NAME_FILE = F$SEARCH("''PRIV_DIR'DECALC*.NAM",2)
$
$	IF T_NAME_FILE .NES. "" THEN GOTO HAVE_NAME
$	
$	WTO "%%%% NO NAME FILE"
$	
$	GOTO CHECK_HOO
$	
$ HAVE_NAME:
$	
$	OPEN/WRITE ULOG USER.LOG
$	
$	WRITE ULOG ""
$	WRITE ULOG "''PRIV_DIR'" ! <-<<< PROD CHG NEXT LINE
$	WRITE ULOG ""
$!<-<<<	WRITE ULOG "*** DECALC VERSION 3 CONVERSION STATUS     LIST         ''F$TIME()'"
$	WRITE ULOG "*** DECALC VERSION 3 PRE-CONVERSION ACTION LIST         ''F$TIME()'"
$	WRITE ULOG ""
$	WRITE ULOG "                                               DATE     "
$	WRITE ULOG "    VERSION 2 GRID NAME                      CREATION  VER."
$	WRITE ULOG "GRD -------------------                      --------  ----"
$	WRITE ULOG "NO. VERSION 3 GRID NAME                      MODIFIED  SIZE OWNER NAME"
$	WRITE ULOG "--- ---------------------------------------- --------- ---- --------------------"
$	WRITE ULOG ""
$
$	OPEN/READ NF 'T_NAME_FILE'
$	
$	READ/END=DO_DIR NF NF_REC
$	
$ READ_LOOP:
$	
$	READ/END=DO_DIR NF NF_REC
$	
$	T_LEN = F$CVUI(0, 8, F$EXTRACT( 23, 1,NF_REC))
$
$	GRID_NAME = F$EXTRACT(24,T_LEN,NF_REC)
$
$	G_NUM	= F$CVUI(0, 8, F$EXTRACT( 21, 1,NF_REC))
$	
$	NF_DELETE = F$CVUI(0, 8, F$EXTRACT(  0, 1,NF_REC))
$
$	! SKIP DELETED GRIDS, ODD MAN OUT:
$
$	IF NF_DELETE/2*2 .NE. NF_DELETE  THEN GOTO READ_LOOP 
$
$	IF F$EDIT(GRID_NAME,"COLLAPSE") .EQS. "" THEN GOTO READ_LOOP
$
$	ERROR_SW = 0
$
$	WTO ""
$	WTO "''PRIV_DIR' ''GRID_NAME'	--------------------------------------"
$	WTO ""
$
$	V3_GRID_NAME == GRID_NAME
$	
$	SPEC_CHAR_CNT == 0
$	
$	@DECALC_V3NAME	! GO CONVERT GRID NAME TO V3 FORMAT
$	
$	G_SIZE = 0
$	
$	T_GN = F$FAO("!5ZL",G_NUM)
$	
$	G_FILE = F$SEARCH("''PRIV_DIR'*''T_GN'*.GRD;*",3)
$
$	IF G_FILE .EQS. "" THEN GOTO NOT_FOUND
$	
$	G_SIZE	= F$FILE_ATTRIBUTES(G_FILE, "ALQ")
$
$	G_CRE	= F$FILE_ATTRIBUTES(G_FILE, "CDT")
$
$	G_CRE	= F$EXTRACT(0,7,G_CRE) + F$EXTRACT(9,2,G_CRE)
$
$	G_MOD	= F$FILE_ATTRIBUTES(G_FILE, "RDT")
$
$	G_MOD	= F$EXTRACT(0,7,G_MOD) + F$EXTRACT(9,2,G_MOD)
$
$	G_MEM	= F$FILE_ATTRIBUTES(G_FILE,"MBM")
$
$	G_GRP 	= F$FILE_ATTRIBUTES(G_FILE,"GRP")
$
$	G_ID	= F$IDENTIFIER( G_MEM + (%X10000 * G_GRP),"NUMBER_TO_NAME")
$
$	IF G_ID .EQS. "" THEN G_ID = F$FILE_ATTRIBUTES(G_FILE,"UIC")
$
$	G_VER	= F$INTEGER(F$EXTRACT(F$LOCATE(";",G_FILE) + 1, 5, G_FILE))
$
$ NOT_FOUND:
$	
$	IF G_SIZE .NE. 0 THEN GOTO SIZE_OK
$	
$	WRITE ULOG F$FAO("!3UL !40AS ", -
		   G_NUM, GRID_NAME)
$
$	WRITE ULOG F$FAO("    !40AS ", -
			V3_GRID_NAME)
$	
$	WRITE ULOG ""
$	
$	WRITE ULOG "    SEVERE  - GRID FILE IS MISSING.                      SEE THE SYSTEM MANAGER."
$	
$	WTO ""
$	WTO "    SEVERE  - GRID FILE IS MISSING.                      SEE THE SYSTEM MANAGER."
$	
$	ERROR_SW = 2
$
$	GOTO CHECK_TRUNK
$	
$ SIZE_OK:
$
$	WRITE ULOG F$FAO("!3UL !40AS !9AS !4UL !20AS", -
		   G_NUM, GRID_NAME, G_CRE, G_VER, G_ID)
$
$	WRITE ULOG F$FAO("    !40AS !9AS !4UL", -
			V3_GRID_NAME, G_MOD, G_SIZE)
$	
$	WRITE ULOG ""
$	
$	WTO F$FAO("!3UL !40AS !9AS !4UL !20AS", -
		   G_NUM, GRID_NAME, G_CRE, G_VER, G_ID)
$
$	WTO F$FAO("    !40AS !9AS !4UL", -
			V3_GRID_NAME, G_MOD, G_SIZE)
$	
$	WTO ""
$	
$ CHECK_TRUNK:
$
$	L = F$LENGTH("''F$EDIT(GRID_NAME,"TRIM,COMPRESS")'") 
$
$	IF F$LENGTH("''F$EDIT(GRID_NAME,"TRIM,COMPRESS")'") .LT. 40 THEN -
								GOTO LEN_OK
$
$	WRITE ULOG "    WARNING - GRID NAME WILL BE TRUNCATED.                 CHANGE THE GRID NAME."
$
$	WTO "    WARNING - GRID NAME WILL BE TRUNCATED.                 CHANGE THE GRID NAME."
$
$	ERROR_SW = 1
$
$ LEN_OK:	! <---<<< PROD ENABLE I DO NOT USE SPEC CHAR ROUTINE
$
$	IF SPEC_CHAR_CNT .EQ. 0 THEN GOTO CHECK_DUP
$
$!	WRITE ULOG "    WARNING - GRID NAME HAS SPECIAL CHARACTERS.            CHANGE THE GRID NAME."
$
$!	WTO "    WARNING - SPECIAL CHARACTERS IN GRID NAME CHANGED TO $.    CHANGE GRID NAME."
$
$!	ERROR_SW = 1
$
$ CHECK_DUP:
$
$	IF F$SEARCH("''DECALC$OUT'''V3_GRID_NAME'.CALC$GRD",4) .EQS. "" THEN -
			GOTO NO_DUP
$	
$	WRITE ULOG "    SEVERE  - VERSION 3 GRID NAME IS A DUPLICATE.          CHANGE THE GRID NAME."
$	
$	WTO "    SEVERE  - VERSION 3 GRID NAME IS A DUPLICATE.          CHANGE THE GRID NAME."
$	
$	ERROR_SW = 2
$
$	GOTO ULOG_END2
$	
$ NO_DUP:
$	
$	IF G_SIZE .EQ. 0 THEN GOTO ULOG_END2
$	
$	WTO ""
$	WTO "***  CONVERTING >>>---> ''GRID_NAME'"
$
$	OPEN/WRITE DF DECALC$FILE
$
$	WRITE DF GRID_NAME
$
$	CLOSE DF
$
$	PUR/NOLOG DECALC$FILE
$
$	IF USER_NAME .EQS. "DECALC" THEN GOTO SKIP_DIR ! BYPASS FOR COMMON DIR
$	
$!	GOSUB CRE_OUT_DIR	! <-<<< PROD
$
$ SKIP_DIR:
$
$	ON SEVERE_ERROR THEN GOTO CONV_BOMBER
$
$	RUN CALC$UTILITY:CALC$CONVERT_GRIDS/NODEBUG
$	
$ 	ON ERROR THEN GOTO BOMBER
$
$	CLOG_REC = "CALC$LOG MISSING"
$	
$	OPEN/READ/ERR=CLOG_OTHER CLOG 'DECALC$OUT'CONVERT_GRIDS.CALC$LOG 
$	
$ CLOG_READ:
$	
$	READ/END=ULOG_END CLOG CLOG_REC
$	
$	T_POS = F$LOCATE(".CALC$GRD",CLOG_REC)
$
$	IF T_POS .EQ. F$LENGTH(CLOG_REC) THEN GOTO NOT_CLOG_V3
$	
$	T_NAME = F$EDIT(F$EXTRACT(0,T_POS,CLOG_REC), "TRIM")
$
$	IF T_NAME .EQS. V3_GRID_NAME THEN GOTO NOT_CLOG_V3
$	
$	WTO " *** XXX V3_GRID_NAME DOSENT MATCH:"
$
$	WTO "''V3_GRID_NAME'<"
$
$	WTO "''T_NAME'<---<"
$	
$ NOT_CLOG_V3:
$
$	IF F$LOCATE("*** CONVERSION FAILED ***",CLOG_REC) .EQ. -
					F$LENGTH(CLOG_REC) THEN GOTO CLOG_READ
$	
$	READ/END=ULOG_END CLOG CLOG_REC
$	
$	IF F$LOCATE("Invalid Password",CLOG_REC) .EQ. -
					F$LENGTH(CLOG_REC) THEN GOTO CLOG_WRITE
$	
$	WRITE ULOG "    WARNING - GRID PASSWORD IS UNKNOWN.   ENTER THE PASSWORD FOR THE CONVERSION."
$	
$	WTO "    WARNING - GRID PASSWORD IS UNKNOWN.   ENTER THE PASSWORD FOR THE CONVERSION.
$	
$	ERROR_SW = 2
$
$	GOTO ULOG_END
$
$ CLOG_WRITE:
$	
$	IF F$LOCATE("File write",CLOG_REC) .EQ. -
					F$LENGTH(CLOG_REC) THEN GOTO CLOG_OTHER
$	WRITE ULOG "    SEVERE  - CONVERSION FAILED: File write failed.      SEE THE SYSTEM MANAGER."
$
$	WTO "    SEVERE  - CONVERSION FAILED: File write failed.      SEE THE SYSTEM MANAGER.
$
$	ERROR_SW = 2
$
$	GOTO ULOG_END
$
$ CLOG_OTHER:
$	
$	WTO "    UNEXPECTED - " + F$EDIT(CLOG_REC,"TRIM,COMPRESS") + " SEE THE SYSTEM MANAGER."
$	
$	ERROR_SW = 2
$
$ ULOG_END:
$
$	CLOSE CLOG
$
$ ULOG_END2:
$
$!	IF ERROR_SW .LT. 2 THEN RENA 'G_FILE' .CON/LOG !<--<<< PROD
$	
$	IF ERROR_SW .EQ. 2 THEN WRITE ULOG "    GRID WILL NOT BE CONVERTED." !<-<<< UPDATE FOR PROD WAS NOT
$	
$	IF ERROR_SW .NE. 0 THEN WRITE ULOG ""
$	
$	GOTO READ_LOOP
$
$ CONV_BOMBER:
$	
$ 	ON ERROR THEN GOTO BOMBER
$
$	WRITE ULOG "    SEVERE  - CONVERSION FAILED: Internal Fatal Error.   SEE THE SYSTEM MANAGER."
$
$	WTO "    SEVERE  - CONVERSION FAILED: Internal Fatal Error.   SEE THE SYSTEM MANAGER."
$
$	ERROR_SW = 2
$
$	GOTO ULOG_END2
$
$ DO_DIR:
$
$	CLOSE NF
$	
$	CLOSE ULOG
$
$	DI/DAT=(CRE,MOD)/SIZ=ALL 'DECALC$IN'
$	
$	IF F$SEARCH("''PRIV_DIR_ROOT']DECALC_GRIDS.DIR",5) .NES. "" THEN -
					DI/DAT=(CRE,MOD)/SIZ=ALL 'DECALC$OUT'
$	
$	DEL WORKA:[BAKER.CONVERTER_GRIDS]*.*;*	! <--<<< PROD REMOVE
$	
$!	GOSUB MAIL_LOG	!<--<<< PROD
$	
$	GOTO CHECK_HOO
$	
$ HOO_END:
$
$	WTO ""
$	WTO "*** COMPLETE ''P1'"
$	WTO ""
$
$	SHO TIME
$
$	EXIT 1
$
$ CTRL_Y:
$	
$ BOMBER:
$
$	OPEN  DF NL:
$	
$	CLOSE DF
$	
$	OPEN  NF NL:
$	
$	CLOSE NF
$	
$	OPEN  CLOG NL:
$	
$	CLOSE CLOG
$	
$	OPEN  ULOG NL:
$	
$	CLOSE ULOG
$	
$	SHO TIME
$
$	EXIT 1
$	
$ MAIL_LOG:	
$	
$	IF F$LOCATE("HOO",DECALC$IN) .EQ. F$LENGTH(DECALC$IN) THEN RETURN
$	
$ 	ON ERROR THEN GOTO MAIL_BOMBER
$
$	MAIL/SUB="DECALC VERSION 3 PRE-CONVERSION ACTION LIST DOCUMENTATION" ACTION.DOC -
								'USER_NAME'
$	
$	MAIL/SUB="DECALC VERSION 3 PRE-CONVERSION ACTION LIST" USER.LOG -
								'USER_NAME'
$	
$ 	ON ERROR THEN GOTO BOMBER
$	
$	RETURN
$	
$ MAIL_BOMBER:
$	
$ 	ON ERROR THEN GOTO BOMBER
$
$	WTO ""
$	WTO "*** XXX MAIL USER.LOG TO ''USER_NAME' FAILED"
$	WTO ""
$	
$	RETURN
$	
$ CRE_OUT_DIR: ! CHECK USER HAS A DECALC V3 DIR IF NOT CREATE IT	
$	
$	IF F$SEARCH("''PRIV_DIR_ROOT']DECALC_GRIDS.DIR",5) .NES. "" THEN RETURN
$	
$!<--<<<  NOTE:	THE CREATE/DIRECTORY SETS VERSION = 1. YOU MAY NOT WANT THIS.
$	
$	CRE/DIR/VER=1/PROT=(G,W) ['PRIV_DIR_ROOT'.DECALC_GRIDS]/LOG
$	
$	RETURN
$	
$ TOP_PAGE:
$
$	WTO ""
$	RETURN
