$! DECALCON.COM	CONVERT V2.2 GRIDS TO V3
$!	
$!	This is the interactive single grid convert called by DECAL2.COM.
$!	
$!	The CALC$CONVERT_GRIDS.COM allows the user to convert all his grids
$!	at once. This will has a considerable impact on response time.
$!	
$
$	ON ERROR THEN GOTO BOMBER
$
$	SYS$IN_SAVE = F$TRNLNM("SYS$INPUT")
$
$	T_PRIV_DIR = F$SEARCH("HOO*.DIR")
$	
$	IF T_PRIV_DIR .NES. "" THEN GOTO HOO_EXISTS
$	
$	WRITE SYS$OUTPUT ""
$	WRITE SYS$OUTPUT "YOU DO NOT HAVE A DECALC VERSION 2 DIRECTORY"
$	WRITE SYS$OUTPUT ""
$	WRITE SYS$OUTPUT "USE OF THIS PROCEDURE IS UNNECESSARY."
$	
$ 	WRITE SYS$OUTPUT ""
$
$ 	INQUIRE ANS "DEPRESS RETURN TO CONTINUE"
$
$	EXIT 1
$	
$ HOO_EXISTS:
$	
$	@DECALCDIR	! CHECK USER HAS A V3 GRID DIR
$	
$	T_BRACKET = F$LOCATE("]",T_PRIV_DIR)
$	
$	T_PRIV_DIR_ROOT = F$EXTRACT(0, T_BRACKET, T_PRIV_DIR)
$	
$	T_PERIOD = F$LOCATE(".",T_PRIV_DIR)
$
$	PRIV_DIR = T_PRIV_DIR_ROOT + "." + -
		   F$EXTRACT(T_BRACKET +1, T_PERIOD -T_BRACKET -1, T_PRIV_DIR) -
		   + "]"
$	
$	DEF/NOLOG DECALC$IN	'PRIV_DIR'
$	
$	DEF/NOLOG DECALC$OUT	'T_PRIV_DIR_ROOT'.DECALC_GRIDS]
$	
$ 	ASSIGN/USER/NOLOG TT SYS$INPUT
$
$ DGC_ASK_DIR:
$
$	WRITE SYS$OUTPUT ""
$	
$	INQ COM_DIR "DO YOU WANT TO CONVERT A GRID IN YOUR COMMON DIRECTORY [NO]"
$	
$	COM_DIR = F$EDIT(COM_DIR,"COLLAPSE,UPCASE")
$
$	IF COM_DIR .EQS. "\" THEN GOTO CLEANUP
$	
$	IF COM_DIR .EQS. "" THEN COM_DIR = "NO"
$	
$	IF 	COM_DIR .EQS. "NO"	.OR. -
		COM_DIR .EQS. "N"	THEN GOTO DGC_PRIV
$	
$	IF 	COM_DIR .EQS. "YES"	.OR. -
		COM_DIR .EQS. "Y"	THEN GOTO COM_DIR
$	
$	WRITE SYS$OUTPUT ""
$	WRITE SYS$OUTPUT "ERROR - PLEASE RESPOND WITH YES OR NO"
$	
$	GOTO DGC_ASK_DIR
$	
$ COM_DIR:
$	
$	COM_DIR = F$TRNLNM("CALC$COMMON")
$
$	DEF/NOLOG DECALC$IN	'COM_DIR'
$	
$	DEF/NOLOG DECALC$OUT	'COM_DIR'
$	
$	IF F$SEARCH("DECALC$OUT:CONVERT_GRIDS.CALC$LOG") .EQS. "" THEN -
							GOTO PUT_IN_USE
$
$	WRITE SYS$OUTPUT ""
$	WRITE SYS$OUTPUT "SORRY, ANOTHER USER IS CONVERTING A GRID IN YOUR"
$	WRITE SYS$OUTPUT ""
$	WRITE SYS$OUTPUT "COMMON DIRECTORY. PLEASE TRY LATER"
$	WRITE SYS$OUTPUT ""
$ 
$ 	INQUIRE ANS "DEPRESS RETURN TO CONTINUE"
$
$	EXIT 1
$ 
$ PUT_IN_USE:	! CREATE A DUMMY LOG UNTIL CONVERT CREATES THE REAL ONE. 
$		! You can not have more then one user creating the .calc$log
$		! at the same time.
$ 
$	OPEN/WRITE IN_USE DECALC$OUT:CONVERT_GRIDS.CALC$LOG
$ 
$	WRITE IN_USE -
		"''F$GETSYI("NODENAME")' " + -
		"''F$EDIT(F$GETJPI("","USERNAME"),"COLLAPSE")' " + -
		"''F$TRNLNM("TT") ''F$GETJPI("", "PID")' ''F$TIME()"
$ 
$	CLOSE IN_USE
$ 
$ DGC_PRIV:
$	
$	WRITE SYS$OUTPUT ""
$	WRITE SYS$OUTPUT "*** BUILDING GRID LIST -- PLEASE WAIT FOR PROMPT ***"
$	WRITE SYS$OUTPUT ""
$	
$	DEF/NOLOG SYS$INPUT 'SYS$IN_SAVE'
$	
$	SHO LOG SYS$INPUT/OUT=NL: ! THIS IS REALLY NEED TO MAKE DECALCON2 WORK
$
$	@DECALCON2/OUT=NL:	'F$TRNLNM("DECALC$IN")' -
					'F$TRNLNM("DECALC$OUT")'
$	
$	WRITE SYS$OUTPUT "YOU WILL NOW BE ASKED TO SPECIFY WHICH GRID WITHIN THE INPUT"
$	WRITE SYS$OUTPUT "DIRECTORY YOU WISH TO CONVERT."
$
$	DEF/NOLOG DECALC$PSWD CALC$SELECT_PSWD.TMP
$	DEF/NOLOG DECALC$FILE CALC$SELECT_GRID.TMP
$
$ 	ASSIGN/USER/NOLOG TT SYS$INPUT
$
$	RUN DECALC_SELECT_GRID
$
$	IF F$FILE_ATTRIBUTES("CALC$SELECT_GRID.TMP","EOF") .EQ. 0 THEN -
								GOTO CLEANUP
$
$	SET FILE/PROT=(G,W)/ERASE CALC$SELECT_PSWD.TMP	! SECURE PSWD FILE
$
$	OPEN/READ GTMP CALC$SELECT_GRID.TMP
$	
$	READ GTMP GTMP_REC
$
$	GRID_NAME = GTMP_REC
$
$	CLOSE GTMP
$	
$	V3_GRID_NAME == GRID_NAME
$	
$	@DECALC_V3NAME	! GO CONVERT GRID NAME TO V3 FORMAT
$	
$	WRITE SYS$OUTPUT "VERSION 2 GRID NAME: ''GRID_NAME'"
$	WRITE SYS$OUTPUT ""
$	WRITE SYS$OUTPUT "VERSION 3 GRID NAME: ''V3_GRID_NAME'"
$	WRITE SYS$OUTPUT ""
$	
$	L = F$LENGTH("''F$EDIT(GRID_NAME,"TRIM,COMPRESS")'") 
$
$	IF F$LENGTH("''F$EDIT(GRID_NAME,"TRIM,COMPRESS")'") .GT. 39 THEN -
		WRITE SYS$OUTPUT "GRID NAME WILL BE TRUNCATED"
$
$	IF F$SEARCH("DECALC$OUT:''V3_GRID_NAME'.CALC$GRD") .EQS. "" THEN -
			GOTO NO_DUP
$	
$	WRITE SYS$OUTPUT ""
$	WRITE SYS$OUTPUT "A GRID WITH THEN VERSION 3 NAME EXISTS (''V3_GRID_NAME')."
$
$ ASK_ZAPPER:
$
$	WRITE SYS$OUTPUT ""
$	
$	INQ ZAPPER "DO YOU WANT TO REPLACE THE VERSION 3 GRID [NO]"
$	
$	ZAPPER = F$EDIT(ZAPPER,"COLLAPSE,UPCASE")
$
$	IF ZAPPER .EQS. "\" THEN GOTO CLEANUP
$	
$	IF ZAPPER .EQS. "" THEN ZAPPER = "NO"
$	
$	IF 	ZAPPER .EQS. "NO"	.OR. -
		ZAPPER .EQS. "N"	THEN GOTO CLEANUP
$	
$	IF 	ZAPPER .EQS. "YES"	.OR. -
		ZAPPER .EQS. "Y"	THEN GOTO NO_DUP
$	
$	WRITE SYS$OUTPUT ""
$	WRITE SYS$OUTPUT "ERROR - PLEASE RESPOND WITH YES OR NO"
$	
$	GOTO ASK_ZAPPER
$	
$ NO_DUP:
$	
$	WRITE SYS$OUTPUT ""
$	WRITE SYS$OUTPUT "***  CONVERT IN PROGRESS"
$
$	DEF/NOLOG SYS$INPUT 'SYS$IN_SAVE'
$	
$	SHO LOG SYS$INPUT/OUT=NL: ! THIS IS REALLY NEED TO MAKE DECALCON3 WORK
$
$	@DECALCON3/OUT=NL:	'F$TRNLNM("DECALC$IN")'		-
					'F$TRNLNM("DECALC$OUT")'	-
					'F$TRNLNM("DECALC$PSWD")'	-
					'F$TRNLNM("DECALC$FILE")'
$	
$	ROOT_DIR = F$TRNLNM("SYS$LOGIN")
$
$	COP DECALC$OUT:CONVERT_GRIDS.CALC$LOG 'ROOT_DIR'*.LIS
$
$	DEL DECALC$OUT:CONVERT_GRIDS.CALC$LOG;*
$
$ 	WRITE SYS$OUTPUT ""
$
$	T 'ROOT_DIR'CONVERT_GRIDS.LIS
$
$ 	ASSIGN/USER/NOLOG TT SYS$INPUT
$
$ CLEANUP:
$
$	SET NOON
$
$	SAVE_MESSAGE = F$ENVIORNMENT("MESSAGE")
$
$	SET MESSAGE /NOFACILITY/NOIDENTIFICATION/NOSEVERITY/NOTEXT
$
$	DEL CALC$SELECT_GRID.TMP;*
$
$	DEL CALC$SELECT_PSWD.TMP;*
$
$	DEL CALC$CONVERT_GRIDS.LIS;*
$
$	PURGE 'ROOT_DIR'CONVERT_GRIDS.LIS
$
$	DEASSIGN DECALC$IN
$	DEASSIGN DECALC$OUT
$	DEASSIGN DECALC$PSWD
$	DEASSIGN DECALC$FILE
$
$	SET ON
$
$	SET MESSAGE 'SAVE_MESSAGE'
$
$	GOTO EXIT
$
$ BOMBER:
$
$ 	WRITE SYS$OUTPUT ""
$ 	WRITE SYS$OUTPUT "DECALC GRID CONVERSION FAILED"
$
$ EXIT:
$
$ 	WRITE SYS$OUTPUT ""
$
$ 	INQUIRE ANS "DEPRESS RETURN TO CONTINUE"
$
$ 	IF F$SEARCH("DECALC$OUT:CONVERT_GRIDS.CALC$LOG") .EQS. "" THEN EXIT 1
$
$	SET NOON
$
$	SET MESSAGE /NOFACILITY/NOIDENTIFICATION/NOSEVERITY/NOTEXT
$
$	COP DECALC$OUT:CONVERT_GRIDS.CALC$LOG 'ROOT_DIR'*.LIS
$
$	DEL DECALC$OUT:CONVERT_GRIDS.CALC$LOG;*
$
$	SET MESSAGE /FACILITY/IDENTIFICATION/SEVERITY/TEXT
$
$	SET ON
$
$	EXIT 1
