$! Create data files with AI1 forms listed
$! for processing with DATATRIEVE to create a domain table.
$!
$! B. Z. Lederman
$!
$!	For V2.1 and newer, TRIM has changed (compared with V2.0)
$!
$! 23-Oct-1987	B. Z. Lederman	Change trim of first line of directories.
$!
$! This requires the TRIM utility supplied (supposedly) with AI1.
$! You should be in whatever account you normally use for AI1 system
$! management when you run this (or the same account you will use
$! when in DATATRIEVE to analyze this data).
$!
$ SET COMMAND OA$LIB:TRIM
$!
$! The idea is quite simple.  Get a listing (either of a forms library
$! or a script directory), use TRIM to strip out everything except
$! the raw data, sort it (partially to make it look nice and partially
$! because it should load faster and more cleanly into an indexed
$! file), and purge old copies.  A DATATRIEVE procedure reads the
$! sequential files created here to load the domain (table).
$!
$ FMS/DIR/OUT=OAFORM.SEQ OA$LIB:OAFORM
$ TRIM/FIRST=11 OAFORM.SEQ
$ SORT OAFORM.SEQ OAFORM.SEQ
$ PURGE OAFORM.SEQ
$!
$ FMS/DIR/OUT=MEMRES.SEQ OA$LIB:MEMRES
$ TRIM/FIRST=11 MEMRES.SEQ
$ SORT MEMRES.SEQ MEMRES.SEQ
$ PURGE MEMRES.SEQ
$!
$ FMS/DIR/OUT=MANAGER.SEQ OA$LIB:MANAGER
$ TRIM/FIRST=11 MANAGER.SEQ
$ SORT MANAGER.SEQ MANAGER.SEQ
$ PURGE MANAGER.SEQ
$!
$ DIR/COL=1/NOSIZE/NODATE/NOTRAIL/OUT=OADO.SEQ OA$DO:*.SCP
$ TRIM/FIRST=4/START="." OADO.SEQ
$ PURGE OADO.SEQ
$!
$ DIR/COL=1/NOSIZE/NODATE/NOTRAIL/OUT=OALIB.SEQ OA$LIB:*.SCP
$ TRIM/FIRST=4/START="." OALIB.SEQ
$ PURGE OALIB.SEQ
$!
$ EXIT
