# include	<ssdef.h>
# include	<stdio.h>

# define	MASTERSIZE	204
# define	UAI$_PWD	 18
# define	UAI$_SALT	 21
# define	UAI$_PWD_DATE	 27

struct DESC				/* Define a descriptor structure */
{
	long length;
	char *addr;
};

struct	ITEM
{
	short	len;		/* buffer length */
	short	item_code;	/* information item requested */
	char	*buf;		/* return buffer */
	int	*rlen;		/* return length */
};

main()
{

char pwd[8];
unsigned int salt;
char pwd_date[8];

struct
{
	struct	ITEM items[3];
	int	endoflist;
} itemlist				=
					{
		/* hashed pass	*/	8,UAI$_PWD,pwd		,0
		/* salt		*/	,4,UAI$_SALT,&salt	,0
		/* pwd date	*/	,8,UAI$_PWD_DATE,pwd_date,0
					};


char	username[32];
short	status;

struct DESC user;

int	counter,cmp,cmp2,cnt;

static char	usr[] = "USERS.DAT";
static char	old_masterfile[] = "MASTEROLD.DAT";
static char	new_masterfile[] = "MASTER.DAT";
static char	x_masterfile[] = "XMASTER.DAT";
static char	outfile[] = "OUTPUT.TMP";

FILE	*users;
FILE	*old_mas;
FILE	*new_mas;
FILE	*out;
FILE	*x_mas;		/* have we got a present for the users, or what??!! */

struct MASTER
{
	char username[32];
	unsigned int salt;
	char pwd_date[8];
	char pwd[20][8];
};

struct MASTER new_master;
struct MASTER old_master;

/******************************** Pass 1 ***************************************
* Pass 1 reads the UAF and extracts the necessary info into master.dat	       *
*******************************************************************************/

	itemlist.endoflist = 0;
	new_mas = fopen(new_masterfile,"w");
	users = fopen(usr,"r");
	user.addr = username;
	for (;;)
		{
		status = fscanf (users,"%s",username);
		if (status != 1)
		    break;

		user.length = strlen(username);
		status = sys$getuai(0,0,&user,&itemlist,0,0,0);
		if (status != SS$_NORMAL)
			{
			printf("GETUAI status = %d \n",status);
			exit(SS$_NORMAL);
			}

		strcpy(new_master.username,username);
		for(counter=strlen(new_master.username);counter < 31;counter++)
			new_master.username[counter] = 32;
		new_master.username[31] = 0;
		bytcpy(new_master.pwd_date,pwd_date,8);
		bytcpy(&new_master.pwd[0][0],pwd,8);
		new_master.salt = salt;
		status = fwrite(&new_master,MASTERSIZE,1,new_mas);
		if (status != 1)
		    {
		    printf("Error writing new_mas!\n");
		    exit(1);
		    }
		}
	fclose(new_mas);

/*********************************** Pass 2 ************************************
* Pass 2 reads master, updates masterold (into xmaster.old) and checks	       *
* passwords against the history. 					       *
*******************************************************************************/

	x_mas = fopen(x_masterfile,"w");
	new_mas = fopen(new_masterfile,"r");
	old_mas = fopen(old_masterfile,"r");
	out = fopen(outfile,"w");
	status = fread(&new_master,MASTERSIZE,1,new_mas);
	if (status != 1)
	    {
	    printf("Error reading new_mas!\n");
	    exit(1);
	    }
	status = fread(&old_master,MASTERSIZE,1,old_mas);
	if (status != 1)
	    {
	    printf("Error reading old_mas!\n");
	    exit(1);
	    }
	for(;;)
		{
		old_master.username[31] = 0;
		cmp = strncmp(old_master.username,new_master.username,32);
		if (cmp < 0)		/* IF OLD NAME < NEW NAME */
		    {
		    status = fread(&old_master,MASTERSIZE,1,old_mas);
		    if (status != 1)
			    break;
		    continue;
		    }
		if (cmp > 0)		/* IF OLD NAME > NEW NAME */
		    {
		    printf("New user %s \n",new_master.username);
		    status = fwrite(&new_master,MASTERSIZE,1,x_mas);
		    status = fread(&new_master,MASTERSIZE,1,new_mas);
		    if (status != 1)
			    break;
		    continue;
		    }
		/* IF THE PWD DATE HASN'T CHANGED, SIMPLY REWRITE OLD RECORD */
		if (bytcmp(new_master.pwd_date,old_master.pwd_date,8) == 0)
		    {
		    status = fwrite(&old_master,MASTERSIZE,1,x_mas);
		    goto read_next;
		    }
		/* IF THE SALT HAS CHANGED, SCRATCH PASSWORD HISTORY */
		if (new_master.salt != old_master.salt)
		    {
		    printf("Salt change for user %s (%d,%d) \n",
			new_master.username,old_master.salt,new_master.salt);
		    status = fwrite(&new_master,MASTERSIZE,1,x_mas);
		    goto read_next;
		    }
		/* SCAN THE PASSWORD HISTORY FOR A MATCH */
		for (cnt=0;cnt < 20;cnt++)
		    {
		    cmp2 = bytcmp(&new_master.pwd[0][0],
			&old_master.pwd[cnt][0],8);
		    if (cmp2 == 0)
			{
			printf("Re-used password for user %s \n",
			    new_master.username);
			fprintf(out,"%s\n",new_master.username);
			bytcpy(old_master.pwd_date,new_master.pwd_date,8);
			status = fwrite(&old_master,MASTERSIZE,1,x_mas);
			goto read_next;
			}
		    }
		printf("New password for user %s \n",new_master.username);
		bytcpy(&new_master.pwd[1][0],&old_master.pwd[0][0],152);
		status = fwrite(&new_master,MASTERSIZE,1,x_mas);
		goto read_next;

read_next:
		status = fread(&old_master,MASTERSIZE,1,old_mas);
		if (status != 1)
			break;
		status = fread(&new_master,MASTERSIZE,1,new_mas);
		if (status != 1)
			break;
		}
	fclose(new_mas);
	fclose(old_mas);
	fclose(x_mas);
	fclose(out);
}

/* BYTCMP compares two strings much like strncmp but does not terminate
	on nulls */

bytcmp(string1,string2,length)
char *string1;
char *string2;
int length;
{
	int counter;
	for (counter=0;counter < length;counter++)
		if (string1[counter] != string2[counter])
			return(-1);
	return(0);
}

/* BYTCPY copies one string to another much like strncpy but does not
	terminate on nulls */

bytcpy(string1,string2,length)
char *string1;
char *string2;
int length;
{
	int counter;
	for (counter=0;counter < length;counter++,string1++,string2++)
		*string1 = *string2;
	return(0);
}
