	/* include files */
# include	<jpidef.h>
# include	<ssdef.h>
# include	<ctype.h>
# include	<desc.h>
# include	<libdef.h>

main()
{
unsigned int current_cpu_sec, current_clock_sec;
unsigned int old_cpu_sec, old_clock_sec;

unsigned int shift = 10000000;

/* Raw times */
unsigned int raw_cpu_time;
unsigned int login_time[2], current_time[2], elapsed_time[2];

float	pct_since_login, pct_since_last;

char	cpu_sec[16],clock_sec[16];

char	says_cpu_text[16],says_clock_text[16];

struct DESC says_cpu;
struct DESC says_clock;
struct DESC cpu;
struct DESC clock;

struct
{
	short	status;
	short	len;
	int	info;
} iosb;

unsigned int	status;
int	counter, len;
int	pidcontext;		/* process id context for getjpi call	*/
int	sys$getjpiw();		/* getjpi system service returns an int	*/

struct	ITEM
{
	short	len;		/* buffer length			*/
	short	item_code;	/* information item requested		*/
	char	*buf;		/* return buffer			*/
	int	*rlen;		/* return length			*/
};

struct
{
	struct	ITEM items[2];
	int	endoflist;
} itemlist				=
					{
		/* cpu time	*/	4 , JPI$_CPUTIM	,&raw_cpu_time,0
		/* login time	*/	,8 ,JPI$_LOGINTIM,&login_time,0
					};

/* Set up some stuff for symbol definitions */
	strcpy(says_cpu_text,"cpu_sec");
	strcpy(says_clock_text,"clock_sec");
	says_cpu.addr = &says_cpu_text;
	says_cpu.length = strlen(says_cpu_text);
	says_clock.addr = &says_clock_text;
	says_clock.length = strlen(says_clock_text);

/* Get values from last run, if any */
	cpu.addr = &cpu_sec;
	cpu.length = 16;
	clock.addr = &clock_sec;
	clock.length = 16;
	status=lib$get_symbol(&says_cpu,&cpu,&len,&2);
	if (status == LIB$_NOSUCHSYM)
		old_cpu_sec = 0;
	    else
		if (status == SS$_NORMAL)
			{
			cpu_sec[len] = 0;
			sscanf(cpu_sec,"%d",&old_cpu_sec);
			}
	    else
		exit(status);

	status=lib$get_symbol(&says_clock,&clock,&len,&2);
	if (status == LIB$_NOSUCHSYM)
		old_clock_sec = 0;
	    else
		if (status == SS$_NORMAL)
			{
			clock_sec[len] = 0;
			sscanf(clock_sec,"%d",&old_clock_sec);
			}
	    else
		exit(status);

/* Get login time and cpu time */
	itemlist.endoflist = pidcontext = 0;
	status = sys$getjpiw(0,&pidcontext,0,&itemlist,&iosb,0,0);
	if (status != SS$_NORMAL)
		exit(status);
	if (iosb.status != SS$_NORMAL)
		exit(iosb.status);

/* Get current time */
	status = sys$gettim(&current_time);
	if (status != SS$_NORMAL)
		exit(status);

/* Find elapsed clock time since login */
	subquad (&current_time,&login_time,&elapsed_time);
	ediv (&elapsed_time,&shift,&current_clock_sec);

/* Find elapsed cpu time since login */
	current_cpu_sec = raw_cpu_time / 100;

/* Calculate percentages */
	pct_since_login = (((float)current_cpu_sec / (float)current_clock_sec)
		 * 100);
	pct_since_last = (((float)(current_cpu_sec - old_cpu_sec) /
			 (float)(current_clock_sec - old_clock_sec)) * 100);

/* Now print something */
	printf("%3.1f%% percent CPU used since last PCT command\n", pct_since_last);
	printf("%3.1f%% percent CPU used since login\n", pct_since_login);

/* Stash current values in symbols */
	sprintf(cpu_sec,"%d",current_cpu_sec);
	sprintf(clock_sec,"%d",current_clock_sec);
	cpu.addr = &cpu_sec;
	cpu.length = strlen(cpu_sec);
	clock.addr = &clock_sec;
	clock.length = strlen(clock_sec);
	status=lib$set_symbol(&says_cpu,&cpu,&2);
	if (status != SS$_NORMAL)
		{
		printf("Error %d defining symbol cpu_sec as %s\n",status,
				cpu_sec);
		}
	status=lib$set_symbol(&says_clock,&clock,&2);
	if (status != SS$_NORMAL)
		{
		printf("Error %d defining symbol clock_sec as %s\n",status,
				clock_sec);
		}

	exit(1);
}
