$ save_verify = f$verify(0)
$ !##################################################################
$ !
$ !  File : build_eveplus.com 
$ !	A procedure to correctly invoke the TPU editor to build
$ !	an EVE-PLUS as specified by the EVE-PLUS input provided
$ !	to this routine.  See the EVE-PLUS documentation for 
$ !	detailed desciption of how/why this utility does its thing.
$ !
$ !  Assumptions:
$ !	The logical name TPU$EVEPLUS points the directory containing
$ !	the EVEPLUS utilities.  The utility will abort if it is
$ !	not defined.
$ !
$ !  Developed by:      Denny Thury
$ !                     DCS VAX System Support
$ !                     13-Mar-1986
$ ! 
$ !##################################################################
$ !
$ !  Ensure reliable DCL commands
$ !
$ define = "define"
$ edit = "edit"
$ exit = "exit"
$ if = "if"
$ inquire = "inquire"
$ write = "write"
$ ss$_normal = %X10000001
$ ss$_abort = %X2C
$ !
$ if f$trnlnm("TPU$EVEPLUS") .nes. "" then goto master_ok
$ write sys$output "The logical name TPU$EVEPLUS is not defined"
$ write sys$output "Unable to build custom EVEPLUS"
$ stat = ss$_abort
$ goto common_exit
$ !
$master_ok:
$ !
$ ! Obtain parameters
$ !
$ If P1 .nes. "" then goto chk_src
$ Inquire P1 "EVEPLUS input file"
$ If P1 .nes. "" then goto chk_src
$ stat = ss$_abort
$ goto common_exit
$ !
$chk_src:
$ src_file = f$search(f$parse(p1,"*.tpu"))
$ if src_file .nes. "" then goto GOT_SRC
$ write sys$output "''src_file' does NOT exist"
$ write sys$output "EVEPLUS build aborted!"
$ stat = ss$_abort
$ goto common_exit
$ !
$GOT_SRC:
$ If P2 .nes. "" then goto build_ready
$ Inquire P2 "TPU Section file"
$ !
$BUILD_READY:
$ vms_ver = f$edit(f$getsyi("VERSION"),"COLLAPSE")
$ section = f$parse(P2,"''f$environment("default")'EVEPLUS.GBL")
$ if vms_ver .ges. "V4.4" then -
  section = f$parse(P2,"''f$environment("default")'EVEPLUS.TPU$SECTION")
$ if section .nes. "" then goto build_eveplus
$ errmsg = f$message(stat)
$ write sys$output "Invalid Section file address"
$ write sys$outupt errmsg
$ stat = ss$_abort
$ goto common_exit
$ !
$BUILD_EVEPLUS:
$ define/user EVEPLUS 'section'
$ DEFINE/USER SYS$INPUT SYS$COMMAND
$ EDIT/TPU/SECTION=SYS$SHARE:EVESECINI/command=TPU$EVEPLUS:EVEPLUS_BUILD -
   'src_file'
$ stat = ss$_normal
$ !
$COMMON_EXIT:
$ EXIT stat + 0*f$verify(save_verify)
