$ SAVE_VERIFY = 'F$VERIFY(0)'		!SAVE INIT VERIFY STATUS, TURN IT OFF.
$ ! ALE.COM		MAO		13-MAY-80
$ !
$ ! DCL PROCEDURE TO TRANSLATE AND ASSEMBLE (VAX MACRO USED) ALECS MODULES
$ !
$ ! CALLING SEQUENCE:  @ALE NAME MACSW ALESW
$ !	WHERE	NAME=FILE NAME (WITHOUT EXTENSION) FOR ALECS INPUT FILE.
$ !		MACSW=ANY VAX MACRO SWITCHES TO BE USED (MAY BE BLANK).
$ !			IF ALECS SWITCHES ARE TO BE GIVEN WITHOUT ANY
$ !			MACRO SWITCHES, PUT A POUND SIGN (#) HERE.
$ !		ALESW=ANY ALECS SWITCHES TO BE USED (MAY BE BLANK).
$ !
$ ! IF NAME IS NOT GIVEN (EG. @ALE<CR>), INFORMATION IS PROMPTED FOR
$ !	UNTIL A ^Y IS GIVEN OR A FATAL ERROR OCCURS.
$ ! IF NAME IS GIVEN, THE GIVEN MODULE IS PROCESSED AND ALE.COM EXITS.
$ !
$ ! REVISIONS
$ ! 04-MAR-83 (MAO) ALLOW ALECS SWITCHES; USE # FOR MISSING MAC SWITCHES.
$ !			CALL VMS MACRO, NOT PDP-11 MACRO.
$ ! 24-AUG-83 (MAO) FIX SET PROC/NAME TO ALLOW SPACES IN PROCESS NAME.
$ ! 16-DEC-83 (MAO) Purge .OBJ & .ALL instead of delete.
$ ! 13-AUG-84 (MAO) New ALE.EXE doesnt require changing process name.
$ ! 14-SEP-84 (MAO) Check if .ALX file exists before running ALE.
$ !
$ !
$ ON ERROR THEN GOTO FIN
$ !
$ ALECS:=$USER$Q:ALE
$ !
$ POUND = "#"
$ BLANK = ""
$ SLASH = "/"
$ FU = "FU"		!ALECS /FU
$ MFU = "-FU"
$ SP = "SP"		!ALECS /SP
$ MSP = "-SP"
$ CO = "CO"		!ALECS /CO
$ MCO = "-CO"
$ !
$	IF P1 .EQS. BLANK THEN GOTO 10$	!MUST PROMPT FOR INPUT
$ !
$ WASCMD := "TRUE"		!INPUT WAS IN COMMAND LINE
$ NAM := 'P1'
$ MACSW := 'P2'
$ ALESW := 'P3'
$ GOTO TSTMAC
$ !
$ 10$:	WASCMD := "FALSE"	!NO COMMAND LINE GIVEN, PROMPT
$ !
$ QUERY:
$ !
$	INQUIRE NAM "GIVE ALE FILE NAME (^Y TO EXIT)"
$	INQUIRE MACSW "GIVE MAC SWITCHES"
$	INQUIRE ALESW "GIVE ALE SWITCHES"
$ !
$ TSTMAC:
$	IF POUND .EQS. MACSW THEN $ MACSW := ""	!Just a space holder
$ !
$	TEMP := 'F$EXTRACT(0,1,MACSW)'
$	IF BLANK .EQS. MACSW .OR. SLASH .EQS. TEMP THEN $ GOTO TSTALE
$ !
$ WRITE SYS$OUTPUT "FIRST CHARACTER OF MAC SWITCH NOT A '/'"
$	GOTO FIN
$ !
$ TSTALE:
$	INPFU := ""		!Assume no /FU given
$	INPSP := ""		!Assume no /SP given
$	INPCO := ""		!Assume no /CO given
$ !
$	IF BLANK .EQS. ALESW THEN GOTO ACT	!Nothing to parse
$ !
$ TEMP := 'F$EXTRACT(0,1,ALESW)'		!Is first char a slash?
$ IF SLASH .EQS. TEMP THEN $ GOTO 20$
$ !
$ WRITE SYS$OUTPUT "First character of ALE switch not a '/'"
$ STOP
$ !
$ 20$:
$ TEMP := 'ALESW'		!Get the string to work on
$ !
$ LOOP:
$ TEMP := 'F$EXTRACT(1,F$LENGTH(TEMP)-1,TEMP)'	!Get rid of slash
$ LOCSL = 'F$LOCATE("/",TEMP)'			!Find next slash
$ SW := 'F$EXTRACT(0,LOCSL,TEMP)'		!Extract the Switch
$ !
$ SUB1 = F$EXTRACT(0,2,SW)
$ SUB2 = F$EXTRACT(0,3,SW)
$ IF FU .NES. SUB1 .AND. MFU .NES. SUB2 THEN $ GOTO 30$
$ INPFU = "/"+SW				!Some form of /FU
$ GOTO 60$
$ 30$:
$ IF SP .NES. SUB1 .AND. MSP .NES. SUB2 THEN $ GOTO 40$
$ INPSP = "/"+SW				!Some form of /SP
$ GOTO 60$
$ 40$:
$ IF CO .NES. SUB1 .AND. MCO .NES. SUB2 THEN $ GOTO 50$
$ INPCO = "/"+SW				!Some form of /CO
$ GOTO 60$
$ 50$:
$ WRITE SYS$OUTPUT "Unknown ALECS switch /",SW
$ 	GOTO FIN
$ !
$ 60$:
$ IF LOCSL .EQ. 'F$LENGTH(TEMP)' THEN $ GOTO ACT	!Finished?
$ TEMP := 'F$EXTRACT(LOCSL,F$LENGTH(TEMP)-LOCSL,TEMP)'	!No, get rest of string
$ GOTO LOOP
$ !
$ ACT:
$ FILENAM="''NAM'"+".ALX"
$ FTEMP=F$SEARCH(FILENAM)			!.ALX file exists?
$ IF FTEMP.NES."" THEN GOTO ACT1
$ WRITE SYS$OUTPUT "File ''NAM'.ALX is not in current default directory"
$ GOTO FIN
$ !
$ ACT1:
$ ON WARNING THEN CONTINUE		!MAKE SURE DONT LEAVE NAME CHANGED
$ ON CONTROL_Y THEN $ GOTO FIN
$ IF .NOT.WASCMD THEN $ SET VERIFY			!Echo commands
$ !
$	ON ERROR THEN GOTO FIN			!Give up if error
$	ALECS 'NAM'.AAC'INPFU','NAM'.ALL/-SP'INPSP'='NAM'.ALX'INPCO'
$ !
$	ON ERROR THEN GOTO FIN			!Give up if error
$	MACRO/LIST='NAM'.LST'MACSW' 'NAM'.AAC
$ !
$	ON ERROR THEN GOTO FIN			!Give up if error
$	APPEND 'NAM'.LST 'NAM'.ALL
$ !
$	ON ERROR THEN GOTO FIN			!Give up if error
$	DELETE 'NAM'.LST;*,'NAM'.AAC;*			!Delete intermediate files
$ !
$	ON WARNING THEN CONTINUE
$	PURGE 'NAM'.OBJ,'NAM'.ALL		!Purge old versions
$ !
$	SET NOVERIFY
$	IF .NOT.WASCMD THEN $ GOTO QUERY	!IF WAS NO CMD LINE, PROMPT FOR MORE
$ !
$ FIN:
$ SAVE = 'F$VERIFY(SAVE_VERIFY)		!RESET INITIAL VERIFY STATUS
$ !
$ ! END OF FILE ALE.COM
