$ SAVE_VERIFY = 'F$VERIFY(0)'		!SAVE INIT VERIFY STATUS, TURN IT OFF.
$ ! FLE.COM		MAO		13-MAY-80
$ !
$ ! DCL PROCEDURE TO TRANSLATE AND COMPILE FLECS MODULES
$ !
$ ! CALLING SEQUENCE:  @FLE NAME FORSW FLESW
$ !	WHERE	NAME=FILE NAME (WITHOUT EXTENSION) FOR FLECS INPUT FILE.
$ !		FORSW=ANY FORTRAN SWITCHES TO BE USED (MAY BE BLANK).
$ !			IF FLECS SWITCHES ARE TO BE GIVEN WITHOUT ANY
$ !			FORT SWITCHES, PUT A POUND SIGN (#) HERE.
$ !		FLESW=ANY FLECS SWITCHES TO BE USED (MAY BE BLANK).
$ !
$ ! IF NAME IS NOT GIVEN (EG. @FLE<CR>), INFORMATION IS PROMPTED FOR
$ !	UNTIL A ^Y IS GIVEN OR A FATAL ERROR OCCURS.
$ ! IF NAME IS GIVEN, THE GIVEN MODULE IS PROCESSED AND FLE.COM EXITS.
$ !
$ ! REVISIONS
$ ! 04-MAR-83 (MAO) Allow FLECS switches; use # for missing for switches.
$ !			Make F77 and NOI4 FORTRAN default for this file.
$ ! 16-DEC-83 (MAO) Purge .OBJ & .FLL files instead of deleting.
$ ! 14-SEP-84 (MAO) Check for existance of .FLX file before calling FLE.
$ ! 01-MAR-85 (MAO) Delete any .FID files after FOR is done with them.
$ !		    Use new native mode FLECS.
$ ! 850402mao Find FORT version #; if >3.x, use /CO:GLBOPT.
$ ! 860313mao If FORTRAN /DEBUG or /MACHINE given, save .FOR & .LST files.
$ !
$ !
$ ON ERROR THEN GOTO FIN
$ !
$ FLECS := $USER$Q:FLE		!native mode FLECS
$ AFF   := $USER$Q:AFF		!native mode AFF
$ !
$ POUND = "#"
$ BLANK = ""
$ SLASH = "/"
$ FU = "FU"		!FLECS /FU
$ MFU = "-FU"
$ SP = "SP"		!FLECS /SP
$ MSP = "-SP"
$ CO = "CO"		!FLECS /CO
$ MCO = "-CO"
$ !
$	IF P1 .EQS. BLANK THEN GOTO 10$	!MUST PROMPT FOR INPUT
$ !
$ WASCMD := "TRUE"		!INPUT WAS IN COMMAND LINE
$ NAM := 'P1'
$ FORSW := 'P2'
$ FLESW := 'P3'
$ GOTO TSTFOR
$ !
$ 10$:	WASCMD := "FALSE"	!NO COMMAND LINE GIVEN, PROMPT
$ !
$ QUERY:
$ !
$	INQUIRE NAM "Give FLE file name (^Y to exit)"
$	INQUIRE FORSW "Give FOR switches"
$	INQUIRE FLESW "Give FLE switches"
$ !
$ TSTFOR:
$	IF POUND .EQS. FORSW THEN $ FORSW := ""	!Just a space holder
$ !
$	TEMP := 'F$EXTRACT(0,1,FORSW)'
$	IF BLANK .EQS. FORSW .OR. SLASH .EQS. TEMP THEN $ GOTO FORDEBUG
$ !
$ WRITE SYS$OUTPUT "First character of FOR switch not a '/'"
$	GOTO FIN
$ !
$ FORDEBUG:		!Was /DEBUG or /MACHINE given?
$ FD = -1		!assmue not given
$ IF FORSW .EQS. "" THEN $ GOTO TSTFLE
$ I = F$LOCATE("/DE",FORSW)
$ IF I.GE.F$LEN(FORSW) THEN $ I = F$LOCATE("/MA",FORSW)
$ IF I.LT.F$LEN(FORSW) THEN $ FD=I
$ !
$ TSTFLE:
$	INPFU := ""		!Assume no /FU given
$	INPSP := ""		!Assume no /SP given
$	INPCO := ""		!Assume no /CO given
$ !
$	IF BLANK .EQS. FLESW THEN GOTO ACT	!Nothing to parse
$ !
$ TEMP := 'F$EXTRACT(0,1,FLESW)'		!Is first char a slash?
$ IF SLASH .EQS. TEMP THEN $ GOTO 20$
$ !
$ WRITE SYS$OUTPUT "First character of FLE switch not a '/'"
$ 	GOTO FIN
$ !
$ 20$:
$ TEMP := 'FLESW'		!Get the string to work on
$ !
$ LOOP:
$ TEMP := 'F$EXTRACT(1,F$LENGTH(TEMP)-1,TEMP)'	!Get rid of slash
$ LOCSL = 'F$LOCATE("/",TEMP)'			!Find next slash
$ SW := 'F$EXTRACT(0,LOCSL,TEMP)'		!Extract the Switch
$ !
$ SUB1 = F$EXTRACT(0,2,SW)
$ SUB2 = F$EXTRACT(0,3,SW)
$ IF FU .NES. SUB1 .AND. MFU .NES. SUB2 THEN $ GOTO 30$
$ INPFU = "/"+SW				!Some form of /FU
$ GOTO 60$
$ 30$:
$ IF SP .NES. SUB1 .AND. MSP .NES. SUB2 THEN $ GOTO 40$
$ INPSP = "/"+SW				!Some form of /SP
$ GOTO 60$
$ 40$:
$ IF CO .NES. SUB1 .AND. MCO .NES. SUB2 THEN $ GOTO 50$
$ INPCO = "/"+SW				!Some form of /CO
$ GOTO 60$
$ 50$:
$ WRITE SYS$OUTPUT "Unknown FLECS switch /",SW
$ STOP
$ !
$ 60$:
$ IF LOCSL .EQ. 'F$LENGTH(TEMP)' THEN $ GOTO ACT	!Finished?
$ TEMP := 'F$EXTRACT(LOCSL,F$LENGTH(TEMP)-LOCSL,TEMP)'	!No, get rest of striri
$ GOTO LOOP
$ !
$ ACT:
$ FILENAM="''NAM'"+".FLX"
$ FTEMP=F$SEARCH(FILENAM)			!.FLX file exists?
$ IF FTEMP.NES."" THEN GOTO ACT1
$ WRITE SYS$OUTPUT "File ''NAM'.FLX is not in current default directory"
$ GOTO FIN
$ !
$ ACT1:
$ FORT_VER = F$LOGICAL("FOR_VRSN")		!FORT version, eg. 3.3
$ IF FORT_VER .EQS. "" THEN FORT_VER = "3.3"	!default to FOR V3.3
$ FORT_RLS = F$EXTRACT(0,F$LOCATE(".",FORT_VER),FORT_VER) !FORT release, eg. 3
$ IF FORT_RLS .LES. "3" THEN GOTO ACT2		!DO nothing if before V4.0.
$ IF INPCO .EQS. "" THEN INPCO = "/CO"		!/CO not given by caller
$ INPCO = INPCO+":GLBOPT"			!Add "global optimize" conditional
$ !
$ ACT2:
$ IF .NOT.WASCMD THEN $ SET VERIFY			!Echo commands
$ !
$	ON ERROR THEN GOTO FIN			!Give up if error
$	FLECS 'NAM'.FOR'INPFU','NAM'.FLL/-SP'INPSP'='NAM'.FLX'INPCO'
$ !
$	FOR/LIST='NAM'.LST/NOI4/F77'FORSW' 'NAM'
$ !
$	ASSIGN/USER TT SYS$OUTPUT			!For AFF error msgs
$	AFF 'NAM'
$ !
$	IF FD.LT.0 THEN $ DELETE 'NAM'.LST;*,'NAM'.FOR;* !Delete intermediate files
$ !
$	ON WARNING THEN CONTINUE
$ !
$ FILENAM="*.FID"
$ FTEMP=F$SEARCH(FILENAM)			!Any .FID files?
$ IF FTEMP.NES."" THEN $ DEL *.FID;*		!Yes, delete them
$ !
$	PURGE 'NAM'.OBJ,'NAM'.FLL		!Purge older files
$ !
$	SET NOVERIFY
$	IF .NOT.WASCMD THEN $ GOTO QUERY	!IF WAS NO CMD LINE, PROMPT FOR MORE
$ !
$ FIN:
$ SAVE = 'F$VERIFY(SAVE_VERIFY)		!Restore original value
$ !
$ ! END OF FILE FLE.COM
