$! FLEIICMP.COM		MAO	850214
$!
$! COMMAND FILE TO TRANSLATE AND COMPILE FLECS MODULES TO RUN IN
$! NATIVE MODE ON THE VAX GENERATING F77 SUBSET.
$!
$!*****************************************************************************
$! NEVER DELETE FLECS FTN FILES.  SAVE FOR TRANSPORTING FLECS TO OTHER COMPUTERS
$!*****************************************************************************
$!
$! REVISIONS
$! 850516mao Support generation of F77 output code.
$! 870327mao Generate F77 subset.
$!
$! INPUT: 
$!
$! P1 =	Y IF SHOULD USE EXISTING VERSION OF FLECS TO PROCESS .FLX
$!		SOURCES.
$!	N IF SHOULD JUST USE EXISTING .FTN FILES (IE. FLE.EXE DOES NOT
$!		YET EXIST.
$!
$5$:
$ IF (P1 .EQS."Y") .OR. (P1 .EQS. "N") THEN $ GOTO 10$
$!
$ INQUIRE P1 "Should existing FLE.EXE be used on .FLX sources? "
$ GOTO 5$
$!
$10$:
$ FLECS := $USER$Q:FLE		!define locally
$!
$ SRC   := [MP1Q.FLEALECOM]	!sources (note listing and object files
$!				!should be kept in [MP1Q.FLEALECOM.FLECS]
$!				!to distinguish them from ALECS files.
$!
$ WRITE SYS$OUTPUT "...COMPILING MODULES:"
$ WRITE SYS$OUTPUT "FILEVMS..."
$ MAC/LIST 'SRC'FILEVMS.MAR
$ PURGE FILEVMS.LIS,FILEVMS.OBJ
$!
$ WRITE SYS$OUTPUT "FSUB..."
$ FOR/NOI4/F77/LIST 'SRC'FSUB.FFF
$ PURGE FSUB.LIS,FSUB.OBJ
$!
$ WRITE SYS$OUTPUT "A..."
$ IF P1 .EQS. "Y" THEN $ FLECS A,A/-SP='SRC'A/CO:FLECS:F77SUB
$ FOR/NOI4/F77/LIST A.FTN
$ PURGE A.FLL,A.OBJ,A.LIS
$!
$!
$ WRITE SYS$OUTPUT "L..."
$ IF P1 .EQS. "Y" THEN $ FLECS L,L/-SP='SRC'L/CO:FLECS
$ FOR/NOI4/F77/LIST L.FTN
$ PURGE L.FLL,L.OBJ,L.LIS
$!
$ WRITE SYS$OUTPUT "M..."
$ IF P1 .EQS. "Y" THEN $ FLECS M,M/-SP='SRC'M/CO:FLECS:F77SUB
$ FOR/NOI4/F77/LIST M.FTN
$ PURGE M.FLL,M.OBJ,M.LIS
$!
$ WRITE SYS$OUTPUT "LAMPFI..."
$ IF P1 .EQS. "Y" THEN $ FLECS LAMPFI,LAMPFI/-SP='SRC'LAMPFI/CO:FLECS:VAX
$ FOR/NOI4/F77/LIST LAMPFI.FTN
$ PURGE LAMPFI.FLL,LAMPFI.OBJ,LAMPFI.LIS
$!
$ WRITE SYS$OUTPUT "ISUB..."
$ IF P1 .EQS. "Y" THEN $ FLECS ISUB,ISUB/-SP='SRC'ISUB/CO:VAX
$ FOR/NOI4/F77/LIST ISUB.FTN
$ PURGE ISUB.FLL,ISUB.OBJ,ISUB.LIS
$!
$ WRITE SYS$OUTPUT "STRING..."
$ IF P1 .EQS. "Y" THEN $ FLECS STRING,STRING/-SP='SRC'STRING
$ FOR/NOI4/F77/LIST STRING.FTN
$ PURGE STRING.FLL,STRING.OBJ,STRING.LIS
$!
$ WRITE SYS$OUTPUT "FILE..."
$ IF P1 .EQS. "Y" THEN $ FLECS FILE,FILE/-SP='SRC'FILE/CO:FLECS:VAX
$ FOR/NOI4/F77/LIST FILE.FTN
$ PURGE FILE.FLL,FILE.OBJ,FILE.LIS
$!
$! SAVE MOST RECENT COPY OF .FTN FILES FOR EXPORT TO PLACES W/O FLE.EXE
$!
$ SET PROT=(O:RWED) *.FTN;*
$ PURGE *.FTN
$ SET PROT=(S:RWE,G:RWE,O:RWE,W:R) *.FTN;*
$!
$! END OF FILE FLECMP.COM
