$ SAVE_VERIFY = 'F$VERIFY(0)'		!SAVE INIT VERIFY STATUS, TURN IT OFF.
$ ! FLE.COM		MAO		13-MAY-80
$ !
$ ! DCL PROCEDURE TO TRANSLATE AND COMPILE FLECS MODULES
$ !
$ ! CALLING SEQUENCE:  @FLE NAME FORSW FLESW
$ !	WHERE	NAME=FILE NAME (WITHOUT EXTENSION) FOR FLECS INPUT FILE.
$ !		FORSW=ANY FORTRAN SWITCHES TO BE USED (MAY BE BLANK).
$ !			IF FLECS SWITCHES ARE TO BE GIVEN WITHOUT ANY
$ !			FOR SWITCHES, PUT A POUND SIGN (#) HERE.
$ !		FLESW=ANY FLECS SWITCHES TO BE USED (MAY BE BLANK).
$ !
$ ! IF NAME IS NOT GIVEN (EG. @FLE<CR>), INFORMATION IS PROMPTED FOR
$ !	UNTIL A ^Y IS GIVEN OR A FATAL ERROR OCCURS.
$ ! IF NAME IS GIVEN, THE GIVEN MODULE IS PROCESSED AND FLE.COM EXITS.
$ !
$ ! REVISIONS
$ ! 04-MAR-83 (MAO) ALLOW FLECS SWITCHES; USE # FOR MISSING FOR SWITCHES.
$ !			MAKE F77 AND NOI4 FORTRAN DEFAULT FOR THIS FILE.
$ ! 16-DEC-83 (MAO) Purge .OBJ & .FLL files instead of deleting.
$ ! 14-SEP-84 (MAO) Check for existance of .FLX file before calling FLE.
$ !
$ !
$ ON ERROR THEN GOTO FIN
$ POUND = "#"
$ BLANK = ""
$ SLASH = "/"
$ FU = "FU"		!FLECS /FU
$ MFU = "-FU"
$ SP = "SP"		!FLECS /SP
$ MSP = "-SP"
$ CO = "CO"		!FLECS /CO
$ MCO = "-CO"
$ !
$	IF P1 .EQS. BLANK THEN GOTO 10$	!MUST PROMPT FOR INPUT
$ !
$ WASCMD := "TRUE"		!INPUT WAS IN COMMAND LINE
$ NAM := 'P1'
$ FORSW := 'P2'
$ FLESW := 'P3'
$ GOTO TSTFOR
$ !
$ 10$:	WASCMD := "FALSE"	!NO COMMAND LINE GIVEN, PROMPT
$ !
$ QUERY:
$ !
$	INQUIRE NAM "GIVE FLE FILE NAME (^Y TO EXIT)"
$	INQUIRE FORSW "GIVE FOR SWITCHES"
$	INQUIRE FLESW "GIVE FLE SWITCHES"
$ !
$ TSTFOR:
$	IF POUND .EQS. FORSW THEN $ FORSW := ""	!Just a space holder
$ !
$	TEMP := 'F$EXTRACT(0,1,FORSW)'
$	IF BLANK .EQS. FORSW .OR. SLASH .EQS. TEMP THEN $ GOTO TSTFLE
$ !
$ WRITE SYS$OUTPUT "FIRST CHARACTER OF FOR SWITCH NOT A '/'"
$	GOTO FIN
$ !
$ TSTFLE:
$	INPFU := ""		!Assume no /FU given
$	INPSP := ""		!Assume no /SP given
$	INPCO := ""		!Assume no /CO given
$ !
$	IF BLANK .EQS. FLESW THEN GOTO ACT	!Nothing to parse
$ !
$ TEMP := 'F$EXTRACT(0,1,FLESW)'		!Is first char a slash?
$ IF SLASH .EQS. TEMP THEN $ GOTO 20$
$ !
$ WRITE SYS$OUTPUT "First character of FLE switch not a '/'"
$ 	GOTO FIN
$ !
$ 20$:
$ TEMP := 'FLESW'		!Get the string to work on
$ !
$ LOOP:
$ TEMP := 'F$EXTRACT(1,F$LENGTH(TEMP)-1,TEMP)'	!Get rid of slash
$ LOCSL = 'F$LOCATE("/",TEMP)'			!Find next slash
$ SW := 'F$EXTRACT(0,LOCSL,TEMP)'		!Extract the Switch
$ !
$ SUB1 = F$EXTRACT(0,2,SW)
$ SUB2 = F$EXTRACT(0,3,SW)
$ IF FU .NES. SUB1 .AND. MFU .NES. SUB2 THEN $ GOTO 30$
$ INPFU = "/"+SW				!Some form of /FU
$ GOTO 60$
$ 30$:
$ IF SP .NES. SUB1 .AND. MSP .NES. SUB2 THEN $ GOTO 40$
$ INPSP = "/"+SW				!Some form of /SP
$ GOTO 60$
$ 40$:
$ IF CO .NES. SUB1 .AND. MCO .NES. SUB2 THEN $ GOTO 50$
$ INPCO = "/"+SW				!Some form of /CO
$ GOTO 60$
$ 50$:
$ WRITE SYS$OUTPUT "Unknown FLECS switch /",SW
$ STOP
$ !
$ 60$:
$ IF LOCSL .EQ. 'F$LENGTH(TEMP)' THEN $ GOTO ACT	!Finished?
$ TEMP := 'F$EXTRACT(LOCSL,F$LENGTH(TEMP)-LOCSL,TEMP)'	!No, get rest of striri
$ GOTO LOOP
$ !
$ ACT:
$ FILENAM="''NAM'"+".FLX"
$ FTEMP=F$SEARCH(FILENAM)			!.FLX file exists?
$ IF FTEMP.NES."" THEN GOTO ACT1
$ WRITE SYS$OUTPUT "File ''NAM'.FLX is not in current default directory"
$ GOTO FIN
$ !
$ ACT1:
$ IF .NOT.WASCMD THEN $ SET VERIFY			!Echo commands
$ !
$	ON ERROR THEN GOTO FIN			!Give up if error
$	MCR FLE 'NAM'.FOR'INPFU','NAM'.FLL/-SP'INPSP'='NAM'.FLX'INPCO'
$ !
$	FOR/LIST='NAM'.LST/NOI4/F77'FORSW' 'NAM'
$ !
$	ASSIGN/USER TT SYS$OUTPUT			!For AFF error msgs
$	AFF 'NAM'
$ !
$	DELETE 'NAM'.LST;*,'NAM'.FOR;*		!Delete intermediate files
$ !
$	ON WARNING THEN CONTINUE
$	PURGE 'NAM'.OBJ,'NAM'.FLL		!Purge older files
$ !
$	SET NOVERIFY
$	IF .NOT.WASCMD THEN $ GOTO QUERY	!IF WAS NO CMD LINE, PROMPT FOR MORE
$ !
$ FIN:
$ SAVE = 'F$VERIFY(SAVE_VERIFY)		!Restore original value
$ !
$ ! END OF FILE FLE.COM
