C;+
C.ENTRY MSGOUT
C - M S G O U T
C IDENT:      /840614/
C FILE:       MSGOUT.FOR
C SYSTEM:     VMS V2.1
C LANGUAGE:   FORTRAN
C AUTHOR:     M. OOTHOUDT
C DATE:       12-FEB-81
C;-
C REFERENCES: 
C
C REVISIONS:  
C 26-JUL-83 (MAO) Prefix mesage with image name, not process name.
C 09-FEB-84 (MAO) $WAITFR after $GETJPI for V4.0 compatibility.
C 14-JUN-84 (MAO) Use IMAGE_NAME to get the image's name.
C;+
C
C****PURPOSE: PUT OUT A MESSAGE ON TI:
C
C****RESTRICTIONS:  
C
C****CALLING SEQUENCE:  CALL MSGOUT(TEXT [,NUM])
C
C    INPUT:    
C
C TEXT	=(BYTE ARRAY) TEXT OF MESSAGE TO PUT OUT, TERMINATED WITH A NULL.
C	 IF THE ARGUMENT IS GIVEN AS A LITERAL [EG. CALL MSGOUT('HI')]
C	 THE NULL IS AUTOMATICALLY PUT IN.
C NUM	=(I*2) ERROR NUMBER; NEED NOT BE GIVEN.
C 
C    MODIFIED: NONE
C
C    OUTPUT:   NONE
C
C    CMN BLOCKS USED:  NONE
C
C****RESOURCES:
C	LIBRARIES:   QLIB:ARGS:IMAGE_NAME
C	OTHER SUBR:  NONE
C	DISK FILES:  NONE
C	DEVICES:     FOR$TYPE
C	SGAS:        NONE
C	EVENT FLAGS: NONE
C	SYSTEM DIR:  NONE
C
C****NOTES:  
C	1.  THIS IS AN EXACT MIMIC OF THE PDP-11 11M MSGOUT SUBROUTINE.
C
C	2.  THE SUBROUTINE PUTS OUT THE TEXT (AND IF GIVEN, AN ERROR #)
C ON TI:.  EG. CALL MSGOUT('DATA RETRIEVAL ERROR',11) WILL GIVE
C
C	IMAGENAM -- DATA RETRIEVAL ERROR
C	IMAGENAM -- IERR= 11
C
C WHERE IMAGENAM IS THE NAME OF THE CALLING IMAGE (EG. IF THE PROGRAM'S
C FILE NAME IS DRA1:[F.G]ABC.EXE;37, IMAGENAM=ABC). THE SECOND LINE IS
C NOT PUT OUT IF THE NUM ARGUMENT IS OMITTED.
C;-
	SUBROUTINE MSGOUT(TEXT,NUM)
C
	IMPLICIT NONE
	BYTE TEXT(1)
	LOGICAL*1 NUMARG
	INTEGER*2 NUM,NARGS,MAP,I,J
	CHARACTER IMAGENAME*9
C
	CALL ARGS (NARGS,MAP)	!FIND IF NUM ARG IS GIVEN
	NUMARG = NARGS.GT.1 .AND. ((2.AND.MAP).NE.0)
C
C	Get image name
C
	CALL IMAGE_NAME(IMAGENAME)
C
C	OUTPUT THE MESSAGE
C
	DO 100 I=1,65
		IF (TEXT(I).EQ.0) GOTO 200
100		CONTINUE
	I=66
C
200	I=I-1		!NUMBER OF CHARACTERS TO PUT OUT
C
	TYPE 1,IMAGENAME,(TEXT(J),J=1,I)
1	FORMAT(1H0,A,' -- ',65A1)
C
	IF(NUMARG) THEN
		TYPE 2,IMAGENAME,NUM
2		FORMAT(1H0,A,' -- IERR = ',I9)
		ENDIF
C
C
	RETURN
	END
