$ SAVERIFY = F$VERIFY(0)	! Save and turn off verification
$!
$! This command procedure is for compressing files on a disk, where the files
$! have allocated more space than they require.  The file specification should
$! not include version numbers, as this command procedure assumes it is being
$! run on a PURGEd directory.
$!
$!MODIFICATION	Do NOT use SET NOON in this command procedure!  If the
$!  WARNING:	file copy fails, we do NOT want to delete the file anyway!
$!
$ IF P1 .EQS. "" THEN INQUIRE P1 "Wildcard directory and file specification"
$ IF P1 .EQS. "" THEN EXIT
$ FILESCHECKED = 0
$ FILENAME = F$SEARCH("''P1'")			! Preliminary search
$ IF FILENAME .EQS. "" THEN GOTO FINISHED	! No files
$ DISK = F$FILE_ATTRIBUTES("''FILENAME'","DVI")	! Get disk name
$ CLUSIZ = F$GETDVI("''DISK'","CLUSTER")	! Get disk cluster size
$ IF CLUSIZ .EQ. 0 THEN GOTO FINISHED		! Get out if not valid
$ IF P2 .EQS. "" THEN INQUIRE P2 -
	"Do compression (as opposed to just listing files) <NO>"
$ IF .NOT. P2 THEN WRITE SYS$OUTPUT "Okay, not compressing files."
$ WRITE SYS$OUTPUT "[Cluster size for ''DISK': is ''CLUSIZ']"
$ FINDFILE:
$ FILENAME = F$SEARCH("''P1'",1)
$ IF FILENAME .EQS. "" THEN GOTO FINISHED	! No more files
$ FILESCHECKED = FILESCHECKED + 1		! Increment counter
$ IF F$LOCATE(".DIR;1","''FILENAME'") .NES. -	! Don't mess with
     F$LENGTH("''FILENAME'") THEN GOTO FINDFILE	!  directory files
$ ALQ = F$FILE_ATTRIBUTES("''FILENAME'","ALQ")	! Get file allocations
$ EOF = F$FILE_ATTRIBUTES("''FILENAME'","EOF")	! Get blocks used
$ IF EOF .EQ. 0 THEN -
	WRITE SYS$OUTPUT "%COMPRESS-I-ZERLENFIL, Zero length file: ''FILENAME'"
$ IF (EOF + CLUSIZ) .GT. ALQ THEN GOTO FINDFILE	! If within clustersize then try
$!							another file
$ WRITE SYS$OUTPUT "''FILENAME' allocated ''ALQ' used ''EOF'."
$ IF .NOT. P2 THEN GOTO FINDFILE
$ NOVERNAME = F$EXTRACT(0,F$LOCATE(";","''FILENAME'"),"''FILENAME'")
$ COPY 'NOVERNAME' 'NOVERNAME'	! COPY it (recovers unused allocated blocks)
$ DELETE 'FILENAME'		! Delete the old version
$ GOTO FINDFILE			! Try another
$ FINISHED:
$ WRITE SYS$OUTPUT "%COMPRESS finished.  ''FILESCHECKED' files checked."
$ SAVERIFY = F$VERIFY(SAVERIFY)
$ EXIT
