$   on_verify = F$VERIFY ( 0 )
$!
$!	DRAWTREE.COM	Draws a directory tree on a VT100
$!
$!	written by DMWalp	on March 7th, 1982
$!
$!
$!	Requires: a to be run on a VT100 if output is a terminal
$!	Parameters:  P1 - The disk directory sepcification ( will prompt if
$!			    missing ).  Directory must not sub-level.
$!		     P2 - Output ( default is SYS$OUTPUT, no prompting )
$!
$!	B. Z. Lederman	27-Mar-1986	Disable reverse video, underlining,
$!					VT100 restriction (linked to video)
$!					eliminate [000000] recursion on
$!					VMS V4.+ packs.
$!
$!	Reverse video and lower casing are commented out, can be re-enabled
$!
$   ON CONTROL_Y THEN EXIT
$   SET NOON
$!
$   if p1 .eqs. "" then p1 = f$trnlnm("sys$login")
$   root = P1
$   GOTO past_prompt
$!
$ prompt_directory:
$!
$   INQUIRE root "Root Directory "
$!
$ past_prompt:
$!
$   IF root .EQS. "" THEN GOTO prompt_directory
$!
$!	test if the directory exists
$!
$   parse_root = F$PARSE ( root + "*.*;*" )
$   IF parse_root .EQS. "" THEN GOTO prompt_directory
$   IF F$SEARCH ( parse_root ) .EQS. "" THEN GOTO prompt_directory
$!
$! a nice project in the future would be: if the directory find		! BZL
$! fails, check to see if the input string can be translated as a	! BZL
$! logical name for something, like SYS$SYSROOT, and try again		! BZL
$!
$!	extract the disk and directory fields
$!
$   disk	= F$PARSE ( parse_root, , , "DEVICE" )
$   dir_root	= F$PARSE ( parse_root, , , "DIRECTORY" )
$!
$!	test it is not a sub-directory
$!	strip delimiters
$!
$   IF F$LOCATE ( ".", dir_root ) .NES. F$LENGTH ( dir_root ) -
	THEN GOTO prompt_directory
$   dir_root = dir_root - "<" - "[" - ">" - "]"
$!
$!	set up the output file
$!	test if output is terminal it is a VT100
$!
$   output_file = P2
$   IF output_file .EQS. "" THEN output_file = "SYS$OUTPUT"
$!
$    output_device = F$PARSE ( output_file, "DEVICE" )
$!
$! If output is not to a terminal, assume the user knows the device to
$! which it is going (either directly or via a file) has line drawing
$! characters.
$!
$    IF F$GETDVI ( output_device, "DEVCLASS" ) .NE. 66 THEN GOTO device_ok
$!
$! Check for a series of compatible device types: any device with the	! BZL
$! VT100 line drawing character set is acceptable.  If reverse video is	! BZL
$! put back in this is still O.K. as acceptable devices will either have  BZL
$! reverse video or will ignore it (such as LA100 and LN03 printers)	! BZL
$! If someone knows the device type for an LA50, it could be added.	! BZL
$!
$  term = F$GETDVI ( output_device, "DEVTYPE"  )			! BZL
$  IF term .EQ. 35 THEN GOTO device_ok		! LA38 (probably o.k.)	! BZL
$  IF term .EQ. 36 THEN GOTO device_ok		! LA12			! BZL
$  IF term .EQ. 37 THEN GOTO device_ok		! LA100			! BZL
$  IF term .EQ. 41 THEN GOTO device_ok		! LN03			! BZL
$  IF term .GE. 96 THEN -						! BZL
   IF term .LE. 102 THEN GOTO device_ok		! all VT100 series	! BZL
$  IF term .EQ. 110 THEN GOTO device_ok		! all VT200 series	! BZL
$  IF term .EQ. 111 THEN GOTO device_ok		! PRO_Series		! BZL
$!
$   WRITE SYS$OUTPUT "Sorry, must be run on a VT100 line drawing device."
$   EXIT
$!
$ device_ok:
$!
$   ON CONTROL_Y THEN GOTO abort
$   OPEN/WRITE output 'output_file'
$!
$!	If the next line does not go across it says
$!	WRITE output "<ESC>)0"
$!
$   WRITE output ")0"	! into graphics mode
$
$!	initialize things
$!
$!   lower_chars = "abcdefghijklmnopqrstuvwxyz0123456789" ! no lower case ! BZL
$   pad_chars	= "qqqqqqqqqqq"	! graphic dash
$   line_0      = ""
$   level	= 1
$   entry_1     = dir_root
$   GOTO call_pre_case
$!
$ return_pre_case:
$!
$   level_1_dir = dir_root
$!
$!	If the next line does not go across it says
$!	line_1 = "<ESC>[4;7m''entry_1'<ESC>[m^N"
$! or
$!	line_1 = "''entry_1'^N		 for no reverse video/underline	! BZL
$!
$   line_1	= "''entry_1'"
$!
$ push:
$!
$!	push down a level
$!
$   old_level = level
$   level     = level + 1
$   parsed_spec_'level' = F$PARSE ( "*.DIR", disk, -
				     "<" + level_'old_level'_dir + ">")
$ no_zero:								! BZL
$   next_entry_'level'	= F$SEARCH ( parsed_spec_'level', level )
$!
$! Prevent endless loop on ddun:[000000] but still get entire device	! BZL
$!
$ ax = f$locate( "<", next_entry_'level') + 1	! start of directory	! BZL
$ as = f$extract( ax, 6, next_entry_'level')	! extract first direc.	! BZL
$ if as .nes. "000000" then goto ok_go		! if not root, no problem BZL
$ ax = f$locate( ">", next_entry_'level') + 1	! end of directory	! BZL
$ as = f$extract( ax, 6, next_entry_'level')	! extract last direct.	! BZL
$ if as .nes. "000000" then goto ok_go		! if not root, no problem BZL
$!
$! repeat parsing the root directory until we find the first directory	! BZL
$! which is not 000000.  This is where the tree really starts.		! BZL
$!
$ goto no_zero
$!
$ ok_go:
$!
$! if search fails no more levels
$!
$   IF next_entry_'level' .NES. "" THEN GOTO more_levels
$   WRITE output line_'old_level'
$   GOTO pop
$!
$ more_levels:
$!
$!	mark this as the first entry and not the last entry
$!
$   last_'level' = 0
$   first_'level' = 1
$!
$ list_loop:
$!
$!	for each each sub-directory
$!	test if this entry is the last in the list
$!	make the entry the file name field
$!	Capitalize and lower case entry name
$!
$   entry_'level' = next_entry_'level'
$   next_entry_'level'	= F$SEARCH ( parsed_spec_'level', level )
$   IF next_entry_'level' .EQS. "" THEN last_'level' = 1
$   entry_'level' = F$PARSE ( entry_'level', , , "NAME" )
$ call_pre_case:
$!
$! The following section is commented out to prevent conversion of	! BZL
$! directory names to lower case.  In this case it makes things harder	! BZL
$! to read, rather than easier (in my opinion).				! BZL
$!
$!   entry_length = F$LENGTH ( entry_'level' )
$!   counter	 = 1
$! case_loop:
$!   IF counter .EQ. entry_length THEN GOTO end_case
$!   index = F$CVUI ( 0, 8, F$EXTRACT ( counter, 1, entry_'level' ) ) - 65
$!   IF index .LT. 0 THEN index = index + 43
$!   entry_'level'['counter',1] := "''F$EXTRACT ( index, 1, lower_chars )'"
$!   counter = counter + 1
$!   GOTO case_loop
$! end_case:
$!
$   IF level .EQ. 1 THEN GOTO return_pre_case
$!
$!	fiqure out the attaching character
$!		  | not first |	  first
$!	----------+-----------+----------
$!	 not last | right "T" | down "T"
$!	----------+-----------+----------
$!	   last	  | right "L" |	  dash
$!
$					     end_pad = "t"
$   IF first_'level'			THEN end_pad = "w"
$   IF			   last_'level' THEN end_pad = "m"
$   IF first_'level' .AND. last_'level' THEN end_pad = "q"
$!
$!	append dashes, attach character and new entry to line
$!
$   line_'level' = line_'old_level' + -
		   F$EXTRACT ( F$LENGTH ( entry_'old_level' ), -
			       11, -
			       pad_chars ) + -
		   end_pad + -
		   "" + entry_'level' + ""
$!
$!	If the previous line does not go across it says
$!	   "^O<ESC>[4;7m" + entry_'level' + "<ESC>[m^N"
$! or
$!	"^O" + entry_'level' + "^N" for no reverse video/underline	! BZL
$!
$!	blank out the entry and may be add place vertical bar connector
$!
$   entry_'old_level' = "           x"
$   IF last_'level' THEN entry_'old_level' = "            "
$!
$!	fix up the lower level output line
$!
$   old_old_level = old_level - 1
$   line_'old_level' = line_'old_old_level' + entry_'old_level'
$!
$!	calculate the directory specification for the next level
$!
$   level_'level'_dir = level_'old_level'_dir + "." + entry_'level'
$   GOTO push
$!
$ pop:
$!
$! restore parameters
$!
$   level = old_level
$   old_level = old_level - 1
$   old_old_level = old_level - 1
$!
$   IF level .EQ. 1 THEN GOTO clean_up	! initial level all done
$   first_'level' = 0			! mark end of first entry
$   entry_'old_level' = "           "	! blank out the entry
$   line_'old_level' = line_'old_old_level' + entry_'old_level'
$   IF last_'level' THEN GOTO pop	! done with this level
$   GOTO list_loop		  	! for each sub-directory loop
$!
$ abort:
$!
$!	If the next line does not go across it says
$!      WRITE output "<ESC>[m"		! turn off reverse video on abort
$!
$   WRITE output "[m"
$ clean_up:
$!
$!	If the next line does not go across it says
$!      WRITE output "^O"	! turn off line drawing on abort
$!
$   WRITE output ""
$   CLOSE output
$   IF on_verify THEN SET VERIFY
$ exit
