100	%title "Great Cribbage Game"
	%sbttl "Comments"
	option size=(integer long, real single), type=explicit
	rem

	CRIB - a game for one player, a VAX, and a BASIC program.


	These called routines are located at the end of this file:

	Display_points	displays the number of points and draws the
			lines.
	Okay_to_play	checks the file "games:gamcron." for valid
			times to play games.
	Sorthand	bubblesorts the cards.
	Update_history	updates the cards' histories in the file.

	Note that most of the external routines require you to
	link in a macro file that contains smg$ definitions, such as:

	 .TITLE  SMGDEF
	         $SMGDEF GLOBAL
	 .END

	See CRIB.MEM for more details.

150	on error goto 29000	! Catchy number, huh?
	%sbttl "Declarations"
	record quad
		long	high_long
		long	low_long
	end record quad
	record cardz
		string	rank	= 1	! Such as "K" for King
		string	suit	= 1	! Such as "C" for Club
		long	valve		! The point value when playing the
					!   card, such as "10" for a King
	    	long	ordinal		! The card's rank, numbered 1-13
	end record cardz
	record paleontology
		long	success		! Number of times this was successful
		long	times		! Number of times this was seen
	end record paleontology
	map (card_rec)				&
		string	C_ardkey = 3%,		&
		paleontology	C_history
   	map (play_rec)				&
		string	H_player = 10%,		&
		quad	H_play_time,		&
		byte	H_winner,		&
		byte	H_15(4%),		&
		byte	H_pairs(4%),		&
		byte	H_3runs(4%),		&
		byte	H_4runs(4%),		&
		byte	H_5runs(4%),		&
		byte	H_nobs(4%),		&
		byte	H_flushes(4%),		&
		byte	H_hands(4%),		&
		byte	H_skunks(2%),		&
		byte	H_pegpoints(2%)

	map (fixed_length)			&
	    	cardz	card(52),	   	&
		cardz	hand(2,6),     		&
		cardz	myhand(5),		&
		cardz	permhand(2,4),		&
		cardz	crib(4),    		&
		cardz	temphand(9),		&
		cardz	tempthrow(2),		&
		cardz	unpairhand(5),		&
		cardz	play(9),		&
		string	asctim = 23%

	declare			      					&
	      	byte	four_run, go_flag(2), pair_was(6),		&
 		long	your_crib, i, j, j1, goodness, k, counter, 	&
			stat, i2, j2, pairs, temppoints, i1, in_play,	&
     			best_goodness, me, last_play, cards_left(2),	&
		      	pair_multiple, term_code, last_points,		&
			points, score, counted_points(4), S_skunks(2),	&
			S_games, c154, s154erl,	S_pegpoints(2),		&
		 	S_winner, S_15(4), S_pairs(4), S_3runs(4),	&
			S_4runs(4), S_5runs(4), S_nobs(4), pip(2),	&
			S_flushes(4), S_hands(4), points(2),		&
			paste, kbid, yr_id, my_id, cr_id, py_id,  	&
			pt_id, bg_id, in_id, en_id, discard1, hi(9,4),	&
			discard2, counter1, counter2, last_player,	&
			G_15(4), G_pairs(4), G_3runs(4), G_pegpoints(2),&
			G_4runs(4), G_5runs(4), G_nobs(4),		&
			G_flushes(4), G_hands(4),			&
		string	text, answer, played_cards, player_name, a, b,	&
			for_str,					&
		cardz	tcard, potential, best_play

	declare	string	constant  ranks = "A23456789TJQK",	&
				  suits = "HDCS"

	declare	byte	constant	true=-1%, false=0%

	external integer constant		&
		jpi$_username,			&
		smg$m_blink,			&
		smg$m_bold,			&
		smg$m_border,			&
		smg$k_bottom,			&
		smg$m_reverse,			&
		smg$k_trm_ctrlz

	external integer function 		&
		lib$getjpi,			&
		lib$spawn,			&
		okay_to_play,			&
		smg$begin_display_update,	&
		smg$change_rendition,		&
		smg$change_virtual_display,	&
		smg$create_pasteboard,		&
		smg$create_virtual_display,	&
		smg$create_virtual_keyboard,	&
		smg$draw_line,			&
		smg$end_display_update,		&
		smg$erase_display,		&
		smg$erase_line,			&
		smg$erase_pasteboard,		&
		smg$label_border,		&
		smg$paste_virtual_display,	&
		smg$put_chars,			&
		smg$read_string,		&
		smg$repaint_screen,		&
		smg$set_cursor_abs,	    	&
		sys$gettim


	%sbttl "Local function declarations"
	def long goodfulishnessly(string a)
		select a
		case "A"
			goodfulishnessly= 1%
		case "2","3","4","5","6","7","8","9"
		       	goodfulishnessly = val%(a)
		case "T","J","Q","K"
			goodfulishnessly= 10%
		end select
	end def

200	%sbttl "Initial setups"

	! Check to see if it's ok to play now.
	goto 31999 if not(okay_to_play)	! External function

	! Open up data files, creating them if they don't exist.
	open "games:card_history.dat" as file #1%	&
		, indexed fixed		&
		, recordsize 11%	&
		, primary (C_ardkey)	&
		, map card_rec		&
		, allow modify		&
		, access modify

	open "games:play_history.dat" as file #2%	&
		, indexed fixed	   	&
		, primary (H_player)	&
		, map play_rec		&
		, allow modify		&
		, access modify

	call lib$get_foreign(for_str, , , )

	! Create a pasteboard called 'paste'
	stat = smg$create_pasteboard( paste , , , , )

	! Create some virtual displays

	! 'bg_id' is the big display that everything else sits on.
	!  It's only real use to have big borders.
	stat = smg$create_virtual_display( 22%, 76%, bg_id, smg$m_border, , )
	stat = smg$paste_virtual_display( bg_id, paste, 2%, 2%)
 	stat = smg$label_border( bg_id, "Great Cribbage Game", , ,	&
		smg$m_bold, , )

	! 'yr_id' is where your cards are displayed.
	stat = smg$create_virtual_display( 3%, 76%, yr_id, , , )
	stat = smg$paste_virtual_display( yr_id, paste, 3%, 2%)

	! 'my_id' is where my cards are displayed.
	! Everything in it is always bolded.
	stat = smg$create_virtual_display( 3%, 76%, my_id, 	&
		smg$m_border, smg$m_bold, )
	stat = smg$paste_virtual_display( my_id, paste, 7%, 2%)

	! 'cr_id' is where the crib cards and the cut card will show.
	stat = smg$create_virtual_display( 3%, 76%, cr_id, , , )
	stat = smg$paste_virtual_display( cr_id, paste, 11%, 2%)

	! 'py_id' is where the already played cards will appear.
	stat = smg$create_virtual_display( 3%, 76%, py_id, , , )
	stat = smg$paste_virtual_display( py_id, paste, 15%, 2%)

	! 'pt_id' is where the points are displayed.
	stat = smg$create_virtual_display( 3%, 76%, pt_id, , , )
	stat = smg$paste_virtual_display( pt_id, paste, 19%, 2%)

	! 'in_id' is where some error messages are shown.
	stat = smg$create_virtual_display( 2%, 76%, in_id, , , )
	stat = smg$paste_virtual_display( in_id, paste, 22%, 2%)

	! 'kbid' is where your input comes from.
	stat = smg$create_virtual_keyboard( kbid, "sys$input:",,)

	! Set up the cards.
	randomize
	for i = 1% to 13%
		card(i)::rank = seg$(ranks,i,i)
		card(i)::ordinal = i
		card(i)::valve = goodfulishnessly(card(i)::rank)
	next i
	for i = 14% to 26%
		card(i)::rank = seg$(ranks,i-13%,i-13%)
		card(i)::ordinal = i-13%
		card(i)::valve = goodfulishnessly(card(i-13%)::rank)
	next i
	for i = 27% to 39%
		card(i)::rank = seg$(ranks,i-26%,i-26%)
		card(i)::ordinal = i-26%
		card(i)::valve = goodfulishnessly(card(i-26%)::rank)
	next i
	for i = 40% to 52%
		card(i)::rank = seg$(ranks,i-39%,i-39%)
		card(i)::ordinal = i-39%
		card(i)::valve = goodfulishnessly(card(i-39%)::rank)
	next i
	card(i+1%)::suit = seg$(suits,(i/13%)+1%,(i/13%)+1%) for i = 0% to 51%

	! Set up and paste some of the useful variables.
	pip(1%), pip(2%) = 0%
	text = "You:"
	stat = smg$put_chars(pt_id, text, 2%, 2%, , )
	text = "  0"
	stat = smg$put_chars(pt_id, text, 2%, 7%, , )
	stat = smg$put_chars(pt_id, text, 1%, 7%, , )
	text = "Me:"
	stat = smg$put_chars(pt_id, text, 1%, 2%, , )
	stat = smg$draw_line(pt_id, 1%, 11%, 2%, 11%,,)
	your_crib = 0%
	your_crib = -1% if rnd<.5

300	%sbttl "Main loop - shuffle, deal, throw, count"
	! Shuffling, RoBrott style
	go_flag(1%), go_flag(2%) = false
	for k = 1% to 7%
		for i = 1% to 52%
			j = (rnd*52%)+1%
			tcard = card(j)
			card(j) = card(i)
			card(i) = tcard
		next i
	next k
	! Deal
	hand(k,i) = card(((k-1%)*6%)+i) for i = 1% to 6% for k = 1% to 2%
	played_cards = "XXX"
	your_crib = not(your_crib)
	if your_crib then
		text = "Your crib"
	    	stat = smg$label_border( my_id, text, smg$k_bottom, , , , )
	else
		text = "My crib"
	    	stat = smg$label_border( my_id, text, smg$k_bottom, , , , )
	end if

500	gosub 10200   	! Calculate best throw
	text = "Cards played:  "
	stat = smg$put_chars(py_id, text, 1%, 2%, , )
	text = "Your cards:    "
	stat = smg$put_chars(yr_id, text, 1%, 2%, , )
	text = ""
	temphand(i) = hand(2%,i) for i = 1% to 6%
	call sorthand(temphand(),1%,6%)
	hand(2%,i) = temphand(i) for i = 1% to 6%
	for i = 1% to 6%
		text = hand(2%,i)::rank+hand(2%,i)::suit+"   "
		stat = smg$put_chars(yr_id, text, , , )
	next i
	text = "My cards:      XX   XX   XX   XX"
	stat = smg$put_chars(my_id, text, 1%, 2%, , )
550	stat = smg$set_cursor_abs (in_id, 1%, 2%)
	stat = smg$read_string(kbid, answer, "Your throw --> ",5%,,,	&
		,,term_code,in_id)
	if answer="*****" then
		stat = smg$repaint_screen (paste)
		goto 550
	end if
	if term_code=smg$k_trm_ctrlz then
		stat = lib$spawn (,,,,,,,,,,,)
		stat = smg$repaint_screen (paste)
		goto 31999
	end if
	answer = edit$(answer,32%)
	a = seg$(answer,1%,2%)
	goto 560 if a=hand(2%,i)::rank+hand(2%,i)::suit for i = 1% to 6%
	text = "You don't have the first one, silly."
	stat = smg$put_chars(in_id, text, 2%, 10%, )
	goto 550
560	b = seg$(answer,4%,5%)
	goto 570 if b=hand(2%,i)::rank+hand(2%,i)::suit for i = 1% to 6%
	text = "You don't have the second one, silly."
	stat = smg$put_chars(in_id, text, 2%, 10%, )
	goto 550
570	if a=b then
		text = "Only one deck at a time, please."
		stat = smg$put_chars(in_id, text, 2%, 10%, )
		goto 550
	end if
	stat = smg$erase_display(in_id)
	counter2 = 0% \ counter1 = 2%
   	for i = 1% to 6%
		if (hand(2%,i)::rank+hand(2%,i)::suit=a) or 	&
			(hand(2%,i)::rank+hand(2%,i)::suit=b) then
			counter1 = counter1+1%
		      	crib(counter1) = hand(2%,i)
		else
			counter2 = counter2+1%
			hand(2%,counter2) = hand(2%,i)
		end if
	next i
	permhand(j,i) = hand(j,i) for i=1% to 4% for j=1% to 2%
	cards_left(i)=4% for i = 1% to 2%
	stat = smg$set_cursor_abs( yr_id, 1%, 17%)
	for i1 = 1% to cards_left(2%)
		text = hand(2%,i1)::rank+hand(2%,i1)::suit+"   "
		stat = smg$put_chars( yr_id, text, , , , )
	next i1
	stat = smg$erase_line( yr_id, , )
	text = "The cut card is "
	stat = smg$put_chars (cr_id,text, 3%, 2%, , )
	text =card(13%)::rank+card(13%)::suit
	stat = smg$put_chars (cr_id, text, , , , smg$m_reverse)
	if card(13%)::rank="J" then	! A jack was cut
		if your_crib then
			points(2%) = points(2%)+2%
			G_nobs(2%) = G_nobs(2%)+2%
			call display_points (2%, pt_id, points(2%))
			goto end_game if points(2%)>=121%
		else
		    	points(1%) = points(1%)+2%
			G_nobs(1%) = G_nobs(1%)+2%
			call display_points (1%, pt_id, points(1%))
			goto end_game if points(1%)>=121%
		end if
	end if
	score, in_play = 0%

600	if not(your_crib) then
		gosub 10300	! Ask yours
		goto end_game if points(2%)>=121%
		gosub 10400	! Ask mine
		goto end_game if points(1%)>=121%
	else
		gosub 10400 	! Ask mine
		goto end_game if points(1%)>=121%
		gosub 10300 	! Ask yours
		goto end_game if points(2%)>=121%
	end if
	goto 600 if cards_left(1%)+cards_left(2%)>0%
	if last_play=1% then
		points(1%) = points(1%)+1%
		call display_points (1%, pt_id, points(1%))
		goto end_game if points(1%)>=121%
	else if last_play=2% then
		points(2%) = points(2%)+1%
		call display_points (2%, pt_id, points(2%))
		goto end_game if points(2%)>=121%
	end if \ end if

610    	stat = smg$begin_display_update (my_id)
	stat = smg$set_cursor_abs (my_id, 1%, 17%)
	stat = smg$set_cursor_abs (yr_id, 1%, 17%)
	stat = smg$begin_display_update (yr_id)
	for i = 1% to 4%
		text = permhand(2%,i)::rank+permhand(2%,i)::suit+"   "
		stat = smg$put_chars (yr_id, text, , )
	next i
	stat = smg$end_display_update (my_id)
	stat = smg$end_display_update (yr_id)
	if your_crib then
		temphand(i) = permhand(1%,i) for i = 1% to 4%
		me = 1%
		gosub 10600
		text = "I got:    "+num1$(points)
		stat = smg$put_chars( my_id, text, 3%, 4%, , )
		points(1%) = points(1%)+points
		call display_points (1%, pt_id, points(1%))
		goto end_game if points(1%)>=121%
		temphand(i) = permhand(2%,i) for i = 1% to 4%
		me = 2%
		gosub 10600
		text = "You got:  "+num1$(points)
		stat = smg$put_chars( yr_id, text, 3%, 4%, , )
		points(2%) = points(2%)+points
		call display_points (2%, pt_id, points(2%))
		goto end_game if points(2%)>=121%
	else
		temphand(i) = permhand(2%,i) for i = 1% to 4%
		me = 2%
		gosub 10600
		text = "You got:  "+num1$(points)
		stat = smg$put_chars( yr_id, text, 3%, 4%, , )
		points(2%) = points(2%)+points
		call display_points (2%, pt_id, points(2%))
		goto end_game if points(2%)>=121%
		temphand(i) = permhand(1%,i) for i = 1% to 4%
		me = 1%
		gosub 10600
		text = "I got:    "+num1$(points)
		stat = smg$put_chars( my_id, text, 3%, 4%, , )
		points(1%) = points(1%)+points
		call display_points (1%, pt_id, points(1%))
		goto end_game if points(1%)>=121%
	end if
	temphand(i) = crib(i) for i = 1% to 4%
	text = "Crib cards:    "
	text = text+temphand(i)::rank+temphand(i)::suit+"   " for i = 1% to 4%
	stat = smg$put_chars( cr_id, text, 1%, 2%, , )
	if your_crib then
		me = 4%
		gosub 10600
	   	text = num1$(points)+" in your crib"
		stat = smg$put_chars(cr_id, text, 2%, 50%, 1%, , )
		points(2%) = points(2%)+points
		call display_points (2%, pt_id, points(2%))
		goto end_game if points(2%)>=121%
	else
		me = 3%
		gosub 10600
		text = num1$(points)+" in my crib"
		stat = smg$put_chars(cr_id, text, 2%, 50%, 1%, , )
		points(1%) = points(1%)+points
		call display_points (1%, pt_id, points(1%))
	      	goto end_game if points(1%)>=121%
	end if
	gosub hit_key
	stat = smg$erase_line( yr_id, 3%, 1%)
	stat = smg$erase_line( my_id, 3%, 1%)
	stat = smg$erase_line (pt_id, 3%, 1%)
	stat = smg$erase_display (cr_id)
	stat = smg$erase_display (py_id)
	goto 300

10200	%sbttl "Subroutines"

	%sbttl "Figure my best throw"
	! Calculate goodness of hand
	best_goodness = 0%
	for discard1 = 1% to 5% \ for discard2 = discard1+1% to 6%
	tempthrow(1%) = hand(1%,discard1)
	tempthrow(2%) = hand(1%,discard2)
	counter = 0%
	for i = 1% to 6%
		if i<>discard1 and i<>discard2 then
		    	counter = counter+1%
			temphand(counter) = hand(1%,i)
		end if
	next i
	call sorthand (temphand(),1%,4%)
	goodness = 0%
 pairs:
 	goodness = goodness+4% 	&
		if temphand(i)::rank=temphand(j)::rank	&
			for i = j+1% to 4% for j = 1% to 3%
 preferences:
 	for i = 1% to 4%
		select temphand(i)::rank
		case "A","2"
			goodness = goodness+1%
		case "5"
		     	goodness = goodness+1%
		case "J"
			goodness = goodness+1% if your_crib
		case "K"
			goodness = goodness-1%
		end select
	next i

 fifteens:
 	goodness = goodness+3%	&
		if temphand(i)::valve+temphand(j)::valve=15%	&
 			for j = i+1% to 4%	&
				for i=1% to 3%
	goodness = goodness+3%	&
		if temphand(i)::valve+temphand(j)::valve+	&
 			temphand(j1)::valve=15%			&
				for j1 = j+1% to 4%		&
					for j = i+1% to 3%	&
						for i = 1% to 2%
	goodness = goodness+3%	&
		if temphand(1%)::valve+temphand(2%)::valve+	&
			temphand(3%)::valve+temphand(4%)::valve=15%

 run_of_3:
 	unpairhand(1%) = temphand(1%)
	counter = 1%
	for i = 2% to 4%
		if temphand(i)::rank<>temphand(i-1%)::rank then
			counter = counter+1%
			unpairhand(counter) = temphand(i)
		end if
	next i
 	goodness = goodness+7%+(4%-counter)*3	&
		if unpairhand(i+2%)::ordinal=unpairhand(i+1%)::ordinal+1%	&
			if unpairhand(i+1%)::ordinal=unpairhand(i)::ordinal+1%	&
				for i = 1% to counter-2%
 adjacent:
 	goodness = goodness+1%	&
		if temphand(i+1%)::ordinal=temphand(i)::ordinal+1%	&
			for i = 1% to 3%
 blush:
	goodness = goodness+4%	&
		if temphand(1%)::suit=temphand(2%)::suit and	&
 			temphand(1%)::suit=temphand(3%)::suit and	&
 			temphand(1%)::suit=temphand(4%)::suit

 throw_preferences:
	for i = 1% to 2%
		select tempthrow(i)::rank
		case "5"
			goodness = goodness-6% if your_crib
		case "J"
			goodness = goodness-1% if your_crib
		end select
	next i

 throw_pairs:
	if tempthrow(1%)::rank=tempthrow(2%)::rank then
		if your_crib then
	 		goodness = goodness-6%
		else
		  	goodness = goodness+4%
		end if
	end if

 throw_adjacent:
 	goodness = goodness-1%	&
		if abs(pos(ranks,tempthrow(1%)::rank,1%)-	&
	      		pos(ranks,tempthrow(2%)::rank,1%))=1% and your_crib
 	goodness = goodness+1%	&
		if abs(pos(ranks,tempthrow(1%)::rank,1%)-	&
	      		pos(ranks,tempthrow(2%)::rank,1%))=1% and not(your_crib)

 throw_fifteen:
 	if tempthrow(1%)::valve+tempthrow(2%)::valve=15% then
		if your_crib then
			goodness = goodness-5%
		else
			goodness = goodness+3%
		end if
	end if

 throw_five:
 	if tempthrow(1%)::valve+tempthrow(2%)::valve=5% then
		if your_crib then
			goodness = goodness-3%
		else
			goodness = goodness+3%
		end if
	end if

 fix_hand:
	if goodness>best_goodness then
		best_goodness = goodness
		myhand(i) = temphand(i) for i = 1% to 4%
		crib(i) = tempthrow(i) for i = 1% to 2%
	end if
	next discard2 \ next discard1
	hand(1%,i) = myhand(i) for i = 1% to 4%
	return

10300	%sbttl "Ask your play"
	! Ask yours
	if cards_left(2%)=0% then
		go_flag(2%)=true
	else
		goto 10310 if hand(2%,i)::valve+score<=31%	&
			for i = 1% to cards_left(2%)
		go_flag(2%)=true
	end if
	if (go_flag(1%)=true) then
		points(2%) = points(2%)+1%
		call display_points (2%, pt_id, points(2%))
		text = "Your GO for 1"
		stat = smg$put_chars( cr_id, text, 2%, 33%, , )
		stat = smg$erase_line( py_id, 1%, 17%)
		stat = smg$set_cursor_abs (py_id, 1%, 17%)
		call update_history (2%, last_player, 1%, last_points, &
		     	in_play, played_cards, play(in_play)::rank)
		played_cards = "XXX"
		score, in_play = 0%
		go_flag(1%), go_flag(2%) = false
	else
		text = "You must GO"
		stat = smg$put_chars( cr_id, text, 2%, 15%, , )
		stat = smg$erase_line(cr_id, 2%, 1%)
		go_flag(2%) = true
	end if
	return

10310	stat = smg$set_cursor_abs (in_id, 1%, 2%)
    	stat = smg$read_string(kbid, answer, "Your play --> ",2%,,,	&
		,,term_code,in_id)
	if answer="**" then
		stat = smg$repaint_screen (paste)
		goto 10310
	end if
	if term_code=smg$k_trm_ctrlz then
		stat = smg$erase_pasteboard (paste)
		goto 31999
	end if
	a = edit$(answer,32%)
     	goto 10320 if hand(2%,i)::rank+hand(2%,i)::suit=a 	&
		for i = 1% to cards_left(2%)
	text = "You don't have that card..."
	stat = smg$put_chars(in_id, text, 2%, 10%, , )
	goto 10300
10320	if hand(2%,i)::valve+score>31% then
		text = "You can't count "+num1$(hand(2%,i)::valve+score)
		stat = smg$put_chars (in_id, text, 2%, 20%, , )
		goto 10300
	end if
	stat = smg$erase_display(in_id)
	text = a+"   "
	stat = smg$put_chars( py_id, text, , , , )
	last_play = 2%
	score = hand(2%,i)::valve+score
	text = "The count is "+num1$(score)+" "
	stat = smg$put_chars (pt_id, text, 3%, 28%, , )
	stat = smg$erase_line (cr_id, 2%, 1%)
	in_play = in_play+1%
	play(in_play) = hand(2%,i)
	cards_left(2%) = cards_left(2%)-1%
	stat = smg$set_cursor_abs( yr_id, 1%, 17%)
	counter1 = 0%
	for i1 = 1% to cards_left(2%)+1%
		if play(in_play)<>hand(2%,i1) then
			counter1 = counter1+1%
	     		hand(2%,counter1) = hand(2%,i1)
		end if
	next i1
	for i1 = 1% to cards_left(2%)
		text = hand(2%,i1)::rank+hand(2%,i1)::suit+"   "
		stat = smg$put_chars( yr_id, text, , , , )
	next i1
	stat = smg$erase_line( yr_id, , )
	me = 2%
	gosub 10700	! Count during peg
	points(2%) = points(2%)+points
	call display_points (2%, pt_id, points(2%))
	call update_history (2%, last_player, points, last_points, &
	     	in_play, played_cards, play(in_play)::rank)	&
	     	if in_play<>0%	! We've already done the update after a 31.
	return

10400	%sbttl "Ask my play"
	! Ask mine
	if cards_left(1%)=0% then
		go_flag(1%)=true
	else
		goto 10450 if hand(1%,i)::valve+score<=31%	&
			for i = 1% to cards_left(1%)
		go_flag(1%)=true
	end if
	if go_flag(2%)=true then
	 	points(1%) = points(1%)+1%
		call display_points (1%, pt_id, points(1%))
		call update_history (1%, last_player, 1%, last_points, &
		     	in_play, played_cards, play(in_play)::rank)
		played_cards = "XXX"
		score, in_play = 0%
		text = "My GO for 1  "
		stat = smg$put_chars( cr_id, text, 2%, 33%, , )
		stat = smg$erase_line( py_id, 1%, 17%)
		stat = smg$set_cursor_abs (py_id, 1%, 17%)
		go_flag(1%), go_flag(2%) = false
	 	stat = smg$erase_line (pt_id, 3%, 27%)
	else
	   	text = "   GO        "
		stat = smg$put_chars( cr_id, text, 2%, 33%, , )
		go_flag(1%) = true
	end if
	return

10450	i2 = 1%
	best_goodness, goodness = -1000%
	for i2 = 1% to cards_left(1%)
		if (hand(1%,i2)::valve+score<=31%) then
			potential = hand(1%,i2)
			gosub 10800
			if goodness>=best_goodness then
				best_goodness = goodness
				best_play = potential
			end if
		end if
	next i2
	last_play = 1%
	text = best_play::rank+best_play::suit+"   "
	stat = smg$put_chars( py_id, text, , , , smg$m_bold, , )
	score = best_play::valve+score
	text = "The count is "+num1$(score)+" "
	stat = smg$put_chars (pt_id, text, 3%, 28%, , )
	in_play = in_play+1%
	play(in_play) = best_play
	cards_left(1%) = cards_left(1%)-1%
	counter1 = 0%
	text = best_play::rank+best_play::suit
	i2 = 17%+5%*(cards_left(1%))
	stat = smg$put_chars( my_id, text, 1%, i2, , )
	text = ""
	for i1 = 1% to cards_left(1%)+1%
		if hand(1%,i1)<>best_play then
			counter1 = counter1+1%
			hand(1%,counter1) = hand(1%,i1)
	     	end if
	next i1
	me = 1%
	gosub 10700	! Count during peg
	points(1%) = points(1%)+points
	call display_points (1%, pt_id, points(1%))
	call update_history (1%, last_player, points, last_points, &
	     	in_play, played_cards, play(in_play)::rank)	&
			if score<>0%	! Don't update if there was just a 31.
	return

10600	%sbttl "Count points"
	! Count cards
	temphand(5%) = card(13%)
	points = 0%
	G_hands(me) = G_hands(me)+1%

 count_blush:
	if (temphand(1%)::suit=temphand(2%)::suit) and	&
 		(temphand(1%)::suit=temphand(3%)::suit) and	&
 		(temphand(1%)::suit=temphand(4%)::suit) then
		if ((me<>3%) and (me<>4%)) or	&
			(temphand(1%)::suit=temphand(5%)::suit) then
			G_flushes(me) = G_flushes(me)+4%
			points = points+4%
		end if
		if temphand(1%)::suit=temphand(5%)::suit then
			points = points+1%
		    	G_flushes(me) = G_flushes(me)+1%
		end if
	end if
 count_nobs:
	for i = 1% to 4%
		if (temphand(i)::rank="J") and 	&
			(temphand(i)::suit=temphand(5%)::suit) then
		 	points = points+1%
			G_nobs(me) = G_nobs(me)+1%
		end if
	next i
	call sorthand (temphand(),1%,5%)

 count_pairs:
	pairs = 0%
	for j = 1% to 4%
		for i = j+1% to 5%
			if temphand(i)::rank=temphand(j)::rank then
	      			points = points+2%
				G_pairs(me) = G_pairs(me)+2%
				pairs = pairs+1%
			 	pair_was(pairs) = temphand(i)::ordinal
				pair_multiple = 2%
			end if
		next i
	next j
	! Specialties for triple_runs
	if (pairs=3%) and (pair_was(1%)=pair_was(2%)) then
		pairs=1%
		pair_multiple = 3%
	end if

 count_fifteens:
	for i=1% to 4%
 		for j = i+1% to 5%
			if temphand(i)::valve+temphand(j)::valve=15% then
			 	points = points+2%
				G_15(me) = G_15(me)+2%
			end if
		next j
	next i

	for i = 1% to 3%
		for j = i+1% to 4%
			for j1 = j+1% to 5%
				if temphand(i)::valve+temphand(j)::valve+	&
 					temphand(j1)::valve=15% then
					points = points+2%
					G_15(me) = G_15(me)+2%
				end if
			next j1
		next j
	next i

	for i = 1% to 2%
		for j = i+1% to 3%
			for j1 = j+1% to 4%
				for j2 = j1+1% to 5%
					if temphand(i)::valve+temphand(j)::valve+	&
 					temphand(j1)::valve+temphand(j2)::valve=15% then
						points = points+2%
						G_15(me) = G_15(me)+2%
					end if
				next j2
			next j1
		next j
	next i

	if temphand(1%)::valve+temphand(2%)::valve+	&
		temphand(3%)::valve+temphand(4%)::valve+	&
		temphand(5%)::valve=15% then
			points = points+2%
			G_15(me) = G_15(me)+2%
	end if

 count_runs:
	if temphand(5%)::ordinal=temphand(4%)::ordinal+1% and &
		temphand(4%)::ordinal=temphand(3%)::ordinal+1% and &
		temphand(3%)::ordinal=temphand(2%)::ordinal+1% and &
		temphand(2%)::ordinal=temphand(1%)::ordinal+1% then
			G_5runs(me) = G_5runs(me)+5%
		 	points = points+5%
			goto end_count
	end if

	unpairhand(1%) = temphand(1%)
	counter = 1%
	for i = 2% to 5%
		if temphand(i)::rank<>temphand(i-1%)::rank then
			counter = counter+1%
		  	unpairhand(counter) = temphand(i)
		end if
	next i
	four_run = false
	for i = 1% to counter-3%
		if unpairhand(i+1%)::ordinal=unpairhand(i)::ordinal+1% then
			if unpairhand(i+2%)::ordinal=unpairhand(i+1%)::ordinal+1% then
	 			if unpairhand(i+3%)::ordinal=unpairhand(i+2%)::ordinal+1% then
				 	points = points+4%*(pairs+1%)
  					four_run = true
					G_4runs(me) = G_4runs(me)+(4%*(pairs+1%))
				end if
			end if
		end if
	next i
	goto end_count if four_run	!	 Don't count three and* four runs
	for i = 1% to counter-2%
		if unpairhand(i+1%)::ordinal=unpairhand(i)::ordinal+1% then
			if unpairhand(i+2%)::ordinal=unpairhand(i+1%)::ordinal+1% then
				temppoints = 3%
				temppoints = temppoints*pair_multiple 	&
					if ((unpairhand(i)::ordinal=pair_was(j)) &
						or (unpairhand(i+1%)::ordinal=pair_was(j))	&
						or (unpairhand(i+2%)::ordinal=pair_was(j)))	&
			     			for j = 1% to pairs if pairs=>1%
			  	points = points+temppoints
				G_3runs(me) = G_3runs(me)+temppoints
				goto end_count
			end if
		end if
	next i

 end_count:
	return

10700	%sbttl "Check for pegging points"
	points = 0%
 peg_four_o_kind:
	goto peg_three_o_kind if in_play<4%
	if (play(in_play)::rank=play(in_play-1%)::rank) and	&
		(play(in_play)::rank=play(in_play-2%)::rank) and&
		(play(in_play)::rank=play(in_play-3%)::rank) then
		points = points+12%
		goto peg_15
	end if

 peg_three_o_kind:
	goto peg_two_o_kind if in_play<3%
	if (play(in_play)::rank=play(in_play-1%)::rank) and	&
		(play(in_play)::rank=play(in_play-2%)::rank) then
		points = points+6%
		goto peg_15
	end if

 peg_two_o_kind:
	goto peg_runs if in_play<2%
	if (play(in_play)::rank=play(in_play-1%)::rank) then
		points = points+2%
		goto peg_15
	end if

 peg_runs:
	goto peg_15 if in_play<3%
	for i = in_play to 3% step -1%
		temphand(i1)=play(in_play-(i1-1%))	&
			for i1 = 1% to i
		call sorthand (temphand(), 1%, i)
 		goto end_peg_runs	&
			if temphand(1%)::ordinal<>((temphand(i1)::ordinal)-(i1-1%))	&
				for i1 = 2% to i
		points = points+i
		goto peg_15
 end_peg_runs:
	next i

 peg_15:
	if score=15% then
		points = points+2%
	end if
 peg_31:
	if score=31% then
		points = points+2%
		call update_history (me, last_player, 2%, last_points, &
		     	in_play, played_cards, play(in_play)::rank)
		played_cards = "XXX"
		score, in_play = 0%
		last_play = 0%	! So that no one gets the last card point
		go_flag(1%),go_flag(2%) = false
		gosub hit_key if me=1%
		stat = smg$erase_line (pt_id, 3%, 28%)
		stat = smg$erase_line (py_id, 1%, 17%)
		stat = smg$set_cursor_abs (py_id, 1%, 17%)
	end if
	return

10800	%sbttl "Calculate best playing card"
	! Figure best card to play
	goodness = 0%
 play_four_o_kind:
	goto play_three_o_kind if in_play<3%
	if (potential::rank=play(in_play)::rank) and	&
		(potential::rank=play(in_play-1%)::rank) and &
		(potential::rank=play(in_play-2%)::rank) then
		goodness = goodness+80%
  		goto play_10
	end if

 play_three_o_kind:
	goto play_two_o_kind if in_play<2%
	if (potential::rank=play(in_play)::rank) and	&
		(potential::rank=play(in_play-1%)::rank) then
		goodness = goodness+10%*((in_play+cards_left(1%))/	&
			(cards_left(2%)+1%))
		goodness = goodness+20% if (hand(1%,i)::rank=potential::rank)	&
			and (hand(1%,i)<>potential) 	&
				for i = 1% to cards_left(1%)
		goodness = goodness+20% if (play(i)::rank=potential::rank)	&
			for i = 1% to in_play-2% if in_play>=3%
		goodness = goodness+20% if potential::rank=card(13%)::rank
		goodness = goodness+20% if potential::valve+score>31%
		goto play_10
	end if

 play_two_o_kind:
	goto play_runs if in_play<1%
	if (potential::rank=play(in_play)::rank) then
		goodness = goodness+	&
			(in_play+cards_left(1%))/(cards_left(2%)+1%)*3%
		goodness = goodness+12% if (hand(1%,i)::rank=potential::rank)	&
			and (hand(1%,i)<>potential) for i = 1% to cards_left(1%)
		goodness = goodness+10% if (play(i)::rank=potential::rank)	&
			for i = 1% to in_play-2% if in_play>=2%
	    	goodness = goodness+10% if potential::rank=card(13%)::rank
		goodness = goodness+10% if potential::valve+score>31%
		goto play_10
	end if

 play_runs:
	goto play_10 if in_play<2%
	for i = in_play to 2% step -1%
		temphand(i1)=play(in_play-(i1-1%))	&
	       		for i1 = 1% to i-1%
		temphand(i1)=potential
		call sorthand (temphand(), 1%, i)
 		goto end_play_runs	&
			if temphand(1%)::ordinal<>	&
				((temphand(i1)::ordinal)-(i1-1%))	&
					for i1 = 2% to i
		goodness = goodness+(i*3%)
		goto play_10
 end_play_runs:
	next i

 play_adjacent:
	goodness = goodness-8%	&
		if (abs(play(in_play)::ordinal-potential::ordinal)=1%) and&
			potential::valve+(play(in_play)::ordinal-	&
			potential::ordinal)+score<31%
	goodness = goodness-13%	&
		if (abs(play(in_play)::ordinal-potential::ordinal)=1%) and&
			potential::valve-1%+score=31%

 play_10:
	goodness = goodness-3% if score+potential::valve=10%
	goodness = goodness-5% if score+potential::valve=5%
	goodness = goodness+15% if score+potential::valve=15%
	goodness = goodness-8% if score+potential::valve=21%
	goodness = goodness+3% if score+potential::valve=30%
	goodness = goodness+20% if score+potential::valve=31%

 play_preferences:
	select potential::rank
		case "5"
			goodness = goodness-5%
		case "2"
			goodness = goodness-1%
		case "A","J"
			goodness = goodness-3%
		case "Q"
			goodness = goodness+1%
		case "K"
			goodness = goodness+3%
	end select

10810	! Do file work
	select in_play
	case 0%
		C_ardkey = "XX"+potential::rank
	case 1%
		C_ardkey = "X"+play(in_play)::rank+potential::rank
	case else
		C_ardkey = play(in_play-1%)::rank+play(in_play)::rank+potential::rank
	end select
	get #1%, key #0% eq C_ardkey, regardless
 nuff_history:
	goodness = goodness+((real(C_history::success+1%)/	&
		real(C_history::times+2%))*100%)-50%
	return

15000	%sbttl "Miscellaneous routines"
 	! Hit any key...
 hit_key:
	stat = smg$erase_display (in_id)
	stat = smg$set_cursor_abs (in_id, 1%, 2%)
	stat = smg$read_string(kbid, answer, "Hit any key to continue -> ",1%,,,,,,in_id)
	stat = smg$erase_display (in_id)
	return

29000	%sbttl "Error traps"
	select err
	case 11
		select erl
		case 29200
			resume 29300
		end select
	case 154
		if s154erl<>erl then sleep 1% \s154erl=erl \c154=1% \resume
		end if
		if s154erl=erl then sleep 1% \c154=c154+1%
		end if
		if c154>9%  then c154=0% \ print bel; \sleep 1% \print bel;
			resume else resume
		end if
	case 155
		select erl
		case 10810
		      	C_history::times, C_history::success = 0%
				! Make it neutral
			resume nuff_history
		end select
	end select

	print "Erl = ";erl;" Err = ";err
	resume 31999

29100	%sbttl "End of game statistics"
 end_game:
 	stat = smg$begin_display_update (yr_id)
	stat = smg$begin_display_update (my_id)
	stat = smg$begin_display_update (cr_id)
	stat = smg$set_cursor_abs (yr_id, 1%, 17%)
	stat = smg$set_cursor_abs (my_id, 1%, 17%)
	for i = 1% to 4%
		text = permhand(2%,i)::rank+permhand(2%,i)::suit+"   "
	   	stat = smg$put_chars (yr_id, text, , )
   		text = permhand(1%,i)::rank+permhand(1%,i)::suit+"   "
		stat = smg$put_chars (my_id, text, , )
	next i
	text = "Crib cards:    "
	text = text+crib(i)::rank+crib(i)::suit+"   " for i = 1% to 4%
	stat = smg$put_chars( cr_id, text, 1%, 2%, , )
	stat = smg$end_display_update (yr_id)
	stat = smg$end_display_update (my_id)
	stat = smg$end_display_update (cr_id)
 	select points(1%)
	case >=121%
		H_winner = 1%
		H_skunks(2%) = 0%
		select points(2%)
		case 1% to 60%
			text = "Pay as you leave"
			H_skunks(1%) = 2%
		case 61% to 90%
			text = " SKUNK!! "
			H_skunks(1%) = 1%
		case 91% to 119%
			text = " -=*grin*=- "
			H_skunks(1%) = 0%
		case 120%
			text = " HeeHee! "
			H_skunks(1%) = 0%
		end select
	case else
	    	H_winner = 2%
		H_skunks(1%) = 0%
		select points(1%)
		case 1% to 60%
			text = " SYSTEM SHUTDOWN COMPLETE "
			H_skunks(2%) = 2%
		case 61% to 90%
			text = " Aw, man... "
			H_skunks(2%) = 1%
		case 91% to 119%
			text = " *sigh* "
			H_skunks(2%) = 0%
		case 120%
			text = " ARGH!! "
			H_skunks(2%) = 0%
		end select
	end select
	stat = smg$change_virtual_display (my_id, 3%, 76%, 0%, , )
 	stat = smg$label_border (bg_id, text, i, , smg$m_bold)	&
		for i = 0% to 3% for i1 = 1% to 2%
	gosub hit_key
	if len(for_str)<>0% then
		player_name = trm$(for_str)
	else
		stat = lib$getjpi (jpi$_username by ref, , , , player_name, i )
		player_name = trm$(player_name)
	end if
	H_player = seg$(player_name,1%,10%)+	&
		string$(10%-len(player_name),32%)
	counted_points(i) = G_15(i)+G_pairs(i)+G_3runs(i)+	&
		G_4runs(i)+G_5runs(i)+G_nobs(i)+G_flushes(i)	for i = 1% to 4%
	G_pegpoints(1%) = points(1%)-counted_points(1%)-counted_points(3%)
	G_pegpoints(2%) = points(2%)-counted_points(2%)-counted_points(4%)
 update_list:
	stat = sys$gettim (H_play_time)
	for i = 1% to 4%
		H_15(i) = G_15(i) \ H_pairs(i) = G_pairs(i)
		H_3runs(i) = G_3runs(i) \ H_hands(i) = G_hands(i)
		H_4runs(i) = G_4runs(i) \ H_5runs(i) = G_5runs(i)
		H_nobs(i) = G_nobs(i) \ H_flushes(i) = G_flushes(i)
	next i
	for i = 1% to 2%
		H_pegpoints(i) = G_pegpoints(i)
	next i
	put #2%
	stat = smg$create_virtual_display( 22%, 76%, en_id, smg$m_border, , )
	text = "Statistics for "+player_name
	stat = smg$label_border (en_id, text, 0%, smg$m_bold)
	stat = smg$put_chars (en_id, 	&
		"Me             You          MyCrib       YourCrib", 4%, 26%)
	stat = smg$put_chars (en_id, "Points by 15's", 5%, 3%)
	stat = smg$put_chars (en_id, "Points by pairs", 6%, 3%)
	stat = smg$put_chars (en_id, "Points by 3-runs", 7%, 3%)
	stat = smg$put_chars (en_id, "Points by 4-runs", 8%, 3%)
	stat = smg$put_chars (en_id, "Points by 5-runs", 9%, 3%)
	stat = smg$put_chars (en_id, "Points by nobs", 10%, 3%)
	stat = smg$put_chars (en_id, "Points by flushes", 11%, 3%)
	stat = smg$put_chars (en_id, "Number of hands", 12%, 3%)
	stat = smg$put_chars (en_id, "Points by count", 13%, 3%)
	stat = smg$put_chars (en_id, "Avg. points/hand", 14%, 3%)
	stat = smg$put_chars (en_id, "Points by pegging", 15%, 3%)
	stat = smg$put_chars (en_id, "Games won", 18%, 8%)
	stat = smg$put_chars (en_id, "Skunks", 19%, 8%)
	for i = 1% to 4%
		text = format$(G_15(i),"###/")
		stat = smg$put_chars (en_id, text, 5%, 11%+(14%*i))
		text = format$(G_pairs(i),"###/")
		stat = smg$put_chars (en_id, text, 6%, 11%+(14%*i))
		text = format$(G_3runs(i),"###/")
		stat = smg$put_chars (en_id, text, 7%, 11%+(14%*i))
		text = format$(G_4runs(i),"###/")
		stat = smg$put_chars (en_id, text, 8%, 11%+(14%*i))
		text = format$(G_5runs(i),"###/")
		stat = smg$put_chars (en_id, text, 9%, 11%+(14%*i))
		text = format$(G_nobs(i),"###/")
		stat = smg$put_chars (en_id, text, 10%, 11%+(14%*i))
		text = format$(G_flushes(i),"###/")
 		stat = smg$put_chars (en_id, text, 11%, 11%+(14%*i))
		text = format$(G_hands(i),"###/")
		stat = smg$put_chars (en_id, text, 12%, 11%+(14%*i))
	next i
	for i = 1% to 4%
		text = format$(counted_points(i),"###/")
    		stat = smg$put_chars (en_id, text, 13%, 11%+(14%*i))
	       	text = format$(real(counted_points(i))/G_hands(i),"##.#/")
		stat = smg$put_chars (en_id, text, 14%, 10%+(14%*i))
	next i
	for i = 1% to 2%
		text = format$(G_pegpoints(i),"###/")
		stat = smg$put_chars (en_id, text, 15%, 11%+(14%*i))
	next i
 	if H_winner=1% then
		stat = smg$put_chars (en_id, "1/", 18%, 27%)
		stat = smg$put_chars (en_id, "0/", 18%, 41%)
	else
		stat = smg$put_chars (en_id, "0/", 18%, 27%)
		stat = smg$put_chars (en_id, "1/", 18%, 41%)
	end if
	restore #2%
29200
 show_summary:
	get #2%, key #0% eq player_name, regardless
	while H_player=player_name
		S_games = S_games+1%
		S_winner = S_winner+1% if H_winner=2%
		for i = 1% to 4%
			S_15(i) = S_15(i)+H_15(i)
			hi(1%,i) = H_15(i) if H_15(i)>hi(1%,i)
			S_pairs(i) = S_pairs(i)+H_pairs(i)
			hi(2%,i) = H_pairs(i) if H_pairs(i)>hi(2%,i)
			S_3runs(i) = S_3runs(i)+H_3runs(i)
			hi(3%,i) = H_3runs(i) if H_3runs(i)>hi(3%,i)
			S_4runs(i) = S_4runs(i)+H_4runs(i)
			hi(4%,i) = H_4runs(i) if H_4runs(i)>hi(4%,i)
			S_5runs(i) = S_5runs(i)+H_5runs(i)
			hi(5%,i) = H_5runs(i) if H_5runs(i)>hi(5%,i)
			S_nobs(i) = S_nobs(i)+H_nobs(i)
			hi(6%,i) = H_nobs(i) if H_nobs(i)>hi(6%,i)
		       	S_flushes(i) = S_flushes(i)+H_flushes(i)
			hi(7%,i) = H_flushes(i) if H_flushes(i)>hi(7%,i)
			S_hands(i) = S_hands(i)+H_hands(i)
			hi(8%,i) = H_hands(i) if H_hands(i)>hi(8%,i)
		next i
		for i = 1% to 2%
			S_skunks(i) = S_skunks(i)+H_skunks(i)
			S_pegpoints(i) = S_pegpoints(i)+H_pegpoints(i)
			hi(9%,i) = H_pegpoints(i) if H_pegpoints(i)>hi(9%,i)
		next i
		get #2%, regardless
	next	! while

29300	for i = 1% to 4%
		text = format$(S_15(i)/S_games,"###")
		stat = smg$put_chars (en_id, text, 5%, 15%+(14%*i))
		text = format$(S_pairs(i)/S_games,"###")
		stat = smg$put_chars (en_id, text, 6%, 15%+(14%*i))
		text = format$(S_3runs(i)/S_games,"###")
		stat = smg$put_chars (en_id, text, 7%, 15%+(14%*i))
		text = format$(S_4runs(i)/S_games,"###")
		stat = smg$put_chars (en_id, text, 8%, 15%+(14%*i))
		text = format$(S_5runs(i)/S_games,"###")
		stat = smg$put_chars (en_id, text, 9%, 15%+(14%*i))
		text = format$(S_nobs(i)/S_games,"###")
		stat = smg$put_chars (en_id, text, 10%, 15%+(14%*i))
		text = format$(S_flushes(i)/S_games,"###")
		stat = smg$put_chars (en_id, text, 11%, 15%+(14%*i))
		text = format$(S_hands(i)/S_games,"###")
		stat = smg$put_chars (en_id, text, 12%, 15%+(14%*i))
	next i
	counted_points(i) = S_15(i)+S_pairs(i)+S_3runs(i)+	&
		S_4runs(i)+S_5runs(i)+S_nobs(i)+S_flushes(i) &
			for i = 1% to 4%
	for i = 1% to 4%
		text = format$(counted_points(i)/S_games,"###")
    		stat = smg$put_chars (en_id, text, 13%, 15%+(14%*i))
	       	text = format$(real(counted_points(i))/(S_hands(i)),&
			"##.#")
		stat = smg$put_chars (en_id, text, 14%, 15%+(14%*i))
	next i
	for i = 1% to 2%
		text = format$(real(S_pegpoints(i))/S_games,"##.#")
		stat = smg$put_chars (en_id, text, 15%, 15%+(14%*i))
	next i
	text = format$(S_games-S_winner,"####")
	stat = smg$put_chars (en_id, text, 18%, 29%)
	text = format$(S_winner,"####")
	stat = smg$put_chars (en_id, text, 18%, 43%)
	for i = 1% to 2%
		text = format$(S_skunks(i),"###")
		stat = smg$put_chars (en_id, text, 19%, 16%+(14%*i))
	next i
	for i = 1% to 4%
		stat = smg$change_rendition (en_id, 5%, 11%+(14%*i), 1%, 3%, &
	    		smg$m_blink,) if G_15(i)>=hi(1%,i)
		stat = smg$change_rendition (en_id, 6%, 11%+(14%*i), 1%, 3%, &
			smg$m_blink,) if G_pairs(i)>=hi(2%,i)
		stat = smg$change_rendition (en_id, 7%, 11%+(14%*i), 1%, 3%, &
			smg$m_blink,) if G_3runs(i)>=hi(3%,i)
		stat = smg$change_rendition (en_id, 8%, 11%+(14%*i), 1%, 3%, &
			smg$m_blink,) if G_4runs(i)>=hi(4%,i)
		stat = smg$change_rendition (en_id, 9%, 11%+(14%*i), 1%, 3%, &
			smg$m_blink,) if G_5runs(i)>=hi(5%,i)
		stat = smg$change_rendition (en_id, 10%, 11%+(14%*i), 1%, 3%, &
			smg$m_blink,) if G_nobs(i)>=hi(6%,i)
		stat = smg$change_rendition (en_id, 11%, 11%+(14%*i), 1%, 3%, &
			smg$m_blink,) if G_flushes(i)>=hi(7%,i)
		stat = smg$change_rendition (en_id, 12%, 11%+(14%*i), 1%, 3%, &
			smg$m_blink,) if G_hands(i)>=hi(8%,i)
	next i
	for i = 1% to 2%
 		stat = smg$change_rendition (en_id, 15%, 11%+(14%*i), 1%, 3%, &
			smg$m_blink,) if G_pegpoints(i)>=hi(9%,i)
	next i
	stat = smg$paste_virtual_display( en_id, paste, 2%, 2%)

31999	%sbttl "Allocation information"
	end

32000	%title "Subroutine Sorthand"
	sub sorthand (cardz ar_ray(), long first, last)
	record cardz
		string	rank	= 1
		string	suit	= 1
		long	valve
		long	ordinal
	end record cardz
	declare	cardz	temp
     	on error goto 32020

32010	for outer% = first to last
		for inner% = first to last-1%-(outer%-first)
			goto skip if ar_ray(inner%)::ordinal<ar_ray(inner%+1%)::ordinal
	      	temp = ar_ray(inner%)
			ar_ray(inner%) = ar_ray(inner%+1%)
			ar_ray(inner%+1%) = temp
 SKIP:		next inner%
	next outer%
	exit sub

32020 	on error go back

32030	%sbttl "Allocation information"
	end sub

32130	%title "Subroutine Update_history"
	sub update_history (long player, prev_player, points, prev_points, &
	    	in_play, string cards_in_play, newcard)
	option size=(integer long, real single)
	external integer function	&
		smg$put_chars
	record paleontology
		long	success
		long	times
	end record paleontology
	map (card_rec)				&
		string	C_ardkey = 3%,		&
	       	paleontology	C_history
	declare	string	text

   		on error goto 32140
		cards_in_play = cards_in_play+newcard
		if in_play<2% then
		       	prev_points = 0%
			prev_player = player
			goto 32150
		end if
32135		text = seg$(cards_in_play,len(cards_in_play)-3%,len(cards_in_play)-1%)
		get #1%, key #0% eq text
		if player=prev_player then
			C_history::times = C_history::times+1%
			C_history::success = C_history::success+1%
		else
		      	C_history::times = C_history::times+2%
			C_history::success = C_history::success+1% if points<prev_points
	      		C_history::success = C_history::success+1% if points<=prev_points
		end if
   		update #1%
		prev_points = points
		prev_player = player
	       	goto 32150

32140 		if err=155 then
			C_history::times, C_history::success = 0%
			C_ardkey = seg$(cards_in_play,	&
				len(cards_in_play)-3%,len(cards_in_play)-1%)
			put #1%
			resume 32135
		end if
	if err=154 and s154erl<>erl then sleep 1% \s154erl=erl \c154=1% \resume
	end if
	if err=154 and s154erl=erl then sleep 1% \c154=c154+1%
	end if
	if c154>9%  then c154=0% \ print bel; \sleep 1% \print bel;
		resume else resume
	end if
	print "Err=";err,"Erl=";erl,ert$(err)
	on error go back
32150	%sbttl "Allocation information"
	end sub

32160	%title "Subroutine Display_points"
	sub display_points (long player, pt_id, points)
	option size=(integer long, real single)
	external long function			&
	    	smg$draw_line,			&
		smg$put_chars,			&
		smg$begin_display_update,	&
		smg$end_display_update
	declare long	stat, line_length,	&
		string	text
	
32170	stat = smg$begin_display_update (pt_id)
	text = format$(points,"###")
	stat = smg$put_chars(pt_id, text, player, 7%, , )
	if points>56% then
		line_length = points-56%+11%
		line_length = 76% if line_length>76%
	    	stat = smg$draw_line (pt_id, player, 11%, player, line_length,,)
	end if
	stat = smg$end_display_update (pt_id)

32180	%sbttl "Allocation information"
	end sub

32200	%title "Okay_to_play"
	function long okay_to_play

	! As far as I can tell, this routine will parse the same
	! "games:gamcron." file that CONQUEST uses.

	option size=(integer long, real single)
	external long function 			&
		lib$day_of_week,		&
		lib$free_lun,			&
		lib$get_lun

	declare	long   	stat, chan, newpos, first, last,	&
			current_hour, current_day, 		&
			current_month, current_weekday,		&
	     	string	timelist, beatsme, hours, days, months,	&
		     	weekdays

	on error goto 32290

	stat = lib$get_lun(chan)
	open "games:gamcron." as file #chan	&
		, sequential variable		&
		, access read

32210	linput #chan, timelist
	goto 32210 if seg$(timelist,1%,1%)="#"
	beatsme = seg$(timelist,1%,pos(timelist,":",1%)-1%)
	newpos = pos(timelist,":",1%)+1%
	hours = seg$(timelist,newpos,pos(timelist,":",newpos)-1%)
	newpos = pos(timelist,":",newpos)+1%
	days = seg$(timelist,newpos,pos(timelist,":",newpos)-1%)
	newpos = pos(timelist,":",newpos)+1%
	months = seg$(timelist,newpos,pos(timelist,":",newpos)-1%)
	newpos = pos(timelist,":",newpos)+1%
	weekdays = seg$(timelist,newpos,pos(timelist,":",newpos)-1%)
	newpos = pos(timelist,":",newpos)+1%

	! Run away if any of the fields are null or there's no last colon
	goto 32210 if (newpos=0%) or (beatsme="") or (hours="") or	&
		(days="") or (months="") or (weekdays="")

 check_hours:
	goto check_days if hours="*"
	current_hour = val(seg$(time$(0%),1%,2%))
	current_hour = current_hour+12%	&
		if right$(time$(0%),pos(time$(0%)," ",2%))=" PM" and	&
			current_hour<>12%
	current_hour = 0%	&
		if right$(time$(0%),pos(time$(0%)," ",2%))=" AM" and	&
			current_hour=12%
	if pos(hours,"-",1%) then
		first = val(seg$(hours,1%,pos(hours,"-",1%)-1%))
		last = val(seg$(hours,pos(hours,"-",1%)+1%,len(hours)))
		goto 32210 if (current_hour>last) or (current_hour<first)
	else
		goto 32210 if current_hour<>val(hours)
	end if

 check_days:
	goto check_months if days="*"
	current_day = val(seg$(date$(0%),1%,2%))
	if pos(days,"-",1%) then
		first = val(seg$(days,1%,pos(days,"-",1%)-1%))
	  	last = val(seg$(days,pos(days,"-",1%)+1%,len(days)))
		goto 32210 if (current_day>last) or (current_day<first)
	else
		goto 32210 if current_day<>val(days)
	end if

 check_months:
	goto check_weekdays if months="*"
	current_month = (pos("JanFebMarAprMayJunJulAugSepOctNovDec",	&
		seg$(date$(0%),4%,6%),1%)/3%)+1%
	if pos(months,"-",1%) then
		first = val(seg$(months,1%,pos(months,"-",1%)-1%))
	  	last = val(seg$(months,pos(months,"-",1%)+1%,len(months)))
		goto 32210 if (current_month>last) or (current_month<first)
	else
		goto 32210 if current_month<>val(months)
	end if

 check_weekdays:
	goto its_okay if weekdays="*"
	stat = lib$day_of_week (0% by value, current_weekday)
	if pos(weekdays,"-",1%) then
		first = val(seg$(weekdays,1%,pos(weekdays,"-",1%)-1%))
	  	last = val(seg$(weekdays,pos(weekdays,"-",1%)+1%,len(weekdays)))
		goto 32210 if (current_weekday>last) or (current_weekday<first)
	else
		goto 32210 if current_weekday<>val(weekdays)
	end if

 its_okay:
	close #chan
	stat = lib$free_lun (chan)
	okay_to_play = -1%
	exit function

 its_not_okay:
	close #chan
	stat = lib$free_lun (chan)
	print "Now is not a good time to play games."
	print "For a list of valid times, see the file games:gamcron."
	okay_to_play = 0%
	exit function

32290	if err=133 then
	      	print "The logical GAMES: must be assigned to wherever "+ &
			"the file GAMCRON. is."
	end if
	resume 32210 if (err=51) or (err=52)	! val() error
	resume its_not_okay if err=11%		! We've run out of timelists
	on error go back

	end function
