/* Copyright (c) Stichting Mathematisch Centrum, Amsterdam, 1985. */
/* hack.termcap.c - version 1.0.2 - added VS,VE,SG,TI,TO (Robert Viduya) */
/*
	rewrote most of this file to use the CURSES package instead of termcap
	Dean Grover
 */

#include <stdio.h>
#include "config.h"	/* for ROWNO and COLNO */
#include <curses.h>
#define ESC '\033'

curses_refresh()
{
	refresh();
}

addchar(ch)
char ch;
{
	addch(ch);
}
addstring(s)
char *s;
{
	printw("%s\n",s);
}
startup()
{
	set_whole_screen();		/* uses LI and CD */
}

start_screen()
{
	initscr();	/* call curses initialization		*/
	noecho();
}

end_screen()
{
	endwin();	/* call to restore screen		*/
	echo();
}

/* Cursor movements */
extern xchar curx, cury;

curs(x,y)
register int x,y;	/* not xchar: perhaps xchar is unsigned and
			   curx-x would be unsigned as well */
{
	cmov(x,y);
}

nocmov(x,y)	/* rewrote the whole thing		DG	*/
register x,y;
{
	if ((cury != y) || (curx != x))
	    cmov(x,y);
}
cmov(x,y)
register x,y;
{
/*
	There are some problems with the VMS curses move, so fake it 
	out by printing a null string with mvaddstr
 */
	mvaddstr (y-1,x-1,"");	
	cury = y;
	curx = x;
}


cl_end() {	/* rewrote this too		DG		*/
	clrtoeol();
	refresh();
}

clear_screen() {
	clear();
	home();
	refresh();
}

home()
{
	move (0,0);
	curx = cury = 1;
}

standoutbeg()
{
/*	printf("%c[7m",ESC);	*/
	setattr(_BOLD);
}

standoutend()
{
/*printf("%c[0m",ESC);*/
	clrattr(_BOLD);
}

backsp()
{
	cmov(curx-1,cury);
	refresh();
}

bell()
{
	(void) addch('\007');		/* curx does not change */
	(void) fflush(stdout);
}

delay_output() {	/* no need for this*/
}

cl_eos()			/* rewrote		DG	*/
{
	clrtobot();
	refresh();
}

add_string(string)
char *string;
{
	addstr(string);
}
