            PROGRAM CALC2

C     Calculator emulator (2-4-84 Greg Janee)
C     CALC3  January, 1987  David Deley

C     The logical name CALC$HELPFILE is not used.
C     NOTE:  THE HELP FACILITY HAS BEEN DISABLED.

      EXTERNAL HANDLER

      CHARACTER MODE*1,STRING*37
      LOGICAL   BLACK,WHITE,ERROR,ERR_CHECK
      INTEGER DISPLAY1, DISPLAY2, DISPLAY3, DISPLAY4, DISPLAY5
      INTEGER SMG$PUT_CHARS,TERM_CHAR, SMG$READ_KEYSTROKE,KEYBOARD1
      INTEGER KEY
      INTEGER SMG$CREATE_VIRTUAL_KEYBOARD

      COMMON / DISP   / MODE,STRING,ERROR
      COMMON / DISPLAYS / DISPLAY1,DISPLAY2,DISPLAY3,DISPLAY4,DISPLAY5
      COMMON / ERROR  / ERR_CHECK
      COMMON / STATE / WHITE,BLACK
      COMMON / KEYBOARD / KEYBOARD1

      CALL LIB$ESTABLISH ( HANDLER )
      CALL INITIALIZE

      BLACK = .FALSE.
      WHITE = .FALSE.

C+
C Create a virtual keyboard.
C-
	ISTATUS = SMG$CREATE_VIRTUAL_KEYBOARD ( KEYBOARD1)

C
C --- MAIN LOOP --------------------------------------------------------
C

1000  CONTINUE

C+
C Read a key stroke from the virtual keyboard.
C-
      CALL SMG$READ_KEYSTROKE ( KEYBOARD1, KEY )
      ERR_CHECK = .FALSE.
      IF ( ERROR ) CALL ERR_HAND ( 0 )
      CALL CASE( KEY )
      GOTO 1000
	END

      SUBROUTINE ABS_VALUE

C     Calculates | X |

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      X = DABS( X )

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE ADD

C     Adds the Y register to the X register

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

C     Load the X register if necessary

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      X = X + Y
      Y = Z
      Z = T
      T = 0.

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE ADD_DIGIT ( DIGIT )

C     Adds a digit to the current display

      PARAMETER CARR_RETURN = '0000000D'X

      REAL*8    X,Y,Z,T,LASTX
      BYTE      LAST
      CHARACTER STRING*37,DIGIT*1,MODE*1
      LOGICAL   PUSH_FLAG,ERROR,RADS,D_OK
      INTEGER DISPLAY1, DISPLAY2, DISPLAY3, DISPLAY4, DISPLAY5

      COMMON / DISP  / MODE,STRING,ERROR
      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK
      COMMON / DISPLAYS / DISPLAY1,DISPLAY2,DISPLAY3,DISPLAY4,DISPLAY5

      IF ( LAST .EQ. CARR_RETURN ) THEN
         X = 0.
         STRING = ' '
         ISTATUS = SMG$PUT_CHARS( DISPLAY1, STRING, 2,  3)
         CALL MOVE_TO  ( 24,1 )
      END IF

      IF ( PUSH_FLAG ) THEN
         CALL PUSH_STACK
         STRING = ' '
         ISTATUS = SMG$PUT_CHARS( DISPLAY1, STRING, 2,  3)
         CALL MOVE_TO  ( 24,1 )
         PUSH_FLAG = .FALSE.
      END IF

      IF ( STRING(1:1) .NE. ' ' ) THEN
         CALL ERR_HAND ( -5 )
      ELSE
         STRING = STRING(2:37)//DIGIT
         ISTATUS = SMG$PUT_CHARS( DISPLAY1, STRING, 2,  3)
         CALL MOVE_TO  ( 24,1 )
         D_OK = .TRUE.
      END IF

      LAST = 0

      RETURN
      END


      SUBROUTINE ARC_COSINE

C     Calculates ARCCOS( X )

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      IF ( RADS ) THEN
         X = DACOS( X )
      ELSE
         X = DACOSD( X )
      END IF

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE ARC_SINE

C     Calculates ARCSIN( X )

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      IF ( RADS ) THEN
         X = DASIN( X )
      ELSE
         X = DASIND( X )
      END IF

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE ARC_TANGENT

C     Calculates ARCTAN( X )

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      IF ( RADS ) THEN
         X = DATAN( X )
      ELSE
         X = DATAND( X )
      END IF

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

	SUBROUTINE CASE(KEY)

	LOGICAL BLACK,WHITE
	INTEGER KEY, DISPLAY1, DISPLAY2, DISPLAY3, DISPLAY4, DISPLAY5
	CHARACTER*1 CHARACTER, INPUT
	COMMON / STATE / WHITE,BLACK
	COMMON / DISPLAYS / DISPLAY1,DISPLAY2,DISPLAY3,DISPLAY4,DISPLAY5
	INCLUDE '($SMGDEF)'
	PARAMETER SMG$K_TRM_EXCLAMATION_POINT = '00000021'X ! !
	PARAMETER SMG$K_TRM_LEFT_PAREN        = '00000028'X ! (
	PARAMETER SMG$K_TRM_RIGHT_PAREN       = '00000029'X ! )
	PARAMETER SMG$K_TRM_PLUS_SIGN         = '0000002B'X ! +
	PARAMETER SMG$K_TRM_ZERO              = '00000030'X ! 0


      IF ( BLACK ) THEN
C     ******************************************************************
C     ****************** IF STATE BLACK ********************************
C     ******************************************************************

C     -------------- CONTROL CHARACTERS  000 - 031 ---------------------
        IF ( KEY .LT. SMG$K_TRM_SPACE ) THEN      !CONTROL CHARACTERS

          IF ( KEY .EQ. SMG$K_TRM_CTRLR ) THEN
            CALL RESET
          ELSEIF ( KEY .EQ. SMG$K_TRM_CTRLW ) THEN
            CALL RESET
          ELSEIF ( KEY .EQ. SMG$K_TRM_CTRLZ ) THEN
            CALL CLEAR_SCREEN
            CALL SYS$EXIT (%VAL(1) )
          ENDIF


C     -------------MISCELANEOUS !"#$%&'()*+,-./ ------------------------
        ELSEIF ( KEY .LT. SMG$K_TRM_ZERO ) THEN      !MISC


C     --------------- NUMBERS 0-9 --------------------------------------
        ELSEIF ( KEY .LE. SMG$K_TRM_NINE ) THEN      !NUMBERS


C     ------------- MISCELLANEOUS :;<=>?@ ------------------------------
        ELSEIF ( KEY .LT. SMG$K_TRM_UPPERCASE_A) THEN      !MISC


C     -------------- LETTERS A-Z ---------------------------------------
        ELSEIF ( KEY .LE. SMG$K_TRM_UPPERCASE_Z) THEN      !UPPERCAE ALPHABET


C     ---------------- MISCELANEOUS [\]^_` -----------------------------
        ELSEIF ( KEY .LT. SMG$K_TRM_LOWERCASE_A) THEN      !MISC


C     ---------------- lowercase letters a-z ---------------------------
        ELSEIF ( KEY .LE. SMG$K_TRM_LOWERCASE_Z) THEN      !lowercase alphabet


C     ----------------- MISCELLANEOUS {|}~ del -------------------------
        ELSEIF ( KEY .LT. SMG$K_TRM_PF1) THEN      !MISC


C     ------------------ KEYPAD PF1-PF4 --------------------------------
        ELSEIF ( KEY .LE. SMG$K_TRM_PF4) THEN      !PF1-PF4

          IF ( KEY .EQ. SMG$K_TRM_PF1 ) THEN
             BLACK = .TRUE.
             CALL SMG$PUT_CHARS( DISPLAY4, 'B',  2,  28)
             CALL MOVE_TO  ( 24,1 )
          ELSEIF ( KEY .EQ. SMG$K_TRM_PF2 ) THEN
             WHITE = .TRUE.
             CALL SMG$PUT_CHARS( DISPLAY4, 'W',  2,  31)
             CALL MOVE_TO  ( 24,1 )
          ELSEIF ( KEY .EQ. SMG$K_TRM_PF3 ) THEN
             CALL LOG_10
          ELSEIF ( KEY .EQ. SMG$K_TRM_PF4 ) THEN
             CALL LOG_E
          ENDIF


C     --------------------- KEYPAD 0-9 ---------------------------------
        ELSEIF ( KEY .LE. SMG$K_TRM_KP9) THEN      !KP0-KP9

          IF ( KEY .EQ. SMG$K_TRM_KP0) THEN
             CALL CLEAR_X_REG
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP1) THEN
             CALL ROLL_DOWN
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP2) THEN
             CALL OUT_CHAR  ( 8,71,1,'Q' )
             CALL ERR_HAND  ( -1 )
             CALL GET_INPUT ( INPUT )
             CALL FIX ( INPUT )
             CALL OUT_CHAR ( 8,71,1,' ' )
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP3) THEN
             CALL LAST_X
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP4) THEN
             CALL SQUARE_ROOT
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP5) THEN
             CALL INVERT
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP6) THEN
             CALL CHANGE_SIGN
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP7) THEN
             CALL SINE
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP8) THEN
             CALL COSINE
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP9) THEN
             CALL TANGENT
          END IF


C     --------------------- MISCELLANEOUS ------------------------------
        ELSEIF ( KEY .LT. SMG$K_TRM_F1) THEN      !MISC

          IF (KEY .EQ. SMG$K_TRM_ENTER ) THEN
C            CALL OUT_CHAR  ( 8,71,1,'Q' )
C            CALL ERR_HAND  ( -2 )
C            CALL GET_INPUT ( INPUT )
C            CALL HELP ( INPUT )
          ELSEIF ( KEY .EQ. SMG$K_TRM_MINUS ) THEN
            CALL CHANGE_TRIG ( 'RAD',1 )
          ELSEIF ( KEY .EQ. SMG$K_TRM_COMMA ) THEN
            CALL INTEGER
          ELSEIF ( KEY .EQ. SMG$K_TRM_PERIOD ) THEN
            CALL PI
          ELSEIF ( KEY .EQ. SMG$K_TRM_UP ) THEN
            CALL ADD
          ELSEIF ( KEY .EQ. SMG$K_TRM_DOWN ) THEN
            CALL SUBTRACT
          ELSEIF ( KEY .EQ. SMG$K_TRM_LEFT ) THEN
            CALL MULTIPLY
          ELSEIF ( KEY .EQ. SMG$K_TRM_RIGHT ) THEN
            CALL DIVIDE
          ENDIF


C     -------------- END CASE IF BLACK ---------------------------------
        ELSE
          CALL ERR_HAND ( -3 )
        END IF
        BLACK = .FALSE.
        ISTATUS = SMG$PUT_CHARS( DISPLAY4, ' ',  2,  28)
        CALL MOVE_TO  ( 24,1 )



      ELSEIF ( WHITE ) THEN
C     ******************************************************************
C     ****************** IF STATE WHITE ********************************
C     ******************************************************************

C     -------------- CONTROL CHARACTERS  000 - 031 ---------------------
        IF ( KEY .LT. SMG$K_TRM_SPACE ) THEN      !CONTROL CHARACTERS

          IF ( KEY .EQ. SMG$K_TRM_CR ) THEN
               CALL CLEAR_SCREEN
               CALL SYS$EXIT ( %VAL(1) )
          ELSEIF ( KEY .EQ. SMG$K_TRM_CTRLR ) THEN
             CALL RESET
          ELSEIF ( KEY .EQ. SMG$K_TRM_CTRLW ) THEN
             CALL RESET
          ELSEIF ( KEY .EQ. SMG$K_TRM_CTRLZ ) THEN
             CALL CLEAR_SCREEN
             CALL SYS$EXIT (%VAL(1) )
          ENDIF


C     -------------MISCELANEOUS !"#$%&'()*+,-./ ------------------------
        ELSEIF ( KEY .LT. SMG$K_TRM_ZERO ) THEN      !MISC


C     --------------- NUMBERS 0-9 --------------------------------------
        ELSEIF (KEY .LE. SMG$K_TRM_NINE) THEN      !NUMBERS


C     ------------- MISCELLANEOUS :;<=>?@ ------------------------------
        ELSEIF ( KEY .LT. SMG$K_TRM_UPPERCASE_A) THEN      !MISC


C     -------------- LETTERS A-Z ---------------------------------------
        ELSEIF ( KEY .LE. SMG$K_TRM_UPPERCASE_Z ) THEN      !UPPERCAE ALPHABET


C     ---------------- MISCELANEOUS [\]^_` -----------------------------
        ELSEIF ( KEY .LT. SMG$K_TRM_LOWERCASE_A ) THEN      !MISC


C     ---------------- lowercase letters a-z ---------------------------
        ELSEIF ( KEY .LE. SMG$K_TRM_LOWERCASE_Z) THEN      !lowercase alphabet


C     ----------------- MISCELLANEOUS {|}~ del -------------------------
        ELSEIF ( KEY .LT. SMG$K_TRM_PF1 ) THEN      !MISC


C     ------------------ KEYPAD PF1-PF4 --------------------------------
        ELSEIF ( KEY .LE. SMG$K_TRM_PF4) THEN      !PF1-PF4

          IF ( KEY .EQ. SMG$K_TRM_PF1 ) THEN
             BLACK = .TRUE.
             CALL SMG$PUT_CHARS( DISPLAY4, 'B',  2,  28)
             CALL MOVE_TO  ( 24,1 )
          ELSEIF ( KEY .EQ. SMG$K_TRM_PF2 ) THEN
             WHITE = .TRUE.
             CALL SMG$PUT_CHARS( DISPLAY4, 'W',  2,  31)
             CALL MOVE_TO  ( 24,1 )
          ELSEIF ( KEY .EQ. SMG$K_TRM_PF3 ) THEN
              CALL POWER_10
          ELSEIF ( KEY .EQ. SMG$K_TRM_PF4 ) THEN
              CALL POWER_E
          ENDIF


C     --------------------- KEYPAD 0-9 ---------------------------------
        ELSEIF ( KEY .LE. SMG$K_TRM_KP9 ) THEN      !KP0-KP9

          IF ( KEY .EQ. SMG$K_TRM_KP0 ) THEN
               CALL CLEAR_STACK
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP1 ) THEN
               CALL ROLL_UP
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP2 ) THEN
               CALL EXCHANGE
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP3 ) THEN
               CALL RESET
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP4 ) THEN
             CALL SQUARE_X
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP5 ) THEN
             CALL EXPONENT
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP6 ) THEN
             CALL ABS_VALUE
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP7 ) THEN
            CALL ARC_SINE
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP8 ) THEN
            CALL ARC_COSINE
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP9 ) THEN
            CALL ARC_TANGENT
          END IF


C     --------------------- MISCELLANEOUS ------------------------------
        ELSEIF ( KEY .LT. SMG$K_TRM_F1 ) THEN      !MISC

          IF ( KEY .EQ. SMG$K_TRM_ENTER ) THEN
               CALL CLEAR_SCREEN
               CALL SYS$EXIT ( %VAL(1) )
          ELSEIF ( KEY .EQ. SMG$K_TRM_MINUS ) THEN
            CALL CHANGE_TRIG ( 'DEG',1 )
          ELSEIF ( KEY .EQ. SMG$K_TRM_COMMA ) THEN
               CALL FRACTION
          ELSEIF ( KEY .EQ. SMG$K_TRM_PERIOD ) THEN
               CALL E
          ELSEIF ( KEY .EQ. SMG$K_TRM_UP ) THEN
            CALL ADD
          ELSEIF ( KEY .EQ. SMG$K_TRM_DOWN ) THEN
            CALL SUBTRACT
          ELSEIF ( KEY .EQ. SMG$K_TRM_LEFT ) THEN
            CALL MULTIPLY
          ELSEIF ( KEY .EQ. SMG$K_TRM_RIGHT ) THEN
            CALL DIVIDE
          ENDIF


C     -------------- END CASE ------------------------------------------
        ELSE
          CALL ERR_HAND ( -3 )
        END IF
        WHITE = .FALSE.
        ISTATUS = SMG$PUT_CHARS( DISPLAY4, ' ',  2,  31)
        CALL MOVE_TO  ( 24,1 )



      ELSE
C    ******************************************************************
C    ***********************IF STATE OFF ******************************
C    ******************************************************************
C     -------------- CONTROL CHARACTERS  000 - 031 ---------------------
        IF ( KEY .LT. SMG$K_TRM_SPACE ) THEN      !CONTROL CHARACTERS

          IF ( KEY .EQ. SMG$K_TRM_CTRLB ) THEN
             CALL CHANGE_MODE ('B',1 )
          ELSEIF ( KEY .EQ. SMG$K_TRM_CTRLE ) THEN
             CALL CHANGE_MODE ('E',1 )
          ELSEIF ( KEY .EQ. SMG$K_TRM_CTRLF ) THEN
             CALL CHANGE_MODE ('F',1 )
          ELSEIF ( KEY .EQ. SMG$K_TRM_CTRLH ) THEN
             CALL CHANGE_MODE ('H',1 )
          ELSEIF ( KEY .EQ. SMG$K_TRM_CTRLI ) THEN
             CALL CHANGE_MODE ('I',1 )
          ELSEIF ( KEY .EQ. SMG$K_TRM_CR ) THEN
             CALL ENTER
          ELSEIF ( KEY .EQ. SMG$K_TRM_CTRLR ) THEN
             CALL RESET
          ELSEIF ( KEY .EQ. SMG$K_TRM_CTRLW ) THEN
             CALL RESET
          ELSEIF ( KEY .EQ. SMG$K_TRM_CTRLZ ) THEN
             CALL CLEAR_SCREEN
             CALL SYS$EXIT (%VAL(1) )
          ENDIF


C     -------------MISCELANEOUS !"#$%&'()*+,-./ ------------------------
        ELSEIF ( KEY .LT. SMG$K_TRM_ZERO ) THEN      !MISC

          IF ( KEY .EQ. SMG$K_TRM_ASTERISK ) THEN
            CALL MULTIPLY
          ELSEIF ( KEY .EQ. SMG$K_TRM_PLUS_SIGN ) THEN
            CALL ADD
          ELSEIF ( KEY .EQ. SMG$K_TRM_DASH ) THEN
            CALL SUBTRACT
          ELSEIF ( KEY .EQ. SMG$K_TRM_DOT ) THEN
            CHARACTER = CHAR( KEY )
            CALL DIGIT( CHARACTER )
          ELSEIF ( KEY .EQ. SMG$K_TRM_SLASH ) THEN
            CALL DIVIDE
          ENDIF

C     --------------- NUMBERS 0-9 --------------------------------------
        ELSEIF ( KEY .LE. SMG$K_TRM_NINE ) THEN      !NUMBERS
           CHARACTER = CHAR( KEY )
           CALL DIGIT( CHARACTER )


C     ------------- MISCELLANEOUS :;<=>?@ ------------------------------
        ELSEIF ( KEY .LT. SMG$K_TRM_UPPERCASE_A ) THEN      !MISC


C     -------------- LETTERS A-Z ---------------------------------------
        ELSEIF ( KEY .LE. SMG$K_TRM_UPPERCASE_Z) THEN      !UPPERCAE ALPHABET
	   IF ( KEY .EQ. SMG$K_TRM_UPPERCASE_O) THEN
              CALL CHANGE_MODE ('O',1 )
	   ELSE
              CHARACTER = CHAR( KEY )
              CALL DIGIT( CHARACTER )
	   ENDIF

C     ---------------- MISCELANEOUS [\]^_` -----------------------------
        ELSEIF ( KEY .LT. SMG$K_TRM_LOWERCASE_A ) THEN      !MISC


C     ---------------- lowercase letters a-z ---------------------------
        ELSEIF ( KEY .LE. SMG$K_TRM_LOWERCASE_Z ) THEN      !lowercase alphabet
	   IF ( KEY .EQ. SMG$K_TRM_LOWERCASE_O) THEN
              CALL CHANGE_MODE ('O',1 )
	   ELSE
              CHARACTER = CHAR( KEY )
              CALL STR$UPCASE ( CHARACTER, CHARACTER )
              CALL DIGIT( CHARACTER)
	   ENDIF

C     ----------------- MISCELLANEOUS {|}~ del -------------------------
        ELSEIF ( KEY .LT. SMG$K_TRM_PF1 ) THEN      !MISC

          IF ( KEY .EQ. SMG$K_TRM_DELETE ) THEN
            CALL DELETE_DIGIT
          ENDIF


C     ------------------ KEYPAD PF1-PF4 --------------------------------
        ELSEIF ( KEY .LE. SMG$K_TRM_PF4 ) THEN      !PF1-PF4

          IF ( KEY .EQ. SMG$K_TRM_PF1 ) THEN
             BLACK = .TRUE.
             CALL SMG$PUT_CHARS( DISPLAY4, 'B',  2,  28)
             CALL MOVE_TO  ( 24,1 )
          ELSEIF ( KEY .EQ. SMG$K_TRM_PF2 ) THEN
             WHITE = .TRUE.
             CALL SMG$PUT_CHARS( DISPLAY4, 'W',  2,  31)
             CALL MOVE_TO  ( 24,1 )
          ENDIF


C     --------------------- KEYPAD 0-9 ---------------------------------
      ELSEIF ( KEY .LE. SMG$K_TRM_KP9 ) THEN      !KP0-KP9
          IF ( KEY .EQ. SMG$K_TRM_KP0 ) THEN
            CHARACTER = '0'
            CALL DIGIT( CHARACTER )
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP1 ) THEN
            CHARACTER = '1'
            CALL DIGIT ( CHARACTER )
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP2 ) THEN
            CHARACTER = '2'
            CALL DIGIT ( CHARACTER )
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP3 ) THEN
            CHARACTER = '3'
            CALL DIGIT ( CHARACTER )
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP4 ) THEN
            CHARACTER = '4'
            CALL DIGIT ( CHARACTER )
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP5 ) THEN
            CHARACTER = '5'
            CALL DIGIT (CHARACTER)
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP6 ) THEN
            CHARACTER = '6'
            CALL DIGIT ( CHARACTER )
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP7 ) THEN
            CHARACTER = '7'
            CALL DIGIT ( CHARACTER )
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP8 ) THEN
            CHARACTER = '8'
            CALL DIGIT ( CHARACTER )
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP9 ) THEN
            CHARACTER = '9'
            CALL DIGIT ( CHARACTER )
          END IF


C     --------------------- MISCELLANEOUS ------------------------------
        ELSEIF ( KEY .LT. SMG$K_TRM_F1 ) THEN      !MISC

          IF ( KEY .EQ. SMG$K_TRM_ENTER ) THEN
               CALL ENTER
          ELSEIF ( KEY .EQ. SMG$K_TRM_PERIOD ) THEN
            CHARACTER = '.'
            CALL DIGIT( CHARACTER )
          ELSEIF ( KEY .EQ. SMG$K_TRM_UP ) THEN
            CALL ADD
          ELSEIF ( KEY .EQ. SMG$K_TRM_DOWN ) THEN
            CALL SUBTRACT
          ELSEIF ( KEY .EQ. SMG$K_TRM_LEFT ) THEN
            CALL MULTIPLY
          ELSEIF ( KEY .EQ. SMG$K_TRM_RIGHT ) THEN
            CALL DIVIDE
          ENDIF


C     -------------- END CASE ------------------------------------------
        ENDIF


C     ----- END CASES BLACK, WHITE, OFF -----
      ENDIF
      RETURN
      END


      SUBROUTINE CHANGE_MODE ( NEW_MODE,FLAG )

C     Changes the display mode as follows:
C
C        I   Decimal integer
C        B   Binary integer
C        O   Octal integer  -- NOT AVAILABLE
C        H   Hexadecimal integer
C        F   Floating point (decimal)
C        E   Exponential floating point (decimal)

      INTEGER   FLAG
      REAL*8    X,Y,Z,T,LASTX
      LOGICAL   PUSH_FLAG,ERROR,RADS,D_OK
      BYTE      LAST
      CHARACTER MODE*1,NEW_MODE*1,STRING*37
      INTEGER DISPLAY1, DISPLAY2, DISPLAY3, DISPLAY4, DISPLAY5, PASTE1
      INTEGER SMG$PUT_CHARS

      COMMON / DISPLAYS / DISPLAY1,DISPLAY2,DISPLAY3,DISPLAY4,DISPLAY5
      COMMON / DISP  / MODE,STRING,ERROR
      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      IF     ( NEW_MODE .EQ. 'I' ) THEN
	ISTATUS = SMG$PUT_CHARS( DISPLAY4, 'Integer mode            ',  2,  2)
	MODE = NEW_MODE
      ELSEIF ( NEW_MODE .EQ. 'B' ) THEN
	ISTATUS = SMG$PUT_CHARS( DISPLAY4, 'Binary integer mode     ',  2,  2)
	MODE = NEW_MODE
      ELSEIF ( NEW_MODE .EQ. 'O' ) THEN
	ISTATUS = SMG$PUT_CHARS( DISPLAY4, 'Octal integer mode      ',  2,  2)
	MODE = NEW_MODE
      ELSEIF ( NEW_MODE .EQ. 'H' ) THEN
	ISTATUS = SMG$PUT_CHARS( DISPLAY4, 'Hexadecimal integer mode',  2,  2)
	MODE = NEW_MODE
      ELSEIF ( NEW_MODE .EQ. 'F' ) THEN
	ISTATUS = SMG$PUT_CHARS( DISPLAY4, 'Floating point mode     ',  2,  2)
	MODE = NEW_MODE
      ELSEIF ( NEW_MODE .EQ. 'E' ) THEN
	ISTATUS = SMG$PUT_CHARS( DISPLAY4, 'Exponential mode        ',  2,  2)
	MODE = NEW_MODE
      END IF
      CALL MOVE_TO ( 24,1 )

      PUSH_FLAG = .TRUE.
      LAST = 0

      IF ( FLAG .EQ. 1 ) CALL DISPLAY

      RETURN
      END


      SUBROUTINE CHANGE_SIGN

C     Changes the sign of the X register

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      X = - X

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE CHANGE_TRIG ( MODE,FLAG )

C     Changes from degrees to radians, and vice-versa

      INTEGER   FLAG
      REAL*8    X,Y,Z,T,LASTX
      BYTE      LAST
      CHARACTER MODE*3
      LOGICAL   PUSH_FLAG,RADS,D_OK
      INTEGER DISPLAY1, DISPLAY2, DISPLAY3, DISPLAY4, DISPLAY5, PASTE1
      INTEGER SMG$PUT_CHARS

      COMMON / DISPLAYS / DISPLAY1,DISPLAY2,DISPLAY3,DISPLAY4,DISPLAY5
      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      IF ( MODE .EQ. 'DEG' ) THEN
         RADS = .FALSE.
         ISTATUS = SMG$PUT_CHARS( DISPLAY4, 'DEG',  2,  38)
      ELSE
         RADS = .TRUE.
         ISTATUS = SMG$PUT_CHARS( DISPLAY4, 'RAD',  2,  38)
      END IF
      CALL MOVE_TO ( 24,1 )

      PUSH_FLAG = .TRUE.
      LAST = 0
      IF ( FLAG .EQ. 1 ) CALL DISPLAY
 
      RETURN
      END


      SUBROUTINE CLEAR_SCREEN

C     Clears the screen

      INTEGER SMG$ERASE_PASTEBOARD, PASTE1
      COMMON / PASTE  /  PASTE1

C     Clear the screen
      ISTATUS = SMG$ERASE_PASTEBOARD( PASTE1 )

      RETURN
      END


      SUBROUTINE CLEAR_STACK

C     Resets the stack

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      X = 0.
      Y = 0.
      Z = 0.
      T = 0.
      LASTX = 0.

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE CLEAR_X_REG

C     Clears the X register

      PARAMETER CARR_RETURN = '0000000D'X

      CHARACTER MODE*1,STRING*37
      LOGICAL   ERROR,PUSH_FLAG,RADS,D_OK
      BYTE      LAST
      REAL*8    X,Y,Z,T,LASTX

      COMMON / DISP  / MODE,STRING,ERROR
      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      X = 0.

      PUSH_FLAG = .FALSE.
      LAST = CARR_RETURN

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE COSINE

C     Calculates COS( X )

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      IF ( RADS ) THEN
         X = DCOS( X )
      ELSE
         X = DCOSD( X )
      END IF

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END
      SUBROUTINE CREATE_DISPLAYS

C  DISPLAY4 - BACKGROUND BORDER OF CALCULATOR KEYS
C  DISPLAY2 - CALCULATOR KEYS
C  DISPLAY1 - CALCULATOR OUTPUT DISPLAY AT TOP
C  DISPLAY3 - CALCULATOR INFORMATION ON SIDE
C  DISPLAY5 - ERROR TEXT AT TOP OF CALCULATOR

      INCLUDE '($SMGDEF)'
      LOGICAL CRT
      INTEGER SMG$CREATE_VIRTUAL_DISPLAY, SMG$CREATE_PASTEBORD
      INTEGER DISPLAY1, DISPLAY2, DISPLAY3, DISPLAY4, DISPLAY5
      INTEGER PASTE1, KEYBOARD1, ROWS, COLUMNS, TERM_CHAR

      COMMON / DISPLAYS / DISPLAY1,DISPLAY2,DISPLAY3,DISPLAY4,DISPLAY5
      COMMON / PASTE  /  PASTE1

      if ( .not. crt() ) then
         print*, 'You must use a DEC CRT terminal'
         call exit
      endif

C+
C Create the pasteboard.
C-
      ISTATUS = SMG$CREATE_PASTEBOARD (PASTE1)

C+
C Create the virtual displays.
C-
      ROWS = 3
      COLUMNS = 41
      ISTATUS = SMG$CREATE_VIRTUAL_DISPLAY( ROWS, COLUMNS, DISPLAY1 )

      ROWS = 16
      COLUMNS = 41
      ISTATUS = SMG$CREATE_VIRTUAL_DISPLAY( ROWS, COLUMNS, DISPLAY2 )

      ROWS = 17
      COLUMNS = 33
      ISTATUS = SMG$CREATE_VIRTUAL_DISPLAY( ROWS, COLUMNS, DISPLAY3 )

      ROWS = 16
      COLUMNS = 41
      ISTATUS = SMG$CREATE_VIRTUAL_DISPLAY
     *          ( ROWS, COLUMNS, DISPLAY4, SMG$M_BORDER )

      ROWS = 1
      COLUMNS = 41
      ISTATUS = SMG$CREATE_VIRTUAL_DISPLAY( ROWS, COLUMNS, DISPLAY5 )

      END


      logical function crt

      include    '($dvidef)'
      include    '($ttdef)'
      include    '($tt2def)'

      logical    avo
      integer*2  b2(14)
      integer*4  b4(7), buf, len_buf, sys$trnlog, sys$getdvi, dev_type
      logical*4  for$bjtest, istat

      equivalence ( b4(1), b2(1) )

      b2(1) = 4
      b2(2) = dvi$_devdepend2
      b4(2) = %loc( buf )
      b4(3) = %loc( len_buf )

      b2(7) = 4
      b2(8) = dvi$_devtype
      b4(5) = %loc( dev_type )
      b4(6) = %loc( len_dev_type )

      b4(7) = 0

      istat = sys$getdviw( ,, 'SYS$COMMAND', b4,,,, )

      crt      = ( for$bjtest( buf, tt2$v_deccrt ) .or. 
     .                            dev_type .eq. tt$_vt52 )
      avo      = for$bjtest( buf, tt2$v_avo )

      return
      end


      SUBROUTINE DELETE_DIGIT

C     Deletes a digit from the current display

      PARAMETER CARR_RETURN = '0000000D'X

      REAL*8    X,Y,Z,T,LASTX
      BYTE      LAST
      CHARACTER MODE*1,STRING*37
      LOGICAL   PUSH_FLAG,RADS,ERROR,D_OK
      INTEGER DISPLAY1, DISPLAY2, DISPLAY3, DISPLAY4, DISPLAY5

      COMMON / DISP  / MODE,STRING,ERROR
      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK
      COMMON / DISPLAYS / DISPLAY1,DISPLAY2,DISPLAY3,DISPLAY4,DISPLAY5

      IF ( D_OK ) THEN
         STRING = ' '//STRING(1:36)
         IF ( STRING(37:37) .EQ. ' ' ) THEN
            CALL DISPLAY
            LAST = CARR_RETURN
         ELSE
            ISTATUS = SMG$PUT_CHARS( DISPLAY1, STRING,  2,  3)
            CALL MOVE_TO  ( 24,1 )
         END IF
      ELSE
         CALL ERR_HAND ( -4 )
      END IF

      RETURN
      END

      SUBROUTINE DIGIT ( CHAR )

C     Determines if the character is a valid digit

      PARAMETER CARR_RETURN = '0000000D'X

      CHARACTER MODE*1,CHAR*1,STRING*37
      REAL*8    X,Y,Z,T,LASTX
      BYTE      LAST
      INTEGER   STR$POSITION
      LOGICAL   PUSH_FLAG,ERROR,RADS,D_OK,FLAG

      COMMON / DISP  / MODE,STRING,ERROR
      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( LAST .EQ. CARR_RETURN ) THEN
         FLAG = .TRUE.
      ELSE
         FLAG = PUSH_FLAG
      END IF

      IF ( MODE .EQ. 'I' ) THEN

         IF ( CHAR.GE.'0' .AND. CHAR.LE.'9' ) THEN
            CALL ADD_DIGIT ( CHAR )
         ELSE
            CALL ERR_HAND ( -6 )
         END IF

      ELSEIF ( MODE .EQ. 'B' ) THEN

         IF ( CHAR.GE.'0' .AND. CHAR.LE.'1' ) THEN
            CALL ADD_DIGIT ( CHAR )
         ELSE
            CALL ERR_HAND ( -6 )
         END IF

      ELSEIF ( MODE .EQ. 'O' ) THEN

         IF ( CHAR.GE.'0' .AND. CHAR.LE.'7' ) THEN
            CALL ADD_DIGIT ( CHAR )
         ELSE
            CALL ERR_HAND ( -6 )
         END IF

      ELSEIF ( MODE .EQ. 'H' ) THEN

         IF ( (CHAR.GE.'0' .AND. CHAR.LE.'9') .OR.
     .        (CHAR.GE.'A' .AND. CHAR.LE.'F')      ) THEN
            CALL ADD_DIGIT ( CHAR )
         ELSE
            CALL ERR_HAND ( -6 )
         END IF

      ELSEIF ( MODE .EQ. 'F' ) THEN

         IF ( CHAR.GE.'0' .AND. CHAR.LE.'9' ) THEN
            CALL ADD_DIGIT ( CHAR )
         ELSEIF ( CHAR .EQ. '.' ) THEN
            IF ( FLAG ) THEN
               CALL ADD_DIGIT ( CHAR )
            ELSE
               IF ( STR$POSITION( STRING,'.' ) .EQ. 0 ) THEN
                  CALL ADD_DIGIT ( CHAR )
               ELSE
                  CALL ERR_HAND ( -7 )
               END IF
            END IF
         ELSE
            CALL ERR_HAND ( -6 )
         END IF

      ELSEIF ( MODE .EQ. 'E' ) THEN

         IF ( CHAR.GE.'0' .AND. CHAR.LE.'9' ) THEN
            IF ( FLAG ) THEN
               CALL ADD_DIGIT ( CHAR )
            ELSE
               I = STR$POSITION( STRING,'E' )
               IF ( I .NE. 0 ) THEN
                  CALL STR$TRIM ( STRING,STRING,J )
                  IF ( J-I .LE. 1 ) THEN
                     CALL ADD_DIGIT ( CHAR )
                  ELSE
                     IF ( J-I.EQ.2 .AND. STRING(36:36).EQ.'-' ) THEN
                        CALL ADD_DIGIT ( CHAR )
                     ELSE
                        CALL ERR_HAND ( -8 )
                     END IF
                  END IF
               ELSE
                  CALL ADD_DIGIT ( CHAR )
               END IF
            END IF
         ELSEIF ( CHAR .EQ. 'E' ) THEN
            IF ( .NOT.FLAG ) THEN
               IF ( STR$POSITION( STRING,'E' ) .EQ. 0 ) THEN
                  CALL ADD_DIGIT ( CHAR )
               ELSE
                  CALL ERR_HAND ( -9 )
               END IF
            ELSE
               CALL ERR_HAND ( -10 )
            END IF
         ELSEIF ( CHAR .EQ. '.' ) THEN
            IF ( FLAG ) THEN
               CALL ADD_DIGIT ( CHAR )
            ELSE
               IF ( STR$POSITION( STRING,'.' ) .EQ. 0 ) THEN
                  IF ( STR$POSITION( STRING,'E' ) .EQ. 0 ) THEN
                     CALL ADD_DIGIT ( CHAR )
                  ELSE
                     CALL ERR_HAND ( -11 )
                  END IF
               ELSE
                  CALL ERR_HAND ( -7 )
               END IF
            END IF
         ELSE
            CALL ERR_HAND ( -6 )
         END IF

      END IF

      RETURN
      END


      SUBROUTINE DISPLAY

C     Displays the contents of the X register

      REAL*8    X,Y,Z,T,LASTX
      INTEGER   I_X,IO_CHAN,TT_TYPE,FIX_NUM,SMG$PUT_CHARS
      BYTE      LAST
      CHARACTER MODE*1,STRING*37
      LOGICAL   FLAG,MINUS,PUSH_FLAG,ERROR,RADS,D_OK
      INTEGER DISPLAY1, DISPLAY2, DISPLAY3, DISPLAY4, DISPLAY5

      COMMON / DISPLAYS / DISPLAY1,DISPLAY2,DISPLAY3,DISPLAY4,DISPLAY5
      COMMON / STACK  / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK
      COMMON / DISP   / MODE,STRING,ERROR
      COMMON / SCREEN / IO_CHAN,TT_TYPE,FIX_NUM

1000  IF     ( MODE .EQ. 'I' ) THEN
         IF ( DABS( X ) .GE. 2147483647. ) GO TO 1200
         ENCODE ( 37,10,STRING,ERR=1200 ) JIDNNT( X )
      ELSEIF ( MODE.EQ.'B' .OR. MODE.EQ.'O' .OR. MODE.EQ.'H' ) THEN
         IF ( DABS( X ) .GE. 2147483647. ) GO TO 1200
         I_X = JIDNNT( X )
         IF ( I_X .LT. 0 ) THEN
            MINUS = .TRUE.
            I_X = -I_X
         ELSE
            MINUS = .FALSE.
         END IF
         IF ( MODE .EQ. 'B' ) THEN
            FLAG = .FALSE.
            DO I = 30, 0, -1
               IF ( I_X .GE. 2**I ) THEN
                  FLAG = .TRUE.
                  STRING(37-I:37-I) = '1'
                  I_X = I_X - 2**I
               ELSE
                  IF ( FLAG ) THEN
                     STRING(37-I:37-I) = '0'
                  ELSE
                     STRING(37-I:37-I) = ' '
                  END IF
               END IF
            END DO
            STRING(1:6) = ' '
            IF ( STRING(37:37) .EQ. ' ' ) STRING(37:37) = '0'
         ELSEIF ( MODE .EQ. 'O' ) THEN
            ENCODE ( 37,20,STRING,ERR=1200 ) I_X
         ELSEIF ( MODE .EQ. 'H' ) THEN
            ENCODE ( 37,30,STRING,ERR=1200 ) I_X
         END IF
         IF ( MINUS ) THEN
            DO I = 2, 37
               IF ( STRING(I:I) .NE. ' ' ) GO TO 1100
            END DO
1100        STRING(I-1:I-1) = '-'
         END IF
      ELSEIF ( MODE .EQ. 'E' ) THEN
         ENCODE ( 37,40,STRING,ERR=1200 ) X
         STRING(34:34) = ' '
         IF ( STRING(35:35) .EQ. '+' ) STRING(35:35) = ' '
      ELSEIF ( MODE .EQ. 'F' ) THEN
         ENCODE ( 37,50,STRING,ERR=1200 ) X
      END IF

         ISTATUS = SMG$PUT_CHARS( DISPLAY1, STRING,  2,  3)
      CALL MOVE_TO  ( 24,1 )

      D_OK = .FALSE.
      RETURN

C     Encoding error

1200  CALL ERR_HAND ( -5 )
      X = 0.

      GO TO 1000

10    FORMAT ( I37 )
20    FORMAT ( O37 )
30    FORMAT ( Z37 )
40    FORMAT ( E37.<FIX_NUM> )
50    FORMAT ( F37.<FIX_NUM> )

      END


      SUBROUTINE DIVIDE

C     Divides Y by X

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

C     Load the X register if necessary

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      X = Y / X
      Y = Z
      Z = T
      T = 0.

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

	SUBROUTINE DRAW_CALC

C  DISPLAY4 - BACKGROUND BORDER OF CALCULATOR KEYS
C  DISPLAY2 - CALCULATOR KEYS
C  DISPLAY1 - CALCULATOR OUTPUT DISPLAY AT TOP
C  DISPLAY3 - CALCULATOR INFORMATION ON SIDE
C  DISPLAY5 - ERROR TEXT AT TOP OF CALCULATOR

      INCLUDE '($SMGDEF)'
      INTEGER SMG$PASTE_VIRTUAL_DISPLAY, SMG$PUT_LINE
      INTEGER DISPLAY1, DISPLAY2, DISPLAY3, DISPLAY4, DISPLAY5
      INTEGER PASTE1, KEYBOARD1, ROWS, COLUMNS

      COMMON / DISPLAYS / DISPLAY1,DISPLAY2,DISPLAY3,DISPLAY4,DISPLAY5

	parameter  PF1_U  = '  BLACK  '
	parameter  PF1_L  = '         '
	parameter  PF2_U  = '         '
	parameter  PF2_L  = '  WHITE  '
	parameter  PF3_U  = '   LOG   '
	parameter  PF3_L  = '   10^X  '
	parameter  PF4_U  = '   LN    '
	parameter  PF4_L  = '   EXP   '
	parameter  KP1_U  = '   RDN   '
	parameter  KP1_L  = '   RUP   '
	parameter  KP2_U  = '   FIX   '
	parameter  KP2_L  = '   X<>Y  '
	parameter  KP3_U  = '  LASTX  '
	parameter  KP3_L  = '  RESET  '
	parameter  KP4_U  = '   SQRT  '
	parameter  KP4_L  = '   X^2   '
	parameter  KP5_U  = '   1/X   '
	parameter  KP5_L  = '   Y^X   '
	parameter  KP6_U  = '   +/-   '
	parameter  KP6_L  = '   |X|   '
	parameter  KP7_U  = '   SIN   '
	parameter  KP7_L  = '   ASIN  '
	parameter  KP8_U  = '   COS   '
	parameter  KP8_L  = '   ACOS  '
	parameter  KP9_U  = '   TAN   '
	parameter  KP9_L  = '   ATAN  '
	parameter  MINUS_U  = '   RAD   '
	parameter  MINUS_L  = '   DEG   '
	parameter  COMMA_U  = '   INT   '
	parameter  COMMA_L  = '   FRAC  '
	parameter  ENTER_U  = '         '
	parameter  ENTER_L  = '   EXIT  '
	parameter  PERIOD_U = '    PI   '
	parameter  PERIOD_L = '    e    '
	parameter  KP0_U  = '       CL X        '
	parameter  KP0_L  = '       CLST        '

C     .BEGIN

C Draw the keys on display2

	ISTATUS = SMG$DRAW_LINE ( DISPLAY2,  1,  1,  1, 41)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY2,  4,  1,  4, 41)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY2,  7,  1,  7, 41)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY2, 10,  1, 10, 41)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY2, 13,  1, 13, 31)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY2, 16,  1, 16, 41)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY2,  1,  1, 16,  1)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY2,  1, 11, 13, 11)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY2,  1, 21, 16, 21)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY2,  1, 31, 16, 31)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY2,  1, 41, 16, 41)

C Label the keys

	ISTATUS = SMG$PUT_CHARS( DISPLAY2, PF1_U,  2,  2)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, PF1_L,  3,  2)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, PF2_U,  2, 12, , SMG$M_REVERSE)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, PF2_L,  3, 12, , SMG$M_REVERSE)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, PF3_U,  2, 22)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, PF3_L,  3, 22, , SMG$M_REVERSE)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, PF4_U,  2, 32)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, PF4_L,  3, 32, , SMG$M_REVERSE)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, KP1_U, 11,  2)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, KP1_L, 12,  2, , SMG$M_REVERSE)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, KP2_U, 11, 12)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, KP2_L, 12, 12, , SMG$M_REVERSE)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, KP3_U, 11, 22)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, KP3_L, 12, 22, , SMG$M_REVERSE)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, KP4_U,  8,  2)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, KP4_L,  9,  2, , SMG$M_REVERSE)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, KP5_U,  8, 12)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, KP5_L,  9, 12, , SMG$M_REVERSE)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, KP6_U,  8, 22)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, KP6_L,  9, 22, , SMG$M_REVERSE)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, KP7_U,  5,  2)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, KP7_L,  6,  2, , SMG$M_REVERSE)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, KP8_U,  5, 12)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, KP8_L,  6, 12, , SMG$M_REVERSE)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, KP9_U,  5, 22)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, KP9_L,  6, 22, , SMG$M_REVERSE)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, MINUS_U,  5, 32)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, MINUS_L,  6, 32, , SMG$M_REVERSE)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, COMMA_U,  8, 32)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, COMMA_L,  9, 32, , SMG$M_REVERSE)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, ENTER_U, 12, 32)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, ENTER_L, 14, 32, , SMG$M_REVERSE)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, PERIOD_U, 14, 22)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, PERIOD_L, 15, 22, , SMG$M_REVERSE)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, KP0_U, 14, 2)
	ISTATUS = SMG$PUT_CHARS( DISPLAY2, KP0_L, 15, 2, , SMG$M_REVERSE)

C Calculator information on display3

	ISTATUS = SMG$PUT_CHARS( DISPLAY3, '(arrows)', 1, 14)
	ISTATUS = SMG$PUT_CHARS( DISPLAY3,       'up', 2,  4)
	ISTATUS = SMG$PUT_CHARS( DISPLAY3,     'down', 2, 11)
	ISTATUS = SMG$PUT_CHARS( DISPLAY3,      '<--', 2, 21)
	ISTATUS = SMG$PUT_CHARS( DISPLAY3,      '-->', 2, 28)
	ISTATUS = SMG$PUT_CHARS( DISPLAY3,        '+', 4,  5)
	ISTATUS = SMG$PUT_CHARS( DISPLAY3,        '-', 4, 13)
	ISTATUS = SMG$PUT_CHARS( DISPLAY3,        '*', 4, 22)
	ISTATUS = SMG$PUT_CHARS( DISPLAY3,        '/', 4, 30)
	ISTATUS = SMG$PUT_CHARS( DISPLAY3,'Integer modes:',           7,  1)
	ISTATUS = SMG$PUT_CHARS( DISPLAY3,'Ctrl-I  (Decimal)',        9,  3)
	ISTATUS = SMG$PUT_CHARS( DISPLAY3, 'Ctrl-B  Binary',         10,  3)
	ISTATUS = SMG$PUT_CHARS( DISPLAY3, '     O  Octal',          11,  3)
	ISTATUS = SMG$PUT_CHARS( DISPLAY3, 'Ctrl-H  Hexadecimal',    12,  3)
	ISTATUS = SMG$PUT_CHARS( DISPLAY3, 'Real modes:',            14,  1)
	ISTATUS = SMG$PUT_CHARS( DISPLAY3, 'Ctrl-F  Floating point', 16,  3)
	ISTATUS = SMG$PUT_CHARS( DISPLAY3, 'Ctrl-E  Exponential',    17,  3)

C       Draw boxes around + - * / keys

	ISTATUS = SMG$DRAW_LINE ( DISPLAY3,  3,  2, 3, 8)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY3,  3,  8, 5, 8)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY3,  3,  2, 5, 2)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY3,  5,  2, 5, 8)

	ISTATUS = SMG$DRAW_LINE ( DISPLAY3,  3, 10, 3, 16)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY3,  3, 16, 5, 16)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY3,  3, 10, 5, 10)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY3,  5, 10, 5, 16)

	ISTATUS = SMG$DRAW_LINE ( DISPLAY3,  3, 19, 3, 25)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY3,  3, 25, 5, 25)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY3,  3, 19, 5, 19)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY3,  5, 19, 5, 25)

	ISTATUS = SMG$DRAW_LINE ( DISPLAY3,  3, 27, 3, 33)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY3,  3, 33, 5, 33)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY3,  3, 27, 5, 27)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY3,  5, 27, 5, 33)

	ISTATUS = SMG$DRAW_LINE ( DISPLAY1,  1,  1, 1, 41)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY1,  3,  1, 3, 41)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY1,  1,  1, 3,  1)
	ISTATUS = SMG$DRAW_LINE ( DISPLAY1,  1, 41, 3, 41)
C+
C+
C Paste the virtual displays.
	ISTATUS = SMG$PASTE_VIRTUAL_DISPLAY ( DISPLAY4, PASTE1, 7, 38)
	ISTATUS = SMG$PASTE_VIRTUAL_DISPLAY ( DISPLAY2, PASTE1, 9, 38)
	ISTATUS = SMG$PASTE_VIRTUAL_DISPLAY ( DISPLAY1, PASTE1, 5, 38)
	ISTATUS = SMG$PASTE_VIRTUAL_DISPLAY ( DISPLAY5, PASTE1, 4, 38)
	ISTATUS = SMG$PASTE_VIRTUAL_DISPLAY ( DISPLAY3, PASTE1, 7,  3)
C-
C+
	END



      SUBROUTINE DRAW_HELP ( FLAG )
C	THIS ROUTINE HAS BEEN DISABLED

C     Draws the bottom part of the help display

      PARAMETER DT$_VT100 = '00000060'X
      PARAMETER DT$_VT52  = '00000040'X

      INTEGER IO_CHAN,TT_TYPE,FIX_NUM
      BYTE    G_ON(3),G_OFF(3)
      LOGICAL FLAG

      DATA G_ON  / 27,'(','0' /
      DATA G_OFF / 27,'(','B' /

      COMMON / SCREEN / IO_CHAN,TT_TYPE,FIX_NUM

      IF     ( TT_TYPE .EQ. DT$_VT100 ) THEN
         CALL OUT_BYTE ( 3,G_ON )
         CALL OUT_CHAR ( 20, 1,34,'qqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqq' )
         CALL OUT_CHAR ( 20,35,34,'qqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqq' )
         CALL OUT_CHAR ( 20,69,11,'qqqqqqqqqqq' )
         CALL OUT_BYTE ( 3,G_OFF )
      ELSEIF ( TT_TYPE .EQ. DT$_VT52 ) THEN
         CALL OUT_CHAR ( 20, 1,34,'----------------------------------' )
         CALL OUT_CHAR ( 20,35,34,'----------------------------------' )
         CALL OUT_CHAR ( 20,69,11,'-----------' )
      END IF
      IF ( FLAG ) THEN
         CALL OUT_CHAR ( 21,13,34,'Type A SPACE     to continue the o' )
         CALL OUT_CHAR ( 21,47,10,'utput; or,' )
      ELSE
         CALL OUT_CHAR ( 22,13,4,'Type' )
      END IF
      CALL OUT_CHAR ( 22,18,37,'ANOTHER KEY for help on that key; or,' )
      CALL OUT_CHAR ( 23,18,29,'A CTRL-Z    to return to CALC' )
      CALL MOVE_TO  ( 24,1 )

      RETURN
      END

      SUBROUTINE E

C     Puts E in the X register and in LASTX

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      CALL PUSH_STACK
      X     = 2.71828182845904523536
      LASTX = X

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE ENTER

C     Enters the display into the stack

      PARAMETER CARR_RETURN = '0000000D'X

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      CALL PUSH_STACK
      X = Y

      PUSH_FLAG = .FALSE.
      LAST = CARR_RETURN

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE ERR_HAND ( CODE )

C     CALC's error handler

      INTEGER   CODE,LENGTH, SMG$PUT_CHARS
      INTEGER DISPLAY1, DISPLAY2, DISPLAY3, DISPLAY4, DISPLAY5
      CHARACTER MODE*1,STRING*37,LINE*67
      LOGICAL   ERROR,BELL

      COMMON / DISPLAYS / DISPLAY1,DISPLAY2,DISPLAY3,DISPLAY4,DISPLAY5
      COMMON / DISP / MODE,STRING,ERROR

      IF ( CODE .EQ. 0 ) THEN
         LINE  = ' '
         BELL  = .FALSE.
         ERROR = .FALSE.
      ELSE
         ERROR = .TRUE.
         IF     ( CODE .EQ. -1 ) THEN
            LINE = 'Enter a hexadecimal digit between 1 and F'
            BELL = .FALSE.
         ELSEIF ( CODE .EQ. -2 ) THEN
            LINE = 'Type a key for help on that key '
            BELL = .FALSE.
         ELSEIF ( CODE .EQ. -3 ) THEN
            LINE = 'Unrecognized input'
            BELL = .TRUE.
         ELSEIF ( CODE .EQ. -4 ) THEN
            LINE = 'Delete not allowed now'
            BELL = .TRUE.
         ELSEIF ( CODE .EQ. -5 ) THEN
            LINE = 'Display overflow'
            BELL = .TRUE.
         ELSEIF ( CODE .EQ. -6 ) THEN
            LINE = 'Invalid digit for this mode'
            BELL = .TRUE.
         ELSEIF ( CODE .EQ. -7 ) THEN
            LINE = 'Decimal point already entered'
            BELL = .TRUE.
         ELSEIF ( CODE .EQ. -8 ) THEN
            LINE = 'Exponent limited to 2 digits'
            BELL = .TRUE.
         ELSEIF ( CODE .EQ. -9 ) THEN
            LINE = 'Exponent delimiter already entered'
            BELL = .TRUE.
         ELSEIF ( CODE .EQ. -10 ) THEN
            LINE = 'Numeric digit must precede E'
            BELL = .TRUE.
         ELSEIF ( CODE .EQ. -11 ) THEN
            LINE = 'Decimal point not allowed in exponent'
            BELL = .TRUE.
         ELSEIF ( CODE .EQ. -12 ) THEN
            LINE = 'Bad FIX precision parameter'
            BELL = .TRUE.
         ELSEIF ( CODE .EQ. -13 ) THEN
            LINE = 'Internal overflow'
            BELL = .TRUE.
         ELSEIF ( CODE .EQ. -14 ) THEN
            LINE = 'Arithmetic error'
            BELL = .TRUE.
         ELSEIF ( CODE .EQ. -15 ) THEN
C            LINE = 'Type ? for general instructions' !HELP HAS BEEN DISABLED
             LINE = ' '
            BELL = .FALSE.
         ELSE
            CALL SYS$GETMSG ( %VAL(CODE),LENGTH,LINE,%VAL(1), )
            LINE(LENGTH+1:67) = ' '
            BELL = .TRUE.
         END IF
         CALL STR$TRIM ( LINE,LINE,LENGTH )
      END IF

      IF ( BELL ) CALL SMG$RING_BELL( DISPLAY5 )
      ISTATUS = SMG$PUT_CHARS( DISPLAY5, LINE,  1, 1)
      CALL MOVE_TO  ( 24,1 )

      RETURN
      END


      SUBROUTINE EXCHANGE

C     Exchanges the X and Y registers

      REAL*8  X,Y,Z,T,Q,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      Q = X
      X = Y
      Y = Q

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE EXPONENT

C     Calculates Y**X

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      IF ( X .LT. 0. ) THEN
         X = 1. / (Y**(-X))
      ELSE
         X = Y**X
      END IF
      Y = Z
      Z = T
      T = 0.

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE FIX ( NEW_NUM )

C     Changes the number of decimal digits in 'E' and 'F' modes

      CHARACTER NEW_NUM*1
      INTEGER   FIX_NUM,IO_CHAN,TT_TYPE,TEMP
      REAL*8    X,Y,Z,T,LASTX
      BYTE      LAST
      LOGICAL   PUSH_FLAG,RADS,D_OK

      COMMON / SCREEN / IO_CHAN,TT_TYPE,FIX_NUM
      COMMON / STACK  / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      DECODE ( 1,10,NEW_NUM,ERR=1000 ) TEMP
10    FORMAT ( Z1 )

      IF ( TEMP.GT.0 .AND. TEMP.LE.15 ) THEN
         CALL ERR_HAND ( 0 )
         FIX_NUM = TEMP
      ELSE
1000     CALL ERR_HAND ( 0 )
         CALL ERR_HAND ( -12 )
      END IF

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE FRACTION

C     Strips off the integer part of X

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      X = X - DFLOTJ( JIDINT(X) )

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE GET_INPUT ( INPUT )

C     Asks for and analyzes a character from the keyboard

      INCLUDE '($SMGDEF)'
      PARAMETER SMG$K_TRM_EXCLAMATION_POINT = '00000021'X ! !
      PARAMETER SMG$K_TRM_LEFT_PAREN        = '00000028'X ! (
      PARAMETER SMG$K_TRM_RIGHT_PAREN       = '00000029'X ! )
      PARAMETER SMG$K_TRM_PLUS_SIGN         = '0000002B'X ! +
      PARAMETER SMG$K_TRM_ZERO              = '00000030'X ! 0

      CHARACTER INPUT*1
      LOGICAL   ERR_CHECK
      INTEGER   SMG$READ_KEYSTROKE, KEY

      COMMON / ERROR  / ERR_CHECK
      COMMON / KEYBOARD / KEYBOARD1

      ERR_CHECK = .FALSE.

      CALL SMG$READ_KEYSTROKE ( KEYBOARD1, KEY )

      INPUT = 'X'    !This should cause an error unless input is changed
                     !upon parsing the keystroke below.  A bit kludgy.

C     ******************************************************************
C     -------------- CONTROL INPUTS  000 - 031 ---------------------
        IF ( KEY .LT. SMG$K_TRM_SPACE ) THEN      !CONTROL INPUTS


C     -------------MISCELANEOUS !"#$%&'()*+,-./ ------------------------
        ELSEIF ( KEY .LT. SMG$K_TRM_ZERO ) THEN      !MISC


C     --------------- NUMBERS 0-9 --------------------------------------
        ELSEIF ( KEY .LE. SMG$K_TRM_NINE ) THEN      !NUMBERS
           INPUT = CHAR( KEY )


C     ------------- MISCELLANEOUS :;<=>?@ ------------------------------
        ELSEIF ( KEY .LT. SMG$K_TRM_UPPERCASE_A ) THEN      !MISC


C     -------------- LETTERS A-Z ---------------------------------------
        ELSEIF ( KEY .LE. SMG$K_TRM_UPPERCASE_Z) THEN      !UPPERCAE ALPHABET
           INPUT = CHAR( KEY )


C     ---------------- MISCELANEOUS [\]^_` -----------------------------
        ELSEIF ( KEY .LT. SMG$K_TRM_LOWERCASE_A ) THEN      !MISC


C     ---------------- lowercase letters a-z ---------------------------
        ELSEIF ( KEY .LE. SMG$K_TRM_LOWERCASE_Z ) THEN      !lowercase alphabet
           INPUT = CHAR( KEY )
           CALL STR$UPCASE ( INPUT, INPUT )


C     ----------------- MISCELLANEOUS {|}~ del -------------------------
        ELSEIF ( KEY .LT. SMG$K_TRM_PF1 ) THEN      !MISC


C     ------------------ KEYPAD PF1-PF4 --------------------------------
        ELSEIF ( KEY .LE. SMG$K_TRM_PF4 ) THEN      !PF1-PF4



C     --------------------- KEYPAD 0-9 ---------------------------------
      ELSEIF ( KEY .LE. SMG$K_TRM_KP9 ) THEN      !KP0-KP9
          IF ( KEY .EQ. SMG$K_TRM_KP0 ) THEN
            INPUT = '0'
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP1 ) THEN
            INPUT = '1'
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP2 ) THEN
            INPUT = '2'
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP3 ) THEN
            INPUT = '3'
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP4 ) THEN
            INPUT = '4'
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP5 ) THEN
            INPUT = '5'
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP6 ) THEN
            INPUT = '6'
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP7 ) THEN
            INPUT = '7'
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP8 ) THEN
            INPUT = '8'
          ELSEIF ( KEY .EQ. SMG$K_TRM_KP9 ) THEN
            INPUT = '9'
          END IF


C     --------------------- MISCELLANEOUS ------------------------------
        ELSEIF ( KEY .LT. SMG$K_TRM_F1 ) THEN      !MISC

C     -------------- END CASE ------------------------------------------
        ENDIF

      RETURN
      END


      INTEGER FUNCTION HANDLER ( SIGARGS,MECHARGS )

C     Error condition handler

      EXTERNAL PATCH_FAULT

      PARAMETER SS$_CONTINUE = '00000001'X
      PARAMETER SS$_RESIGNAL = '00000918'X
      PARAMETER SS$_FLTDIV_F = '000004BC'X
      PARAMETER SS$_FLTOVF_F = '000004B4'X
      PARAMETER SS$_FLTUND_F = '000004C4'X

      INTEGER SIGARGS(1:*),MECHARGS(1:*)
      LOGICAL ERR_CHECK

      COMMON / ERROR / ERR_CHECK

      ERR_CHECK = .NOT.ERR_CHECK
      IF ( .NOT.ERR_CHECK ) THEN

C        If HANDLER has been called twice in a row, the condition must
C        be unrecoverable

         HANDLER = SS$_RESIGNAL

      ELSE

C        Otherwise, attempt to recover

         IF ( SIGARGS(2) .EQ. SS$_FLTOVF_F ) THEN
            CALL ERR_HAND ( -13 )
         ELSE
            CALL ERR_HAND ( -14 )
         END IF

         IF ( SIGARGS(2).EQ.SS$_FLTDIV_F .OR.
     .        SIGARGS(2).EQ.SS$_FLTOVF_F .OR.
     .        SIGARGS(2).EQ.SS$_FLTUND_F      ) THEN

            HANDLER = LIB$DECODE_FAULT ( SIGARGS,
     .                                   MECHARGS,
     .                                   %DESCR(PATCH_FAULT),, )

         ELSE

            MECHARGS(3) = '00000000'X
            MECHARGS(4) = '00000000'X
            HANDLER     = SS$_CONTINUE

         END IF

      END IF

      RETURN
      END

      SUBROUTINE HELP ( KEY )
C	HELP HAS BEEN DISABLED
C     Functions as an online help facility

      PARAMETER DT$_VT100     = '00000060'X
      PARAMETER DT$_VT52      = '00000040'X
      PARAMETER CARR_RETURN   = '0000000D'X
      PARAMETER LBR$C_READ    = '00000001'X
      PARAMETER LBR$C_TYP_TXT = '00000004'X
      PARAMETER LBR$_NORMAL   = '00268001'X
      PARAMETER SS$_NORMAL    = '00000001'X
      PARAMETER RMS$_EOF      = '0001827A'X
      PARAMETER DELETE        = '0000007F'X
      PARAMETER CTRL_B        = '00000002'X
      PARAMETER CTRL_E        = '00000005'X
      PARAMETER CTRL_F        = '00000006'X
      PARAMETER CTRL_H        = '00000008'X
      PARAMETER CTRL_I        = '00000009'X
      PARAMETER CTRL_O        = '0000000F'X
      PARAMETER CTRL_Z        = '0000001A'X

      CHARACTER KEY*1,LINE*67,LIBKEY*6
      INTEGER   IO_CHAN,TT_TYPE,FIX_NUM,INDEX,STATUS,LBR$OPEN,RFA(2),
     .          LBR$LOOKUP_KEY,LBR$GET_RECORD,O_STAT,STR$POSITION
      LOGICAL   MORE

      COMMON / SCREEN / IO_CHAN,TT_TYPE,FIX_NUM

C     Open CALC's help library

      CALL LBR$INI_CONTROL ( INDEX,LBR$C_READ,LBR$C_TYP_TXT, )
      O_STAT = LBR$OPEN ( INDEX,'CALC$HELPFILE',,,,, )

C     Help loop

1000  CONTINUE

         IF     ( KEY .EQ. CHAR( CARR_RETURN ) ) THEN
            LIBKEY = 'CR'
         ELSEIF ( KEY .EQ. CHAR( DELETE ) ) THEN
            LIBKEY = 'DEL'
         ELSEIF ( KEY .EQ. CHAR( CTRL_B ) ) THEN
            LIBKEY = 'CTRL_B'
         ELSEIF ( KEY .EQ. CHAR( CTRL_E ) ) THEN
            LIBKEY = 'CTRL_E'
         ELSEIF ( KEY .EQ. CHAR( CTRL_F ) ) THEN
            LIBKEY = 'CTRL_F'
         ELSEIF ( KEY .EQ. CHAR( CTRL_H ) ) THEN
            IF ( TT_TYPE .EQ. DT$_VT100 ) THEN
               LIBKEY = 'BS100'
            ELSEIF ( TT_TYPE .EQ. DT$_VT52 ) THEN
               LIBKEY = 'BS52'
            END IF
         ELSEIF ( KEY .EQ. CHAR( CTRL_I ) ) THEN
            LIBKEY = 'CTRL_I'
         ELSEIF ( KEY .EQ. CHAR( CTRL_O ) ) THEN
            LIBKEY = 'CTRL_O'
         ELSEIF ( KEY .EQ. ',' ) THEN
            LIBKEY = 'COMMA'
         ELSEIF ( KEY .EQ. '+' ) THEN
            LIBKEY = 'PLUS'
         ELSEIF ( KEY .EQ. '-' ) THEN
            LIBKEY = 'MINUS'
         ELSEIF ( KEY .EQ. '*' ) THEN
            LIBKEY = 'STAR'
         ELSEIF ( KEY .EQ. '/' ) THEN
            LIBKEY = 'SLASH'
         ELSE
            LIBKEY = KEY
         END IF

         STATUS = LBR$LOOKUP_KEY ( INDEX,LIBKEY,RFA )
         IF ( STATUS .EQ. SS$_NORMAL ) THEN

1100        CALL CLEAR_SCREEN
            MORE = .TRUE.
            DO I = 1, 18
               LINE = ' '
               STATUS = LBR$GET_RECORD ( INDEX,LINE, )
               IF ( STATUS .EQ. RMS$_EOF ) THEN
                  MORE = .FALSE.
                  GO TO 1400
               ELSE
                  IF ( TT_TYPE .EQ. DT$_VT52 ) THEN
1200                 CONTINUE
                        J = STR$POSITION( LINE,'BLACK' )
                        IF ( J .NE. 0 ) THEN
                           LINE(J:J+4) = 'UPPER'
                        ELSE
                           J = STR$POSITION( LINE,'WHITE' )
                           IF ( J .NE. 0 ) THEN
                              LINE(J:J+4) = 'LOWER'
                           ELSE
                              GO TO 1300
                           END IF
                        END IF
                     GO TO 1200
                  END IF
1300              CALL STR$TRIM ( LINE,LINE,J )
                  CALL OUT_CHAR ( I,13,J,LINE )
               END IF
            END DO

         ELSE

            CALL CLEAR_SCREEN
            MORE = .FALSE.
            IF ( O_STAT .NE. LBR$_NORMAL ) THEN
               CALL OUT_CHAR ( 4,13,25,'Unable to open help file:' )
               CALL ERR_HAND ( O_STAT )
            ELSE
               CALL OUT_CHAR ( 4,13,29,'That key does nothing; typing' )
               CALL OUT_CHAR ( 4,42,28,' it will result in an error' )
            END IF

         END IF

1400     CALL DRAW_HELP ( MORE )
         CALL GET_INPUT ( KEY )
         IF ( MORE .AND. KEY.EQ.' ' ) THEN
            GO TO 1100
         ELSEIF ( KEY .EQ. CHAR( CTRL_Z ) ) THEN
            CALL LBR$CLOSE ( INDEX )
            CALL RESET
            RETURN
         END IF

      GO TO 1000

      END

      SUBROUTINE INITIALIZE

C     Initializes the calculator

      INTEGER   IO_CHAN,TT_TYPE,FIX_NUM
      REAL*8    X,Y,Z,T,LASTX
      BYTE      LAST
      LOGICAL   PUSH_FLAG,RADS,D_OK

      COMMON / SCREEN / IO_CHAN,TT_TYPE,FIX_NUM
      COMMON / STACK  / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK
      COMMON / PASTE  /  PASTE1

C     Establish a channel to the terminal

      CALL SYS$ASSIGN ( 'SYS$COMMAND',IO_CHAN,, )

C     Set the defaults and clear the stack

      FIX_NUM = 4
      LAST    = 0
      D_OK    = .FALSE.

C     Write out the display
      CALL CREATE_DISPLAYS
      CALL ERR_HAND ( -15 )
      CALL DRAW_CALC
      CALL CHANGE_MODE ( 'F',0 )
      CALL CHANGE_TRIG ( 'RAD',0 )
      CALL CLEAR_STACK
      CALL MOVE_TO (1,1)

      RETURN
      END


      SUBROUTINE INTEGER

C     Integerizes the X register

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      X = DFLOTJ( JIDINT(X) )

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE INVERT

C     Calculates 1 / X

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      X = 1. / X

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE LAST_X

C     Puts the last-entered number in the X register

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      CALL PUSH_STACK
      X = LASTX

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE LOAD_X_REG

C     Loads the X register

      PARAMETER CARR_RETURN = '0000000D'X

      CHARACTER STRING*37,MODE*1
      REAL*8    X,Y,Z,T,LASTX
      BYTE      LAST
      INTEGER   I_X,STR$POSITION
      LOGICAL   PUSH_FLAG,ERROR,MINUS,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK
      COMMON / DISP  / MODE,STRING,ERROR

      IF ( LAST .EQ. CARR_RETURN ) RETURN

      IF ( MODE .EQ. 'I' ) THEN
         DECODE ( 37,10,STRING,ERR=1100 ) I_X
         X = DFLOTJ( I_X )
      ELSEIF ( MODE.EQ.'B' .OR. MODE.EQ.'O' .OR. MODE.EQ.'H' ) THEN
         MINUS = .FALSE.
         DO I = 1, 37
            IF ( STRING(I:I) .EQ. '-' ) THEN
               STRING(I:I) = ' '
               MINUS = .TRUE.
               GO TO 1000
            END IF
         END DO
1000     IF ( MODE .EQ. 'B' ) THEN
            I_X = 0
            DO I = 7, 37
               IF ( STRING(I:I) .EQ. '1' ) THEN
                  I_X = I_X + 2**(37-I)
               END IF
            END DO
            X = FLOATJ( I_X )
         ELSEIF ( MODE .EQ. 'O' ) THEN
            DECODE ( 37,20,STRING,ERR=1100 ) I_X
            X = FLOATJ( I_X )
         ELSEIF ( MODE .EQ. 'H' ) THEN
            DECODE ( 37,30,STRING,ERR=1100 ) I_X
            X = FLOATJ( I_X )
         END IF
         IF ( MINUS ) X = -X
      ELSEIF ( MODE .EQ. 'F' ) THEN
         IF ( STR$POSITION( STRING,'.' ) .EQ. 0 ) THEN
            STRING = STRING(2:37)//'.'
         END IF
         DECODE ( 37,40,STRING,ERR=1100 ) X
      ELSEIF ( MODE .EQ. 'E' ) THEN
         IF ( STRING(33:33).NE.' ' .AND. STRING(34:34).EQ.' ' ) THEN
            STRING(34:34) = 'D'
            IF ( STRING(35:35) .EQ. ' ' ) STRING(35:35) = '+'
         ELSE
            IF ( STR$POSITION( STRING,'.' ) .EQ. 0 ) THEN
               I = STR$POSITION( STRING,'E' )
               IF ( I .EQ. 0 ) THEN
                  STRING = STRING(2:37)//'.'
               ELSE
                  STRING(1:I-1) = STRING(2:I-1)//'.'
               END IF
            END IF
         END IF
         DECODE ( 37,50,STRING,ERR=1100 ) X
      END IF

      LASTX = X
      RETURN

C     Error in decoding

1100  CALL ERR_HAND ( -5 )
      X = 0.

      RETURN

10    FORMAT ( I37 )
20    FORMAT ( O37 )
30    FORMAT ( Z37 )
40    FORMAT ( F37.16 )
50    FORMAT ( E37.16 )

      END

      SUBROUTINE LOG_10

C     Calculates LOG( X )

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      X = DLOG10( X )

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE LOG_E

C     Calculates LN( X )

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      X = DLOG( X )

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE MOVE_TO ( LINE,COLUMN )

C     Moves the cursor out of the way.  Line and column are not used.

      INTEGER LINE, COLUMN
      INTEGER SMG$SET_CURSOR_ABS
      INTEGER DISPLAY1, DISPLAY2, DISPLAY3, DISPLAY4, DISPLAY5
      COMMON / DISPLAYS / DISPLAY1,DISPLAY2,DISPLAY3,DISPLAY4,DISPLAY5

      ISTATUS = SMG$SET_CURSOR_ABS( DISPLAY3, 17, 1 )
      RETURN
      END


      SUBROUTINE MULTIPLY

C     Multiplies X by Y

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

C     Load the X register if necessary

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      X = X * Y
      Y = Z
      Z = T
      T = 0.

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE OUT_BYTE ( LENGTH,STRING )

C	THIS SUBROUTINE SHOULD NO LONGE BE CALLED.  USE SMG SERVICES INSTEAD
C     Writes out a byte string of given length

      PARAMETER IO$_WRITEVBLK = '00000030'X
      PARAMETER IO$M_NOFORMAT = '00000100'X
      PARAMETER IO$M_CANCTRLO = '00000040'X

      BYTE    STRING(100)
      INTEGER IO_CHAN,LENGTH,TT_TYPE,FIX_NUM

      COMMON / SCREEN / IO_CHAN,TT_TYPE,FIX_NUM

      CALL SYS$QIOW ( %VAL(0),
     .                %VAL(IO_CHAN),
     .                %VAL(IO$_WRITEVBLK+
     .                     IO$M_CANCTRL0+
     .                     IO$M_NOFORMAT),,,,
     .                 STRING,
     .                %VAL(LENGTH),,,, )

      RETURN
      END

      SUBROUTINE OUT_CHAR ( X,Y,LENGTH,STRING )
C	THIS SUBROUTINE SHOULD NO LONGE BE CALLED.  USE SMG SERVICES INSTEAD

C     Writes out a character string of given length at (X,Y)

      PARAMETER IO$_WRITEVBLK = '00000030'X
      PARAMETER IO$M_NOFORMAT = '00000100'X
      PARAMETER IO$M_CANCTRLO = '00000040'X

      CHARACTER STRING*100
      INTEGER   IO_CHAN,LENGTH,TT_TYPE,FIX_NUM,X,Y

      COMMON / SCREEN / IO_CHAN,TT_TYPE,FIX_NUM

      CALL MOVE_TO ( X,Y )

      CALL SYS$QIOW ( %VAL(0),
     .                %VAL(IO_CHAN),
     .                %VAL(IO$_WRITEVBLK+
     .                     IO$M_CANCTRLO+
     .                     IO$M_NOFORMAT),,,,
     .                %REF(STRING),
     .                %VAL(LENGTH),,,, )

      RETURN
      END

      INTEGER FUNCTION PATCH_FAULT ( OPCODE,PC,PSL,REGISTERS,OP_COUNT,
     .                               OP_TYPES,READ_OPS,WRITE_OPS,
     .                               SIGARGS,SIGNAL,CONTEXT,USERARG )

C     Dummy routine needed by LIB$DECODE_FAULT

      PARAMETER SS$_CONTINUE = '00000001'X

      INTEGER OPCODE,PC,PSL,REGISTERS(15),OP_COUNT,OP_TYPES(1:*),
     .        READ_OPS(1:*),WRITE_OPS(1:*),SIGARGS(1:*),SIGNAL,
     .        CONTEXT,USERARG

      PATCH_FAULT = SS$_CONTINUE

      RETURN
      END

      SUBROUTINE PI

C     Puts PI in the X register and in LASTX

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      CALL PUSH_STACK
      X     = 3.1415926535897932384626433
      LASTX = X

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE POWER_10

C     Calculates 10**X

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      IF ( X .LT. 0. ) THEN
         X = 1. / 10.**(-X)
      ELSE
         X = 10.**X
      END IF

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE POWER_E

C     Calculates E**X

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      IF ( X .LT. 0. ) THEN
         X = 1. / DEXP( -X )
      ELSE
         X = DEXP( X )
      END IF

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE PUSH_STACK

C     Pushes the stack up

      REAL*8    X,Y,Z,T,LASTX
      BYTE      LAST
      LOGICAL   PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      T = Z
      Z = Y
      Y = X
      X = 0.

      RETURN
      END

      SUBROUTINE RESET

C     Resets the display

      INTEGER  PASTE1, SMG$REPAINT_SCREEN
      COMMON / PASTE  /  PASTE1

C     Write out the display
      ISTATUS = SMG$REPAINT_SCREEN( PASTE1 )
      RETURN
      END


      SUBROUTINE ROLL_DOWN

C     Rolls the stack down

      REAL*8  X,Y,Z,T,Q,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      Q = X
      X = Y
      Y = Z
      Z = T
      T = Q

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE ROLL_UP

C     Rolls the stack up

      REAL*8  X,Y,Z,T,Q,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      Q = T
      T = Z
      Z = Y
      Y = X
      X = Q

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE SINE

C     Calculates SIN( X )

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      IF ( RADS ) THEN
         X = DSIN( X )
      ELSE
         X = DSIND( X )
      END IF

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE SQUARE_ROOT

C     Calculates the square root of X

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      X = DSQRT( X )

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE SQUARE_X

C     Calculates X**2

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      X = X**2.

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END

      SUBROUTINE SUBTRACT

C     Subtracts X from Y

      REAL*8    X,Y,Z,T,LASTX
      BYTE      LAST
      CHARACTER MODE*1,STRING*37
      LOGICAL   PUSH_FLAG,ERROR,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK
      COMMON / DISP  / MODE,STRING,ERROR

C     Load the X register if necessary

      LAST = 0
      IF ( .NOT.PUSH_FLAG ) THEN
         IF ( MODE .EQ. 'E' ) THEN
            IF ( STRING(37:37) .EQ. 'E' ) THEN
               CALL ADD_DIGIT ( '-' )
               RETURN
            ELSE
               CALL LOAD_X_REG
            END IF
         ELSE
            CALL LOAD_X_REG
         END IF
      END IF

      X = Y - X
      Y = Z
      Z = T
      T = 0.

      PUSH_FLAG = .TRUE.
      CALL DISPLAY

      RETURN
      END

      SUBROUTINE TANGENT

C     Calculates TAN( X )

      REAL*8  X,Y,Z,T,LASTX
      BYTE    LAST
      LOGICAL PUSH_FLAG,RADS,D_OK

      COMMON / STACK / X,Y,Z,T,PUSH_FLAG,LAST,RADS,LASTX,D_OK

      IF ( .NOT.PUSH_FLAG ) CALL LOAD_X_REG

      IF ( RADS ) THEN
         X = DTAN( X )
      ELSE
         X = DTAND( X )
      END IF

      PUSH_FLAG = .TRUE.
      LAST = 0

      CALL DISPLAY

      RETURN
      END
