	Program EDT_Xlater
C
C  Required files:
C       EDT_XLATE.FOR
C       XLATE_CMDS.CLD
C	SHODIR.FOR
C       FILATR.MAR
C
C  Compiling:
C       $ FORTRAN EDT_XLATE
C	$ FORTRAN SHODIR
C       $ SET COMMAND/OBJECT XLATE_CMDS
C       $ MACRO FILATR
C       $ LINK/NOTRACEBACK EDT_XLATE, XLATE_CMDS, SHODIR, FILATR
C
C  Using:
C      DEFINE EDT source_directory:EDT_XLATE        (Add to LOGIN.COM)
C      DEFINE KEY GOLD D AS 'XLATE    .'            (Add to EDTINI file.  4 spaces minimum required.)
C  or  DEFINE KEY GOLD D AS 'XLATE DIR.'            (another example)
C  or  DEFINE KEY GOLD D AS 'XLATE DIR/SIZE/DATE.'  (another example)
C
C  David Deley  September, 1987
C-----------------------------------------------------------------------
	Integer Status
C
	Integer  Xlate_parse_cmnd
	External Xlate_parse_cmnd
C
	Integer  EDT$Edit, Lib$Stop, CLI$Present, CLI$Get_Value
	External EDT$Edit, Lib$Stop, CLI$Present, CLI$Get_Value
C
        External CLI$_Present, CLI$_Defaulted
        External CLI$_Negated, CLI$_Absent
C
        External EDT$M_Recover,  EDT$M_NoCommand, EDT$M_NoJournal
        External EDT$M_NoOutput, EDT$M_NoCreate
C
	Integer  Xlate( 0:1), Options
	Character*255   Input_File,  Output_File
	Character*255 Journal_File, Command_File
C
	Data   nif,    Input_File/ 0, ' '/
	Data   nof,   Output_File/ 0, ' '/
	Data   njf,  Journal_File/ 0, ' '/
	Data   ncf,  Command_File/ 0, ' '/
C
C		Load Xlate with Address of Spawn_EDT_SubProcess.
C
	Xlate( 0)= %Loc( Xlate_parse_cmnd)
C
C		EDT Input File:
C
	If( CLI$Present( 'INPUT')) Then
	  Call CLI$Get_Value( 'INPUT', Input_File, nif)
	 EndIf
C
C		Recover Option?
C
	If( CLI$Present( 'RECOVER')) Then
	  Options= Options+ %Loc( EDT$M_Recover)
	 EndIf
C
C		ReadOnly Option?
C
	If( CLI$Present( 'READ_ONLY')) Then 
	  Options= Options+ %Loc( EDT$M_NoOutput)
	  Options= Options+ %Loc( EDT$M_NoJournal)
	 EndIf
C
C		Command (initiation) file specified?
C
	Status= CLI$Present( 'COMMAND')
C
	If( status .eq. %Loc( CLI$_Present)) Then
	  Call CLI$Get_Value( 'COMMAND', Command_File, ncf)
C
	 Else If( status .eq. %Loc( CLI$_Defaulted)) Then
C	  Default to command file= EDTINI.
C
	 Else If( status .eq. %Loc( CLI$_Negated)) Then
C	  Command_File= ' '
	  Options= Options+ %Loc( EDT$M_NoCommand)
	EndIf
C
C		Output File?
C
	If( CLI$Present( 'OUTPUT')) Then
	  Call CLI$Get_Value( 'OUTPUT', Output_File, nof)
C
        Else
C	  Default to Output= Input.
        EndIf
C
C		Journal file?
C
	status= CLI$Present( 'JOURNAL')
C
	If( status .eq. %Loc( CLI$_Present)) Then
	  Call CLI$Get_Value( 'JOURNAL', Journal_File, njf)
C
	 Else If( status .eq. %Loc( CLI$_Defaulted)) Then
C	  Default journal file to Journal= "Input_name".JOU.
C
	 Else 
	  Options= Options+ %Loc( EDT$M_NoJournal)
        EndIf
C
C		Create Option?
C
	status= CLI$Present( 'CREATE')
C
	If( status .eq. %Loc( CLI$_Negated)) Then
	  Options= Options+ %Loc( EDT$M_NoCreate)
        EndIf
C
D2998	Format( ' %Edit_Xlater-I; ', 5X, A,  '= ', I10)
D2999	Format( ' %Edit_Xlater-I; ', A, '_File= ',   A)
D      If( nif .gt. 0)	Print 2999, '  Input',   Input_File( 1:nif)
D      If( nof .gt. 0)	Print 2999, ' Output',  Output_File( 1:nof)
D      If( ncf .gt. 0)	Print 2999, 'Command', Command_File( 1:ncf)
D      If( njf .gt. 0)	Print 2999, 'Journal', Journal_File( 1:njf)
D			Print 2998, 'Options', Options
C
C		Start up EDT.
C
	Status= EDT$Edit 
     $(    Input_File( 1:nif) 
     $,   Output_File( 1:nof) 
     $,  Command_File( 1:ncf) 
     $,  Journal_File( 1:njf) 
     $,  Options,,, Xlate)
C
	If( .not.status) Then
	  Write( 6, '(A)') '%Edit (EDT_Xlater):  Could not start EDT.'
	  status= Lib$Stop( %val( status))
	 EndIf
C
	Call Exit
	End

C-----------------------------------------------------------------------

	Integer Function Xlate_Parse_Cmnd( Xlate_command)
C	This routine gains control when the nokeypad command XLATE is issued
	Implicit Integer (a-z)
	Logical asked
	Character*(*) Xlate_command
	Character*80  Command
	External Handler, Xlate_Cmds
	Common /Command/ Command

20	Format(
	1	' Commands available:'/
	2       '   DIR   (Directory)'/
	3       '     /SIZE  (Optional)'/
	4       '     /DATE  (Optional)'/
	5       ' '/
	6	' Command: ',$)
21	Format(q,a)

C	.ENTRY -------
C
C	Establish a handler for unexpected errors.
	Status = Lib$Establish( Handler)

C	Reset terminal screen
	Call Reset_Screen

C	Check length of XLate Command.
	If( Len( Xlate_command) .lt. 4) Then
	   Print *
	   Print *,
     *     '%(EDT)-W; ',
     *'Please Use XLATE followed by at least 4 blanks or characters.'
	   Print *
	   Xlate_get_command = 0	!Set return value to warning
	   Return			!Return to editor
	EndIf
C
C	Examine the command.
C
        Asked = .false.
	Call Str$trim( Command, Xlate_command, length)
	If (length .eq. 0) Then
	   Write (6,20)
	   Read  (5,21,end=99) length, Command
	   If (length .eq. 0) goto 99
           Asked = .true.
        Endif
C
C	Process the command
C
	Status = CLI$DCL_PARSE( Command, Xlate_Cmds)
	If (Status) Call CLI$DISPATCH( Asked)

C
C	Return to EDT editor
C
99	Xlate_command= 'EXIT'	!Goto line mode on return
	Xlate_Parse_Cmnd = 1	!Sucess
	Return
	End

C ---------------------------------------------------------------------

	Subroutine Xlate_dir( Asked)
	Implicit Integer (a-z)
	Logical asked
	Character*80 Command
	Character*76 Dirspec
	External cli$_absent, xlate_cmds
	Include '($ssdef)'
	PARAMETER GET_SIZE = '00000001'X
	PARAMETER GET_DATE = '00000002'X
	COMMON /COMMAND/ COMMAND

11	Format (1x,'Directory: ',$)
15	Format (1x, ' ')
16	Format (q,a)

C	.ENTER -------------
	Status = cli$get_value( 'DIRSPEC', dirspec, L)
	IF (Status .eq. %loc( cli$_absent)) then
	   If (.not. Asked) then
	      write(6,11)
	      read(5,16,end=99) D_Len, Dirspec
	      Asked = .true.
	      Call Str$trim( Command, Command, C_Len)
	      If (C_len+1+D_len .gt. len(Command)) then
		 Write(6,*) ' Command line too long'
	         write(6,15)		!blank line for EDT to overwrite
99		 Return
	      Endif
	      Command(C_Len+1:C_len+1) = ' '
	      Command(C_len+2:C_len+1+D_len) = Dirspec
	      Status = CLI$DCL_PARSE( Command(1:C_len+1+D_len), Xlate_cmds)
	      If (Status) Call CLI$DISPATCH( Asked)
	      write(6,15)	!blank line for EDT to overwrite
 	      Return
	   Else
	      Dirspec = '*.*;*'
	   Endif
	ENDIF
	Dirflags = 0
	If ( cli$present('SIZE') ) Dirflags = Dirflags + get_SIZE
	If ( cli$present('DATE') ) Dirflags = Dirflags + get_DATE
	Call SHODIR( Dirspec(1:L), Dirflags)
	write(6,15)  !blank line for EDT to overwrite
	return

	END

C-----------------------------------------------------------------------

	SUBROUTINE RESET_SCREEN

C	This routine set the following video attributes:
C	  1.  Normal video attributes.  (Inverse video is switched off).
C	  2.  Scrolling region is set to 1,24  (full screen).
C         3.  Insert mode ended
C	  4.  Cursor is positioned at 23,1

	IMPLICIT     none
	INCLUDE      '($DVIDEF)'
	INTEGER*4    LIB$GETDVI, LIB$PUT_OUTPUT
	INTEGER*4    SMG$GET_TERM_DATA, SMG$INIT_TERM_TABLE_BY_TYPE
	INTEGER*4    Term_type, Term_table_addr, Esc_seq_len, Status
	INTEGER*4    Arg_vector(3)
	CHARACTER    USER_TERMINAL*10 /'SYS$OUTPUT'/, Esc_seq*12
	PARAMETER    max_esc_seq_len = 12
	PARAMETER    SMG$K_BEGIN_NORMAL_RENDITION = 595	!from SYS$LIBRARY:STARLET.MLB module $$SMGTRMPTRDEF
	PARAMETER    SMG$K_SET_SCROLL_REGION = 572	!from SYS$LIBRARY:STARLET.MLB module $$SMGTRMPTRDEF
	PARAMETER    SMG$K_SET_CURSOR_ABS = 570		!from SYS$LIBRARY:STARLET.MLB module $$SMGTRMPTRDEF
	PARAMETER    SMG$K_END_INSERT_MODE = 468	!from SYS$LIBRARY:STARLET.MLB module $$SMGTRMPTRDEF

C	.ENTRY -------------------------------------

	Status = LIB$GETDVI( DVI$_DEVTYPE, , USER_TERMINAL, Term_type)
	If (.not. Status) Return

	Status = SMG$INIT_TERM_TABLE_BY_TYPE(Term_type, Term_table_addr)
	If (.not. Status) Return

C	1.  Normal video attributes.  (Inverse video is switched off).
	Status = SMG$GET_TERM_DATA ( Term_table_addr,
	2				SMG$K_BEGIN_NORMAL_RENDITION,
	3				max_esc_seq_len,
	4				esc_seq_len,
	5				%REF( Esc_seq))
	If (.not. Status) Return
	Status = LIB$PUT_OUTPUT ( Esc_seq(1:esc_seq_len))

C	2.  Scrolling region is set to 1,24  (full screen)
	Arg_vector(1) = 2	!number of args to follow
	Arg_vector(2) = 1	!scroll top margin
	Arg_vector(3) = 24	!scroll bottom margin
	Status = SMG$GET_TERM_DATA ( Term_table_addr,
	2				SMG$K_SET_SCROLL_REGION,
	3				max_esc_seq_len,
	4				esc_seq_len,
	5				%REF( Esc_seq),
	6				Arg_vector)
	If (.not. Status) Return
	Status = LIB$PUT_OUTPUT ( Esc_seq(1:esc_seq_len))

C	3.  Insert mode switched off
	Status = SMG$GET_TERM_DATA ( Term_table_addr,
	2				SMG$K_END_INSERT_MODE,
	3				max_esc_seq_len,
	4				esc_seq_len,
	5				%REF( Esc_seq))
	If (.not. Status) Return
	Status = LIB$PUT_OUTPUT ( Esc_seq(1:esc_seq_len))

C	4.  Cursor is positioned at (23,1)
	Arg_vector(1) = 2	!number of args to follow
	Arg_vector(2) = 23	!cursor row number
	Arg_vector(3) = 1	!cursor column number
	Status = SMG$GET_TERM_DATA ( Term_table_addr,
	2				SMG$K_SET_CURSOR_ABS,
	3				max_esc_seq_len,
	4				esc_seq_len,
	5				%REF( Esc_seq),
	6				Arg_vector)
	If (.not. Status) Return
	Status = LIB$PUT_OUTPUT ( Esc_seq(1:esc_seq_len))

	RETURN
	END

C-----------------------------------------------------------------------

	Integer Function Handler( Sigargs, Mechargs)
	Integer  Sigargs(*), Mechargs(*)
	Include  '($ssdef)'
	Include  '($stsdef)'

C	If error was severe attempt to return to EDT,
C	otherwise signal error and continue.

	If ( (sigargs(2).and.sts$m_severity) .eq. sts$k_severe) then
	    Call LIB$SIG_TO_RET( Sigargs, Mechargs)
	Else
	    Handler = ss$_resignal
	Endif
	return
	end
