PROGRAM FINDMAIL(INPUT, OUTPUT, MAILFILE, MAILDATA, OUTLINKUP, INLINKUP);

CONST

   len_qual	= 20;
   len_fold	= 39;
   len_actn	= 130;
   len_user	= 31;
   len_frwd	= 20;
   len_buff	= 181;
   len_comm	= 127;
   len_dir	= 64;
   len_node     = 8;
   len_skip	= 31;
   len_file	= 64;
   len_from     = 150;
   len_title    = 132;

   nul          = chr(00);
   bell		= chr(07);
   esc          = chr(27);
   blank1       = ' ';
   null_acc     = '        ';
   null_link    = '                  ';
   null_node    = '        ';
   null_user	= '                               ';
   new_fold	= 'NEWMAIL';

TYPE

   string_two      =  packed array [1..2]        of char;
   string_extra    =  packed array [1..196]      of char;
   string_skip     =  packed array [1..len_skip] of char;
   string_buff     =  packed array [1..len_buff] of char;
   string_node     =  packed array [1..len_node] of char;

   string_link     =  packed array [1..80] of char;
   string_pass     =  packed array [1..31] of char;
   string_user     =  packed array [1..31] of char;
   string_name     =  packed array [1..60] of char;
   string_time     =  packed array [1..23] of char;
   string_acct     =  packed array [1..8]  of char;
   string_uic      =  packed array [1..9]  of char;

   string_frwd     =  packed array [1..len_frwd] of char;
   string_comm     =  packed array [1..len_comm] of char;
   string_qual     =  packed array [1..len_qual] of char;
   string_actn     =  packed array [1..len_actn] of char;
   string_dir      =  packed array [1..len_dir]  of char;
   string_file     =  packed array [1..len_file] of char;
   string_folder   =  packed array [1..len_fold] of char;
   string_from     =  packed array [1..len_from] of char;
   string_title    =  packed array [1..len_title] of char;

   comment         =  array [1..len_comm] of char;
   forward         =  array [1..len_frwd] of char;
   directry        =  array [1..len_dir]  of char;

   Quad_Word       =  Record
      L0           :  Unsigned;
      L1           :  Integer;
   End;

   In_Record       =  Record
      Case integer of
      1: (instring : packed array [1..249] of char);
      2: (usrname  :  string_user;
          sndrcv   ,
          space    ,
          num_msg  :  char;
          skip     :  string_skip;
          dir_len  ,
          com_len  ,
          for_len  :  char;
          usrbuff  :  string_buff);
   End;

   Mail_Record     =  Record
      rec_id       :  Quad_Word;
      len_fold     :  char;
      folder       :  [key(1)] string_folder;
      unk_buff     :  packed array [1..18] of char;
      buffer       :  packed array [1..384] of char;
   End;

VAR

findit		:  integer  := 0;
dir_len         :  integer  := 0;
dev_len         :  integer  := 0;
def_len         :  integer  := 0;
lenstr          :  integer  := 0;
nummsg          :  integer  := 0;
len_frm         :  integer  := 0;
len_name	:  integer  := 0;
loc_node        :  integer  := 0;
snd_name	:  integer  := 0;
index           :  integer  := 0;
jndex           :  integer  := 0;
kndex           :  integer  := 0;
lndex           :  integer  := 0;
return		:  integer  := 0;

continue	:  boolean  := true;
net_bit         ,
rd_bit		,
all_bit		,
full_bit	,
my_bit		,
dir_return	:  boolean  := false;

name_file	:  string_file;
usrdrty	        :  string_dir := '[]                                                              ';
def_dev 	:  string_dir;
def_drty	:  string_dir;
buffer		:  string_buff;

instrng		,
outstrng	,
username	,
fnd_usr		:  string_user;

title_buff	:  string_title;
from_buff	:  string_from;

nodename        :  string_node  := null_node;
sendname        :  string_user  := null_user;
newuser         :  string_user  := null_user;
myname		:  string_user  := null_user;
cur_time 	:  string_time;
passname	:  string_pass;
findacct	,
myacct		:  string_acct;

Mailfile	:  File of In_Record;
MailData	:  File of Mail_Record;
OutLinkUp	,
InLinkUp	:  Text;

FUNCTION cli$present (
  %STDESCR name   : PACKED ARRAY [l1..u1 : INTEGER] OF CHAR) : INTEGER;
  EXTERN;

FUNCTION cli$get_value (
  %STDESCR name   : PACKED ARRAY [l1..u1 : INTEGER] OF CHAR;
           retbuf : PACKED ARRAY [l2..u2 : INTEGER] OF CHAR) : INTEGER;
  EXTERN;

PROCEDURE whoami (
  %STDESCR name   : PACKED ARRAY [l1..u1 : INTEGER] OF CHAR;
  %STDESCR accnt  : string_acct;
           count  : INTEGER	);
  EXTERN;

PROCEDURE whereami (
  %STDESCR name   : PACKED ARRAY [l1..u1 : INTEGER] OF CHAR;
           count  : INTEGER;
  %STDESCR device : PACKED ARRAY [l2..u2 : INTEGER] OF CHAR;
           devlen : INTEGER;
  %STDESCR drctry : PACKED ARRAY [l3..u3 : INTEGER] OF CHAR;
           dirlen : INTEGER;
           return : INTEGER	);
  EXTERN;

PROCEDURE str$trim (
  %STDESCR instrg : PACKED ARRAY [l1..u1 : INTEGER] OF CHAR;
  %STDESCR oustrg : PACKED ARRAY [l2..u2 : INTEGER] OF CHAR;
  %REF     length : integer   );
  EXTERN;

FUNCTION str$position (
  %STDESCR instrg : PACKED ARRAY [l1..u1 : INTEGER] OF CHAR;
  %STDESCR oustrg : PACKED ARRAY [l2..u2 : INTEGER] OF CHAR)	:   INTEGER;
  EXTERN;

PROCEDURE sys$asctim (
  %REF     length : integer;
  %STDESCR date   : string_time;
  %REF     time   : Quad_Word;
           cvtflg : integer);
  EXTERN;

{****************************************************************************}
{	PARSES OUT THE FULL MAIL FILE SPECIFICATION FOR OPENING THE MAIL FILE}
{****************************************************************************}

procedure	get_mail_file;

VAR
   loc_len      ,
   loc_dev      ,
   loc_pnt	:  integer;
   temp2	,
   temp4	,
   temp3	,
   temp1	:  array [1..len_file] of char;

BEGIN

   unpack(def_dev,temp4,1);
   for index := 1 to dev_len do
       temp3[index] := temp4[index];

   unpack(def_drty,temp1,1);
   for index :=  1 to (def_len - 1) do
       temp3[index+dev_len] := temp1[index];

   unpack(usrdrty,temp2,1);
   for index := 1 to (dir_len - 1) do
       temp3[index+dev_len+def_len-1] := temp2[index+1];

   loc_pnt := dev_len + def_len + dir_len - 1;

   temp3[loc_pnt]	:= 'M';   temp3[loc_pnt+1]	:= 'A';
   temp3[loc_pnt+2]	:= 'I';   temp3[loc_pnt+3]	:= 'L';
   temp3[loc_pnt+4]	:= '.';   temp3[loc_pnt+5]	:= 'M';
   temp3[loc_pnt+6]	:= 'A';   temp3[loc_pnt+7]	:= 'I';

   loc_pnt := loc_pnt + 7;

   pack(temp3,1,name_file);
   str$trim( name_file, substr(name_file,1,loc_pnt), Loc_Len );

END;

{****************************************************************************}
{	PARSES OUT THE MAIL SUB-DIRECTORY FROM THE VMSMAIL.DAT FILE          }
{****************************************************************************}

function get_dir	:	boolean;

VAR

   for_len	,
   com_len	:  integer;
   temp1	:  array [1..len_buff] of char;
   temp2	:  array [1..len_dir]  of char;

BEGIN

   get_dir := false;

   for_len := ord(mailfile^.for_len);

   if for_len <= 0 then
   BEGIN

      dir_len := ord(mailfile^.dir_len);
      com_len := ord(mailfile^.com_len);

      unpack(mailfile^.usrbuff,temp1,1);

      if dir_len > 0 then
      BEGIN
         get_dir := true;

         FOR jndex := 1 to len_dir DO
             temp2[jndex] := blank1;

         FOR jndex := (1+com_len) to (com_len+dir_len) DO
             temp2[jndex-com_len] := temp1[jndex];

         pack(temp2,1,usrdrty);

      END
      else
         dir_len := 2;

   END;

END;
{****************************************************************************}
{	PARSES OUT THE FROM USERNAME AND SUBJECT FROM THE USERS MAIL.MAI     }
{****************************************************************************}

procedure parse_msg;

VAR

   frm_len	,
   loc_colon    ,
   loc_len      ,
   tit_len	:  integer;
   temp3	:  array [1..384] of char;
   temp1	:  array [1..len_title] of char;
   temp2	:  array [1..len_from]  of char;

BEGIN

      frm_len := ord(maildata^.buffer[1]);

      loc_colon := str$position( maildata^.buffer, '::');

      unpack(maildata^.buffer,temp3,1);

      for jndex := 1 to frm_len do
             temp2[jndex] := blank1;

      index := 1;
      while (temp3[index+2] <> blank1) do
      begin
         temp2[index] := temp3[index+2];
         index := index + 1;
      end;

      len_frm := index - loc_colon;

      pack(temp2,1,from_buff);

      str$trim( from_buff, substr(from_buff,1,frm_len), loc_len );

      loc_len := ord(temp3[frm_len+5]);

      tit_len := ord(temp3[frm_len+9+loc_len]);

      if tit_len > len_title then tit_len := len_title;

      for jndex := 1 to tit_len do
             temp1[jndex] := blank1;

      for jndex := 1 to tit_len do
             temp1[jndex] := temp3[jndex+frm_len+loc_len+10];

      pack(temp1,1,title_buff);

      str$trim( title_buff, substr(title_buff,1,tit_len), loc_len );

END;

{****************************************************************************}
{	Procedure to check to see if NEWMAIL is across the NETWORK.	     }
{****************************************************************************}

FUNCTION check_net	:  boolean;

  BEGIN
     return := cli$present ('NETWORK');
     IF ODD(return) THEN
	check_net := TRUE
     ELSE
	check_net := FALSE;
  END;


{****************************************************************************}
{	Procedure to check to see if NEWMAIL output should include 	     }
{	the From Username, and Date sent of Mail in the NEWMAIL folder       }
{****************************************************************************}

FUNCTION check_full	:  boolean;

  BEGIN
     return := cli$present ('FULL');
     IF ODD(return) THEN
	check_full := TRUE
     ELSE
	check_full := FALSE;
  END;

{****************************************************************************}
{	Procedure to check to see if NEWMAIL output should be ALL	     }
{	Same as FULL but adds the subject of the mail messages.              }
{****************************************************************************}

FUNCTION check_all	:  boolean;

  BEGIN
     return := cli$present ('ALL');
     IF ODD(return) THEN
	check_all := TRUE
     ELSE
	check_all := FALSE;
  END;

PROCEDURE local_read;

BEGIN

   return := cli$present('SENDNAME');

   sendname := null_user;

   if odd(return) then 
   BEGIN
      return := cli$get_value('SENDNAME', sendname);
      if odd(return) then
	 str$trim( sendname, sendname, snd_name);
   END
   ELSE
      BEGIN
         sendname := myname;
	 snd_name := len_name;
      END;

   if check_all then all_bit := true;

   if check_full then full_bit := true;

END;

PROCEDURE network;

VAR
   buffer       :  packed array [1..80] of char;
   tempobj	:  array [1..18] of char;
   objectname   :  packed array [1..18] of char;
   locname      :  string_user;
   tmplen       ,
   lenname      :  INTEGER;

BEGIN

   tmplen    := loc_node + 1;
   nodename  := substr(sendname, 1, tmplen );

   locname   := substr(sendname, tmplen+1, snd_name-tmplen);

   lenname := snd_name - tmplen;

   str$trim( locname, substr(locname,1,(snd_name-tmplen)), lenname );

   writeln( 'Sent username:  ', locname:lenname, ', To node:  ', nodename:tmplen );
   unpack(nodename,tempobj,1);

   tempobj[tmplen + 1] := chr(34);
   tempobj[tmplen + 2] := '0';		   tempobj[tmplen + 3] := '=';
   tempobj[tmplen + 4] := '$';		   tempobj[tmplen + 5] := 'N';
   tempobj[tmplen + 6] := 'W';		   tempobj[tmplen + 7] := 'M';
   tempobj[tmplen + 8] := 'L';
   tempobj[tmplen + 9] := chr(34);

   objectname := null_link;
   pack(tempobj,1,objectname);
   tmplen := tmplen + 9;

   open (outlinkup, substr(objectname,1,tmplen),
		history          := new,
		access_method    := sequential,
		carriage_control := none,
		error            := CONTINUE	);

   rewrite( outlinkup );

   writeln( outlinkup, locname );
   writeln( outlinkup, lenname );
   if all_bit then
      writeln( outlinkup, '/ALL' )
   else
      writeln( outlinkup, '/NRM' );

   reset( outlinkup );

   readln( outlinkup, buffer );

   WHILE ( Substr(buffer,1,4) <> 'QUIT' ) DO
   BEGIN
      writeln( buffer );
      readln( outlinkup, buffer );
   END;

   close( outlinkup );

END;

PROCEDURE net_read;

VAR
   locbuff : packed array [1..4] of char;

BEGIN

   open( inlinkup, 'SYS$NET',
		history := old,
		access_method	  := sequential,
		carriage_control  := none);

   reset( inlinkup );

   readln( inlinkup, sendname );
   readln( inlinkup, snd_name );
   readln( inlinkup, locbuff  );

   if locbuff = '/ALL' then
      all_bit := true
   else
      all_bit := false;

   rewrite( inlinkup );

END;

PROCEDURE local_mail;

BEGIN

   if myname = sendname then my_bit := true;

   open(Mailfile, file_name        := 'NEWMAIL',
               history          := OLD,
               access_method    := KEYED,
               record_type      := VARIABLE, 
               carriage_control := NONE,
               organization     := INDEXED, 
               disposition      := SAVE,
               error            := CONTINUE,
               sharing          := READWRITE);

   reset(Mailfile);

   findit := 1;

   FINDK(Mailfile, 0, sendname, eql, error := CONTINUE);

   while (not UFB(Mailfile)) and (findit = 1) do
      BEGIN

         username  := Mailfile^.usrname;
         nummsg    := ord(Mailfile^.num_msg);
   
         if sendname = username then
         BEGIN

            findit := 0;
            if nummsg = 0 then
               writeln(username:snd_name, ' has no new mail messages.')
               else if nummsg < 10 then
                  BEGIN
                       write( username:snd_name, ' has ', nummsg:1);
                       if nummsg = 1 then
                            writeln(' unread mail message.')
                       else writeln(' unread mail messages.');
                  END
                  else if nummsg < 100 then
                        BEGIN
                            write( username:snd_name, ' has ', nummsg:2);
                            writeln(' unread mail messages.');
                        END
                        else if nummsg < 1000 then
                              BEGIN
                                 write( username:snd_name, ' has ', nummsg:3);
                                 writeln(' unread mail messages.');
                              END;

               dir_return := get_dir;

               END
            else get(Mailfile);

         END;

   close(Mailfile);

   if (full_bit or all_bit) and (nummsg > 0) then
   BEGIN

            whereami( sendname, snd_name, def_dev, dev_len, 
				def_drty, def_len, return);

            get_mail_file;

            open(MailData, name_file,
		  history         := old,
		  access_method   := keyed,
		  organization    := indexed,
		  sharing         := readwrite,
		  disposition     := save,
		  record_type     := variable,
		  error           := CONTINUE );

            resetk(Maildata, 1, error := CONTINUE);

            FINDK(Maildata, 1, new_fold, eql, error := CONTINUE);

            writeln;
            write('  From:             ':20 );
            if all_bit or my_bit then
               write('Description:                            ':40);
            writeln( '  Time Sent:  ':14 );
            writeln;

            while not UFB(Maildata) and continue do
            BEGIN

               parse_msg;

               if my_bit or 
                  ((str$position(from_buff, substr(myname,1,Len_name)) <> 0) and
                   (len_frm = Len_name)) then
                  BEGIN
                     write(from_buff:18, '  ':2 );
                     if all_bit or my_bit then
                        write(title_buff:38, '  ':2 );
   
                     sys$asctim( kndex, cur_time, Maildata^.rec_id, lndex);

                     writeln( cur_time:17 );

                     rd_bit := true;

                  END;

               get(Maildata);
               if substr(Maildata^.folder,1,7) <> new_fold then continue := false;

            END;

            if not rd_bit then writeln('  NO MAIL FROM USER:  ', myname );

            close( Maildata );

         END;

END;

PROCEDURE net_mail;

BEGIN

   if myname = sendname then my_bit := true;

   open(Mailfile, file_name        := 'NEWMAIL',
               history          := OLD,
               access_method    := KEYED,
               record_type      := VARIABLE, 
               carriage_control := NONE,
               organization     := INDEXED, 
               disposition      := SAVE,
               error            := CONTINUE,
               sharing          := READWRITE);

   reset(Mailfile);

   findit := 1;

   FINDK(Mailfile, 0, sendname, eql, error := CONTINUE);

   while (not UFB(Mailfile)) and (findit = 1) do
      BEGIN

         username  := Mailfile^.usrname;
         nummsg    := ord(Mailfile^.num_msg);
   
         if sendname = username then
         BEGIN

            findit := 0;
            if nummsg = 0 then
               writeln(inlinkup, username:snd_name, ' has no new mail messages.')
               else if nummsg < 10 then
                  BEGIN
                       write(inlinkup, username:snd_name, ' has ', nummsg:1);
                       if nummsg = 1 then
                            writeln(inlinkup, ' unread mail message.')
                       else writeln(inlinkup, ' unread mail messages.');
                  END
                  else if nummsg < 100 then
                        BEGIN
                            write(inlinkup, username:snd_name, ' has ', nummsg:2);
                            writeln(inlinkup, ' unread mail messages.');
                        END
                        else if nummsg < 1000 then
                              BEGIN
                                 write(inlinkup, username:snd_name, ' has ', nummsg:3);
                                 writeln(inlinkup, ' unread mail messages.');
                              END;

               dir_return := get_dir;

               END
            else get(Mailfile);

         END;

   close(Mailfile);

   if all_bit and (nummsg > 0) then
   BEGIN

            whereami( sendname, snd_name, def_dev, dev_len, 
				def_drty, def_len, return);

            get_mail_file;
   
            open(MailData, name_file,
		  history         := old,
		  access_method   := keyed,
		  organization    := indexed,
		  sharing         := readwrite,
		  disposition     := save,
		  record_type     := variable,
		  error           := CONTINUE );

            resetk(Maildata, 1, error := CONTINUE);

            FINDK(Maildata, 1, new_fold, eql, error := CONTINUE);

            writeln(inlinkup);
            write(inlinkup, '  From:             ':20 );
            if all_bit or my_bit then
               write(inlinkup, 'Description:                            ':40);
            writeln(inlinkup,  '  Time Sent:  ':14 );
            writeln(inlinkup);

            while not UFB(Maildata) and continue do
            BEGIN

               parse_msg;

               if my_bit or 
                  ((str$position(from_buff, substr(myname,1,Len_name)) <> 0) and
                   (len_frm = Len_name)) then
                  BEGIN
                     write(inlinkup, from_buff:18, '  ':2 );
                     if all_bit or my_bit then
                        write(inlinkup, title_buff:38, '  ':2 );
   
                     sys$asctim( kndex, cur_time, Maildata^.rec_id, lndex);

                     writeln(inlinkup,  cur_time:17 );

                     rd_bit := true;

                  END;

               get(Maildata);
               if substr(Maildata^.folder,1,7) <> new_fold then continue := false;

            END;

            if not rd_bit then writeln(inlinkup, '  NO MAIL FROM USER:  ', myname );

            close( Maildata );

         END;

writeln(inlinkup, 'QUIT');

END;

{******************************}
{	Main calling program.  }
{******************************}

BEGIN

   whoami( passname, myacct, Len_name );

   myname := passname;
   str$trim( myname, substr(myname,1,Len_name), Len_name );

   if check_net then
      net_bit := true
   else
      net_bit := false;

   if net_bit then
      net_read
   else
      local_read;

   if not net_bit then
      loc_node := str$position(sendname, '::' );

   if loc_node <> 0 then
      network
   else
      if net_bit then
         net_mail
      else
         local_mail;

   if net_bit then
      close( inlinkup );

END.
