      PROGRAM READDATA
C************************************************************************
C **  PROGRAM AUTHOR:       ELAINE FRAHLMAN
C 
C **  PROGRAM DESCRIPTION:  READDATA.FOR READS THE SYMBOLS.DAT DATA 
C **                        DATA FILE PLACES IT IN COMMON.
C
C **  READDATA.FOR DICTIONARY
C **  -----------------------
C **  DEF                   DEFINITION OF A SYMBOL OR A LOGICAL
          CHARACTER DEF(132)*132
C **  I                     COUNTER FOR DO LOOP
          INTEGER   I
C **  LENGTH1               THE LENGTH OF A SYMBOL OR A LOGICAL
          INTEGER   LENGTH1(500)
C **  LENGTH2               THE LENGTH OF THE DEFINITION
          INTEGER   LENGTH2(500)
C **  M                     COUNTER FOR DO LOOP
          INTEGER   M
C **  STAT                  STATUS OF THE INPUT FILE
          INTEGER   STAT
C **  SYM                   SYMBOL OR LOGICAL NAME
          CHARACTER SYM(500)*32
C **  TOTAL                 TOTAL NUMBER OF SYMBOLS AND LOGICALS
          INTEGER   TOTAL
C **  STYPE                  INDICATES IF THE DEFINITION IS A SYMBOL
C **                        OR A LOGICAL
          CHARACTER STYPE(500)*1
C
C*****************************************************************************
C
C **  INDICATE THE VARIABLES: STYPE, TOTAL, SYM, DEF, LENGTH1 AND LENGTH2
C **  ARE TO BE SHARED IN COMMON.
C
      COMMON  /SYM_DATA/ TOTAL, LENGTH1, LENGTH2, STYPE, SYM, DEF
C
C **  OPEN THE INPUT FILE
C
      OPEN (UNIT=8,FILE='SYS_SYMS',IOSTAT=STAT,STATUS='OLD')
C
C **  IF THE STATUS OF THE INPUT FILE IS GOOD THEN
C
      IF (STAT .EQ. 0) THEN
C
C **    INITIALIZE VARIABLES
C
        I = 1
        DO 10 M = 1,500
          STYPE(M) = ' '
          SYM(M) = ' '
          DEF(M) = ' '
          LENGTH1(M) = 0
          LENGTH2(M) = 0
10      CONTINUE
C
C **    READ THE INPUT FILE
C
20      READ (8,100,ERR=888,END=999) STYPE(I), LENGTH1(I), LENGTH2(I)
          READ (8,200,ERR=888) SYM(I)
          READ (8,300,ERR=888) DEF(I)
          I = I + 1
        GO TO 20
C
C **    SEND ERROR MESSAGE IF UNABLE TO READ
C
888     TYPE *,' ERROR - UNABLE TO READ THE SYMBOLS.DAT INPUT FILE'
C 
C **    STORE TOTAL NUMBER OF SYMBOLS AND LOGICALS
C
999     TOTAL = I - 1
C
C *   ELSE, INPUT FILE CANNOT BE OPENED
C
      ELSE
        TYPE *,' ERROR, CANNOT OPEN THE INPUT FILE SYMBOLS.DAT'
C
C **  END OF STATUS CONDITION
C
      ENDIF
100   FORMAT (A1,1X,I3,1X,I3)
200   FORMAT (A32) 
300   FORMAT (A132)
      END 
