	SUBROUTINE AD1_ASYNCH()
C
C **************************************************************************
C **  PROGRAM AUTHOR:       WILLIAM BAKER
C 
C **  PROGRAM DESCRIPTION:  STARTS GATHERING DATA FOR AXA0: DEVICE
C ** 
C
C **  AD1_ASYNCH 
C     -----------
C
	INCLUDE	'LIB3:[ADDASYS.SOURCE]ADDA_DATA_SHR.INC'
C
	INCLUDE	'LIB3:[ADDASYS.SOURCE]ADDA_DATA_MAP.INC'
C
C Go!
C       Enqueue the buffer.  This will start the A/D
C       When the buffer is filled, it will be passed to the AST routine.
C
C
	TYPE *, 'ENQUEUE FOR DEVICE AD1...'
C
        CALL AD1_ENQS( ADDA_ID(1), AD1_NMBR, AD1_BUFFER )
C
	RETURN
	END
C
	SUBROUTINE AD2_ASYNCH()
C
C **************************************************************************
C **  PROGRAM AUTHOR:       WILLIAM BAKER
C 
C **  PROGRAM DESCRIPTION:  STARTS GATHERING DATA FOR AXB0: DEVICE
C ** 
C
C **  AD2_ASYNCH 
C     -----------
C
	INCLUDE	'LIB3:[ADDASYS.SOURCE]ADDA_DATA_SHR.INC'
C
	INCLUDE	'LIB3:[ADDASYS.SOURCE]ADDA_DATA_MAP.INC'
C
C Go!
C       Enqueue the buffer.  This will start the A/D
C       When the buffer is filled, it will be passed to the AST routine.
C
C
	TYPE *, 'ENQUEUE FOR DEVICE AD2...'
C
        CALL AD1_ENQS( ADDA_ID(2), AD2_NMBR, AD2_BUFFER )
C
	RETURN
	END
C
	SUBROUTINE AD2_AST( status, device_ID, buff, buff_len, data_len,
     &				buffer_ix, dev_spec)
C
C **************************************************************************
C **  PROGRAM AUTHOR:       WILLIAM BAKER
C 
C **  PROGRAM DESCRIPTION:  CONTINUES GATHERING DATA FOR AXB0: DEVICE
C ** 			    MOVES DATA TO STORAGE BUFFER FOR FILING.
C
C **  AD2_AST
C     -----------
C
C dummy parameter declarations
C       They are similar to the parameters in the LIO$DEQUEUE call.
C
        INTEGER status          !status of the I/O operation
        INTEGER device_ID       !ID of device that finished the buffer
        INTEGER*2 buff(*)       !the buffer (NOT its address as in LIO$DEQUEUE)
        INTEGER buff_len      !length of the buffer (in bytes)
        INTEGER data_len        !length of the data in the buffer (in bytes)
        INTEGER buffer_ix       !buffer index (if any supplied in LIO$ENQUEUE)
        INTEGER dev_spec        !device specific parameter (not used by AXV)
C
	INCLUDE 'SYS$SHARE:LIOSET.FOR'
C
	INCLUDE	'LIB3:[ADDASYS.SOURCE]ADDA_DATA_SHR.INC'
C
	INCLUDE	'LIB3:[ADDASYS.SOURCE]ADDA_DATA_MAP.INC'
C
C AST routine that processes buffers as they are finished by the AXV
C
C Process each buffer as it finishes and requeue it.
	TYPE *,' AD2 AST ROUTINE ENTRY...'
	AD2_PNTR = AD2_PNTR + 1
C
	IF (CUR_PNTR2 .EQ. 1) THEN
		DO KK = 1,AD2_NMBR
			II = AD2_CHAN(KK) + 1
			AD2_DATA1(AD2_PNTR,II) = BUFF(KK)
		ENDDO
	ELSE
		DO KK = 1,AD2_NMBR
			II = AD2_CHAN(KK) + 1
			AD2_DATA2(AD2_PNTR,II) = BUFF(KK)
		ENDDO
	ENDIF
C
	CALL ADDA_TIMER( 2, CUR_PNTR2, AD2_PNTR )
C
	IF (AD2_PNTR .EQ. 120) THEN
		PRV_PNTR2 = CUR_PNTR2
		IF (CUR_PNTR2 .EQ. 1) THEN
			CUR_PNTR2 = 2
		ELSE
			CUR_PNTR2 = 1
		ENDIF
		AD2_PNTR = 0
		CALL FILE_DATA( 2, PRV_PNTR2, 2 )
	ENDIF
C
	STATUS = LIO$ENQUEUE( DEVICE_ID, BUFF, BUFFER_LEN,,,,LIO$K_INPUT )
                IF(.NOT. STATUS)         CALL LIB$SIGNAL(%VAL(STATUS))

        RETURN
        END
C
	SUBROUTINE AD1_AST( status, device_ID, buff, buff_len, data_len,
     &				buffer_ix, dev_spec)
C
C **************************************************************************
C **  PROGRAM AUTHOR:       WILLIAM BAKER
C 
C **  PROGRAM DESCRIPTION:  CONTINUES GATHERING DATA FOR AXA0: DEVICE
C ** 			    MOVES DATA TO STORAGE BUFFER FOR FILING.
C
C **  AD1_AST
C     -----------
C
C dummy parameter declarations
C       They are similar to the parameters in the LIO$DEQUEUE call.
C
        INTEGER status          !status of the I/O operation
        INTEGER device_ID       !ID of device that finished the buffer
        INTEGER*2 buff(*)       !the buffer (NOT its address as in LIO$DEQUEUE)
        INTEGER buff_len      !length of the buffer (in bytes)
        INTEGER data_len        !length of the data in the buffer (in bytes)
        INTEGER buffer_ix       !buffer index (if any supplied in LIO$ENQUEUE)
        INTEGER dev_spec        !device specific parameter (not used by AXV)
C
	INCLUDE 'SYS$SHARE:LIOSET.FOR'
C
	INCLUDE	'LIB3:[ADDASYS.SOURCE]ADDA_DATA_SHR.INC'
C
	INCLUDE	'LIB3:[ADDASYS.SOURCE]ADDA_DATA_MAP.INC'
C
C AST routine that processes buffers as they are finished by the AXV
C
C Process each buffer as it finishes and requeue it.
	TYPE *,' AD1 AST ROUTINE ENTRY...'
	AD1_PNTR = AD1_PNTR + 1
C
	IF (CUR_PNTR1 .EQ. 1) THEN
		DO KK = 1,AD1_NMBR
			II = AD1_CHAN(KK) + 1
			AD1_DATA1(AD1_PNTR,II) = BUFF(KK)
		ENDDO
	ELSE
		DO KK = 1,AD1_NMBR
			II = AD1_CHAN(KK) + 1
			AD1_DATA2(AD1_PNTR,II) = BUFF(KK)
		ENDDO
	ENDIF
C
	CALL ADDA_TIMER( 1, CUR_PNTR1, AD2_PNTR )
C
	IF (AD1_PNTR .EQ. 120) THEN
		PRV_PNTR1 = CUR_PNTR1
		IF (CUR_PNTR1 .EQ. 1) THEN
			CUR_PNTR1 = 2
		ELSE
			CUR_PNTR1 = 1
		ENDIF
		AD1_PNTR = 0
		CALL FILE_DATA( 1, PRV_PNTR1, 1 )
	ENDIF
C
	STATUS = LIO$ENQUEUE( DEVICE_ID, BUFF, BUFFER_LEN,,,,LIO$K_INPUT )
                IF(.NOT. STATUS)         CALL LIB$SIGNAL(%VAL(STATUS))

        RETURN
        END
C
	SUBROUTINE CLK_AST( device_ID )
C
C **************************************************************************
C **  PROGRAM AUTHOR:       WILLIAM BAKER
C 
C **  PROGRAM DESCRIPTION:  ACTIVATION UPON EVERY CLOCK TIC.
C ** 
C
C **  CLK_AST
C     -----------
C
C dummy parameter declarations
C       They are similar to the parameters in the LIO$DEQUEUE call.
C
        INTEGER		STATUS, BUF1_PNTR, BUF2_PNTR
        INTEGER		DEVICE_id, DATA_LEN1, DATA_LEN2
	LOGICAL AD1_FILE
C
	INCLUDE 'SYS$SHARE:LIOSET.FOR'
C
	INCLUDE	'LIB3:[ADDASYS.SOURCE]ADDA_DATA_SHR.INC'
C
	INCLUDE	'LIB3:[ADDASYS.SOURCE]ADDA_DATA_MAP.INC'
C
C AST routine that processes buffers as they are finished by the AXV'S
C
	TYPE *,' CLK AST ROUTINE ENTRY...'
C
	AD1_FILE = .FALSE.
C
	IF (AD1_CLK) THEN
C
		CALL AD1_ASYNCH
C
	        STATUS = LIO$DEQUEUE(ADDA_ID(1), BUF1_PNTR, AD1_BUFFLEN,
     1          	DATA_LEN1, 1, , LIO$K_INPUT )
                IF(.NOT. STATUS)         CALL LIB$SIGNAL(%VAL(STATUS))
C
		AD1_PNTR = AD1_PNTR + 1
C
		IF (CUR_PNTR1 .EQ. 1) THEN
			DO KK = 1,AD1_NMBR
				II = AD1_CHAN(KK) + 1
				AD1_DATA1(AD1_PNTR,II) = AD1_BUFFER(KK)
			ENDDO
		ELSE
			DO KK = 1,AD1_NMBR
				II = AD1_CHAN(KK) + 1
				AD1_DATA2(AD1_PNTR,II) = AD1_BUFFER(KK)
			ENDDO
		ENDIF
C
	ENDIF
C
	IF (AD2_CLK) THEN
C
		CALL AD2_ASYNCH
C
	        STATUS = LIO$DEQUEUE(ADDA_ID(1), BUF1_PNTR, AD1_BUFFLEN,
     1          	DATA_LEN1, 1, , LIO$K_INPUT )
                IF(.NOT. STATUS)         CALL LIB$SIGNAL(%VAL(STATUS))
C
		AD2_PNTR = AD2_PNTR + 1
C
		IF (CUR_PNTR2 .EQ. 1) THEN
			DO KK = 1,AD2_NMBR
				II = AD2_CHAN(KK) + 1
				AD2_DATA1(AD2_PNTR,II) = AD2_BUFFER(KK)
			ENDDO
		ELSE
			DO KK = 1,AD2_NMBR
				II = AD2_CHAN(KK) + 1
				AD2_DATA2(AD2_PNTR,II) = AD2_BUFFER(KK)
			ENDDO
		ENDIF
C
	ENDIF
C
	CALL ADDA_TIMER( 1, CUR_PNTR1, AD1_PNTR )
	CALL ADDA_TIMER( 2, CUR_PNTR2, AD2_PNTR )
C
	CALL ASYNCH_OUT
C
	IF (AD1_CLK) THEN
C
		IF (AD1_PNTR .EQ. 120) THEN
			PRV_PNTR1 = CUR_PNTR1
			IF (CUR_PNTR1 .EQ. 1) THEN
				CUR_PNTR1 = 2
			ELSE
				CUR_PNTR1 = 1
			ENDIF
			AD1_PNTR = 0
			AD1_FILE = .TRUE.
		ENDIF
C
	ENDIF
C
	IF (AD2_CLK) THEN
C
		IF (AD2_PNTR .EQ. 120) THEN
			PRV_PNTR2 = CUR_PNTR2
			IF (CUR_PNTR2 .EQ. 1) THEN
				CUR_PNTR2 = 2
			ELSE
				CUR_PNTR2 = 1
			ENDIF
			AD2_PNTR = 0
			CALL FILE_DATA( 2, PRV_PNTR2, 1 )
		ENDIF
C
	ENDIF
C
	IF (AD1_FILE) CALL FILE_DATA( 1, PRV_PNTR1, 1 )
C
        RETURN
        END

	SUBROUTINE AD1_ENQS( DEVICE_ID, NCHNL, AD1)
C
C **************************************************************************
C **  PROGRAM AUTHOR:       WILLIAM BAKER
C 
C **  PROGRAM DESCRIPTION:  DEFINES CHANNELS TO A/D CONVERTER.
C **                        
C
C **  ADDA_CHNLDEF.FOR
C     -----------------------
C
	INTEGER*4	STATUS, NCHNL, DEVICE_ID, BUFF_LEN
	INTEGER*2	AD1(NCHNL)
C
	INCLUDE 'SYS$SHARE:LIOSET.FOR'
C
	BUFF_LEN = NCHNL * 2
C
        STATUS = LIO$ENQUEUE( DEVICE_ID, AD1, BUFF_LEN, , , , LIO$K_INPUT )
                IF ( .NOT. STATUS )         CALL LIB$SIGNAL(%VAL(STATUS))
C
	RETURN
	END

	SUBROUTINE AD2_ENQS( DEVICE_ID, NCHNL, AD2)
C
C **************************************************************************
C **  PROGRAM AUTHOR:       WILLIAM BAKER
C 
C **  PROGRAM DESCRIPTION:  DEFINES CHANNELS TO A/D CONVERTER.
C **                        
C
C **  ADDA_CHNLDEF.FOR
C     -----------------------
C
	INTEGER*4	STATUS, NCHNL, DEVICE_ID, BUFF_LEN
	INTEGER*2	AD2(NCHNL)
C
	INCLUDE 'SYS$SHARE:LIOSET.FOR'
C
	BUFF_LEN = NCHNL * 2
C
        STATUS = LIO$ENQUEUE( DEVICE_ID, AD2, BUFF_LEN, , , , LIO$K_INPUT )
                IF ( .NOT. STATUS )         CALL LIB$SIGNAL(%VAL(STATUS))
C
	RETURN
	END
