	PROGRAM    ADDA_DEFINE
C
C **************************************************************************
C **  PROGRAM AUTHOR:       WILLIAM BAKER
C 
C **  PROGRAM DESCRIPTION:  CREATES DEFINITION OF TEST SETTINGS FOR
C ** 			    THE WRITE_CONFIG ROUTINE TO WRITE.
C
C **  ADDA_DEFINE
C     -----------
C
	STRUCTURE /AD_LIST/
		UNION
			MAP
				INTEGER*4	CHAN_NUM
				INTEGER*4	CHAN_GAIN
				CHARACTER*72	CHAN_DSCR
			END MAP
		END UNION
	END STRUCTURE
C
	STRUCTURE /DA_LIST/
		UNION
			MAP
				INTEGER*4	CHAN_NUM
				CHARACTER*72	CHAN_DSCR
				INTEGER*4	CHAN_DEVICE
				INTEGER*4	CHAN_FROM
			END MAP
		END UNION
	END STRUCTURE
C
	RECORD /AD_LIST/ AD_CHNL(16)
C
	RECORD /DA_LIST/ DA_CHNL(2)
C
	LOGICAL		USE_CLOCK, AD_CLOCK
C
	INTEGER*4	AD_NMBER, DA_NMBER
C
	INTEGER*4	TYP_TRGGR
	INTEGER*4	CLK_SOURCE
	INTEGER*4	CLK_DIVIDER
	REAL*4		CLK_RATE
C
C
	CHARACTER*4	DEVICE, AD_IN
C
	COMMON /CLOCK/ CLK_RATE, CLK_DIVIDER, CLK_SOURCE
C
	CALL LIB$GET_FOREIGN(AD_IN,'Device 1 or 2?  ',LEN_AD)
	CALL STR$TRIM(AD_IN, AD_IN(1:LEN_AD), LEN_AD)
C
	DECODE(LEN_AD,250,AD_IN) IDEV
250	FORMAT(I<LEN_AD>)
C
	IF ((IDEV .EQ. 1) .OR. (IDEV .EQ. 2)) THEN
		IF (IDEV .EQ. 1) DEVICE = 'AXA0'
		IF (IDEV .EQ. 2) DEVICE = 'AXB0'
	ENDIF
C
5010	TYPE *, ' '
	TYPE *, ' '
	TYPE *, '	WILL THE KWV11-C CLOCK BE USED?'
	TYPE *, ' '
	TYPE *, '		THE KWV11-C CLOCK CAN BE USED IN TWO MANNERS:'
	TYPE *, ' '
	TYPE *, '			<1> HARDWARE DATA TRIGGER, OR'
	TYPE *, ' '
	TYPE *, '			<2> INTERNAL SOFTWARE TIMER.'
	TYPE *, ' '
	TYPE *, '		IF EITHER OF THE ABOVE 2 SITUATIONS ARE TRUE'
	TYPE *, '		THEN ENTER AS FOLLOWS:'
	TYPE *, ' '
	TYPE *, '			ENTER <1> FOR YES WITH HARDWARE TRIGGER, OR'
	TYPE *, '			ENTER <2> FOR YES AS SOFTWARE TIMER, OR'
	TYPE *, '			ENTER <3> FOR NO, CLOCK NOT USED AT ALL.'
	TYPE *, ' '
	WRITE(6,2010)
2010	FORMAT('$			ENTER CHOICE:  ')
	READ(5,8000) ICHC
8000	FORMAT(I1)
C
	IF ((ICHC .EQ. 1) .OR. (ICHC .EQ. 2) .OR. (ICHC .EQ. 3)) THEN
		AD_CLOCK  = .FALSE.
		IF ((ICHC .EQ. 1) .OR. (ICHC .EQ. 2)) USE_CLOCK = .TRUE.
		IF (ICHC .EQ. 1) AD_CLOCK  = .TRUE.
		IF (ICHC .EQ. 3) USE_CLOCK = .FALSE.
	ELSE
		GOTO 5010
	ENDIF
C
	IF (USE_CLOCK) THEN
C
5850		CLK_DIVIDER = 1
		CLK_SOURCE  = 0
		CLK_RATE    = 100.0
C
C
5020	TYPE *, ' '
	TYPE *, ' '
	TYPE *, '	SINCE YOU ARE USING THE KWV11-C CLOCK YOU MUST TELL'
	TYPE *, '	THE PROGRAM AT WHAT CLOCK RATE TO RUN AT.  YOU CAN:'
	TYPE *, ' '
	TYPE *, '			<1> SPECIFY A CLOCK RATE, OR'
	TYPE *, ' '
	TYPE *, '			<2> DEFINE A CRYSTAL SOURCE AND A DIVIDER.'
	TYPE *, ' '
	TYPE *, '		ENTER AS FOLLOWS:'
	TYPE *, ' '
	TYPE *, '			ENTER <1> FOR A 1MHZ Crystal Source.'
	TYPE *, '			ENTER <2> FOR A 100 kHZ Crystal Source.'
	TYPE *, '			ENTER <3> FOR A 10 kHZ Crystal Source.'
	TYPE *, '			ENTER <4> FOR A 1 kHZ Crystal Source.'
	TYPE *, '			ENTER <5> FOR A 100 HZ Crystal Source.'
	TYPE *, '			ENTER <6> FOR A Schmitt Trigger Source.'
	TYPE *, '			ENTER <7> FOR A 60 HZ Line Frequency Source.'
	TYPE *, '			ENTER <9> TO Enter your desired rate directly.'
	TYPE *, ' '
		WRITE(6,2020)
2020		FORMAT('$			ENTER CHOICE:  ')
		READ(5,8000) ICHC
C
		IF ((ICHC .EQ. 1) .OR. (ICHC .EQ. 2) .OR. (ICHC .EQ. 3) .OR. (ICHC .EQ. 4) .OR. (ICHC .EQ. 5) .OR. (ICHC .EQ. 6) 
     &				  .OR. (ICHC .EQ. 7) .OR. (ICHC .EQ. 9)) THEN
C
			CLK_DIVIDER = 1
			IF (ICHC .LE. 7) CLK_SOURCE = ICHC
			IF (ICHC .LE. 5) THEN
C
	TYPE *, ' '
	TYPE *, ' '
	TYPE *, '			ENTER AN INTEGER DIVIDER FOR YOUR CLOCK SOURCE:'
	TYPE *, '				( DEFAULT DIVIDER IS 1 )'
	TYPE *, ' '
				WRITE(6,2023)
2023	FORMAT('$			ENTER DIVIDER:  ')
				IDIV = 0
				READ(5,*) IDIV
				IF (IDIV .NE. 0) CLK_DIVIDER = IDIV
			ENDIF
C
			IF (ICHC .EQ. 9) THEN
	TYPE *, ' '
	TYPE *, ' '
	TYPE *, '		ENTER A REAL NUMBER CLOCK RATE.  (USE DECIMAL POINT)'
	TYPE *, '			   ( DEFAULT NUMBER IS 100. HERTZ )'
	TYPE *, ' '
				WRITE(6,2026)
2026		FORMAT('$			ENTER CLOCK RATE:  ')
				RATE = 100.0
				READ(5,*) RATE
				IF (RATE .NE. 100.0) CLK_RATE = RATE
			ENDIF
C
		ELSE
			GOTO 5020
		ENDIF
C
5800		CALL DET_CLOCK
C
	TYPE *, ' '
	TYPE *, '	IS THIS CLOCK RATE ACCEPTABLE TO YOU?'
	TYPE *, ' '
	TYPE *, '		ENTER <1> FOR YES.'
	TYPE *, '		ENTER <2> FOR NO.'
	TYPE *, ' '

		WRITE(6,2800)
2800	FORMAT('$			ENTER ANSWER:  ')
				IANS = 1
				READ(5,*) IANS
C
				IF ((IANS .NE. 1) .AND. (IANS .NE. 2)) GOTO 5800
				IF (IANS .EQ. 2) THEN
	TYPE *, ' '
	TYPE *, '	SINCE YOU ANSWERED NO TO THE ABOVE QUESTION ABOUT THE'
	TYPE *, '	CLOCK RATE, I WIL RETURN YOU TO THE SERIES OF QUESTIONS'
	TYPE *, '	RELATING TO SETTING THE CLOCK RATE.'
	TYPE *, ' '
					GOTO 5850
				ENDIF
C
	ENDIF
C
	IF (USE_CLOCK) THEN
C
5030	TYPE *, ' '
	TYPE *, ' '
	TYPE *, '	SELECT FROM ONE OF THE FOLLOWING CLOCK TRIGGERS.'
	TYPE *, ' '
	TYPE *, '		<1>  IMMEDIATE START BURST.  (STARTS ON FIRST READ)'
	TYPE *, '		<3>  CLOCK BURST.  (MOVES FULL BUFFER EACH TRIGGER)'
	TYPE *, '		<5>  CLOCK SWEEP.  (SWEEPS CHANNELS ON EACH TRIGGER)'
	TYPE *, '		<7>  CLOCK POINT.  (ONE CHANNEL ON EACH TRIGGER)'
	TYPE *, ' '
	TYPE *, ' '
		WRITE(6,2020)
		READ(5,8000) ICHC
		IF ((ICHC .EQ. 1) .OR. (ICHC .EQ. 3) .OR. (ICHC .EQ. 5) .OR. (ICHC .EQ. 7)) THEN
			TYP_TRGGR = ICHC
		ELSE
			GOTO 5030
		ENDIF
	ELSE
C
5040	TYPE *, ' '
	TYPE *, ' '
	TYPE *, '	SELECT FROM ONE OF THE FOLLOWING EXTERNAL TRIGGERS.'
	TYPE *, ' '
	TYPE *, '		<1>  IMMEDIATE START BURST.  (STARTS ON FIRST READ)'
	TYPE *, '		<2>  EXTERNAL BURST.  (MOVES FULL BUFFER EACH TRIGGER)'
	TYPE *, '		<4>  EXTERNAL SWEEP.  (SWEEPS CHANNELS ON EACH TRIGGER)'
	TYPE *, '		<6>  EXTERNAL POINT.  (ONE CHANNEL ON EACH TRIGGER)'
	TYPE *, ' '
	TYPE *, ' '
		WRITE(6,2020)
		READ(5,8000) ICHC
		IF ((ICHC .EQ. 1) .OR. (ICHC .EQ. 2) .OR. (ICHC .EQ. 4) .OR. (ICHC .EQ. 6)) THEN
			TYP_TRGGR = ICHC
		ELSE
			GOTO 5040
		ENDIF
	ENDIF
C
5050	TYPE *, ' '
	TYPE *, ' '
	TYPE *, '	HOW MANY A/D CHANNELS WILL YOU BE USING ON DEVICE:  ',DEVICE
	TYPE *, '		(MIN = 0, MAX = 16)'
	TYPE *, ' '
	WRITE(6,2050)
2050	FORMAT('$			ENTER NUMBER:  ')
	READ(5,*) IAD
C
	IF ((IAD .GE. 0) .AND. (IAD .LE. 16)) THEN
		AD_NMBER = IAD
	ELSE
		GOTO 5050
	ENDIF
C
5060	TYPE *, ' '
	TYPE *, ' '
	TYPE *, '	HOW MANY D/A CHANNELS WILL YOU BE USING ON DEVICE:  ',DEVICE
	TYPE *, '		(MIN = 0, MAX = 2)'
	TYPE *, ' '
	WRITE(6,2050)
	READ(5,*) IAD
C
	IF ((IAD .GE. 0) .AND. (IAD .LE. 2)) THEN
		DA_NMBER = IAD
	ELSE
		GOTO 5060
	ENDIF
C
	IF ((DA_NMBER .EQ. 0) .AND. (AD_NMBER .EQ. 0)) THEN
		TYPE *, ' '
		TYPE *, ' '
		TYPE *, ' '
		TYPE *, ' '
		TYPE *, '	WHY DID YOU BOTHER?'
		TYPE *, ' '
		TYPE *, ' '
		TYPE *, ' '
		TYPE *, ' '
		GOTO 5050
	ENDIF
C
	IPRV = 0
C
	DO II = 1,16
		AD_CHNL(II).CHAN_NUM = II - 1
		AD_CHNL(II).CHAN_GAIN = -9
		AD_CHNL(II).CHAN_DSCR = 'NOT USED BY THIS TEST.'
	ENDDO
C
	MAX_CHAN = 0
	MIN_CHAN = 16
C

	IF (AD_NMBER .GT. 0) THEN
		DO II = 1,AD_NMBER
C
	TYPE *, ' '
	TYPE *, '		BE PREPARED TO ENTER THE FOLLOWING FOR EACH A/D CHANNEL:'
	TYPE *, ' '
	TYPE *, '			CHANNEL NUMBER,		(0 - 15)'
	TYPE *, '			CHANNEL DESCRIPTION.    (72 Char)'
	TYPE *, ' '
	TYPE *, ' '
	TYPE *, ' '
C
5200			WRITE(6,2200)
2200	FORMAT('$	ENTER CHANNEL NUMBER:    ')
			READ(5,*) ICHN
			IF ((ICHN .LT. 0) .AND. (ICHN .GT. 15)) THEN
				TYPE *, ' '
				TYPE *, 'RE-ENTER THE CHANNEL NUMBER.'
				TYPE *, ' '
				GOTO 5200
			ENDIF
			AD_CHNL(ICHN+1).CHAN_NUM = ICHN
C
			IF (MAX_CHAN .LT. ICHN) MAX_CHAN = ICHN
			IF (MIN_CHAN .GT. ICHN) MIN_CHAN = ICHN
C
			AD_CHNL(ICHN+1).CHAN_DSCR = ' '
5240			WRITE(6,2240)
2240	FORMAT('$	ENTER CHANNEL DESCRIPT:  ')
			READ(5,2260) LLEN, AD_CHNL(ICHN+1).CHAN_DSCR(1:LLEN)
2260	FORMAT(Q,A<LLEN>)
C
	TYPE *, ' '
	TYPE *, ' '
	TYPE *, ' ##  CH#  DESCRIPTION:'
			WRITE(6,3000)	(KK, AD_CHNL(KK).CHAN_NUM, 
     &					AD_CHNL(KK).CHAN_DSCR(1:60), 
     &					KK=(MIN_CHAN+1),(MAX_CHAN+1))
3000			FORMAT(1X,I2,2X,I2,2X,A60)
C
		ENDDO
C
	TYPE *, ' '
	TYPE *, ' '
	TYPE *, '		ANY CHANNELS SHOW AS:  NOT USED BY THIS TEST'
	TYPE *, ' '
	TYPE *, '		MUST BE JUMPERED TO GROUND BEFORE THE TEST BEGINS.'
	TYPE *, ' '
	TYPE *, ' '
	TYPE *, ' '
	TYPE *, '		BE PREPARED TO ENTER THE A/D CHANNEL GAIN TO BE USED.'
	TYPE *, ' '
	TYPE *, ' '
	TYPE *, '		SINCE THE INTERFACE IN USE IS OF TYPE ASYNCHRONOUS,'
	TYPE *, '		THE VALUE FOR GAIN DEFAULTS TO THE VALUE GIVEN FOR'
	TYPE *, '		THE LOWEST CHANNEL ENTERED.  THE REMAINING CHANNEL'
	TYPE *, '		GAINS ARE SET IDENTICLE TO THE LOWEST CHANNEL.'
	TYPE *, ' '
C
5220			WRITE(6,2220)
2220	FORMAT('$	ENTER CHANNEL GAIN:      ')
			READ(5,*) IGN
			IF (IGN .LE. 0) GOTO 5220
C
			DO II = 1,16
				AD_CHNL(II).CHAN_GAIN = IGN
			ENDDO
C
	ENDIF
C
	AD_NMBER = MAX_CHAN - MIN_CHAN + 1
C
	IPRV = 0
C
	DO II = 1,2
		DA_CHNL(II).CHAN_NUM = 9
		DA_CHNL(II).CHAN_DEVICE = 9
		DA_CHNL(II).CHAN_FROM = 99
		DA_CHNL(II).CHAN_DSCR = 'NOT USED BY THIS TEST.'
	ENDDO
C
	IF (DA_NMBER .GT. 0) THEN
		DO II = 1,DA_NMBER
C
	TYPE *, ' '
	TYPE *, ' '
	TYPE *, ' '
	TYPE *, '		BE PREPARED TO ENTER THE FOLLOWING FOR EACH D/A CHANNEL:'
	TYPE *, ' '
	TYPE *, '			CHANNEL NUMBER,		(0 - 1)'
	TYPE *, '			SOURCE DEVICE,		(1, 2 or 9)'
	TYPE *, '			SOURCE CHANNEL,		(0 - 15)'
	TYPE *, '			CHANNEL DESCRIPTION.    (72 Char)'
	TYPE *, ' '
	TYPE *, '		CHANNELS MUST BE ENTERED IN SEQUENTIAL ORDER, FROM'
	TYPE *, '		LOWEST CHANNEL NUMBER TO HIGHEST CHANNEL NUMBER.'
	TYPE *, ' '
C
5400			WRITE(6,2400)
2400	FORMAT('$	ENTER CHANNEL NUMBER:    ')
			READ(5,*) ICHN
			IF ((ICHN .LT. 0) .AND. (ICHN .GT. 1)) THEN
				TYPE *, 'RE-ENTER THE CHANNEL NUMBER.'
				GOTO 5400
			ENDIF
			IF (ICHN .LT. IPRV) THEN
				TYPE *, ' '
				TYPE *, 'RE-ENTER THE CHANNEL NUMBER, MUST BE GREATER THAN: ',IPRV
				TYPE *, ' '
				GOTO 5400
			ENDIF
			IPRV = ICHN
			DA_CHNL(II).CHAN_NUM = ICHN
C
5410	TYPE *, ' '
	TYPE *, '	ENTER THE SOURCE DEVICE.  SINCE WE HAVE TWO DEVICES (AXA0 AND AXB0)'
	TYPE *, '	YOU CAN DIRECT THE A/D INPUT FROM EITHER DEVICE TO THE D/A OUTPUT'
	TYPE *, '	ON EITHER DEVICE.  YOU CAN ALSO DESIGNATE THAT A USER PROGRAM WILL'
	TYPE *, '	PROVIDE THE DATA FOR THE D/A OUTPUT CHANNEL BEING CONFIGURED.'
	TYPE *, ' '
	TYPE *, '		ENTER <1> FOR DEVICE AXA0:'
	TYPE *, '		ENTER <2> FOR DEVICE AXB0:'
	TYPE *, ' '
	TYPE *, '		ENTER <9> FOR USER PROGRAM.'
	TYPE *, ' '
C
			WRITE(6,2410)
2410	FORMAT('$	ENTER SOURCE DEVICE:    ')
			READ(5,*) IDEV
			IF ((IDEV .NE. 1) .AND. (IDEV .NE. 2) .AND. (IDEV .NE. 9)) THEN
				TYPE *, ' '
				TYPE *, 'RE-ENTER THE SOURCE DEVICE, INCORRECT VALUE ENTERED.'
				TYPE *, ' '
				GOTO 5410
			ENDIF
			DA_CHNL(II).CHAN_DEVICE = IDEV
C
			IF (IDEV .NE. 9) THEN
C
5420	TYPE *, ' '
	TYPE *, '	ENTER THE SOURCE CHANNEL ON THE SOURCE DEVICE.'
	TYPE *, '	THIS IS THE CHANNEL YOU WISH TO IMMEDIATELY'
	TYPE *, '	REDIRECT ITS VALUE TO THE D/A OUTPUT'
	TYPE *, ' '
C
				WRITE(6,2420)
2420	FORMAT('$	ENTER SOURCE CHANNEL:    ')
				READ(5,*) ICHN
				IF ((ICHN .LT. 0) .AND. (ICHN .GT. 15)) THEN
	TYPE *, ' '
	TYPE *, 'RE-ENTER THE SOURCE CHANNEL, INCORRECT VALUE ENTERED.'
	TYPE *, ' '
					GOTO 5420
				ENDIF
				DA_CHNL(II).CHAN_FROM = ICHN
C
			ENDIF
C
	TYPE *, ' '
			DA_CHNL(II).CHAN_DSCR = ' '
5440			WRITE(6,2440)
2440	FORMAT('$	ENTER CHANNEL DESCRIPTION:  ')
			READ(5,2460) LLEN, DA_CHNL(II).CHAN_DSCR(1:LLEN)
2460	FORMAT(Q,A<LLEN>)
C
	TYPE *, ' '
	TYPE *, ' '
	TYPE *, ' ##  CH# DV# FM# DESCRIPTION:'
			WRITE(6,3050)	(KK, DA_CHNL(KK).CHAN_NUM, DA_CHNL(KK).CHAN_DEVICE, 
     &					DA_CHNL(KK).CHAN_FROM, DA_CHNL(KK).CHAN_DSCR(1:60), KK=1,II)
3050			FORMAT(1X,I2,2X,I2,2X,I2,2X,I2,2X,A60)
C
		ENDDO
C
	ENDIF
C
	TYPE *, ' '
	TYPE *, '	WRITING THE DEFINITION FOR DEVICE:  ',DEVICE
	TYPE *, ' '
C
	OPEN(UNIT=11,	FILE='ADDA_LOAD_FILE',  CARRIAGECONTROL = 'LIST',
     &			TYPE = 'NEW', FORM = 'FORMATTED')
C
	WRITE(11,100) DEVICE
100	FORMAT('%AX=',A4)
C
	IF (USE_CLOCK) THEN
		WRITE(11,700)
700	FORMAT('%CL=T')
	ELSE
		WRITE(11,750)
750	FORMAT('%CL=F')
	ENDIF
C
	IF (AD_CLOCK) THEN
		WRITE(11,800)
800		FORMAT('%AC=T')
	ELSE
		WRITE(11,850)
850		FORMAT('%AC=F')
	ENDIF
C
	WRITE(11,200) CLK_SOURCE, CLK_DIVIDER, CLK_RATE
200	FORMAT('%SR=',I1,2X,'%DI=',I5,2X,'%RT=',F12.2)
C
	WRITE(11,400) AD_NMBER, DA_NMBER, TYP_TRGGR
400	FORMAT('%AN=',I2,2X,'%DN=',I1,2X,'%TR=',I1)
C
	IF (AD_NMBER .GT. 0)
     &		WRITE(11,500) ( AD_CHNL(II).CHAN_NUM,
     &			AD_CHNL(II).CHAN_GAIN,
     &			AD_CHNL(II).CHAN_DSCR, II=(MIN_CHAN+1),(MAX_CHAN+1))
500	FORMAT('%AD=',I2,2X,'%GA=',I6,2X,'%DE=',A72)
C
C
	IF (DA_NMBER .GT. 0)
     &		WRITE(11,600) ( DA_CHNL(II).CHAN_NUM,
     &			DA_CHNL(II).CHAN_DEVICE,
     &			DA_CHNL(II).CHAN_FROM,
     &			DA_CHNL(II).CHAN_DSCR, II=1,2)
600	FORMAT('%DA=',I2,2X,'%DV=',I1,2X,'%FM=',I2,2X,'%DE=',A72)
C
	CLOSE(11)
C
	END

	SUBROUTINE DET_CLOCK()
C
	INTEGER*4	STATUS_C, CLOCK_ID, CLK_SOURCE, CLK_DIVIDER
C
	INCLUDE 'SYS$SHARE:LIOSET.FOR'
C
	COMMON /CLOCK/ CLK_RATE, CLK_DIVIDER, CLK_SOURCE
C
C***
C	ATTACH THE CLOCK MODULE, AND SET IT UP.
C***
C
	STATUS_C = LIO$ATTACH( CLOCK_ID, 'KZA0', LIO$K_QIO )
		IF (.NOT. (STATUS_C)) CALL LIB$SIGNAL(%VAL(STATUS_C))
C
	IF (CLK_SOURCE .EQ. 0) THEN
		STATUS_C = LIO$SET_R( CLOCK_ID, LIO$K_CLK_RATE, 1, CLK_RATE)
			IF (.NOT. (STATUS_C)) CALL LIB$SIGNAL(%VAL(STATUS_C))
	ELSE
		STATUS_C = LIO$SET_I( CLOCK_ID, LIO$K_CLK_SRC, 2, CLK_SOURCE, CLK_DIVIDER )
			IF (.NOT. (STATUS_C)) CALL LIB$SIGNAL(%VAL(STATUS_C))
	ENDIF
C
	STATUS_C = LIO$SHOW( CLOCK_ID, LIO$K_CLK_RATE, ACT_RATE, ILEN )
		IF (.NOT. (STATUS_C)) CALL LIB$SIGNAL(%VAL(STATUS_C))
C
	IWAIT = 0
	STATUS_C = LIO$DETACH( CLOCK_ID, IWAIT )
		IF (.NOT. (STATUS_C)) CALL LIB$SIGNAL(%VAL(STATUS_C))
C
	TYPE *, ' '
	TYPE *, 'ACTUAL CLOCK RATE WILL BE:  ', ACT_RATE, ' HERTZ.'
	TYPE *, ' '
C
	CLK_RATE = ACT_RATE
C
	RETURN
	END
