	PROGRAM ADDA_MAINIO
C
C **************************************************************************
C **  PROGRAM AUTHOR:       WILLIAM BAKER
C 
C **  PROGRAM DESCRIPTION:  PROGRAM FOR CONTROL OF AXV11C AD/DA MODULES.
C **                        PROGRAM PERFORMS IO TO BOARDS AND STORES DATA.
C
C **  ADDA_MAINIO.FOR
C     -----------------------
C
	INTEGER*4	STATUS_1, STATUS_2, STATUS_C, AD1_PREV, AD2_PREV,
     &			STATUS_H, DELTA(2), TIMER_EF
C
	CHARACTER	SECONDS*5, MINUTE*2
C
	INCLUDE 'SYS$SHARE:LIOSET.FOR'
C
	INCLUDE 'LIB3:[ADDASYS.SOURCE]ADDA_DATA_SHR.INC/LIST'
C
	INCLUDE 'LIB3:[ADDASYS.SOURCE]ADDA_DATA_MAP.INC'
C
	EXTERNAL	AD1_AST
	EXTERNAL	AD2_AST
	EXTERNAL	CLK_AST
C
1000	CALL ADDA_INIT
C
	CALL ADDA_MAP
C
	IF (USE_CLOCK) THEN
C
C***
C	ATTACH THE CLOCK MODULE, AND SET IT UP.
C***
C
		STATUS_C = LIO$ATTACH( CLOCK_ID, 'KZA0', LIO$K_QIO )
			IF (.NOT. (STATUS_C)) CALL LIB$SIGNAL(%VAL(STATUS_C))
C
		IF (CLK_SOURCE .EQ. 0) THEN
			STATUS_C = LIO$SET_R( CLOCK_ID, LIO$K_CLK_RATE, 1, CLK_RATE)
				IF (.NOT. (STATUS_C)) CALL LIB$SIGNAL(%VAL(STATUS_C))
		ELSE
			STATUS_C = LIO$SET_I( CLOCK_ID, LIO$K_CLK_SRC, 2, CLK_SOURCE, CLK_DIVIDER )
				IF (.NOT. (STATUS_C)) CALL LIB$SIGNAL(%VAL(STATUS_C))
		ENDIF
C
		STATUS_C = LIO$SET_I( CLOCK_ID, LIO$K_FUNCTION, 1, LIO$K_REP_COUNT)
			IF (.NOT. (STATUS_C)) CALL LIB$SIGNAL(%VAL(STATUS_C))
C
		STATUS_C = LIO$SET_I( CLOCK_ID, LIO$K_TRIG, 1, LIO$K_IMMEDIATE)
			IF (.NOT. (STATUS_C)) CALL LIB$SIGNAL(%VAL(STATUS_C))
C
		IF ((.NOT. AD_CLOCK1) .OR. (.NOT. AD_CLOCK2)) THEN
			STATUS_C = LIO$SET_I( CLOCK_ID, LIO$K_AST_RTN, 1, CLK_AST )
				IF (.NOT. (STATUS_C)) CALL LIB$SIGNAL(%VAL(STATUS_C))
		ENDIF
C
	ENDIF
C
	TYPE *, 'AD1 = ',AD1_NMBR,'DA2 = ',DA1_NMBR
	IF (AD1_SET) THEN
		TYPE *,'AD1SET = TRUE'
	ELSE
		TYPE *,'AD1SET = FALSE'
	ENDIF
C
	IF ( AD1_SET ) THEN
C
C***
C	ATTACH THE FIRST AXV11C MODULE, AND SET IT UP.
C***
C
		STATUS_1 = LIO$ATTACH( ADDA_ID(1), DEVICE(1), LIO$K_QIO )
			IF (.NOT. (STATUS_1)) CALL LIB$SIGNAL(%VAL(STATUS_1))
C
		AD1_BUFFLEN = AD1_NMBR * 2
C
		STATUS_1 = LIO$SET_I( ADDA_ID(1), LIO$K_ASYNCH, 0 )
			IF (.NOT. (STATUS_1)) CALL LIB$SIGNAL(%VAL(STATUS_1))
C
		STATUS_1 = LIO$SET_I( ADDA_ID(1), LIO$K_AST_RTN, 1, AD1_AST )
			IF (.NOT. (STATUS_1)) CALL LIB$SIGNAL(%VAL(STATUS_1))
C
		IF (TYP_TRGGR(1) .LE. 1) THEN
C
			IF (AD_CLOCK1 .AND. USE_CLOCK) THEN
				STATUS_1 = LIO$SET_I( ADDA_ID(1), LIO$K_TRIG, 2, LIO$K_IMM_BURST, CLOCK_ID )
					IF (.NOT. (STATUS_1)) CALL LIB$SIGNAL(%VAL(STATUS_1))
			ELSE
				STATUS_1 = LIO$SET_I( ADDA_ID(1), LIO$K_TRIG, 1, LIO$K_IMM_BURST )
					IF (.NOT. (STATUS_1)) CALL LIB$SIGNAL(%VAL(STATUS_1))
				IF (USE_CLOCK) AD1_CLK = .TRUE.
			ENDIF
C
		ELSE IF (TYP_TRGGR(1) .EQ. 2) THEN
C
				STATUS_1 = LIO$SET_I( ADDA_ID(1), LIO$K_TRIG, 1, LIO$K_EXT_BURST )
					IF (.NOT. (STATUS_1)) CALL LIB$SIGNAL(%VAL(STATUS_1))
C
		ELSE IF (TYP_TRGGR(1) .EQ. 3) THEN
C
				IF (AD_CLOCK1 .AND. USE_CLOCK) THEN
					STATUS_1 = LIO$SET_I( ADDA_ID(1), LIO$K_TRIG, 2, LIO$K_CLK_BURST, CLOCK_ID )
						IF (.NOT. (STATUS_1)) CALL LIB$SIGNAL(%VAL(STATUS_1))
				ELSE
					STATUS_1 = LIO$SET_I( ADDA_ID(1), LIO$K_TRIG, 1, LIO$K_CLK_BURST )
						IF (.NOT. (STATUS_1)) CALL LIB$SIGNAL(%VAL(STATUS_1))
					IF (USE_CLOCK) AD1_CLK = .TRUE.
				ENDIF
C
		ELSE IF (TYP_TRGGR(1) .EQ. 4) THEN
C
				STATUS_1 = LIO$SET_I( ADDA_ID(1), LIO$K_TRIG, 1, LIO$K_EXT_SWEEP )
					IF (.NOT. (STATUS_1)) CALL LIB$SIGNAL(%VAL(STATUS_1))
C
		ELSE IF (TYP_TRGGR(1) .EQ. 5) THEN
C
				IF (AD_CLOCK1 .AND. USE_CLOCK) THEN
					STATUS_1 = LIO$SET_I( ADDA_ID(1), LIO$K_TRIG, 1, LIO$K_CLK_SWEEP )
						IF (.NOT. (STATUS_1)) CALL LIB$SIGNAL(%VAL(STATUS_1))
				ELSE
					STATUS_1 = LIO$SET_I( ADDA_ID(1), LIO$K_TRIG, 1, LIO$K_CLK_SWEEP )
						IF (.NOT. (STATUS_1)) CALL LIB$SIGNAL(%VAL(STATUS_1))
					IF (USE_CLOCK) AD1_CLK = .TRUE.
				ENDIF
C
		ELSE IF (TYP_TRGGR(1) .EQ. 6) THEN
C
				STATUS_1 = LIO$SET_I( ADDA_ID(1), LIO$K_TRIG, 1, LIO$K_EXT_POINT )
					IF (.NOT. (STATUS_1)) CALL LIB$SIGNAL(%VAL(STATUS_1))
C
		ELSE IF (TYP_TRGGR(1) .EQ. 7) THEN
C
				IF (AD_CLOCK1 .AND. USE_CLOCK) THEN
					STATUS_1 = LIO$SET_I( ADDA_ID(1), LIO$K_TRIG, 2, LIO$K_CLK_POINT, CLOCK_ID )
						IF (.NOT. (STATUS_1)) CALL LIB$SIGNAL(%VAL(STATUS_1))
				ELSE
					STATUS_1 = LIO$SET_I( ADDA_ID(1), LIO$K_TRIG, 1, LIO$K_CLK_POINT )
						IF (.NOT. (STATUS_1)) CALL LIB$SIGNAL(%VAL(STATUS_1))
					IF (USE_CLOCK) AD1_CLK = .TRUE.
				ENDIF
C
		ENDIF
C
		IF (AD1_NMBR .NE. 0) CALL AD_CHNL_DEF( ADDA_ID(1), AD1_NMBR, AD1_CHAN, AD1_GAIN )
C
	ENDIF
C
	TYPE *, 'AD2 = ',AD2_NMBR,'DA2 = ',DA2_NMBR
	IF (AD2_SET) THEN
		TYPE *,'AD2SET = TRUE'
	ELSE
		TYPE *,'AD2SET = FALSE'
	ENDIF
C
	IF ( AD2_SET ) THEN
C
C***
C	ATTACH THE SECOND AXV11C MODULE, AND SET IT UP.
C***
C
		STATUS_2 = LIO$ATTACH( ADDA_ID(2), DEVICE(2), LIO$K_QIO )
			IF (.NOT. (STATUS_2)) CALL LIB$SIGNAL(%VAL(STATUS_2))
C
		AD2_BUFFLEN = AD2_NMBR * 2
C
		STATUS_2 = LIO$SET_I( ADDA_ID(2), LIO$K_ASYNCH, 0 )
			IF (.NOT. (STATUS_2)) CALL LIB$SIGNAL(%VAL(STATUS_2))
C
		STATUS_2 = LIO$SET_I( ADDA_ID(2), LIO$K_AST_RTN, 1, AD2_AST )
			IF (.NOT. (STATUS_2)) CALL LIB$SIGNAL(%VAL(STATUS_2))
C
		IF (TYP_TRGGR(2) .LE. 1) THEN
C
			IF (AD_CLOCK2 .AND. USE_CLOCK) THEN
				STATUS_2 = LIO$SET_I( ADDA_ID(2), LIO$K_TRIG, 2, LIO$K_IMM_BURST, CLOCK_ID )
					IF (.NOT. (STATUS_2)) CALL LIB$SIGNAL(%VAL(STATUS_2))
			ELSE
				STATUS_2 = LIO$SET_I( ADDA_ID(2), LIO$K_TRIG, 1, LIO$K_IMM_BURST )
					IF (.NOT. (STATUS_2)) CALL LIB$SIGNAL(%VAL(STATUS_2))
				IF (USE_CLOCK) AD2_CLK = .TRUE.
			ENDIF
C
		ELSE IF (TYP_TRGGR(2) .EQ. 2) THEN
C
				STATUS_2 = LIO$SET_I( ADDA_ID(2), LIO$K_TRIG, 1, LIO$K_EXT_BURST )
					IF (.NOT. (STATUS_2)) CALL LIB$SIGNAL(%VAL(STATUS_2))
C
		ELSE IF (TYP_TRGGR(2) .EQ. 3) THEN
C
				IF (AD_CLOCK2 .AND. USE_CLOCK) THEN
					STATUS_2 = LIO$SET_I( ADDA_ID(2), LIO$K_TRIG, 2, LIO$K_CLK_BURST, CLOCK_ID )
						IF (.NOT. (STATUS_2)) CALL LIB$SIGNAL(%VAL(STATUS_2))
				ELSE
					STATUS_2 = LIO$SET_I( ADDA_ID(2), LIO$K_TRIG, 1, LIO$K_CLK_BURST )
						IF (.NOT. (STATUS_2)) CALL LIB$SIGNAL(%VAL(STATUS_2))
					IF (USE_CLOCK) AD2_CLK = .TRUE.
				ENDIF
C
		ELSE IF (TYP_TRGGR(2) .EQ. 4) THEN
C
				STATUS_2 = LIO$SET_I( ADDA_ID(2), LIO$K_TRIG, 1, LIO$K_EXT_SWEEP )
					IF (.NOT. (STATUS_2)) CALL LIB$SIGNAL(%VAL(STATUS_2))
C
		ELSE IF (TYP_TRGGR(2) .EQ. 5) THEN
C
				IF (AD_CLOCK2 .AND. USE_CLOCK) THEN
					STATUS_2 = LIO$SET_I( ADDA_ID(2), LIO$K_TRIG, 2, LIO$K_CLK_SWEEP )
						IF (.NOT. (STATUS_2)) CALL LIB$SIGNAL(%VAL(STATUS_2))
				ELSE
					STATUS_2 = LIO$SET_I( ADDA_ID(2), LIO$K_TRIG, 1, LIO$K_CLK_SWEEP )
						IF (.NOT. (STATUS_2)) CALL LIB$SIGNAL(%VAL(STATUS_2))
					IF (USE_CLOCK) AD2_CLK = .TRUE.
				ENDIF
C
		ELSE IF (TYP_TRGGR(2) .EQ. 6) THEN
C
				STATUS_2 = LIO$SET_I( ADDA_ID(2), LIO$K_TRIG, 1, LIO$K_EXT_POINT )
					IF (.NOT. (STATUS_2)) CALL LIB$SIGNAL(%VAL(STATUS_2))
C
		ELSE IF (TYP_TRGGR(2) .EQ. 7) THEN
C
				IF (AD_CLOCK2 .AND. USE_CLOCK) THEN
					STATUS_2 = LIO$SET_I( ADDA_ID(2), LIO$K_TRIG, 2, LIO$K_CLK_POINT, CLOCK_ID )
						IF (.NOT. (STATUS_2)) CALL LIB$SIGNAL(%VAL(STATUS_2))
				ELSE
					STATUS_2 = LIO$SET_I( ADDA_ID(2), LIO$K_TRIG, 1, LIO$K_CLK_POINT )
						IF (.NOT. (STATUS_2)) CALL LIB$SIGNAL(%VAL(STATUS_2))
					IF (USE_CLOCK) AD2_CLK = .TRUE.
				ENDIF
C
		ENDIF
C
		IF (AD2_NMBR .NE. 0) CALL AD_CHNL_DEF( ADDA_ID(2), AD2_NMBR, AD2_CHAN, AD2_GAIN )
C
	ENDIF
C
	IF (DA1_NMBR .NE. 0) THEN
C
C***
C	SET UP THE FIRST AXV11C D/A MODULE.
C***
C
		CALL DA_CHNL_DEF( ADDA_ID(1), DA1_NMBR, DA1_CHNL )
C
	ENDIF
C
	IF (DA2_NMBR .NE. 0) THEN
C
C***
C	SET UP THE SECOND AXV11C D/A MODULE.
C***
C
		CALL DA_CHNL_DEF( ADDA_ID(2), DA2_NMBR, DA2_CHNL )
C
	ENDIF
C
C***
C	SLEEP TILL PROCESS STARTED BY USER PROGRAM.
C***
C
C	IOP = 0,	KEEP GOING, GET DATA.
C	IOP = 1,	RESET CONFIGURATION.
C	IOP = 2,	STOP GATHERING, AND RE-CONFIGURE.
C	IOP = 3,	STOP GATHERING, AND STOP PROGRAMS.
C
	IOP = 0
C
	TYPE *, 'GOING TO SLEEP NOW, WAITING FOR COMMAND TO START.'
C
	CALL ADDA_SLEEP( IOP )
C
	TYPE *, 'I WOKE UP, AND THE COMMAND WAS = ',IOP
	IF ( IOP .EQ. 1 ) GOTO 2000
C
C***
C	START THE I/O TO THE AXV11C MODULES.
C***
C
C	TYPE *, 'CHECK IF CLOCK NEEDS TO BE STARTED.'
	IF ( USE_CLOCK ) THEN
	TYPE *, 'STARTING CLOCK.'
	        STATUS_C = LIO$SET_I( CLOCK_ID, LIO$K_START, 0)
	                IF(.NOT.STATUS_C)         CALL LIB$SIGNAL(%VAL(STATUS))
	ENDIF
C
	TYPE *, 'START AD1 AST ROUTINE...'
	IF (((AD1_NMBR .NE. 0) .AND. (.NOT. AD1_STRT)) .AND. (.NOT. AD1_CLK)) THEN
		CALL AD1_ASYNCH
	TYPE *, 'STARTED AD1 AST ROUTINE...'
		AD1_STRT = .TRUE.
	ENDIF
C
	TYPE *, 'START AD2 AST ROUTINE...'
	IF (((AD2_NMBR .NE. 0) .AND. (.NOT. AD2_STRT)) .AND. (.NOT. AD2_CLK)) THEN
		CALL AD2_ASYNCH
	TYPE *, 'STARTED AD2 AST ROUTINE...'
		AD2_STRT = .TRUE.
	ENDIF
C
	TYPE *, 'CHECK FOR DA USAGE, OR CLOCK AST USAGE...'
	IF (((DA1_NMBR .NE. 0) .OR. (DA2_NMBR .NE. 0)) .AND. 
     &		((.NOT. AD1_CLK) .AND. (.NOT. AD2_CLK))) THEN
	TYPE *, 'DA USAGE, OR CLOCK AST USAGE...'
		USE_LOGICAL = .TRUE.
		RSEC = 1/(CLK_RATE*1.1)
		IF (RSEC .LT. 1.0) THEN
			ENCODE(4,8000,SECONDS) RSEC
8000			FORMAT(F4.2)
			STATUS_H = SYS$BINTIM('0 00:00:'//SECONDS,DELTA)
		ELSE IF (RSEC .LT. 60.0) THEN
			ENCODE(5,8010,SECONDS) RSEC
8010			FORMAT(F5.2)
			STATUS_H = SYS$BINTIM('0 00:00:'//SECONDS,DELTA)
		ELSE 
			IMINUTE = RSEC/60
			RSEC    = RSEC - (IMINUTE * 60.0)
			ENCODE(5,8020,SECONDS) RSEC
8020			FORMAT(F5.2)
			ENCODE(2,8030,MINUTE) IMINUTE
8030			FORMAT(I2)
			STATUS_H = SYS$BINTIM('0 00:'//MINUTE//':'//SECONDS,DELTA)
		ENDIF
		DELTA(1) = -DELTA(1)
		AD1_PREV = 0
		AD2_PREV = 0
		DO WHILE (.NOT. START_STOP)
			IF ((AD1_PREV .NE. AD1_PNTR) .OR. 
     &			    (AD2_PREV .NE. AD2_PNTR)) THEN
				AD1_PREV = AD1_PNTR
				AD2_PREV = AD2_PNTR
				CALL ASYNCH_OUT
				STATUS_H = SYS$SETIMR(%VAL(TIMER_EF),DELTA,,)
				STATUS_H = SYS$WAITFR(%VAL(TIMER_EF))
			ENDIF
		ENDDO
		IOP = NEWOPT
	ELSE
		IOP = 0
		TYPE *, 'GOING TO SLEEP... AST ROUTINES WILL TAKE OVER...'
		CALL ADDA_SLEEP( IOP )
	ENDIF
	TYPE *, 'TERMINATING THIS SECTION OF TEST...'
C
C***
C	DETACH THE DEVICES FROM THE PROGRAM.
C***
C
2000	IRUN_DWN = 1
	IF (USE_CLOCK) THEN
	TYPE *,'	STOPPING CLOCK...'
		STATUS_C = LIO$DETACH( CLOCK_ID, IRUN_DWN )
			IF (.NOT. (STATUS_C)) CALL LIB$SIGNAL(%VAL(STATUS_C))
	ENDIF
C
	IRUN_DWN = 1
	IF (AD1_NMBR .NE. 0) THEN
	TYPE *,'	STOPPING AD1 DEVICE...'
		STATUS_1 = LIO$DETACH( ADDA_ID(1), IRUN_DWN )
			IF (.NOT. (STATUS_1)) CALL LIB$SIGNAL(%VAL(STATUS_1))
	ENDIF
C
	IRUN_DWN = 1
	IF (AD2_NMBR .NE. 0) THEN
	TYPE *,'	STOPPING AD2 DEVICE...'
		STATUS_2 = LIO$DETACH( ADDA_ID(2), IRUN_DWN )
			IF (.NOT. (STATUS_2)) CALL LIB$SIGNAL(%VAL(STATUS_2))
	ENDIF
C
	IF (IOP .GE. 2) THEN
C
	TYPE *, '	FILING DATA...'
		IF (AD1_NMBR .NE. 0) CALL FILE_DATA( 1, CUR_PNTR1, 1 )
		IF (AD2_NMBR .NE. 0) CALL FILE_DATA( 2, CUR_PNTR2, 2 )
C
	ENDIF
C
	IF ((IOP .EQ. 1) .OR. (IOP .EQ. 2)) THEN
	TYPE *,'	MORE DATA FILING AS NEEDED...'
		IF (AD1_NMBR .NE. 0) CALL FILE_DATA( 1, 0, 3 )
		IF (AD2_NMBR .NE. 0) CALL FILE_DATA( 2, 0, 3 )
		GOTO 1000
	ELSE
	TYPE *,'	MORE DATA FILING AS NEEDED...'
		IF (AD1_NMBR .NE. 0) CALL FILE_DATA( 1, 0, 9 )
		IF (AD2_NMBR .NE. 0) CALL FILE_DATA( 2, 0, 9 )
	ENDIF
C
	TYPE *,'		BYE-BYE'
	AD1_SET = .FALSE.
	AD2_SET = .FALSE.
C
	END
