	PROGRAM    ADDA_PLOT
C
C
	INTEGER*2	AD_DATA(16)
C
	INTEGER*4	SYS$TRNLNM
	INTEGER*2	DAR(240), NAME_LEN, NAME_CODE
	INTEGER*4	NAME_ADDR, RET_ADDR, END_LIST /0/
	INTEGER*4	LOGSTOP_LEN, CURTIME, PRVTIME, GPID, STATUS_L
	CHARACTER*72	DESCRIPT, LOGSTOP
C
C
	INCLUDE	'LIB3:[ADDASYS.SOURCE]ADDA_DATA_SHR.INC'
C
	COMMON /LIST/ NAME_LEN, NAME_CODE, NAME_ADDR, RET_ADDR, END_LIST
C
C
	NAME_LEN = 3
	NAME_CODE = (LNM$_STRING)
	NAME_ADDR = %LOC(LOGSTOP)
	RET_ADDR = %LOC(LOGSTOP_LEN)

C
	LOGSTOP = 'GO'
	LOGSTOP_LEN = 2
C
	OPEN( UNIT = 11, FILE='PLOT_CONFIG', FORM='FORMATTED',
     &		STATUS = 'OLD', CARRIAGECONTROL = 'LIST' )
C
	READ(11,200) IDEV, ICHN
200	FORMAT(I1,I2)
C
	CLOSE(11)
C
	DESCRIPT = AD_CHNL(IDEV,ICHN).CHAN_DSCR
C
	CALL STR$TRIM(DESCRIPT, DESCRIPT, LEN_DSCR)
C
	CALL AXPLOT_START( DESCRIPT, GPID )
C
	CALL GETCURDATA( IDEV, DAR, NMBR, ICHN, PRVTIME )
C
	CALL POPAD( IDEV, AD_DATA, CURTIME )
C
	CALL PLOTDATA( DAR, NMBR, GPID )
C
	IF (CURTIME .NE. PRVTIME) THEN
		DAR(1) = AD_DATA(ICHN)
		CALL PLOTDATA( DAR, 1, GPID )
		PRVTIME = CURTIME
	ENDIF
C
	DO WHILE ((CURTIME .EQ. PRVTIME) .AND. (.NOT. START_STOP) .AND.
     &		  (LOGSTOP(1:LOGSTOP_LEN) .EQ. 'GO'))
C
		CALL POPAD( IDEV, AD_DATA, CURTIME )
C
		STATUS_L = SYS$TRNLNM(, 'LNM$GROUP_000100', 'PLOT_CONTINUE',, NAME_LEN )
		IF (.NOT. STATUS_L) CALL LIB$SIGNAL(%VAL(STATUS_L))
C
		IF (CURTIME .NE. PRVTIME) THEN
			DAR(1) = AD_DATA(ICHN)
			CALL PLOTDATA( DAR, 1, GPID )
			PRVTIME = CURTIME
			IWAITCLK = 0
			CALL WAITABIT( IWAITCLK )
		ENDIF
C
	ENDDO
C
	CALL AXPLOT_STOP( GPID )
C
	END

	SUBROUTINE AXPLOT_START( descript, graphics_id )
C
	INTEGER*4	GRAPHICS_ID, STATUS_P
C
	CHARACTER*72	DESCRIPT
C
	INCLUDE 'SYS$LIBRARY:LIOSET.FOR'	!get LIO symbol definitions
C
!-------------> go <--------------
	
C Set up graphics device

	STATUS_P = lio$attach(graphics_id, 'POA0',)
		if(.NOT.(STATUS_P)) call lib$signal( %val(STATUS_P))

C Plotting one channels, 0

	STATUS_P = lio$set_i(graphics_id,LIO$K_PO_CHAN, 1, 0)
		if(.NOT.(STATUS_P)) call lib$signal( %val(STATUS_P))

C Display 240 points along x axis, and shift in 40 points at a time.

	STATUS_P = lio$set_r(graphics_id,LIO$K_X_RANGE, 2,240.0,40.0)
		if(.NOT.(STATUS_P)) call lib$signal( %val(STATUS_P))

C Set y min for both channels

	STATUS_P = lio$set_r(graphics_id,LIO$K_Y_MIN,1,-10.0)
		if(.NOT.(STATUS_P)) call lib$signal( %val(STATUS_P))

C Set y max for both channels

	STATUS_P = lio$set_r(graphics_id,LIO$K_Y_MAX,1,10.0)
		if(.NOT.(STATUS_P)) call lib$signal( %val(STATUS_P))

C Set up channel labels
	STATUS_P = lio$set_s(graphics_id,LIO$K_TITLE_0, descript )
		if(.NOT.(STATUS_P)) call lib$signal( %val(STATUS_P))

C Tell device the number of channels in the data buffer

	STATUS_P = lio$set_i(graphics_id,LIO$K_N_BUFFS,1,1)
		if(.NOT.(STATUS_P)) call lib$signal( %val(STATUS_P))

C Start the plotting

	STATUS_P = lio$set_r(graphics_id,LIO$K_START,0,)
		if(.NOT.(STATUS_P)) call lib$signal( %val(STATUS_P))
C
	RETURN
	END

	SUBROUTINE PLOTDATA( DAR, NUM, GRAPHICS_ID )
C
	INTEGER*4	GRAPHICS_ID, STATUS_P, GRPH_SIZE
	INTEGER*2	DAR(NUM)
	REAL*4		GRPH(240)
C
	INCLUDE 'SYS$LIBRARY:LIOSET.FOR'	!get LIO symbol definitions

C Translate buffer to floating point format

	  STATUS_P = lsp$format_translate_adc(dar,grph,num)
		if(.NOT.(STATUS_P)) call lib$signal( %val(STATUS_P))

C Write buffer to graphics device
C
	  grph_size = num * 4
C
	  STATUS_P = lio$write(graphics_id, grph, grph_size,)
		if(.NOT.(STATUS_P)) call lib$signal( %val(STATUS_P))
C
	RETURN
	END

	SUBROUTINE AXPLOT_STOP( graphics_id )
C
	INTEGER*4	GRAPHICS_ID, STATUS_P
C
	INCLUDE 'SYS$LIBRARY:LIOSET.FOR'	!get LIO symbol definitions
C
	STATUS_P = lio$detach(graphics_id, )
		if(.NOT.(STATUS_P)) call lib$signal( %val(STATUS_P))
C
	RETURN
	END

	SUBROUTINE GETCURDATA( IDV, DAR, NUM, ICHN, TIME )
C
	INTEGER*4	NUM, IDV, ICHN, TIME
	INTEGER*2	DAR(240)
C
	INCLUDE	'LIB3:[ADDASYS.SOURCE]ADDA_DATA_SHR.INC'
C
	NUM = 0
C
	IF (IDV .EQ. 1) THEN
C
		LOC_PNTR = AD1_PNTR
		LOC_ARRY = CUR_PNTR1
		IF ((LOC_ARRY .EQ. 1) .AND. (LOC_PNTR .NE. 0)) THEN
			DO II = 1,LOC_PNTR
				DAR(II) = AD1_DATA1(II,ICHN)
				NUM = NUM + 1
			ENDDO
			TIME = AD1_TIME1(LOC_PNTR)
		ELSE IF ((LOC_ARRY .EQ. 2) .AND. (LOC_PNTR .NE. 0)) THEN
			DO II = 1,LOC_PNTR
				DAR(II) = AD1_DATA2(II,ICHN)
				NUM = NUM + 1
			ENDDO
			TIME = AD1_TIME2(LOC_PNTR)
		ENDIF
C		
	ELSE
C
		LOC_PNTR = AD2_PNTR
		LOC_ARRY = CUR_PNTR1
		IF ((LOC_ARRY .EQ. 1) .AND. (LOC_PNTR .NE. 0)) THEN
			DO II = 1,LOC_PNTR
				DAR(II) = AD2_DATA1(II,ICHN)
				NUM = NUM + 1
			ENDDO
			TIME = AD2_TIME1(LOC_PNTR)
		ELSE IF ((LOC_ARRY .EQ. 2) .AND. (LOC_PNTR .NE. 0)) THEN
			DO II = 1,LOC_PNTR
				DAR(II) = AD2_DATA2(II,ICHN)
				NUM = NUM + 1
			ENDDO
			TIME = AD2_TIME2(LOC_PNTR)
		ENDIF
C
	ENDIF
C
	RETURN
	END
