C	PROGRAM ax_read
C 
C This example uses the synchronous user interface (LIO$read) to
C read 360 a/d values from each of two channels, and plots them
C using the LIO plotting device in a continuous real time display.
C
C NOTE:
C	THIS EXAMPLE ONLY RUNS ON A VAXSTATION BASED VAXLAB
C
C
!----------------------------------------------------------------------------
!	LIO setup and declarations
!----------------------------------------------------------------------------
	INCLUDE 'SYS$LIBRARY:LIOSET.FOR'	!get LIO symbol definitions
	PARAMETER	NPOINT = 720
	PARAMETER	NBYTE  = (2*NPOINT)
	Parameter	bufsiz = (NPOINT + 300)	
	INTEGER*2	buffer(bufsiz), ef !twenty word buffer
	INTEGER		par_list(25)	!set parameter list
	INTEGER		count/45/
	INTEGER		device_id	!variable to hold device id
	integer		graphics_id
	INTEGER		data_length	!number of data points read
	INTEGER		status		!status returned by LIO calls
	EXTERNAL	LIB$SIGNAL, sys$lckpag
	integer		sys$waitfr

	real*4		graph_buffer(720)
	integer		graph_size


!-------------> go <--------------
	
	status = lio$attach(device_id, 'AXA0', LIO$K_QIO )!attach to axv
		if(.NOT.(status)) call lib$signal( %val(status))

	status = lio$SET_i(DEVICE_ID, LIO$K_SYNCH, 0) !set to lio$read/lio$write
		if(.NOT.(status)) call lib$signal( %val(status))

	status = lio$SET_i(DEVICE_ID, LIO$K_AD_CHAN, 2, 0, 1) !2 chans
		if(.NOT.(status)) call lib$signal( %val(status))

	status = lio$SET_i(DEVICE_ID, LIO$K_AD_GAIN, 2, 1, 1) ! 2 gain
		if(.NOT.(status)) call lib$signal( %val(status))


C Set up graphics device

	status = lio$attach(graphics_id, 'POA0',)
		if(.NOT.(status)) call lib$signal( %val(status))

C Plotting two channels (0 and 1)

	status = lio$set_i(graphics_id,LIO$K_PO_CHAN, 2, 0, 1)
		if(.NOT.(status)) call lib$signal( %val(status))

C Display 360 points along x axis, and shift in 45 points at a time.

	status = lio$set_r(graphics_id,LIO$K_X_RANGE, 2,360.0,45.0)
		if(.NOT.(status)) call lib$signal( %val(status))

C Set y min for both channels

	status = lio$set_r(graphics_id,LIO$K_Y_MIN,2,-10.0, -10.0)
		if(.NOT.(status)) call lib$signal( %val(status))

C Set y max for both channels

	status = lio$set_r(graphics_id,LIO$K_Y_MAX,2,10.0, 10.0)
		if(.NOT.(status)) call lib$signal( %val(status))

C Set up channel labels
	status = lio$set_s(graphics_id,LIO$K_TITLE_0,'Channel 0')
		if(.NOT.(status)) call lib$signal( %val(status))

	status = lio$set_s(graphics_id,LIO$K_TITLE_1,'Channel 1')
		if(.NOT.(status)) call lib$signal( %val(status))

C Tell device the number of channels in the data buffer

	status = lio$set_i(graphics_id,LIO$K_N_BUFFS,1,2)
		if(.NOT.(status)) call lib$signal( %val(status))

C Start the plotting

	status = lio$set_r(graphics_id,LIO$K_START,0,)
		if(.NOT.(status)) call lib$signal( %val(status))
        graph_size = 720 * 4

	do iteration = 1, 100 

C read a/d values into the buffer
	  status = lio$read(device_id, buffer, NBYTE, data_length, )
		if(.NOT.(status)) call lib$signal( %val(status))

C Translate buffer to floating point format

	  status = lsp$format_translate_adc(buffer,graph_buffer,720)
		if(.NOT.(status)) call lib$signal( %val(status))

C Write buffer to graphics device

	  status = lio$write(graphics_id, graph_buffer, graph_size,)
		if(.NOT.(status)) call lib$signal( %val(status))

	end do 

C detach the device (no rundown)
	status = lio$detach(device_id, )
		if(.NOT.(status)) call lib$signal( %val(status))

	status = lio$detach(graphics_id, )
		if(.NOT.(status)) call lib$signal( %val(status))

	STOP 'Done'
	END
