(************************************************************************)
(*									*)
(*      The purpose of this file is to establish the VAX-11 PASCAL 	*)
(* ENVIRONMENT file for the OCELOT library.				*)
(*									*)
(************************************************************************)

[ENVIRONMENT ('WJB_LIBRARY:OCELOT.PEN')] MODULE ocelot;

CONST
   size_time   = 8;
   buf_size    = 16;

TYPE
  string_time  = PACKED ARRAY [1..size_time] OF char;

  byte         = -128..127;
  word         = -32768..32767;
  bit8         = 0..255;
  bit16        = 0..65535;




FUNCTION cvt_jtime (intime : integer) : string_time; EXTERN;

FUNCTION cvt_atime (intime : string_time) : integer; EXTERN;

FUNCTION getchar : char; EXTERN;

PROCEDURE putchar (a : char); EXTERN;

PROCEDURE putline (
         a : PACKED ARRAY [l1..u1 : integer] OF char); EXTERN;

FUNCTION utl_ext_parm (
	 %STDESCR input   : PACKED ARRAY [l_1..u_1 : INTEGER] OF CHAR;
	 %STDESCR para    : PACKED ARRAY [l_2..u_2 : INTEGER] OF CHAR;
	 %REF     parlen  : INTEGER;
	 %REF     offset  : INTEGER) : INTEGER; EXTERN;

FUNCTION cvt_w_l  (%IMMED number : word)  : INTEGER; EXTERN;

FUNCTION cvt_b_l  (%IMMED number : byte)  : INTEGER; EXTERN;

FUNCTION cvt_uw_l (%IMMED number : bit16) : INTEGER; EXTERN;

FUNCTION cvt_ub_l (%IMMED number : bit8)  : INTEGER; EXTERN;

FUNCTION ntran (
              code     : INTEGER;
         %REF icb      : PACKED ARRAY [l1..u1 : INTEGER] OF word;
              count    : INTEGER;
         %REF buffer   : PACKED ARRAY [l2..u2 : INTEGER] OF CHAR) : INTEGER;
         EXTERN;

FUNCTION ntran_assign (
 	 %REF icb      : PACKED ARRAY [l1..u1 : INTEGER] OF word;
	 %REF buffer   : PACKED ARRAY [l2..u2 : INTEGER] OF CHAR) : INTEGER;
	 EXTERN;

FUNCTION ntran_rewind (
	 %REF icb      : PACKED ARRAY [l1..u1 : INTEGER] OF word) : INTEGER;
	 EXTERN;

FUNCTION ntran_writeof (
	 %REF icb      : PACKED ARRAY [l1..u1 : INTEGER] OF word) : INTEGER;
	 EXTERN;

FUNCTION ntran_read (
	 %REF icb      : PACKED ARRAY [l1..u1 : INTEGER] OF word;
	      count    : INTEGER;
	 %REF buffer   : PACKED ARRAY [l2..u2 : INTEGER] OF CHAR) : INTEGER;
	 EXTERN;

FUNCTION ntran_write (
	 %REF icb      : PACKED ARRAY [l1..u1 : INTEGER] OF word;
	      count    : INTEGER;
	 %REF buffer   : PACKED ARRAY [l2..u2 : INTEGER] OF CHAR) : INTEGER;
	 EXTERN;

FUNCTION ntran_skiprec (
	 %REF icb      : PACKED ARRAY [l1..u1 : INTEGER] OF word;
	      count    : INTEGER) : INTEGER;
	 EXTERN;

FUNCTION ntran_skipfile (
	 %REF icb      : PACKED ARRAY [l1..u1 : INTEGER] OF word;
	      count    : INTEGER) : INTEGER;
	 EXTERN;

FUNCTION ntran_deassign (
	 %REF icb      : PACKED ARRAY [l1..u1 : INTEGER] OF word) : INTEGER;
	 EXTERN;


PROCEDURE tcp_noecho (%IMMED switch : [LONG] BOOLEAN); EXTERN;

PROCEDURE reset_screen; EXTERN;

PROCEDURE save_cursor; EXTERN;

PROCEDURE restore_cursor; EXTERN;

PROCEDURE continue; EXTERN;

END.
