$!*****************************************************************************
$!
$!	FILE:	OCELOT.COM
$!
$!	This command file completely rebuilds the SYSENG library called
$!	OCELOT.OLB.  First it compiles/assembles all the different modules
$!	that are in the source area.  Then it creates a new library.  If
$!	this is successfull the old library is deleted and the protection
$!	is set on the new one.  To document the change a listing of the
$!	libraries' contexts is made.
$!
$!	To add a new module to this build routine the source code must be
$!	added to the source area and the file name added to list of source
$!	files in this file.  A module can be deleted by reversing the
$!	actions required to add a module.  The module can be updated simply
$!	by editing the source code and place the new source code in the
$!	source directory.
$!
$!*****************************************************************************
$!
$!
$	type SYS$INPUT			! Display pretty header on screen
[2J[1;1H[1m(0
[19Clqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqk
[19Cx  SYSENG OBJECT LIBRARY BUILD PROCEDURE  x
[19Cmqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqj
[0m(B

$	inquire/nopun SOURCE "Enter source directory:  "
$	inquire/nopun LIBDIR "Enter library directory: "
$	write SYS$OUTPUT "

"
$!
$!
$	set message/nofac/nosev/noid/notext	! Suppress error message
$	set default 'SOURCE'			! Set def to source directory
$	delete/log *.OBJ;*			! Delete old object modules
$	set message/text			! enable error message
$!
$!      +-------------------------------------+
$!	| MACRO ASSEMBLER SOURCE CODE SECTION |
$!      +-------------------------------------+
$!
$	macro  BIO.MAR				! Block I/O routines
$	macro  TCP.MAR				! Terminal Control Procedures
$	macro  PRC.MAR				! Process Control Procedures
$	macro  CVT.MAR				! Conversion routines
$	macro  GIO.MAR				! Terminal I/O Procedures
$!
$!	+-----------------------------+
$!	| FORTRAN SOURCE CODE SECTION |
$! 	+-----------------------------+
$!
$	fortran       SYSPAS.FOR		! General procedures
$	fortran       NTRAN.FOR			! Magnetic tape routines
$!
$!	+----------------------------+
$!	| PASCAL SOURCE CODE SECTION |
$! 	+----------------------------+
$!
$	pascal        VAXUTIL.PAS		! General Pascal Utilities
$!
$!	+-----------------------+
$!	| LIBRARY BUILD SECTION |
$!      +-----------------------+
$!
$	lib/create       'LIBDIR'OCELOT.OLB  *.OBJ  ! Create new library
$	set prot=(o:d)   'LIBDIR'OCELOT.OLB;*	    ! set librarys for delete
$	purge/keep=1/log 'LIBDIR'OCELOT.OLB	    ! Delete old libraries
$	set prot=(s:re,o:rwe,g:re,w) -	            ! Protect new libraries
        'LIBDIR'OCELOT.OLB
$!
$!	+----------------------------------+
$!	| DOCUMENTATION / CLEAN-UP SECTION |
$!	+----------------------------------+
$!
$	delete/log 'LIBDIR'OCELOT.LST;*		  ! Delete old listing files
$	lib/list='LIBDIR'OCELOT.LST/names - 	  ! Create new listing file
	'LIBDIR'OCELOT.OLB
$	print/noident    'LIBDIR'OCELOT.LST	  ! Print listing file
$	delete/log   *.OBJ;*			  ! Delete object files
$	set message/text/fac/ident/sev
