      INTEGER FUNCTION UTL_EXT_PARM(INPUT,OUTPUT,LENGTH,OFFSET)
C
C
      INTEGER*4		LENGTH,
     *			OFFSET,
     * 			START,
     *			PARM,
     *			INDEX
C
      CHARACTER		INPUT*(*),
     *			OUTPUT*(*)
C
      LOGICAL*1		ERROR,
     *			BLANK
C
C
C***********************************************************************
C     This procedure extracts an given word from the input string.
C     The desired word is specified by the offset which itself is in 
C     units of words.  If the specified word is too long for the
C     output string then the string is truncated.  
C
C     A word is defined as a contiguous block of ASCII characters 
C     whose values are greater than a blank (20 hex).  Therefore 
C     any character less then or equal to a blank delimits a word.
C***********************************************************************
C
C
      START  = 0
      PARM   = 1
      LENGTH = 0
      ERROR  = .FALSE.
      BLANK  = .TRUE.
C
      DO WHILE (((PARM .LT. OFFSET) .OR. (BLANK)) .AND. ( .NOT. ERROR))
         START = START + 1
         IF ((INPUT(START:START) .LE. CHAR('20'X)) .AND. 
     *      ( .NOT. BLANK)) THEN
            BLANK = .TRUE.
            PARM = PARM + 1
         ELSE IF ((INPUT(START:START) .LE. CHAR('20'X)) .AND.
     *      ( BLANK )) THEN
            BLANK = .TRUE.
         ELSE
            BLANK = .FALSE.
         END IF
         IF (START .EQ. LEN(INPUT)) ERROR = .TRUE.
         IF (START .GT. LEN(INPUT)) CALL LIB$STOP (%VAL(4))
      END DO
C
C
      IF ( .NOT. ERROR) THEN
         INDEX = 1
         DO WHILE ((INPUT(START:START) .GT. CHAR('20'X)) .AND. 
     *      (INDEX .LE. LEN(OUTPUT)))
            OUTPUT(INDEX:INDEX) = INPUT(START:START)
            START = START + 1
            INDEX = INDEX + 1
            LENGTH = LENGTH + 1
         END DO
         UTL_EXT_PARM = 1
         RETURN
      ELSE
         UTL_EXT_PARM = 0
         RETURN
      END IF
      END
