	SUBROUTINE WAKE_UP
C
C	Subroutine to wake up hibernate state.
C
	INTEGER*4 STATUS, SYS$WAKE, CHECK_STATUS

	STATUS = SYS$WAKE(,)	! Wake us up.
	CALL CHECK_STATUS('WAKE_UP',STATUS)
	RETURN
	END

	SUBROUTINE RESET_WORLD
C
C	Exit handler.
C
	CALL SYS$SETSWM(%VAL(0)) 	! Reenable swapping.
C	CALL SYS$SETPRI(,,%VAL(4),) 	! Lower priority.
	RETURN
	END

	LOGICAL FUNCTION GET_SYMBOL(SYMBOL,BUFFER,SIZE)
C
C	This routine is used to lookup a DCL symbol.
C
	INCLUDE 'COM.INC/NOLIST'

	CHARACTER*(*) SYMBOL, BUFFER

	SIZE = 0		! Initialize size
	BUFFER(1:1) = CHAR(0)	!	and first byte to null.

	GET_SYMBOL = LIB$GET_SYMBOL(SYMBOL,BUFFER,SIZE)
	IF (GET_SYMBOL) THEN
		CALL STR$UPCASE (BUFFER,BUFFER) ! Convert to uppercase.
		SYMBOL_COUNT = SYMBOL_COUNT + 1 ! Count symbols found.
	ENDIF
	RETURN
	END

	SUBROUTINE GET_PORT
C
C	This routine is used to request the remote port.
C
	INCLUDE 'COM.INC'

	CHARACTER*50 LOGICAL_DEVICE

	STATUS = GET_SYMBOL('REMOTE_PORT',LOGICAL_DEVICE,LBYTE_COUNT)
C
C	Assign channel to remote terminal.
C
	IF (NEED_TO_DEAS) CALL DEAL_PORT
C
	STATUS = SYS$ALLOC(LOGICAL_DEVICE(1:LBYTE_COUNT),
	1			REMOTE_SIZE,REMOTE_DEVICE,)
C
	NEED_TO_DEAL = .TRUE.	! Show terminal allocated.
C
	EXIT_ON_ERROR = .TRUE.		! Exit on further errors.
C
	STATUS = SYS$ASSIGN(REMOTE_DEVICE(1:REMOTE_SIZE),RCHAN_IN,,)
	STATUS = SYS$ASSIGN(REMOTE_DEVICE(1:REMOTE_SIZE),RCHAN_OUT,,)
C
	IF (STATUS) NEED_TO_DEAS = .TRUE.	! We have a port assigned.
C
	RETURN
	END

	SUBROUTINE DEAL_PORT
C
C	This routine is used to deassign and deallocate the remote port.
C	We don't need to reset the terminal characteristics because VMS
C	does that automatically when we deallocate.
C
	INCLUDE 'COM.INC/NOLIST'

	STATUS = SYS$DASSGN(%VAL(RCHAN_IN))
	STATUS = SYS$DASSGN(%VAL(RCHAN_OUT))
C
	STATUS = SYS$DALLOC(REMOTE_DEVICE(1:REMOTE_SIZE),)
C
	NEED_TO_DEAS = .FALSE.		! No remote port assigned.
C
	RETURN
	END

C
C	Utility routines for VAXNET.
C
	INTEGER FUNCTION CHECK_TYPEAHEAD
C
C	This routine checks for characters in the remote typeahead
C	buffer.  It passes back the typeahead count (if any).
C
	INCLUDE 'COM.INC/NOLIST'

	STATUS = SYS$QIOW(%VAL(REFN_IN), %VAL(RCHAN_IN),
	1	%VAL(IO$_SENSEMODE + IO$M_TYPEAHDCNT),
	1	RIOSB,,,TYPEAHEAD_COUNT,,,,,)
	CALL CHECK_STATUS('CHECK_TYPEAHEAD',STATUS)
	CHECK_TYPEAHEAD = TYPEAHEAD_COUNT(1)	! Pass back the count.
	RETURN
	END

	SUBROUTINE CLEAR_TYPEAHEAD
C
C	Clears the typeahead buffer on the remote channel.
C
	INCLUDE 'COM.INC/NOLIST'

	STATUS = SYS$QIOW(%VAL(REFN_IN), %VAL(RCHAN_IN),
	1	%VAL(IO$_READLBLK + IO$M_PURGE),
	2	RIOSB,,,RBUFFER,%VAL(0),,,,)
	CALL CHECK_STATUS('CLEAR_TYPEAHEAD',STATUS)
	RETURN
	END

	SUBROUTINE SEND_CODE
C
C	These routines are used to send a control character to the remote.
C
C	The entrys for sending of SOH, STX, and ETX were added for the
C	DEC DF03 ACU.  They must not have a carriage return appended to
C	them as do the other control characters.
C
	INCLUDE 'COM.INC/NOLIST'
	LOGICAL*1 LAST_CODE(2)
C
C	Entry to send SOH (Start of Header).	CTRL/A
C
	ENTRY SEND_SOH
	LAST_CODE(1) = SOH		! Save the last code.
	GO TO 50			!  and send it.
C
C	Entry to send STX (Start of Text).	CTRL/B
C
	ENTRY SEND_STX
	LAST_CODE(1) = STX		! Save the last code.
	GO TO 50			!  and send it.
C
C	Entry to send ETX (End of Text).	CTRL/C
C
	ENTRY SEND_ETX
	LAST_CODE(1) = ETX		! Save the last code.
50	CALL WRITE_BYTE(LAST_CODE(1),1)	! Write a single byte.
	RETURN
C
C	Entry to send ACK (Acknowlegment).
C
	ENTRY SEND_ACK
	LAST_CODE(1) = ACK		! Save the last code.
	GO TO 100			!  and send it.
C
C	Entry to send NAK (Negative Acknowlement).
C
	ENTRY SEND_NAK
	LAST_CODE(1) = NAK		! Save the last code,
	GO TO 100			!  and send it.
C
C	Entry to send SYN (Synchronize).
C
	ENTRY SEND_SYN
	LAST_CODE(1) = SYN		! Save the last code,
	GO TO 100 			!  and send it.
C
C	Entry to send ENQ (Enquire).
C
	ENTRY SEND_ENQ
	LAST_CODE(1) = ENQ		! Save the last code,
	GO TO 100			!  and send it.
C
C	Entry to send EOF (End of File).
C
	ENTRY SEND_EOF
	LAST_CODE(1) = EOF 		! Save the last code,
	GO TO 100			!  and send it.
C
C	Entry to send EOT (End of Transmission).
C
	ENTRY SEND_EOT
	LAST_CODE(1) = EOT		! Save the last code,
	GO TO 100			!  and send it.
C
C	Entry to send CAN (Cancel).
C
	ENTRY SEND_CAN
	LAST_CODE(1) = CAN		! Save the last code,
	GO TO 100			!  and send it.
C
C	This entry is used to resend the last code in the event that
C	the previous transmission was lost or garbled and the remote
C	sent us an ENQ to find out what the last response was.
C
	ENTRY RESEND_CODE
100	CALL WRITE_REMOTE(LAST_CODE(1),1)
	RETURN
	END

	SUBROUTINE WAITABIT(SECONDS)
C
C	This subroutine just waits a little then returns.
C
	INCLUDE 'COM.INC/NOLIST'

	CHARACTER*(*) SECONDS
	INTEGER*4 DELTA(2)
C
	STATUS = SYS$BINTIM('0 00:00:'//SECONDS,DELTA)
	IF (.NOT. CHECK_STATUS('WAITABIT(BINTIM)',STATUS)) RETURN
	STATUS = SYS$SETIMR(%VAL(TIMER_EFN),DELTA,,)
	IF (.NOT. CHECK_STATUS('WAITABIT(SETIMR)',STATUS)) RETURN
	STATUS = SYS$WAITFR(%VAL(TIMER_EFN))
	CALL CHECK_STATUS('WAITABIT(WAITFR)',STATUS)

C	STATUS = SYS$SCHDWK(,,DELTA,,)	! Schedule wakeup.
C	IF (.NOT. CHECK_STATUS('WAITABIT(SCHDWK)',STATUS)) RETURN
C	STATUS = SYS$HIBER()		! Go into hibernation.
	RETURN
	END

	INTEGER FUNCTION GET_EFN(EVENT_FLAG)
C
C	Get an event flag.
C
	IMPLICIT NONE
	INTEGER*4 EVENT_FLAG, CHECK_STATUS, LIB$GET_EF, STATUS

	STATUS = LIB$GET_EF(EVENT_FLAG)	! Local input event flag.
	CALL CHECK_STATUS('LIB$GET_EF',STATUS)
	RETURN
	END
