	SUBROUTINE WRITE_REMOTE(BUFFER,LOCBYTE)
C
C	This subroutine is used to write a buffer to the remote.
C
	INCLUDE 'COM.INC/NOLIST'

	LOGICAL*1 BUFFER(1)

	BYTES = LOCBYTE + 1		! Adjust the byte count.
	BUFFER(BYTES) = CR		! Append Terminator.
	GO TO 100			! And continue ...
C
C	The next entry is used to write the buffer without appending
C	a carriage return to the end of the message.
C
	ENTRY WRITE_BYTE(BUFFER,LOCBYTE)
	BYTES = LOCBYTE			! Copy the byte count.

100	STATUS = SYS$QIOW(%VAL(REFN_OUT), %VAL(RCHAN_OUT),
	1		%VAL(IO$_WRITELBLK + IO$M_NOFORMAT),
	1		XIOSB,,,BUFFER,%VAL(BYTES),,,,)
	RETURN
	END

	SUBROUTINE REMOTE_READ( IACT )
C
C	Read from the remote terminal port.
C
	INCLUDE 'COM.INC/NOLIST'

	MAXTRY = 0
	IINDX = 0
	IACT  = 2

	CALL READ_REMOTE(NBYTES)

	IF (NBYTES .GT. 0) THEN
		IINDX = 1
		CALL SHUFFLE(NBYTES)
	ELSE
		IINDX = 0
	ENDIF

	CALL WAITABIT( SHRT_WAIT )

	DO WHILE (MAXTRY .LT. 10) 

	   CALL READ_REMOTE(NBYTES)

	   IF (NBYTES .LE. 0) THEN
		MAXTRY = MAXTRY + 1
	   ELSE
		CALL SHUFFLE(NBYTES)
                IINDX = IINDX + 1
		MAXTRY = 0
	   ENDIF

	   CALL WAITABIT( SHRT_WAIT )

	ENDDO

	IF (IINDX .EQ. 0) IACT = -IACT

	RETURN
	END

	SUBROUTINE CLR_LOCAL

	INCLUDE 'COM.INC/NOLIST'
C
	LBUFFER = '            '
C
	RETURN
	END

	SUBROUTINE SHUFFLE(NB)

	INCLUDE 'COM.INC/NOLIST'

	IF (NB .LT. 12) THEN
	   IF ((NB+LOC_REM) .LE. 12) THEN
		DO II = 1,NB
		   KK = LOC_REM + II
		   LBUFFER(KK:KK) = CHAR(RBUFFER(II) .AND. "177)
		ENDDO
		LOC_REM = NB + LOC_REM
	   ELSE
		IDEL = NB + LOC_REM - 12
		DO II = (IDEL + 1),LOC_REM
		   KK = II - IDEL 
		   LBUFFER(KK:KK) = LBUFFER(II:II)
		ENDDO
		LOC_REM = LOC_REM - IDEL
		DO II = 1,NB
		   KK = LOC_REM + II
		   LBUFFER(KK:KK) = CHAR(RBUFFER(II) .AND. "177)
		ENDDO
		LOC_REM = 12
	   ENDIF
	ELSE
	   ISTRT = NB - 12
	   DO II = 1,12
		LBUFFER(II:II) = CHAR(RBUFFER(II+ISTRT) .AND. "177)
	   ENDDO
	   LOC_REM = 12
	ENDIF

	RETURN
	END

	SUBROUTINE READ_REMOTE(NBYTES)
C
C	Read from the remote terminal port.
C
	INCLUDE 'COM.INC/NOLIST'

	EXTERNAL REMOTE_AST
C
100	CONTINUE
C
	NBYTES = OBYTES
C
C	If there is nothing in the typeahead buffer, we simply issue
C	a one character read.
C
	STATUS = SYS$QIOW(%VAL(REFN_IN), %VAL(RCHAN_IN),
	1	%VAL(IO$_SENSEMODE + IO$M_TYPEAHDCNT),
	1	RIOSB,,,TYPEAHEAD_COUNT,,,,,)
	CALL CHECK_STATUS('REMOTE_SENSEMODE',STATUS)
	NBYTES = TYPEAHEAD_COUNT(1)	! Copy the typeahead count.
C
	IF (NBYTES .GE. 0) GO TO 150
C
	GOTO 200
C
C	Save the maximum typeahead buffer count for output in the
C	status report for debugging.
C
150	IF (NBYTES .GT. MAX_TYPEAHEAD) MAX_TYPEAHEAD = NBYTES	! Save the maximum read.
C
C	If the new typeahead buffer count and the old typeahead buffer
C	count is equal, or the count is nearing the typeahead size, we
C	read the number of characters in the typeahead buffer.
C
	IF (OBYTES .EQ. NBYTES .OR.
	1	NBYTES .GT. TYPEAHEAD_SIZE) GO TO 200
	OBYTES = NBYTES			! Save the typeahead count.
	GO TO 100			! Get typeahead count again.
C
C	We're finally ready to issue the remote read.
C
200	IF (NBYTES .EQ. 0) RETURN
C200	IF (NBYTES .EQ. 0) GOTO 250
C
	RECEIVER_BUSY = .TRUE.		! Set the receiver busy.
	OBYTES = 0
	ITMO = 4	!IN CONJUNCTION WITH IO$M_TIMED IN $QIO
	MAX_ASTS = MAX_ASTS + 1
C
	STATUS = SYS$QIOW(%VAL(REFN_IN), %VAL(RCHAN_IN),
	1	%VAL(IO$_TTYREADALL + IO$M_NOECHO + IO$M_TIMED),
	1	RIOSB,REMOTE_AST,,RBUFFER,%VAL(NBYTES),%VAL(ITMO),NOTERM,,)
	IF (STATUS) THEN
		REMOTE_ASTS = REMOTE_ASTS + 1	! Count outstanding ASTs.
	ENDIF
C
	RECEIVER_BUSY = .FALSE.		! Show receiver not busy.
	CALL CHECK_STATUS('READ_REMOTE',STATUS)
	CALL WAKE_UP()			! Wake us up.
	RETURN
	END

	INTEGER FUNCTION STR_COMPARE(LOCBUF, ICMPRE, LEN)
C
	CHARACTER	LOCBUF*12, ICMPRE*9
C
	LK = 12 - LEN + 1
C
	STR_COMPARE = 0
C
	DO II = 1,LK
C
	   IEND = II + LEN - 1
	   IF (LOCBUF(II:IEND) .EQ. ICMPRE(1:LEN)) STR_COMPARE = II
C
	ENDDO
C
	RETURN
	END

	SUBROUTINE REMOTE_AST
C
C	This AST routine is entered when the read request for the remote
C	terminal completes.  It then writes the data read from the remote
C	to the local terminal and the log file (if any).
C
	INCLUDE 'COM.INC/NOLIST'

	RECEIVER_BUSY = .FALSE. 	! Set receiver not busy.
	REMOTE_ASTS = REMOTE_ASTS - 1	! Adjust our AST count.
	STATUS_CODE = RIOSB(1)		! Copy the status code.
	NBYTES = RIOSB(2)		!  and the byte count.
C
C	Save the maximum typeahead buffer count for output in the
C	status report for debugging.
C
	IF (NBYTES .GT. MAX_TYPEAHEAD) THEN
		MAX_TYPEAHEAD = NBYTES	! Save the maximum read.
	ENDIF
C
C	Don't issue the local write if the read failed.
C
	IF (STATUS_CODE .EQ. SS$_ABORT) THEN
	    GO TO 100			! We've been canceled.
	ELSE
	    IF (.NOT. STATUS_CODE) THEN
		IF (STATUS_CODE .NE. SS$_TIMEOUT) THEN
		    CALL CHECK_STATUS('REMOTE_QIO',STATUS_CODE)
		    GO TO 100		! Continue ...
		ENDIF
	    ENDIF
	ENDIF
C
C	Copy incoming characters to the logfile buffer.
C
	CALL WRITE_LOGFILE(RBUFFER,NBYTES)
C
C	We don't re-arm the remote read in this routine because we're at 
C	AST level which blocks an AST generated by the local read completing.
C
100	CALL WAKE_UP()		! Wakeup the mainline code.
	RETURN
	END

	SUBROUTINE SETUP_REMOTE
C
C	This routine is used to setup the remote terminal characteristics.
C	It also sets the REMOTE flag to TRUE if the remote bit is set.
C	During interactive terminal communication, the terminal is setup:
C
C	/VT100, WIDTH=511, PAGE=same, OWNER=SELF
C	SPEED=(user_specified), CRFILL=0, LFFILL=0, NOPARITY
C	PASSALL, NOECHO, TYPEAHEAD, NOESCAPE, HOSTSYNC, TTYSYNC,
C	LOWERCASE, TAB, NOWRAP, SCOPE, REMOTE, NOHOLDCREEN,
C	EIGHTBIT, NOBROADCAST, NOREADSYNC, FORM, FULLDUP
C
C	During file transmission, HOSTSYNC and TTYSYNC will be disabled
C	so the terminal doesn't send XON and XOFF or expect XON or XOFF.
C	This was causing SNDRCV to get hung in a suspend (XON) state which
C	could only be resolved by aborting and restarting the transfer.
C
C	Inputs:
C		INTERACTIVE - .TRUE. to setup for interactive terminal,
C			      .FALSE. to setup for file transmission.
C		BAUD_RATE   - contains the remote baud rate.
C		READ_ONE    - .TRUE. if doing one character reads.
C			    - .FALSE. if using XON and XOFF to control
C			       typeahead buffer overflow.
C
C	Get remote terminal characteristics.
C
	INCLUDE 'COM.INC/NOLIST'
	INCLUDE 'TTDEF.FOR/NOLIST'
	INCLUDE 'TT2DEF.FOR/NOLIST'

	INTEGER*4 SET_REMOTE(3)
	LOGICAL INTERACTIVE

C
C	Get the remote terminal characteristics.
C
	REMOTE_STATUS = SYS$QIOW(%VAL(REFN_IN), %VAL(RCHAN_IN),
	1	%VAL(IO$_SENSEMODE),RIOSB,,,REMOTE_CHAR,%VAL(12),,,,)
C	CALL CHECK_STATUS('SETUP_TERMINALS',REMOTE_STATUS)
C
C	In VMS version 3.0, we can now determine if a terminal port is
C	enabled for a modem.  If it isn't SET /MODEM, we won't output
C	various messages about dialing the modem, hanging up, etc.
C
	MODEM = .TRUE.		! Port is setup for MODEM.
C
	REMOTE = .TRUE.	! Flag remote (Dialup).
C
C	If the alternate typeahead buffer is enabled, modify the
C	typeahead buffer size.  The default for our system are:
C
C	TTY_ALTYPAHD = 200	! Alternate typeahead size.
C	TTY_ALTALARM = 64	! Count before XON sent.
C
C	Ideally, we never want the terminal driver to send XON.  Until
C	VAXNET is rewritten with a better method of reading the remote
C	characters, we try to set the typeahead buffer size to a count
C	which allows us to read incoming data before TTY_ALTALARM is
C	reached so XON isn't sent.
C
	TYPEAHEAD_SIZE = 200-100 ! Should prevent XON ???
C
C	Copy the current terminal characteristics and add some more.
C	Note, we don't change the extended terminal characteristics.
C
	SET_REMOTE(1) = REMOTE_CHAR(1)
	SET_REMOTE(2) = REMOTE_CHAR(2)

	SET_CHAR =	TT$M_LOWER + TT$M_MECHFORM + TT$M_MECHTAB +
	1		TT$M_NOBRDCST + TT$M_NOECHO + TT$M_PASSALL +
	1		TT$M_EIGHTBIT + TT$M_SCOPE
C
C	For interactive mode, we want to set the bits for HOSTSYNC and
C	TTSYNC so XON and XOFF are used by the terminal driver to control
C	incoming data.  These bits MUST be set when operating at high
C	baud rates otherwise the typeahead buffer is overflowed.  This
C	could be solved by using muliple buffers and multiple QIO's.
C
C Note:
C	Currently these bits are only enabled if the READ_ONE flag is
C	set false when setting up the system type (i.e., DEC or EASYLINK).
C
C	IF (INTERACTIVE) THEN
C		IF (.NOT. READ_ONE)
C	1		SET_CHAR = SET_CHAR + TT$M_HOSTSYNC + TT$M_TTSYNC
C	ENDIF
C
C	In VMS V3.0, if HOSTSYNC and TTSYNC are disabled, the terminal
C	driver is returning a data overrun error on the remote read.
C	If these bits are enabled, everything seems to work Ok. Why ???
C
	SET_CHAR = SET_CHAR + TT$M_HOSTSYNC + TT$M_TTSYNC
C
C	CALL LIB$INSV(TT$_VT100,8,8,SET_REMOTE(1))
	CALL LIB$INSV(511,16,16,SET_REMOTE(1))
	CALL LIB$INSV(SET_CHAR,0,(TT$V_HALFDUP+1),SET_REMOTE(2))
C
C	Setup the remote terminal characteristics.
C
	REMOTE_STATUS = SYS$QIOW(%VAL(REFN_IN), %VAL(RCHAN_IN),
	1	%VAL(IO$_SETMODE),RIOSB,,,SET_REMOTE,,%VAL(BAUD_RATE),,,)
	CALL CHECK_STATUS('SETUP_TERMINALS',REMOTE_STATUS)

	RETURN
	END
