$!
$	SET NOVERIFY
$!
$!
$!			FORD AEROSPACE & COMMUNICATION CORP.
$!
$!			IN COOPERATION WITH:
$!
$!			NASA/JSC BUILDING 37,
$!			LIFE SCIENCES MEDICAL OPERATIONS
$!			HOUSTON, TEXAS  77058.
$!
$!
$!			ATTENTION:
$!
$!			WILLIAM BAKER
$!			SYSTEM MANAGER
$!
$!			713-483-7252
$!			713-335-6318
$!
$!
$!----------------------------------------------------------------------------
$!	ENTER TELEMAIL BULLETIN BOARD BATCH PROGRAM.
$!		SET ERROR CONDITION SUCH THAT WE DON'T KILL JOB WHEN
$!		AN ERROR OCCURS THAT IS PLANNED FOR.
$!		DEFINE COMMUNICATIONS SPEED.
$!		DEFINE SCRIPT FILE FOR TELEBULB EXECUTABLE
$!		DEFINE DATE THAT TELEMAIL SCAN FUNCTION IS TO USE.
$!		GIVE PROCESS A LITTLE EXTRA PRIORITY SO IT CAN RUN
$!		WITHOUT GETTING HUNG BY THE SYSTEM.
$!----------------------------------------------------------------------------
$!
$	SET NOON
$!
$	REMOTE_SPEED := 9600
$!
$	ALT_SERVICE = ""
$	IF P3 .NES. "" THEN ALT_SERVICE = "''P3'"
$!
$	SCRPTFLE = "ROOT_TMAIL:[BULB]TELEBULB.MAI"
$	IF P2 .NES. "" THEN SCRPTFLE = "''P2'"
$!
$	@ROOT_TMAIL:[BULB]BULBDATE 'P1'
$!
$	SHOW SYM SCRPTFLE
$!
$	PORT_STP = 0
$	LOOPCNT = 0
$!
$	SET PROCESS/PRIORITY=4/NAME=TELEBULB
$!
$!----------------------------------------------------------------------------
$!	SET UP DEFAULT CONDITIONS:
$!		SET MESSAGE LEVEL SO WE KNOW WHAT THE ERROR MESSAGES MEAN.
$!		SET DEFAULT DIRECTORY SO WE KNOW WHERE WE ARE.
$!		CLEAN-UP THE DEFAULT DIRECTORY, REMOVE ANY OLD MAIL FILES.
$!		TELL ME USER NAME OF TELEMAIL SYSTEM MANAGER.
$!		DEFINE SYMBOLS FOR PROGRAM TO REFORMAT TELEMAIL BB LOGFILES.
$!		SET NASA/PSCN USERNAME AND PASSWORD.
$!----------------------------------------------------------------------------
$!
$	SET MESSAGE/SEV/ID/TEXT/FAC
$!
$	SET DEFAULT ROOT_TMAIL:[BULB]
$!
$!	DELETE/LOG *.TEL;*,*.LOG;*
$!
$	TMAILMGR :== "SYSTEM"
$!
$	PSCNUSER :== "JSCGP"
$	PSCNPASS :== "PSCN"
$!
$	RFMTMAIL :== $ROOT_TMAIL:[SEND]RFMTMAIL
$!
$!
$!----------------------------------------------------------------------------
$!	DEFINE THE DIAL-OUT PORT THE PROGRAM WILL USE.
$!		OPEN THE TELEPORT.LIS FILE WHICH CONTAINS THE PORT DEFINITIONS.
$!		READ THE TEMPLATE LINE, AND THE FIRST PORT IN THE FILE.
$!		SET UP SYMBOLS CONTAINING THE PORT DEFINITIONS.
$!		LOOP AS NEEDED TO OBTAIN ALL PORT DEFINITIONS.
$!----------------------------------------------------------------------------
$!
$!
$	OPEN/READ/ERROR=NO_PORTS   PORTS    ROOT_TMAIL:[BULB]TELEPORT.LIS
$!
$	READ			   PORTS    LINEOUT
$!
$	PORTCNT = 0
$!
$	READ/END_OF_FILE=NO_PORTS  PORTS    LINEOUT
$!
$ PORT_LOOP:
$!
$	PORTCNT = PORTCNT + 1
$!
$	INPRT = F$EXTRACT(0,8,"''LINEOUT'")
$	CUR_PORT'PORTCNT' = F$EDIT("''INPRT'","COMPRESS,TRIM")
$!
$	INTYP = F$EXTRACT(10,5,"''LINEOUT'")
$	CUR_TYPE'PORTCNT' = F$EDIT("''INTYP'","COMPRESS,TRIM")
$!
$	READ/END_OF_FILE=PORT_EXIT  PORTS    LINEOUT
$!
$	GOTO PORT_LOOP
$!
$ PORT_EXIT:
$!
$!----------------------------------------------------------------------------
$!		CLOSE TELEPORT.LIS FILE
$!		INCREMENT COUNTER TO SET PORT
$!		CHECK PORT COUNTER AND RESET IF NEEDED.
$!----------------------------------------------------------------------------
$!
$	CLOSE PORTS
$!
$ NEXT_PORT:
$!
$	PORT_STP = PORT_STP + 1
$!
$	IF PORT_STP .GT. PORTCNT THEN WAIT 00:15
$	IF PORT_STP .GT. PORTCNT THEN PORT_STP = 1
$!
$!----------------------------------------------------------------------------
$!	FINAL DIAL-OUT PORT CONDITIONS SET.
$!		DEFINE THE SYMBOLS FOR THE PORTS TO USED BY THE TELEMAIL BB .
$!----------------------------------------------------------------------------
$!
$	REMOTE_PORT = CUR_PORT'PORT_STP'
$!
$	MODEM_TYPE = CUR_TYPE'PORT_STP'
$!
$!----------------------------------------------------------------------------
$!	RUN THE TELEMAIL BB  PROGRAM.
$!		ALLOCATE THE CURRENTLY DEFINED DIAL-OUT PORT TO PROCESS.
$!		ASSIGN THE USER DEFINITION FILE TO THE PROGRAM LOGICAL
$!		EXECUTE THE TELEMAIL BB  PROGRAM.
$!		IF PROGRAM FAILS TO EXECUTE PROPERLY, BRANCH TO ERROR EXIT.
$!----------------------------------------------------------------------------
$!
$	ALLOCATE 'REMOTE_PORT'
$	IF .NOT. $STATUS THEN GOTO NEXT_PORT
$!
$	LOOPCNT = LOOPCNT + 1
$!
$	ASSIGN 'SCRPTFLE'	TELEBULB
$!
$!				EXECUTE TELEMAIL PROGRAM
$!
$	RUN ROOT_TMAIL:[BULB]TELEBULB
$	IF .NOT. $STATUS THEN GOTO FAILMSG
$!
$!----------------------------------------------------------------------------
$!	TELEMAIL BB  PROGRAM EXECUTION RESULTS.
$!		SHOW TELEREAD DEFINED SYMBOLS.
$!		DEALLOCATION OF DIAL-OUT PORT.
$!		DETERMINE IF PROGRAM RAN PROPERLY, CONNECTION MADE, ETC...
$!		DEASSIGN FILES ALLOCATED TO PROGRAM EXECUTION.
$!----------------------------------------------------------------------------
$!
$	SHOW SYMBOL/GLOBAL USER_*
$	SHOW SYMBOL/GLOBAL LASTUSER
$!
$	DEALLOCATE 'REMOTE_PORT'
$!
$	IF LOOPCNT .EQ. 2 THEN GOTO NOMORELOOP
$!
$	IF LASTUSER .EQS. "TMAILDOWN" THEN GOTO 'LASTUSER'
$	IF LASTUSER .NES. "COMPLETE" THEN GOTO NEXT_PORT
$!
$ NOMORELOOP:
$!
$	DEASSIGN TELEBULB
$!
$!----------------------------------------------------------------------------
$!	SET UP FOR SENDING BB TO USERS.
$!		CLEANUP FILES GENERATED BY THE TELEMAIL BB  PROGRAM.
$!		OPEN USER DEFINITION FILE AND READ TEMPLATE LINE.
$!		SET DATE FOR MAIL MESSAGES.
$!----------------------------------------------------------------------------
$!
$	PURGE *.LOG,*.TEL
$!
$	PRSNTML :== "$ROOT_TMAIL:[READ]PRSETMAIL
$	SYMFIND :== "$ROOT_TMAIL:[READ]SYMFIND
$!
$	OPEN/READ/ERROR=NO_MORE	RFRM 	'SCRPTFLE'
$!
$	DATE = F$TIME()
$	DATE = F$EXTRACT(0,11,DATE)
$!
$ START:
$!
$!----------------------------------------------------------------------------
$!		READ NEXT LINES OF THE USER DEFINITION.
$!		DETERMINE LOGFILE NAME, VAX USERNAME.
$!		GENERATE SYMBOLS NEEDED (SYMFIND).
$!----------------------------------------------------------------------------
$!
$	READ/END_OF_FILE=NO_MORE  RFRM  SEND_TO
$	SEND_TO = F$EDIT(SEND_TO,"COMPRESS,TRIM")
$!
$	READ/END_OF_FILE=NO_MORE  RFRM  TELUSER
$	TELUSER = F$EDIT(TELUSER, "COMPRESS,TRIM")
$!
$	READ/END_OF_FILE=NO_MORE  RFRM  TELPASS
$!
$	READ/END_OF_FILE=NO_MORE  RFRM  TELBULB
$!
$	WRITE SYS$OUTPUT "*-*-*-*-*-*-*-*-*-*-*-* 	''TELBULB' 	*-*-*-*-*-*-*-*-*-*-*-*"
$!
$	SYMFIND 'TELBULB'
$!
$!----------------------------------------------------------------------------
$!		SET SYMBOL FOR NUMBER OF BB MESSAGES READ TO ZERO.
$!		CHECK IF ANY BB MAIL WAS READ FOR THIS BOARD.
$!			BRANCH IF NO MAIL WAS READ, TO FINAL USER PROCESS.
$!		BUILD SYMBOL FOR CHECKING FOR UNREAD MAIL.
$!		CHECK FOR UNREAD MAIL, INFORM MANAGER IF ANY MAY EXIST.
$!		REFORMAT LOGFILE GENERATED BY TELEMAIL READ PROGRAM.
$!----------------------------------------------------------------------------
$!
$	MLCNT = "0"
$!
$	IF (CNNTUSR .EQS. "NOCONNECT") THEN GOTO NOLOGIN
$!
$	IF (((CNNTUSR .NES. "READ_MAIL")		.AND.	-
	     (CNNTUSR .NES. "INCOMPLETE"))	.OR.	-
	     (CNNTUSR .EQS. "CONNECT"))	THEN GOTO NONEG_MSG
$!
$	UNRDUSR = "READ_''LOG_FILE'" - ".LOG"
$	IF 'UNRDUSR' .NES. "" THEN GOTO INFORM_UNREAD
$!
$ CONT_PROC:
$!
$	RFMTMAIL 'LOG_FILE'
$	IF .NOT. $STATUS THEN GOTO NOLOGIN
$!
$!----------------------------------------------------------------------------
$!	PREPARE BB MAIL FOR TRANSMITTAL TO USERS VAX MAIL ACCOUNT.
$!		DEFINE REFORMATTED LOGFILE AS LOGICAL FOR MAIL PARSE PROGRAM.
$!		RUN MAIL PARSE PROGRAM.
$!		TRANSLATE MAIL COUNT SYMBOL.
$!		CHECK IF ANY MAIL FOUND, BRANCH IF NONE.
$!		DEFINE MAIL SUBJECT SYMBOL.
$!		TRY TO SEND MAIL TO VAX USER.  
$!----------------------------------------------------------------------------
$!
$	ASSIGN ROOT_TMAIL:[BULB]'LOG_FILE' FIRSTLOG
$!
$	PRSNTML
$	IF .NOT. $STATUS THEN GOTO NOLOGIN
$!
$	SBJCNT = F$INTEGER(MLCNT)
$!
$ LOOP:
$!
$	IF SBJCNT .EQ. 0 THEN GOTO NONEG_MSG
$	MLSYM = SUBJ_'SBJCNT'
$	MLSBJ := 'MLSYM'
$!
$	MAIL/SUBJECT="Telemail:  ''MLSBJ'"	 -
	ROOT_TMAIL:[BULB]NEWMAIL.TEL 'SEND_TO'
$	IF $STATUS THEN GOTO DELNEWMAIL
$!
$	GOTO NONEG_MSG
$!
$ DELNEWMAIL:
$!
$!----------------------------------------------------------------------------
$!	PREPARE FOR NEXT MAILING OF TELEMAIL FOR CURRENT USER.
$!		REMOVE MAIL MESSAGE JUST SENT FROM FILE QUEUE.
$!		SET FLAG INDICATING NOT FIRST TELEMAIL MESSAGE.
$!		BRANCH BACK TO SECTION FOR SENDING VAX MAIL.
$!----------------------------------------------------------------------------
$!
$	DELETE/SYMBOL/LOCAL	SUBJ_'SBJCNT'
$	SBJCNT = SBJCNT - 1
$	DELETE/LOG ROOT_TMAIL:[BULB]NEWMAIL.TEL;
$	GOTO LOOP
$!
$ NONEG_MSG:
$!
$!----------------------------------------------------------------------------
$!	PREPARE FOR NEXT TELEMAIL USERS MAIL.
$!		DELETE FLAG FOR FIRST TELEMAIL MESSAGE.
$!		BRANCH TO READ NAME OF NEXT VAX USER.
$!----------------------------------------------------------------------------
$!
$	DELETE/SYMBOL/LOCAL MLCNT
$!
$	GOTO START
$!
$ NO_MORE:
$!
$!----------------------------------------------------------------------------
$!	CLEANUP OF DIRECTORY AND ARCHIVE OF TODAYS LOGFILES.
$!		CLOSE USER DEFINITION FILE.
$!		WAIT 10 SECONDS, JUST FOR LUCK.
$!		PURGE DOWN THE LOGFILES.  RENAME LOGFILES TO SUB-DIRECTORY.
$!		EXIT BATCH JOB.
$!----------------------------------------------------------------------------
$!
$	CLOSE RFRM
$!
$	WAIT 00:00:10
$!
$	PURGE ROOT_TMAIL:[BULB]*.LOG
$!
$	RENAME ROOT_TMAIL:[BULB]*.LOG ROOT_TMAIL:[BULB]*.TEL
$!
$	RENAME ROOT_TMAIL:[BULB]*.TEL ROOT_TMAIL:[BULB.ARCHIVE]
$!
$	RENAME ROOT_TMAIL:[BULB]*.LOG ROOT_TMAIL:[BULB.ARCHIVE]
$!
$	EXIT
$!
$ NOLOGIN:
$!
$!----------------------------------------------------------------------------
$!	FAILURE MESSAGE TO USER.
$!		TELL USER THAT PROGRAM DID NOT READ HIS MAIL FOR HIM.
$!		SENDS TO SYSTEM MANAGER TO, SO HE CAN FIGURE OUT WHY.
$!		BRANCH BACK TO GET MAIL FILE FOR NEXT VAX USER.
$!----------------------------------------------------------------------------
$!
$	MAIL/SUBJECT="No BULLETIN BOARD READ for ''TELBULB', ''CNNTUSR' Accomplished." -
	ROOT_TMAIL:[TEXT]NOLOGMSG.TXT   'TMAILMGR'
$!
$	GOTO START
$!
$ FAILMSG:
$!
$!----------------------------------------------------------------------------
$!	TELEMAIL PROGRAM DID NOT CONNECT.
$!		TELL SYSTEM MANAGER THAT PROGRAM DID NOT PERFORM PROPERLY.
$!		EXIT BATCH JOB.
$!----------------------------------------------------------------------------
$!
$	MAIL/SUBJECT="TELEMAIL BULLETIN BOARD PROGRAM FAILED, ''DATE'" -
	ROOT_TMAIL:[TEXT]FAILMSG.TXT "''TMAILMGR'"
$!
$	EXIT
$!
$ NO_PORTS:
$!
$!----------------------------------------------------------------------------
$!	NO DIAL-OUT PORTS WERE DEFINED FOR PROGRAM.
$!		ISSUE MESSAGE TO SYS$OUTPUT.  SO MESSAGE IS IN LOG FILE.
$!		SEND MAIL TO SYSTEM MANAGER.
$!		EXIT BATCH JOB.
$!----------------------------------------------------------------------------
$!
$	CLOSE PORTS
$!
$	OUT :== WRITE SYS$OUTPUT
$!
$	OUT "YOU HAVE NOT DEFINED YOUR DIAL OUT PORTS IN THE FILE"
$	OUT "ROOT_TMAIL:[BULB]TELEPORT.LIS.  YOU MUST DEFINE AT"
$	OUT "LEAST ONE DIALOUT PORT IN THIS FILE FOR THE TELEMAIL"
$	OUT "READ PROGRAM TO PROPERLY FUNCTION."
$!
$	MAIL/SUBJECT="TELEBULB DIAL-OUT PORTS NOT DEFINED.  ''DATE'" -
	ROOT_TMAIL:[TEXT]FAILMSG.TXT "''TMAILMGR'"
$!
$	EXIT
$!
$ INFORM_UNREAD:
$!
$!----------------------------------------------------------------------------
$!		INFORM TELEMAIL MANAGER THAT A MAIL MESSAGE MAY
$!		HAVE BEEN INCOMPLETELY READ BY THE PROGRAM.
$!----------------------------------------------------------------------------
$!
$	MAIL/SUBJ="NEED TO READ BB MAIL FOR:  ''UNRDUSR'"  NL:  'TMAILMGR'
$!
$	GOTO CONT_PROC
$!
$ TMAILDOWN:
$!
$!----------------------------------------------------------------------------
$!	TELEMAIL PROGRAM DID NOT CONNECT.
$!		TELL SYSTEM MANAGER THAT PROGRAM DID PERFORM PROPERLY,
$!		BUT THAT TELEMAIL SYSTEM WAS NOT AVAILABLE.
$!----------------------------------------------------------------------------
$!
$	MAIL/SUBJECT="TELEBULB PROGRAM COULD NOT CONNECT TO TELEMAIL SYSTEM, ''DATE'" -
	NL: 'TMAILMGR'
$!
$	EXIT
