$!
$	SET NOVERIFY
$!
$!
$!			FORD AEROSPACE & COMMUNICATION CORP.
$!
$!			IN COOPERATION WITH:
$!
$!			NASA/JSC BUILDING 37,
$!			LIFE SCIENCES MEDICAL OPERATIONS
$!			HOUSTON, TEXAS  77058.
$!
$!
$!			ATTENTION:
$!
$!			WILLIAM BAKER
$!			SYSTEM MANAGER
$!
$!			713-483-7252
$!			713-335-6318
$!
$!	COMMAND PROCEDURE FOR VERSION 2.2 OF TELEREAD.
$!
$!----------------------------------------------------------------------------
$!	ENTER TELEMAIL READ BATCH PROGRAM.
$!		SET ERROR CONDITION SUCH THAT WE DON'T KILL JOB WHEN
$!		AN ERROR OCCURS THAT IS PLANNED FOR.
$!		DETERMINE ALTERNATE SERVICES OR ALTERNATE SCRIPT FILE.
$!		GIVE PROCESS A LITTLE EXTRA PRIORITY SO IT CAN RUN
$!		WITHOUT GETTING HUNG BY THE SYSTEM.
$!----------------------------------------------------------------------------
$!
$	SET NOON
$!
$	REMOTE_SPEED := 9600
$!
$	MRMAN :== $SYS$SYSTEM:MRMAN
$!
$	ALT_SERVICE = ""
$	PRCNM = "TELE_MRD"
$	IF P2 .NES. "" THEN ALT_SERVICE = "''P2'"
$	IF P2 .EQS. "TELEMAIL" THEN PRCNM = "USRA_MAIL"
$	IF P2 .EQS. "MAIL" THEN PRCNM = "OMNI_MAIL"
$!
$	SCRPTFLE = "ROOT_TMAIL:[READ.SCRIPTS]TELECOMM.MAI"
$	IF P1 .NES. "" THEN SCRPTFLE = "ROOT_TMAIL:[READ.SCRIPTS]''P1'"
$!
$	LOOPCNT = 0
$!
$	SET PROCESS/PRIORITY=3/NAME='PRCNM'
$!
$!----------------------------------------------------------------------------
$!	SET UP DEFAULT CONDITIONS:
$!		SET MESSAGE LEVEL SO WE KNOW WHAT THE ERROR MESSAGES MEAN.
$!		SET DEFAULT DIRECTORY SO WE KNOW WHERE WE ARE.
$!		CLEAN-UP THE DEFAULT DIRECTORY, REMOVE ANY OLD MAIL FILES.
$!		DEFINE SYMBOLS FOR NPSS LOGON.  (USER ID, AND PASSWORD)
$!		TELL ME USER NAME OF TELEMAIL SYSTEM MANAGER.
$!		DEFINE SYMBOLS FOR PROGRAM TO REFORMAT TELEMAIL READ LOGFILES.
$!		SET NASA/PSCN USERNAME AND PASSWORD.
$!----------------------------------------------------------------------------
$!
$	SET MESSAGE/SEV/ID/TEXT/FAC
$!
$	SET DEFAULT ROOT_TMAIL:[READ]
$!
$!	DELETE/LOG *.TEL;*,*.LOG;*
$!
$	TMAILMGR :== "SYSTEM"
$!
$	PSCNUSER :== "JSCGP"
$	PSCNPASS :== "PSCN"
$!
$	PORT_STP = 0
$!
$	RFMTMAIL :== $ROOT_TMAIL:[SEND]RFMTMAIL
$!
$!----------------------------------------------------------------------------
$!	DEFINE THE DIAL-OUT PORT THE PROGRAM WILL USE.
$!		OPEN THE TELEPORT.LIS FILE WHICH CONTAINS THE PORT DEFINITIONS.
$!		READ THE TEMPLATE LINE, AND THE FIRST PORT IN THE FILE.
$!		SET UP SYMBOLS CONTAINING THE PORT DEFINITIONS.
$!		LOOP AS NEEDED TO OBTAIN ALL PORT DEFINITIONS.
$!----------------------------------------------------------------------------
$!
$!
$	OPEN/READ/ERROR=NO_PORTS   PORTS    ROOT_TMAIL:[READ]TELEPORT.LIS
$!
$	READ			   PORTS    LINEOUT
$!
$	PORTCNT = 0
$!
$	READ/END_OF_FILE=NO_PORTS  PORTS    LINEOUT
$!
$ PORT_LOOP:
$!
$	PORTCNT = PORTCNT + 1
$!
$	INPRT = F$EXTRACT(0,8,"''LINEOUT'")
$	CUR_PORT'PORTCNT' = F$EDIT("''INPRT'","COMPRESS,TRIM")
$!
$	INTYP = F$EXTRACT(10,5,"''LINEOUT'")
$	CUR_TYPE'PORTCNT' = F$EDIT("''INTYP'","COMPRESS,TRIM")
$!
$	READ/END_OF_FILE=PORT_EXIT  PORTS    LINEOUT
$!
$	GOTO PORT_LOOP
$!
$ PORT_EXIT:
$!
$!----------------------------------------------------------------------------
$!		CLOSE TELEPORT.LIS FILE
$!		INCREMENT COUNTER TO SET PORT
$!		CHECK PORT COUNTER AND RESET IF NEEDED.
$!----------------------------------------------------------------------------
$!
$	CLOSE PORTS
$!
$ NEXT_PORT:
$!
$	PORT_STP = PORT_STP + 1
$!
$	IF PORT_STP .GT. PORTCNT THEN WAIT 00:15
$	IF PORT_STP .GT. PORTCNT THEN PORT_STP = 1
$!
$!----------------------------------------------------------------------------
$!	FINAL DIAL-OUT PORT CONDITIONS SET.
$!		DEFINE THE SYMBOLS FOR THE PORTS TO USED BY THE TELEMAIL READ.
$!----------------------------------------------------------------------------
$!
$	REMOTE_PORT = CUR_PORT'PORT_STP'
$!
$	MODEM_TYPE = CUR_TYPE'PORT_STP'
$!
$!----------------------------------------------------------------------------
$!	RUN THE TELEMAIL READ PROGRAM.
$!		ALLOCATE THE CURRENTLY DEFINED DIAL-OUT PORT TO PROCESS.
$!		ASSIGN THE USER DEFINITION FILE TO THE PROGRAM LOGICAL
$!		EXECUTE THE TELEMAIL READ PROGRAM.
$!		IF PROGRAM FAILS TO EXECUTE PROPERLY, BRANCH TO ERROR EXIT.
$!----------------------------------------------------------------------------
$!
$	ALLOCATE 'REMOTE_PORT'
$	IF .NOT. $STATUS THEN GOTO NEXT_PORT
$!
$	LOOPCNT = LOOPCNT + 1
$!
$	ASSIGN 'SCRPTFLE'	TELECOMM
$!
$!				EXECUTE TELEMAIL PROGRAM
$!
$!	SHOW PROC/ACC
$!
$	RUN ROOT_TMAIL:[READ]TELEREAD
$	IF .NOT. $STATUS THEN GOTO FAILMSG
$!
$!	SHOW PROC/ACC
$!
$!----------------------------------------------------------------------------
$!	TELEMAIL READ PROGRAM EXECUTION RESULTS.
$!		SHOW TELEREAD DEFINED SYMBOLS.
$!		DEALLOCATION OF DIAL-OUT PORT.
$!		DETERMINE IF PROGRAM RAN PROPERLY, CONNECTION MADE, ETC...
$!		DEASSIGN FILES ALLOCATED TO PROGRAM EXECUTION.
$!----------------------------------------------------------------------------
$!
$	SHOW SYMBOL/GLOBAL USER_*
$	SHOW SYMBOL/GLOBAL LASTUSER
$!
$	DEALLOCATE 'REMOTE_PORT'
$!
$	IF LOOPCNT .EQ. 2 THEN GOTO NOMORELOOP
$!
$	IF LASTUSER .EQS. "TMAILDOWN" THEN GOTO 'LASTUSER'
$	IF LASTUSER .NES. "COMPLETE" THEN GOTO NEXT_PORT
$!
$ NOMORELOOP:
$!
$	DEASSIGN TELECOMM
$!
$!----------------------------------------------------------------------------
$!	SET UP FOR SENDING TELEMAIL TO USERS.
$!		CLEANUP FILES GENERATED BY THE TELEMAIL READ PROGRAM.
$!		OPEN USER DEFINITION FILE AND READ TEMPLATE LINE.
$!		SET DATE FOR MAIL MESSAGES.
$!----------------------------------------------------------------------------
$!
$	MRTOVMSSUB = "0"
$!
$	PURGE *.LOG,*.TEL
$!
$	PRSNTML :== "$ROOT_TMAIL:[READ]PRSETMAIL
$	SYMFIND :== "$ROOT_TMAIL:[READ]SYMFIND
$!
$	OPEN/READ/ERROR=NO_MORE	RFRM 	'SCRPTFLE'
$!
$	DATE = F$TIME()
$	DATE = F$EXTRACT(0,11,DATE)
$!
$ START:
$!
$!----------------------------------------------------------------------------
$!		READ NEXT LINES OF THE USER DEFINITION.
$!		DETERMINE LOGFILE NAME, VAX USERNAME, AND NEG MAIL STATUS.
$!		GENERATE SYMBOLS NEEDED (SYMFIND).
$!----------------------------------------------------------------------------
$!
$	READ/END_OF_FILE=NO_MORE  RFRM  LINE1
$	NEG_SEND := "''F$EXTRACT(1,1,LINE1)'"
$!
$	READ/END_OF_FILE=NO_MORE  RFRM  SEND_TO
$	SEND_TO = F$EDIT(SEND_TO,"COMPRESS,TRIM")
$!
$	READ/END_OF_FILE=NO_MORE  RFRM  TELUSER
$	TELUSER = F$EDIT(TELUSER, "COMPRESS,TRIM")
$!
$	READ/END_OF_FILE=NO_MORE  RFRM  TELPASS
$!
$	WRITE SYS$OUTPUT "*-*-*-*-*-*-*-*-*-*-*-*-* 	''TELUSER' 	*-*-*-*-*-*-*-*-*-*-*-*-*"
$!
$	SYMFIND 'TELUSER'
$!
$!----------------------------------------------------------------------------
$!		SET SYMBOL FOR NUMBER OF MAIL MESSAGES READ TO ZERO.
$!		CHECK IF ANY MAIL WAS READ FOR THIS USER.
$!			BRANCH IF NO MAIL WAS READ, TO FINAL USER PROCESS.
$!		BUILD SYMBOL FOR CHECKING FOR UNREAD MAIL.
$!		CHECK FOR UNREAD MAIL, INFORM MANAGER IF ANY MAY EXIST.
$!		REFORMAT LOGFILE GENERATED BY TELEMAIL READ PROGRAM.
$!----------------------------------------------------------------------------
$!
$	MLCNT = "0"
$!
$	IF (CNNTUSR .EQS. "NOCONNECT")	THEN GOTO NOLOGIN
$!
$	IF (((CNNTUSR .NES. "READ_MAIL")		.AND.	-
	     (CNNTUSR .NES. "INCOMPLETE"))	.OR.	-
	     (CNNTUSR .EQS. "CONNECT"))	THEN GOTO NEG_SEND
$!
$	UNRDUSR = "READ_''LOG_FILE'" - ".LOG"
$	IF 'UNRDUSR' .NES. "" THEN GOTO INFORM_UNREAD
$!
$ CONT_PROC:
$!
$	RFMTMAIL 'LOG_FILE'
$	IF .NOT. $STATUS THEN GOTO NOLOGIN
$!
$!----------------------------------------------------------------------------
$!	PREPARE MAIL FOR TRANSMITTAL TO USERS VAX MAIL ACCOUNT.
$!		DEFINE REFORMATTED LOGFILE AS LOGICAL FOR MAIL PARSE PROGRAM.
$!		RUN MAIL PARSE PROGRAM.
$!		TRANSLATE MAIL COUNT SYMBOL.
$!		CHECK IF ANY MAIL FOUND, BRANCH IF NONE.
$!		DEFINE MAIL SUBJECT SYMBOL.
$!		TRY TO SEND MAIL TO VAX USER.  
$!----------------------------------------------------------------------------
$!
$	ASSIGN ROOT_TMAIL:[READ]'LOG_FILE' FIRSTLOG
$!
$	PRSNTML
$	IF .NOT. $STATUS THEN GOTO NOLOGIN
$!
$	SBJCNT = F$INTEGER(MLCNT)
$!
$ LOOP:
$!
$	IF SBJCNT .EQ. 0 THEN GOTO NEG_SEND
$	MLSYM = SUBJ_'SBJCNT'
$	MLSBJ := 'MLSYM'
$!
$	OPEN/WRITE	SNDR	ROOT_TMAIL:[READ]TMP_SEND.COM
$!
$	WRITE	SNDR	"$	MRMAN"
$	WRITE	SNDR	"SEND/IDENT=TMAIL_READ"
$	WRITE	SNDR	"''SEND_TO'@MRGATE"
$	WRITE	SNDR	"Telemail:  ''MLSBJ'"
$!
$	CLOSE	SNDR
$!
$	APPEND	ROOT_TMAIL:[READ]NEWMAIL.TEL	ROOT_TMAIL:[READ]TMP_SEND.COM
$!
$	@ROOT_TMAIL:[READ]TMP_SEND
$!
$	MRTOVMSSUB = "1"
$!
$	DELETE/LOG	ROOT_TMAIL:[READ]TMP_SEND.COM;*
$!
$	GOTO DELNEWMAIL
$!
$!----------------------------------------------------------------------------
$!	NO TELEMAIL WAS READ DECISIONS.
$!		IF NOT FIRST MESSAGE ATTEMPTED FOR TRANSMITTAL THEN BRANCH.
$!		IF NEG SEND FLAG SET THEN BRANCH
$!		SEND MAIL INDICATING NO TELEMAIL WAS READ.
$!----------------------------------------------------------------------------
$!
$ NEG_SEND:
$!
$	IF "''NEG_SEND'" .EQS. "N" THEN GOTO NONEG_MSG
$!
$	MAIL/SUBJECT="No Telemail for ''DATE', ''CNNTUSR' Accomplished." -
			'LOG_FILE' 'SEND_TO'
$	GOTO NO_MORESEND
$!
$ DELNEWMAIL:
$!
$!----------------------------------------------------------------------------
$!	PREPARE FOR NEXT MAILING OF TELEMAIL FOR CURRENT USER.
$!		REMOVE MAIL MESSAGE, AND ASSOCIATED SYMBOLS, FROM SEND QUEUE.
$!		DECREMENT MAIL COUNT SYMBOL.
$!		CHECK IF MAIL COUNT IS ZERO
$!			YES, EXIT TO OUTER LOOP.
$!			NO, BRANCH BACK TO SECTION FOR SENDING VAX MAIL.
$!----------------------------------------------------------------------------
$!
$	DELETE/SYMBOL/LOCAL	SUBJ_'SBJCNT'
$	SBJCNT = SBJCNT - 1
$	DELETE/LOG ROOT_TMAIL:[READ]NEWMAIL.TEL;
$	IF SBJCNT .EQ. 0 THEN GOTO NO_MORESEND
$	GOTO LOOP
$!
$ NO_MORESEND:
$!
$!----------------------------------------------------------------------------
$!	NO MORE MAIL TO BE SENT TO USER.
$!		DETERMINE IF LAST DAY FOR NEGATIVE MAIL MESSAGE FROM PROGRAM.
$!		IF LAST DAY FOR NEGATIVE MAIL MESSAGE THEN INFORM USER.
$!----------------------------------------------------------------------------
$!
$	IF "''NEG_SEND'" .NES. "I" THEN GOTO NONEG_MSG
$	MAIL/SUBJECT="Telemail Negative Messages" -
	ROOT_TMAIL:[TEXT]NEGMSG.TXT	'SEND_TO'
$	IF $STATUS THEN GOTO NONEG_MSG
$!
$!----------------------------------------------------------------------------
$!	TELEMAIL READ NOT ABLE TO SEND MAIL TO VAX USER INDICATED.
$!		SEND FAILURE MESSAGE TO SYSTEM MANAGER.
$!		REMOVE ANY FILES CREATED BY THIS LOOP.
$!----------------------------------------------------------------------------
$!
$	MAIL/SUBJECT="Telemail for ''SEND_TO' not delivered" -
	ROOT_TMAIL:[TEXT]FAILMSG.TXT 'TMAILMGR'
$	DELETE/LOG ROOT_TMAIL:[READ]NEWMAIL.TEL;*
$!
$ NONEG_MSG:
$!
$!----------------------------------------------------------------------------
$!	PREPARE FOR NEXT TELEMAIL USERS MAIL.
$!		DELETE SYMBOLS USED FOR SENDING MAIL.
$!		BRANCH TO READ NAME OF NEXT VAX USER.
$!----------------------------------------------------------------------------
$!
$	DELETE/SYMBOL/LOCAL MLCNT
$!
$	GOTO START
$!
$ NO_MORE:
$!
$!
$!----------------------------------------------------------------------------
$!	CLEANUP OF DIRECTORY AND ARCHIVE OF TODAYS LOGFILES.
$!		CLOSE USER DEFINITION FILE.
$!		WAIT 10 SECONDS, JUST FOR LUCK.
$!		PURGE DOWN THE LOGFILES.  RENAME LOGFILES TO SUB-DIRECTORY.
$!		EXIT BATCH JOB.
$!----------------------------------------------------------------------------
$!
$	CLOSE RFRM
$!
$	WAIT 00:00:10
$!
$	PURGE ROOT_TMAIL:[READ]*.LOG
$!
$	RENAME ROOT_TMAIL:[READ]*.LOG ROOT_TMAIL:[READ]*.TEL
$!
$	RENAME ROOT_TMAIL:[READ]*.TEL ROOT_TMAIL:[READ.ARCHIVE]
$!
$	RENAME ROOT_TMAIL:[READ]*.LOG ROOT_TMAIL:[READ.ARCHIVE]
$!
$	IF MRTOVMSSUB .EQS. "1" THEN	-
		SUBMIT/QUEUE=TELEMAIL/USER=MRGATE/LOG=MRG$DIR	-
			/KEEP/NOPRINT	MRG$DIR:MRTOVMS
$!
$	EXIT
$!
$ NOLOGIN:
$!
$!----------------------------------------------------------------------------
$!	FAILURE MESSAGE TO USER.
$!		TELL USER THAT PROGRAM DID NOT READ HIS MAIL FOR HIM.
$!		SENDS TO SYSTEM MANAGER TO, SO HE CAN FIGURE OUT WHY.
$!		BRANCH BACK TO GET MAIL FILE FOR NEXT VAX USER.
$!----------------------------------------------------------------------------
$!
$	MAIL/SUBJECT="No TELEMAIL read for ''SEND_TO', ''CNNTUSR' Accomplished." -
	ROOT_TMAIL:[TEXT]NOLOGMSG.TXT   'TMAILMGR','SEND_TO'
$!
$	GOTO START
$!
$ FAILMSG:
$!
$	SHOW TIME
$!
$!----------------------------------------------------------------------------
$!	TELEMAIL PROGRAM DID NOT CONNECT.
$!		TELL SYSTEM MANAGER THAT PROGRAM DID NOT PERFORM PROPERLY.
$!		EXIT BATCH JOB.
$!----------------------------------------------------------------------------
$!
$	MAIL/SUBJECT="TELEMAIL PROGRAM FAILED, ''DATE'" -
	ROOT_TMAIL:[TEXT]FAILMSG.TXT 'TMAILMGR'
$!
$	EXIT
$!
$ NO_PORTS:
$!
$!----------------------------------------------------------------------------
$!	NO DIAL-OUT PORTS WERE DEFINED FOR PROGRAM.
$!		ISSUE MESSAGE TO SYS$OUTPUT.  SO MESSAGE IS IN LOG FILE.
$!		SEND MAIL TO SYSTEM MANAGER.
$!		EXIT BATCH JOB.
$!----------------------------------------------------------------------------
$!
$	CLOSE PORTS
$!
$	OUT :== WRITE SYS$OUTPUT
$!
$	OUT "YOU HAVE NOT DEFINED YOUR DIAL OUT PORTS IN THE FILE"
$	OUT "ROOT_TMAIL:[SEND]TELEPORT.LIS.  YOU MUST DEFINE AT"
$	OUT "LEAST ONE DIALOUT PORT IN THIS FILE FOR THE TELEMAIL"
$	OUT "READ PROGRAM TO PROPERLY FUNCTION."
$!
$	MAIL/SUBJECT="TELEMAIL DIAL-OUT PORTS NOT DEFINED.  ''DATE'" -
	NL:	'TMAILMGR'
$!
$	EXIT
$!
$ INFORM_UNREAD:
$!
$!----------------------------------------------------------------------------
$!		INFORM TELEMAIL MANAGER THAT A MAIL MESSAGE MAY
$!		HAVE BEEN INCOMPLETELY READ BY THE PROGRAM.
$!----------------------------------------------------------------------------
$!
$	MAIL/SUBJ="NEED TO UNREAD MAIL FOR:  ''UNRDUSR'"  NL:  'TMAILMGR'
$!
$	GOTO CONT_PROC
$!
$ TMAILDOWN:
$!
$!----------------------------------------------------------------------------
$!	TELEMAIL PROGRAM DID NOT CONNECT.
$!		TELL SYSTEM MANAGER THAT PROGRAM DID PERFORM PROPERLY,
$!		BUT THAT TELEMAIL SYSTEM WAS NOT AVAILABLE.
$!----------------------------------------------------------------------------
$!
$	MAIL/SUBJECT="TELEREAD PROGRAM COULD NOT CONNECT TO TELEMAIL SYSTEM, ''DATE'" -
	NL: 'TMAILMGR'
$!
$	EXIT
