C
C	Include file for use with TELEMAIL READ program.
C
C******************************************************************************
C	When you add a symbol, make sure you make an entry in one of the
C	COMMONs below or else the symbol is defined locally not globally.
C******************************************************************************
C
	IMPLICIT INTEGER*4 (A-Z)

	INTEGER*2 RIOSB(4), XIOSB(4), TYPEAHEAD_COUNT(4)

	INTEGER*4 LOC_REM, SYMBOL_COUNT, REMOTE_STATUS, RINDEX, RCHAN_IN, 
	1	RCHAN_OUT, REFN_IN, REMOTE_ASTS, REFN_OUT, MAX_ASTS

	INTEGER*4 BAUD_RATE, REMOTE_SIZE, SPEED_SIZE, LOGFILE_SIZE,  LEN_VAX,
	1	PHONE_SIZE, MODEM_SIZE, TYPEAHEAD_SIZE, MAX_TYPEAHEAD,
	1	SYM_LEN, LPAS, LUSE, LEN_USE, LEN_PAS, LOCLEN, LEN_LOG

	INTEGER*4 REMOTE_CHAR(3)
C
C	Parameters.
C
	CHARACTER*(*) SS, DS, NULL, BELL
	PARAMETER (SS = CHAR(13)//CHAR(10)) ! Single space.
	PARAMETER (DS = SS//SS)		! Double space.
	PARAMETER (BELL = CHAR(7))	! Bell.
	PARAMETER (NULL = CHAR(0))	! NULL.
	PARAMETER LF  = 10		! Line feed.			CTRL/J
	PARAMETER CR  = 13		! Carriage return.		CTRL/M
	PARAMETER DLE = 16		! Data link escape.		CTRL/P
	PARAMETER XON = 17		! Start Data Transmission.	CTRL/Q
	PARAMETER SYN = 22		! Synchronize byte.		CTRL/V
	PARAMETER ETB = 23		! End of transmission block.	CTRL/W
	PARAMETER CAN = 24		! Cancel transmission.		CTRL/X
	PARAMETER EOF = 26		! End of file.			CTRL/Z
	PARAMETER LOG_UNIT = 2		! Unit # for log file.
	PARAMETER CMD_UNIT = 3		! Unit # for command file.
	PARAMETER OUT_UNIT = 6		! Unit for batch SYS$OUTPUT.
	PARAMETER ESCAPE = 27		! Escape.
	PARAMETER LOGBUF_SIZE = 512	! Log file buffer size.
	PARAMETER BUFFER_SIZE = 1024	! Buffer Size.
	PARAMETER AUTODIAL_LIMIT = 3	! # of times to retry autodial.
	LOGICAL*1 RBUFFER(BUFFER_SIZE)	! Receive buffer.
	LOGICAL*1 TBUFFER(BUFFER_SIZE)	! Logfile buffer.

	LOGICAL*1	AFIRM, UNREADMAIL, MAILREAD
	CHARACTER*4	SHRT_WAIT, MEDM_WAIT, LONG_WAIT		! WAITABIT Strings.
	CHARACTER*9     ACTION(7), SEND1, SEND2, SEND3, SEND4, SEND5
	CHARACTER*12    LBUFFER		! Local buffer. 
	CHARACTER*20    CONN1, CONN2, CONN3
	CHARACTER*132   VAXUSER, USER, PASS, SYMSTRING	! User Names and Passwords.
	CHARACTER*3	STRT_STR
	CHARACTER*99	READACT		! Action After Read Buffer.
C
C	Flags.
C
	LOGICAL	LOGFILE, RECEIVER_BUSY, REMOTE, NEED_TO_DEAL,
	1	NEED_TO_DEAS, MODEM, LOG_LOCAL, MODEM_ONLINE
C
C	Character strings for filenames, system type, baud rate, etc.
C
	CHARACTER*128 LOG_FILE, READ_FILE
	CHARACTER*10 REMOTE_BAUD, MODEM_TYPE
	CHARACTER*80 REMOTE_DEVICE
	CHARACTER*80 PHONE_NUMBER 

	COMMON /BUFFERS/ RBUFFER, LBUFFER, TBUFFER, REMOTE_BAUD, REMOTE_DEVICE, 
	1	PHONE_NUMBER, MODEM_TYPE, CMD_FILE, STRT_STR, LOG_FILE, CONN1,
	1	CONN2, CONN3, RINDEX, BAUD_RATE, LOC_REM, SEND, ACTION, VAXUSER,
	1	SYMSTRING, READACT, USER, PASS, SEND1, SEND2, SEND3,
	1	SEND4, SEND5, READ_FILE

	COMMON /CHANNELS/ RCHAN_IN, RCHAN_OUT, REFN_IN, REFN_OUT

	COMMON /COUNTS/ MAX_TYPEAHEAD, TYPEAHEAD_COUNT, SYMBOL_COUNT, 
	1	REMOTE_ASTS, SHRT_WAIT, MEDM_WAIT, LONG_WAIT, MAX_ASTS

	COMMON /FLAGS/ RECEIVER_BUSY, REMOTE, UNREADMAIL, LOGFILE, 
	1	NEED_TO_DEAL, NEED_TO_DEAS, MODEM, LOG_LOCAL, MODEM_ONLINE, 
	1	AFIRM, MAILREAD

	COMMON /SIZES/ REMOTE_SIZE, SPEED_SIZE, LOGFILE_SIZE, 
	1	PHONE_SIZE, CMD_SIZE, MODEM_SIZE, 
	1	TYPEAHEAD_SIZE, RSIZE, SYM_LEN, LEN_VAX,
	1	LPAS, LUSE, LEN_USE, LEN_PAS, LOCLEN, LEN_LOG

	COMMON /STATUS/ LOCAL_STATUS, REMOTE_STATUS, RIOSB, XIOSB,
	1	FUNCTION, REMOTE_CHAR
C
C	Define the I/O functions.
C
	PARAMETER (IO$_READLBLK   =	'00000021'X)
	PARAMETER (IO$_READPROMPT =	'00000037'X)
	PARAMETER (IO$_SETMODE    =	'00000023'X)
	PARAMETER (IO$_SENSEMODE  =	'00000027'X)
	PARAMETER (IO$_TTYREADALL =	'0000003A'X)
	PARAMETER (IO$_WRITELBLK  =	'00000020'X)
	PARAMETER (IO$M_CTRLCAST  =	'00000100'X)
	PARAMETER (IO$M_CVTLOW    =	'00000100'X)
	PARAMETER (IO$M_HANGUP	  =	'00000200'X)
	PARAMETER (IO$M_NOECHO    =	'00000040'X)
	PARAMETER (IO$M_NOFORMAT  =	'00000100'X)
	PARAMETER (IO$M_TYPEAHDCNT=	'00000040'X)
	PARAMETER (IO$M_PURGE     =	'00000800'X)
	PARAMETER (IO$M_TIMED     =	'00000080'X)
C
C	Define the status return codes.
C
	PARAMETER (SS$_ABORT	  =	'0000002C'X)
	PARAMETER (SS$_CONTROLC	  =	'00000651'X)
	PARAMETER (SS$_CONTROLY	  =	'00000611'X)
	PARAMETER (SS$_DATAOVERUN =	'00000838'X)
	PARAMETER (SS$_DEVALRALLOC=	'00000641'X)
	PARAMETER (SS$_EXQUOTA	  =	'0000001C'X)
	PARAMETER (SS$_HANGUP	  =	'000002CC'X)
	PARAMETER (SS$_NOPRIV	  =	'00000024'X)
	PARAMETER (SS$_NOTRAN	  =	'00000629'X)
	PARAMETER (SS$_NORMAL	  =	'00000001'X)
	PARAMETER (SS$_PARITY	  =	'000001F4'X)
	PARAMETER (SS$_TIMEOUT	  =	'0000022C'X)
C
C	End of COM.INC.
C
