C
C	TELEREAD.FOR
C
C	This program is used to read mail for VAX users over
C	an asynchronous interface line.
C
C	Written by:
C	William J. Baker, Utilizing VAXNET written by Robin Miller.
C
C	V1.0 Initial Release of Product.
C			Added RIXON Modem Support.
C			Added Phonelist, and Modem List Support.
C			Updated for general release to public as needed.
C	V1.1 12-DEC-1986, Fix for:
C			Read Registered Mail, Skip Private Mail.
C			Identifies Urgent, and Return-Receipt Mail.
C			Fix End of File Indication for Phone List.
C			Add Test Routine for ROLM PBX Modems.
C
C	V1.2 30-DEC-1986, Fix for:
C			Add support for high speed ROLM lines.
C			Modify DOCOMM Module to redial if can't
C			connect to ROLM.  ROLM Dialout routine
C			validated.  (No change V1.1 ROLM Module.)
C			Now only support ROLM phones.
C
C	V2.0 17-APR-1987, Fix for:
C			Final Debug of V1.2, and verification.
C
C	V2.1 17-JUN-1987, Fix for:
C			Crash of VAX syndrome.  System would crash
C			if program was not watched, and ROLM system
C			disconnected process from TELEMAIL system.
C			Generated to many ASTs for VAX to handle.
C			Fix actually inhances program execution
C			by placing a timeout on the $QIO Call.
C			Program checks for modem responce during
C			Mail read, and sets flags for informing
C			manager of disconnect, then moves on to
C			next user.
C			Also fixes problem with connection to TELEMAIL
C			system.  Program was sendind XOFF at $QIO
C			level, when Typeahead buffer was near to
C			overflowing.  I added an XON statement to
C			turn data flow back on.  This reduces the
C			time per user, by not requiring program to
C			hangup modem, and redial TELEMAIL system.
C	V2.2 17-JUL-1987, Enhancements:
C			Added alternate symbol definition so that
C			the TELEBATCH.COM file will detect that
C			no mail was read for a given user connection.
C			This will reduce CPU time of total job by
C			not requiring command file to process all
C			the usernames completely.  ie:  it bypasses
C			processing of mail when no mail is available
C			to be sent to the user.
C
	INCLUDE 'COM.INC/LIST'
	INCLUDE 'TTDEF.FOR/NOLIST'

	EXTERNAL RESET_WORLD

	CHARACTER*9	ALTSERVICE
	CHARACTER*20	PHONE_BUFF, LASTUSER, NOCONUSER
	INTEGER*4 EXIT_BLOCK(4)
C
	TYPE *,'============================================================'
	TYPE *,'+		Welcome to TELEREAD Version 2.2            +'
	TYPE *,'============================================================'
C
C	Set up an exit handler.
C
	EXIT_BLOCK(2) = %LOC(RESET_WORLD)
	EXIT_BLOCK(3) = 1
	CALL CHECK_STATUS('VAXNET(DCLEXH)',STATUS)
C
C
C	Initialize various flags and counts.
C
	SEND1 = 'NASAMAIL '
	SEND2 = 'BYE      '
	SEND3 = '         '
	SEND4 = 'EXIT     '
	SEND5 = 'PURGE    '
C
	ACTION(1) = 'Action'
	ACTION(2) = '*'
	ACTION(3) = 'Command'
	ACTION(4) = 'Password'
	ACTION(5) = 'name?'
	ACTION(6) = 'MODIFY ?'
	ACTION(7) = 'FAILURE'
C
	AFIRM = 'Y'
C
	MODEM = .FALSE.			! Presume not a modem.
	REMOTE = .FALSE.		! Presume local terminal,
	LOGFILE = .FALSE.		! Default to no log file.
	MODEM_ONLINE = .FALSE.		! Autodial modem is offline.
	NEED_TO_DEAS = .FALSE.		! Don't have remote port yet.
	TIMEOUT_COUNT = 10		! Initialize timeout count.
	TYPEAHEAD_SIZE = 78-38		!	and typeahead size.
	REMOTE_ASTS = 0			!  and remote AST counts.
C
	OPEN (UNIT=CMD_UNIT, FILE='TELECOMM', READONLY,
     1		CARRIAGECONTROL='LIST', STATUS='OLD')

C
C	Request the remote system type.
C
	CALL GET_PORT()
C
C
	CALL SETUP_REMOTE()
C
C	Request the remote baud rate.
C
	CALL SETUP_BAUDRATE		! Setup the remote baud rate.
C
C	If the remote port is setup MODEM, get the modem type.
C
	CALL GET_MODEM_INFO()	! Get autodial modem type.
C
C	If using an autodial modem, dial the phone number.
C
	CALL GET_SYMBOL( 'PHONE_NUMBER', PHONE_NUMBER, PHONE_SIZE)
	IF (PHONE_SIZE .EQ. 0) THEN
C
		PHONE_NUMBER = 'NPSS'
		PHONE_SIZE   = 4
C
	ENDIF
C
	CONN1 = ' LOGON'
C
	CALL GET_SYMBOL( 'PSCNUSER', CONN2, LUSE)
C
	CALL GET_SYMBOL( 'PSCNPASS', CONN3, LPAS)
C
C DEFINE ALTERNATE SERVICE AND ITS LOGFILE.
C
	CALL GET_SYMBOL( 'ALT_SERVICE', ALTSERVICE, LSRV )
	IF (LSRV .GT. 0) THEN
		SEND1 = SEND3
		SEND1 = ALTSERVICE(1:LSRV)
	ENDIF
C
	IF (LSRV .EQ. 0) THEN
		READ_FILE = SEND1(1:8)//'F.LOG'
	ELSE
		READ_FILE = SEND1(1:LSRV)//'F.LOG'
	ENDIF
C
C	TYPE *, READ_FILE
C
C
	CALL GET_SYMBOL( 'LASTUSER', LASTUSER, LST_SIZE )
C
10	READ(CMD_UNIT,1010,IOSTAT=IERR) STRT_STR
C
	IF (IERR .NE. 0) GOTO 3000
C
	READ(CMD_UNIT,1000,IOSTAT=IERR) LOCLEN, VAXUSER
	LEN_VAX = LOCLEN
	READ(CMD_UNIT,1000,IOSTAT=IERR) LOCLEN, USER
	LEN_USE = LOCLEN
	READ(CMD_UNIT,1000,IOSTAT=IERR) LOCLEN, PASS
	LEN_PAS = LOCLEN
C
	CALL SYM_STR( )
C
	LOG_FILE = SYMSTRING(1:SYM_LEN)//'.LOG'
	LEN_LOG = SYM_LEN + 4
C
	IF (LST_SIZE .EQ. 0) GOTO 20
C
	CALL GET_SYMBOL( 'USER_'//SYMSTRING(1:SYM_LEN), NOCONUSER, NCU_SIZE )
	IF (NOCONUSER(1:NCU_SIZE) .EQ. 'CONNECT') GOTO 10
	IF (NOCONUSER(1:NCU_SIZE) .EQ. 'READ_MAIL') GOTO 10
C
20	WRITE(6,2000) LOG_FILE, USER
C
	CALL LIB$SET_SYMBOL( 'LASTUSER', 'COMPLETE', 2)
C
	UNREADMAIL = .FALSE.
	MAILREAD = .FALSE.
	MAX_ASTS = 0
	LOOP = 0
C
	DO WHILE (IERR .EQ. 0)
C
	   IF (.NOT. MODEM_ONLINE) THEN 
C
		CALL DIAL_MODEM()	! Dial the phone number.
		CALL FIND_PROMPT( ICON1 )
C
	   ENDIF
C
	   IF ((MODEM_ONLINE) .AND. (ICON1 .EQ. 0)) THEN
		CALL DO_COMMAND(ICON2)
C
		LOOP = LOOP + 1
C
		IF (ICON2 .EQ. -7) THEN
			CALL LIB$SET_SYMBOL( 'LASTUSER', 'TMAILDOWN', 2)
			GOTO 3000
		ENDIF

		IF (UNREADMAIL) LOOP = 2
C
		IF (ICON2 .GE. 5) THEN
			CALL HANGUP_MODEM()
			CALL WAITABIT( MEDM_WAIT )
		ENDIF
C
		IF ((ICON2 .LT. 5) .OR. (LOOP .GT. 1)) THEN
		   LOOP = 0
C		   TYPE *,'MAX ASTS WERE:  ',MAX_ASTS
		   IF (ICON2 .LT. 5) THEN
			IF (.NOT. MAILREAD) THEN
			    CALL LIB$SET_SYMBOL( 'USER_'//SYMSTRING(1:SYM_LEN), 'CONNECT', 2)
			ELSE
			    CALL LIB$SET_SYMBOL( 'USER_'//SYMSTRING(1:SYM_LEN), 'READ_MAIL', 2)
			ENDIF
		   ELSE
			TYPE *,'SET SYMBOLS, HANGUP MODEM.'
			IF (UNREADMAIL) THEN 
			   IF (.NOT. MAILREAD) THEN
			       CALL LIB$SET_SYMBOL( 'USER_'//SYMSTRING(1:SYM_LEN), 'CONNECT', 2)
			   ELSE
			       CALL LIB$SET_SYMBOL( 'READ_'//SYMSTRING(1:SYM_LEN), 'UNREAD', 2)
			       CALL LIB$SET_SYMBOL( 'LASTUSER', USER(1:LEN_USE), 2)
			       CALL LIB$SET_SYMBOL( 'USER_'//SYMSTRING(1:SYM_LEN), 'INCOMPLETE', 2)
			   ENDIF
			ELSE
				CALL LIB$SET_SYMBOL( 'LASTUSER', USER(1:LEN_USE), 2)
				CALL LIB$SET_SYMBOL( 'USER_'//SYMSTRING(1:SYM_LEN), 'NOCONNECT', 2)
			ENDIF
			CALL HANGUP_MODEM()
		   ENDIF
C
110		   READ(CMD_UNIT,1010,IOSTAT=IERR) STRT_STR
C
		   IF (IERR .NE. 0) GOTO 3000
C
		   READ(CMD_UNIT,1000,IOSTAT=IERR) LOCLEN, VAXUSER
		   LEN_VAX = LOCLEN
		   READ(CMD_UNIT,1000,IOSTAT=IERR) LOCLEN, USER
		   LEN_USE = LOCLEN
		   READ(CMD_UNIT,1000,IOSTAT=IERR) LOCLEN, PASS
		   LEN_PAS = LOCLEN
C
		   CALL SYM_STR()
C
		   LOG_FILE = SYMSTRING(1:SYM_LEN)//'.LOG'
		   LEN_LOG = SYM_LEN + 4
C
		   IF (LST_SIZE .EQ. 0) GOTO 220
		   CALL GET_SYMBOL( 'USER_'//SYMSTRING(1:SYM_LEN), NOCONUSER, NCU_SIZE )
		   IF (NOCONUSER(1:NCU_SIZE) .EQ. 'CONNECT') GOTO 110
		   IF (NOCONUSER(1:NCU_SIZE) .EQ. 'READ_MAIL') GOTO 110
C
220		   TYPE *,'------------------------------------------------------------'
C
		   WRITE(6,2000) LOG_FILE, USER
		ENDIF
	   ELSE
		CALL HANGUP_MODEM()
		CALL WAITABIT( MEDM_WAIT )
	   ENDIF
C
	   UNREADMAIL = .FALSE.
	   MAILREAD = .FALSE.
	   MAX_ASTS = 0
C
	ENDDO
C
3000	CLOSE(CMD_UNIT)
C
	CLOSE(TEL_UNIT)
C
	TYPE *,'============================================================'
C
	CALL FINISH()
C
1000	FORMAT(Q, A<LOCLEN>)
1010    FORMAT(A3)
2000	FORMAT(5X, A<LEN_LOG>, 10X, A<LEN_USE> )
C
	END

	SUBROUTINE FIND_PROMPT( ICON )
C
C
	INCLUDE 'COM.INC/NOLIST'
C
	INTEGER*4	ACTLEN(7)
C
C	CALL CLEAR_TYPEAHEAD
C
	LOOP = 0
	IFND = 0
C
	ACTLEN(1) = 6
	ACTLEN(2) = 1
	ACTLEN(3) = 7
	ACTLEN(4) = 8
	ACTLEN(5) = 5
	ACTLEN(6) = 8
	ACTLEN(7) = 7
C
	DO WHILE ((IFND .LE. 0) .AND. (LOOP .LT. 11))
C
	   CALL REMOTE_READ( IACT )
C
		DO II = 1,7
C
		   IOUT= STR_COMPARE( LBUFFER, ACTION(II), ACTLEN(II))
		   IF (IOUT .NE. 0) IFND = II
C
		ENDDO
C
	   LOOP = LOOP + 1
C
	   IF (( ((LOOP/5)*5) .EQ. LOOP) .AND. (IFND .EQ. 0 )) THEN
C
		CALL WRITE_BYTE(CR, 1)
		CALL WAITABIT( SHRT_WAIT )
C
	   ENDIF
C
	END DO
C
        ICON = LOOP
C
	IF (IFND .LE. 0) RETURN
C
	ICON = 0
C
	IF (IFND .EQ. 2) RETURN
C
	ICON = -IFND
C
	RETURN
	END
C

C
	SUBROUTINE SYM_STR
C
	INCLUDE 'COM.INC/NOLIST'
C
	KK = 0
C
	DO JJ = 1, LEN_USE
C
		IF (USER(JJ:JJ) .GT. CHAR(47)) THEN
C
			KK = KK + 1
C
			SYMSTRING(KK:KK) = USER(JJ:JJ)
C
		ENDIF
C
	ENDDO
C
	SYM_LEN = KK
C
	RETURN
	END
