C
C	Include file for use with TELESEND program.
C
C******************************************************************************
C	When you add a symbol, make sure you make an entry in one of the
C	COMMONs below or else the symbol is defined locally not globally.
C******************************************************************************
C
	IMPLICIT INTEGER*4 (A-Z)

	INTEGER*2 RIOSB(4), XIOSB(4), TYPEAHEAD_COUNT(4)

	INTEGER*4 LOC_REM

	INTEGER*4 SYMBOL_COUNT, REMOTE_STATUS, RINDEX, RCHAN_IN, RCHAN_OUT, 
	1	REFN_IN, REMOTE_ASTS, REFN_OUT

	INTEGER*4 BAUD_RATE, REMOTE_SIZE, SPEED_SIZE, LOGFILE_SIZE, LOCLEN,
	1	OUTFILE_SIZE, PHONE_SIZE, MODEM_SIZE, TYPEAHEAD_SIZE,  LEN_LOG,
	1	MAX_TYPEAHEAD, MAX_RECSIZE, LPAS, LUSE, LEN_USE, LEN_PAS, VSIZE

	INTEGER*4 REMOTE_CHAR(3)
C
C	Parameters.
C
	CHARACTER*(*) SS, DS, NULL, BELL
	PARAMETER (SS = CHAR(13)//CHAR(10)) ! Single space.
	PARAMETER (DS = SS//SS)		! Double space.
	PARAMETER (BELL = CHAR(7))	! Bell.
	PARAMETER (NULL = CHAR(0))	! NULL.
	PARAMETER LF  = 10		! Line feed.			CTRL/J
	PARAMETER CR  = 13		! Carriage return.		CTRL/M
	PARAMETER DLE = 16		! Data link escape.		CTRL/P
	PARAMETER XON = 17		! Start Data Transmission.	CTRL/Q
	PARAMETER SYN = 22		! Synchronize byte.		CTRL/V
	PARAMETER ETB = 23		! End of transmission block.	CTRL/W
	PARAMETER CAN = 24		! Cancel transmission.		CTRL/X
	PARAMETER EOF = 26		! End of file.			CTRL/Z
	PARAMETER LOG_UNIT = 2		! Unit # for log file.
	PARAMETER CMD_UNIT = 3		! Unit # for command file.
	PARAMETER OUT_UNIT = 6		! Unit for batch SYS$OUTPUT.
	PARAMETER TEL_UNIT = 10		! Unit for batch Send File.
	PARAMETER ESCAPE = 27		! Escape.
	PARAMETER OUT_SIZE = 512	! Size of SYS$OUTPUT records.
	PARAMETER READ_SIZE = 512	! Size of remote reads.
	PARAMETER LOGBUF_SIZE = 512	! Log file buffer size.
	PARAMETER BUFFER_SIZE = 1024	! Buffer size.
	PARAMETER RETRY_LIMIT = 8	! # of retries during transmission.
	PARAMETER AUTODIAL_LIMIT = 3	! # of times to retry autodial.
	PARAMETER AUTODIAL_TIMEOUT = 59	! Autodial timeout limit.
	LOGICAL*1 RBUFFER(BUFFER_SIZE)	! Receive buffer.
	LOGICAL*1 XBUFFER(BUFFER_SIZE)	! Transmit buffer.
	LOGICAL*1 TBUFFER(BUFFER_SIZE)	! Logfile buffer.

	LOGICAL*1	AFIRM
	CHARACTER*4	SHRT_WAIT, MEDM_WAIT, LONG_WAIT, MODM_WAIT	! WAITABIT Strings.
	CHARACTER*9     ACTION(7), SEND1, SEND2, SEND3, SEND4, SEND5
	CHARACTER*12    LBUFFER		! Local buffer. 
	CHARACTER*20    CONN1, CONN2, CONN3
	CHARACTER*80    VAXUSER, USER, PASS	! User Names and Passwords.
C
C	Flags.
C
	LOGICAL	LOGFILE, RECEIVER_BUSY, REMOTE, HANGUP, NEED_TO_DEAL,
	1	NEED_TO_DEAS, AUTODIAL, MODEM, LOG_LOCAL, MODEM_ONLINE
C
C	Character strings for filenames, system type, baud rate, etc.
C
	CHARACTER*128 VAX_FILE, REMOTE_FILE, CMD_FILE, LOG_FILE
	CHARACTER*10 SYSTEM_TYPE, REMOTE_BAUD, MODEM_TYPE, TERMINAL_TYPE
	CHARACTER*80 REMOTE_DEVICE
	CHARACTER*80 PHONE_NUMBER 

	COMMON /BUFFERS/ RBUFFER, XBUFFER, LBUFFER, TBUFFER, VAX_FILE,
	1 	REMOTE_BAUD, PHONE_NUMBER, MODEM_TYPE, CMD_FILE, SEND2, SEND4,
	1	LOG_FILE, CONN1, CONN2, CONN3, RINDEX, BAUD_RATE, SEND3, 
	1	LOC_REM, SEND, ACTION, VAXUSER, USER, PASS, SEND1, SEND5

	COMMON /CHANNELS/ RCHAN_IN, RCHAN_OUT, REFN_IN, REFN_OUT

	COMMON /COUNTS/ MAX_TYPEAHEAD, MAX_RECSIZE, TYPEAHEAD_COUNT, VSIZE,
	1	SYMBOL_COUNT, REMOTE_ASTS, SHRT_WAIT, MEDM_WAIT, LONG_WAIT

	COMMON /FLAGS/ RECEIVER_BUSY, REMOTE, LOGFILE, NEED_TO_DEAL, AFIRM,
	1	NEED_TO_DEAS, MODEM, AUTODIAL, LOG_LOCAL, MODEM_ONLINE

	COMMON /SIZES/ REMOTE_SIZE, SPEED_SIZE, LOGFILE_SIZE, OUTFILE_SIZE, 
	1	PHONE_SIZE, CMD_SIZE, MODEM_SIZE, TYPEAHEAD_SIZE, LPAS, 
	1	LUSE, LEN_USE, LEN_PAS, LOCLEN, LEN_LOG

	COMMON /STATUS/ REMOTE_STATUS, RIOSB, XIOSB, FUNCTION, 
	1	REMOTE_CHAR
C
C	Define the I/O functions.
C
	PARAMETER (IO$_READLBLK   =	'00000021'X)
	PARAMETER (IO$_READPROMPT =	'00000037'X)
	PARAMETER (IO$_SETMODE    =	'00000023'X)
	PARAMETER (IO$_SENSEMODE  =	'00000027'X)
	PARAMETER (IO$_TTYREADALL =	'0000003A'X)
	PARAMETER (IO$_WRITELBLK  =	'00000020'X)
	PARAMETER (IO$M_CTRLCAST  =	'00000100'X)
	PARAMETER (IO$M_CVTLOW    =	'00000100'X)
	PARAMETER (IO$M_HANGUP	  =	'00000200'X)
	PARAMETER (IO$M_NOECHO    =	'00000040'X)
	PARAMETER (IO$M_NOFORMAT  =	'00000100'X)
	PARAMETER (IO$M_TYPEAHDCNT=	'00000040'X)
	PARAMETER (IO$M_PURGE     =	'00000800'X)
	PARAMETER (IO$M_TIMED     =	'00000080'X)
C
C	Define the status return codes.
C
	PARAMETER (SS$_ABORT	  =	'0000002C'X)
	PARAMETER (SS$_CONTROLC	  =	'00000651'X)
	PARAMETER (SS$_CONTROLY	  =	'00000611'X)
	PARAMETER (SS$_DATAOVERUN =	'00000838'X)
	PARAMETER (SS$_DEVALRALLOC=	'00000641'X)
	PARAMETER (SS$_EXQUOTA	  =	'0000001C'X)
	PARAMETER (SS$_HANGUP	  =	'000002CC'X)
	PARAMETER (SS$_NOPRIV	  =	'00000024'X)
	PARAMETER (SS$_NOTRAN	  =	'00000629'X)
	PARAMETER (SS$_NORMAL	  =	'00000001'X)
	PARAMETER (SS$_PARITY	  =	'000001F4'X)
	PARAMETER (SS$_TIMEOUT	  =	'0000022C'X)
C
C	End of COM.INC.
C
