	SUBROUTINE ENABLE_LOGFILE
C
C	Character string for questions and log file name.
C
	INCLUDE 'COM.INC/NOLIST'
C
C	WRITE(6,50) VAX_FILE
50	FORMAT( 5X, '%%%-OPEN OF ',A<VSIZE> )
C
	OPEN (UNIT=LOG_UNIT, TYPE='NEW', NAME=VAX_FILE(1:VSIZE),
	1	FORM='FORMATTED', RECORDTYPE='VARIABLE',
	1	RECORDSIZE=LOGBUF_SIZE, CARRIAGECONTROL='NONE',
	1	ORGANIZATION='SEQUENTIAL', BUFFERCOUNT=2)
	LOGFILE = .TRUE.
	LOG_LOCAL = .TRUE.
	RETURN
	END

	SUBROUTINE ENABLE_SNDMAIL
C
C	Character string for questions and log file name.
C
	INCLUDE 'COM.INC/NOLIST'
C
	WRITE(6,50) LOG_FILE
50	FORMAT( 5X, '%%%-OPEN OF ',A<LEN_LOG> )
C
	OPEN (UNIT=TEL_UNIT, STATUS='OLD', NAME=LOG_FILE(1:LEN_LOG),
     1		RECORDTYPE='VARIABLE', ACCESS='SEQUENTIAL',
     1		FORM='FORMATTED', ORGANIZATION='SEQUENTIAL',
     1          CARRIAGECONTROL='LIST', READONLY)
C
	RETURN
	END

	SUBROUTINE WRITE_LOGFILE(BUFFER,NBYTES)
C
C	Copy characters read from remote to the logfile buffer and
C	write it to disk if is full.
C
	INCLUDE 'COM.INC/NOLIST'
	LOGICAL*1 BUFFER(1)

	DO 100 I = 1,NBYTES
	RINDEX = RINDEX+1		! Index into buffer.
	TBUFFER(RINDEX) = BUFFER(I) .AND. "177 ! Strip parity.
	IF (RINDEX .EQ. LOGBUF_SIZE) CALL FLUSH_LOGFILE()
100	CONTINUE
	RETURN
	END

	SUBROUTINE FLUSH_LOGFILE
C
C	This routine writes the logfile buffer to the disk when the
C	buffer is either full or to flush the buffer when exiting.
C
	INCLUDE 'COM.INC/NOLIST'

	IF (LOGFILE) WRITE (LOG_UNIT,100) (TBUFFER(I),I=1,RINDEX)
100	FORMAT(<RINDEX>A1)
	RINDEX = 0
C
	RETURN
	END

	SUBROUTINE FORM_LOG
C
	INCLUDE 'COM.INC/NOLIST'
C
C	TYPE *, 'TRYING TO REFORMAT THE LOGFILE!!'
	ISTAT = LIB$SPAWN('$ RFMTMAIL '//VAX_FILE(1:VSIZE))
	IF (.NOT. ISTAT) CALL SYS$EXIT(SS$_ABORT)
C
	RETURN
C
	END

	SUBROUTINE FIN_LOG
C
C	Performs cleanup.
C
	INCLUDE 'COM.INC/NOLIST'
C
	CALL FLUSH_LOGFILE			! Empty the logfile buffer.
C
C	If a logfile is open, we close it and execute the REFormat.
C
	CLOSE (UNIT=LOG_UNIT)		! Close the logfile.
	LOGFILE = .FALSE.
	CALL FORM_LOG()
	RETURN
	END

	INTEGER FUNCTION CHECK_STATUS(FACILITY_NAME,STATUS_CODE)
C
C	Subroutine to check status from a System Service.
C
C	Inputs:
C		FACILITY_NAME - Subroutine name.
C		STATUS_CODE - Status code.
C
C	Outputs:
C		Returns the status code passed in.
C
	INCLUDE 'COM.INC/NOLIST'
C
C	Setup the error message.
C
	CHARACTER*(*) FACILITY_NAME, ERROR_MESSAGE
	PARAMETER (ERROR_MESSAGE = SS//
	1 '*** VAXNET Terminated with ERROR ***'//BELL//SS)
	CHARACTER*80 MESSAGE
	INTEGER*4 STATUS_CODE

	CHECK_STATUS = STATUS_CODE	! Pass back the status code.

	IF (STATUS_CODE .EQ. SS$_NORMAL) RETURN
C
C	Report error message to the terminal.
C
C	Set flags for GETMSG for:
C		- Include text of message.
C		- Include message identifier.
C		- Include severity indicator.
C		- Do not include facility name.
C
	FLAGS = "7			! Set up the flags.
	CALL SYS$GETMSG(%VAL(STATUS_CODE),MSGLEN,MESSAGE,%VAL(FLAGS),)
C
C	In case local logging is disabled, we save the LOG_LOCAL status,
C	and enable it before calling WRITE_USER to force errors to the
C	log file (if any).
C
	SAVE_LOG_LOCAL = LOG_LOCAL	! Save local logging flag.
	LOG_LOCAL = .TRUE.		! Enable local logging.
C	CALL WRITE_USER('%'//FACILITY_NAME//'-'//
C	1		MESSAGE(2:MSGLEN)//BELL//SS)
	LOG_LOCAL = SAVE_LOG_LOCAL	! Restore original status.
C
C	If the modem lost carrier, or if quota has been exceeded
C	(use overdraft), or if in a command (GET/SEND/DUMP) presume
C	error from open, return, else exit to the system.
C
C
C	Always return, force user to explicitly exit.
C
C	IF ((STATUS_CODE .EQ. SS$_HANGUP) .OR.
C	1	(STATUS_CODE .EQ. SS$_EXQUOTA) .OR.
C	1	(.NOT. EXIT_ON_ERROR)) RETURN
C	IF (IN_A_COMMAND) RETURN	! Return if doing GET/SEND.

C
C	If the modem hangs up, show it was hungup, and insure a file
C	transfer (if any) gets aborted.
C
	IF (STATUS_CODE .EQ. SS$_HANGUP) THEN
		REMOTE = .FALSE.	! Show we're not dialed up.
		MODEM_ONLINE = .FALSE.	! Show autodial modem offline.
		CONTROLC_TYPED = .TRUE.	! Set flag to abort transmission.
C		IN_A_COMMAND = .FALSE.	! Abort any file transmission.
	ENDIF
	IF (.NOT. BATCH_MODE) RETURN	! Continue if interactive.
	CALL HANGUP_MODEM()		! Make sure modem is hungup.
C	CALL WRITE_USER(ERROR_MESSAGE)	! Write the error message.
	CALL FLUSH_LOGFILE()		! Empty the logfile buffer.
	IF (LOGFILE) CLOSE (UNIT=LOG_UNIT) ! Close the logfile.
	CALL SYS$EXIT(%VAL(SS$_NORMAL))	! And exit with success.
	END
