	SUBROUTINE GET_MODEM_INFO	!PART OF DF03 MODULE
C
C	This routine requests the type of autodial modem being used.
C
	INCLUDE 'COM.INC/NOLIST'
C
	CHARACTER*10	TYPE_MODEM

C
	STATUS = GET_SYMBOL( 'MODEM_TYPE', TYPE_MODEM, LMOD_SIZE)
	MODEM_TYPE = TYPE_MODEM(1:LMOD_SIZE)
	MODEM_SIZE = LMOD_SIZE
C
	RETURN
	END

	SUBROUTINE DIAL_MODEM
C
C	This routine is used to dispatch to the appropriate autodial
C
	INCLUDE 'COM.INC/NOLIST'
C
	CALL HANGUP_MODEM()	! Hangup the modem first.
C
	CALL DIAL_ROLM()
C
	RETURN
	END

	SUBROUTINE HANGUP_MODEM
C
C	This routine is called to hangup the modem.
C
	INCLUDE 'COM.INC/NOLIST'

	MODEM_ONLINE = .FALSE.		! Show modem is offline.
	REMOTE = .FALSE.		! Show modem is hungup.
	REMOTE_STATUS = SYS$QIOW(%VAL(REFN_IN), %VAL(RCHAN_IN),
	1			%VAL(IO$_SETMODE + IO$M_HANGUP),
	1			RIOSB,,,,,,,,)
	CALL CHECK_STATUS('HANGUP_MODEM',REMOTE_STATUS)
C
	CALL WAITABIT('05.0')	! Wait for DTR to return.
C
	RETURN
	END

	SUBROUTINE SETUP_BAUDRATE
C
C	Get and set the baud rate for the remote.
C
	INCLUDE 'COM.INC/NOLIST'
	INCLUDE 'TTDEF.FOR/NOLIST'

	CHARACTER*(*) SPEED_DEFAULT

	PARAMETER (SPEED_DEFAULT = '4800')

C
C	The remote speed can be defined at startup time by defining the
C	symbol REMOTE_SPEED or the symbol REMOTE_SPEED_n (where 'n' is
C	the modem slot).  The list of remote speeds is normally used in
C	conjunction with a list of remote ports to access multiple ports
C	with different speeds.
C
C
	STATUS = GET_SYMBOL ('REMOTE_SPEED', REMOTE_BAUD, SPEED_SIZE)
C
	IF (SPEED_SIZE .EQ. 0) THEN
	    REMOTE_BAUD = SPEED_DEFAULT		! Default remote baud rate
	    SPEED_SIZE = 4			!   and the baud rate size.
	ENDIF
C
	IF     (REMOTE_BAUD(1:SPEED_SIZE) .EQ. '1200') THEN
		BAUD_RATE = TT$C_BAUD_1200
	ELSEIF (REMOTE_BAUD(1:SPEED_SIZE) .EQ. '2400') THEN
		BAUD_RATE = TT$C_BAUD_2400
	ELSEIF (REMOTE_BAUD(1:SPEED_SIZE) .EQ. '4800') THEN
		BAUD_RATE = TT$C_BAUD_4800
	ELSEIF (REMOTE_BAUD(1:SPEED_SIZE) .EQ. '9600') THEN
		BAUD_RATE = TT$C_BAUD_9600
	ELSEIF (REMOTE_BAUD(1:SPEED_SIZE) .EQ. '19200') THEN
		BAUD_RATE = TT$C_BAUD_19200
	ELSE
		TYPE *,'*** Invalid remote SPEED ',
	1		REMOTE_BAUD(1:SPEED_SIZE),
	2		'.  Setting to 4800 Baud.'
		REMOTE_BAUD = SPEED_DEFAULT		! Default remote baud rate
		SPEED_SIZE = 4				!   and the baud rate size.
	ENDIF
C
	LONG_WAIT = '1.50'
C
	IF     (REMOTE_BAUD(1:SPEED_SIZE) .EQ. '1200') THEN
		MEDM_WAIT = '0.50'
		SHRT_WAIT = '0.25'
	ELSEIF (REMOTE_BAUD(1:SPEED_SIZE) .EQ. '2400') THEN
		MEDM_WAIT = '0.40'
		SHRT_WAIT = '0.20'
	ELSEIF (REMOTE_BAUD(1:SPEED_SIZE) .EQ. '4800') THEN
		MEDM_WAIT = '0.30'
		SHRT_WAIT = '0.15'
	ELSEIF (REMOTE_BAUD(1:SPEED_SIZE) .EQ. '9600') THEN
		MEDM_WAIT = '0.20'
		SHRT_WAIT = '0.10'
	ENDIF
C
	CALL SETUP_REMOTE(.TRUE.)	! Setup remote characteristics.
	RETURN
	END

	SUBROUTINE WRITE_ROLM (BUFF, BYTES)
C
C	This routine is used to write characters to the ROLM modem.
C	Each character is written with .25 second delays between them
C	so the ROLM doesn't get overrun.  Although the documentation
C	states that three nulls can be sent between characters, our
C	ROLM still gets overrun.  Also the computer mode sending
C	characters between angle brakets <...> gets overrun.
C
	IMPLICIT NONE

	INTEGER*4 BYTES, I
	LOGICAL*1 BUFF(1)

	DO 100 I = 1,BYTES
	    CALL WAITABIT ( '0.10' )		! Wait for a short time.
	    CALL WRITE_BYTE (BUFF(I), 1)	! Write the next character.
100	CONTINUE
	RETURN
	END

	SUBROUTINE DIAL_ROLM
C
C	This routine dials the phone number for the ROLM modems.
C
	INCLUDE 'COM.INC/NOLIST'

	INTEGER*4 AUTO_RETRY, STATUS
	CHARACTER*5  ROLMCALL
	CHARACTER*9  SNDSTRING

	ROLMCALL   = 'CALL '
	AUTO_RETRY = -1			! Initialize retry counter.
C
	CALL CLEAR_TYPEAHEAD()
C
	CALL WAITABIT( SHRT_WAIT )
C
	CALL WRITE_ROLM(CR,1)	
C
C	Now queue up a read to the remote.
C
100	CONTINUE
C
	IF (AUTO_RETRY .EQ. AUTODIAL_LIMIT) RETURN
	AUTO_RETRY = AUTO_RETRY + 1
C
C	To put the ROLM in autodial (interactive) mode, we must
C	send two carriage returns and then wait for the read.
C
	CALL WRITE_ROLM(CR,1)	
C
	CALL WAITABIT( SHRT_WAIT )
C
	CALL REMOTE_READ( IACT )
C
C	TYPE *,'>>', LBUFFER, '<<'
C	IF (IACT .GT. 0) THEN
	        SNDSTRING  = 'MOD      '
		IOUT = STR_COMPARE( LBUFFER, SNDSTRING,3)
C	ENDIF
C
	IF (IOUT .EQ. 0) GOTO 100
C
C	Now we'll do a keyboard dial command.
C
C	CALL
C
	CALL WRITE_ROLM(%REF(ROLMCALL),5)		! Doing a keyboard dial.
C
C	Now send the phone number.
C
	CALL WRITE_ROLM(%REF(PHONE_NUMBER),PHONE_SIZE) ! Send the number.
	CALL WRITE_ROLM(CR,1)			! Finish with RETURN.
C
	LOOP = 0
C
	CALL WAITABIT( LONG_WAIT )
C
	DO WHILE ((LOOP .LT. 5) .AND. (.NOT. MODEM_ONLINE))
C
		CALL REMOTE_READ( IACT )
C
		   SNDSTRING = 'COMPL    '
		   IOUT = STR_COMPARE( LBUFFER, SNDSTRING, 5)
C
                   IF (IOUT .GT. 0) THEN
			MODEM_ONLINE = .TRUE.
			REMOTE = .TRUE.
		   ELSE
C
			SNDSTRING = 'RETRY    '
			IOUT = STR_COMPARE( LBUFFER, SNDSTRING, 5)
			IF (IOUT .GT. 0) THEN
				CALL WRITE_ROLM(%REF('N'),1)
				CALL WRITE_ROLM(CR,1)
			ENDIF
C
		   ENDIF
C
		LOOP = LOOP + 1
C
		IF (.NOT. MODEM_ONLINE) CALL WAITABIT( LONG_WAIT )
C
	ENDDO
C
	IF (.NOT. MODEM_ONLINE) GOTO 100
C
	RETURN
	END
