C
C	SENDTELE.FOR
C
C	This program is used to send VAX files to the TELEMAIL system over
C	an asynchronous interface line.
C
C	Written by:
C	William J. Baker, Utilizing VAXNET written by Robin Miller.
C
C	V2.1 17-JUN-1987, Fix for:
C			Crash of VAX syndrome.  System would crash
C			if program was not watched, and ROLM system
C			disconnected process from TELEMAIL system.
C			Generated to many ASTs for VAX to handle.
C			Fix actually inhances program execution
C			by placing a timeout on the $QIO Call.
C			Program checks for modem responce during
C			Mail send, and sets flags for informing
C			manager of disconnect.
C			Also fixes problem with connection to TELEMAIL
C			system.  Program was sendind XOFF at $QIO
C			level, when Typeahead buffer was near to
C			overflowing.  I added an XON statement to
C			turn data flow back on. 
C
	INCLUDE 'COM.INC/LIST'
	INCLUDE 'TTDEF.FOR/NOLIST'

	EXTERNAL RESET_WORLD

	CHARACTER*9	ALTSERVICE
	INTEGER*4 EXIT_BLOCK(4)
C
C	Set up an exit handler.
C
	EXIT_BLOCK(2) = %LOC(RESET_WORLD)
	EXIT_BLOCK(3) = 1
	CALL CHECK_STATUS('VAXNET(DCLEXH)',STATUS)
C
C	Initialize various flags and counts.
C
	TYPE *,'============================================================'
	TYPE *,'+		Welcome to TELESEND Version 2.2            +'
	TYPE *,'============================================================'
c
	SEND1 = 'NASAMAIL '
	SEND2 = 'BYE      '
	SEND3 = 'COMPOSE  '
	SEND4 = ' .       '
	SEND4(1:1) = CHAR(13)
	SEND4(3:3) = CHAR(13)
	SEND5 = 'Y        '
C
	ACTION(1) = 'Command'
	ACTION(2) = '*'
	ACTION(3) = 'Command'
	ACTION(4) = 'Password'
	ACTION(5) = 'name?'
	ACTION(6) = 'MODIFY ?'
	ACTION(7) = 'FAILURE'
C
	AFIRM = 'Y'
C
C	If using an autodial modem, dial the phone number.
C
	CALL GET_SYMBOL( 'ALT_SERVICE', ALTSERVICE, LSRV )
	IF (LSRV .GT. 0) THEN
		SEND1 = SEND5
		SEND1 = ALTSERVICE(1:LSRV)
	ENDIF
C
	CALL GET_SYMBOL( 'PHONE_NUMBER', PHONE_NUMBER, PHONE_SIZE)
C
	IF (PHONE_SIZE .EQ. 0) THEN
		PHONE_NUMBER = 'NPSS'
		PHONE_SIZE   = 4
	ENDIF
C
	CONN1 = ' LOGON'
C
	CALL GET_SYMBOL( 'PSCNUSER', CONN2, LUSE)
C
	CALL GET_SYMBOL( 'PSCNPASS', CONN3, LPAS)
C
C
	CALL GET_SYMBOL( 'TELSENDF', VAX_FILE, VSIZE)
C
C
	MODEM = .FALSE.			! Presume not a modem.
	REMOTE = .FALSE.		! Presume local terminal,
	LOGFILE = .FALSE.		! Default to no log file.
	MODEM_ONLINE = .FALSE.		! Autodial modem is offline.
	NEED_TO_DEAS = .FALSE.		! Don't have remote port yet.
	TYPEAHEAD_SIZE = 78-38		!	and typeahead size.
	LOCAL_ASTS = 0			! Initialize the local
	REMOTE_ASTS = 0			!  and remote AST counts.
C
C	Request the remote system type.
C
	CALL GET_PORT()
C
C
	CALL SETUP_REMOTE()
C
C	Request the remote baud rate.
C
	CALL SETUP_BAUDRATE		! Setup the remote baud rate.
C
C	If the remote port is setup MODEM, get the modem type.
C
	CALL GET_MODEM_INFO()	! Get autodial modem type.
C
C	If using an autodial modem, dial the phone number.
C
	LOOP = 0
C
	DO WHILE ((.NOT. MODEM_ONLINE) .AND. (LOOP .LT. 3))
C
	   IF (.NOT. MODEM_ONLINE) THEN 
C
		WRITE(6,200) PHONE_NUMBER
200		FORMAT('     %%%*** DIALING MODEM',5X,A20)
C
		CALL DIAL_MODEM()	! Dial the phone number.
		CALL FIND_PROMPT( ICON1 )
C
	   ENDIF
C
	   IF ((MODEM_ONLINE) .AND. (ICON1 .EQ. 0)) THEN
		CALL DO_COMMAND(ICON2)
C
		IF (ICON2 .EQ. -7) THEN
		   CALL LIB$SET_SYMBOL('NOCONTEL','TMAILDOWN',2)
		   GOTO 3000
		ENDIF
C
		IF (ICON2 .GE. 5) THEN
		   CALL LIB$SET_SYMBOL('NOCONTEL','NOCONNECT',2)
		   CLOSE(CMD_UNIT)
		ELSE
		   CALL LIB$SET_SYMBOL('NOCONTEL','CONNECTED',2)
		   LOOP = 5
		ENDIF
	   ELSE
		CALL LIB$SET_SYMBOL('NOCONTEL','NOCONNECT',2)
	   ENDIF
C
	   LOOP = LOOP + 1
C
	   CALL HANGUP_MODEM()
C
	ENDDO
C
3000	CLOSE(CMD_UNIT)
C
	END

	SUBROUTINE FIND_PROMPT( ICON )
C
C
	INCLUDE 'COM.INC/NOLIST'
C
	INTEGER*4	ACTLEN(7)
C
C	CALL CLEAR_TYPEAHEAD
C
	LOOP = 0
	IFND = 0
C
	ACTLEN(1) = 7
	ACTLEN(2) = 1
	ACTLEN(3) = 7
	ACTLEN(4) = 8
	ACTLEN(5) = 5
	ACTLEN(6) = 8
	ACTLEN(7) = 7
C
	DO WHILE ((IFND .LE. 0) .AND. (LOOP .LT. 11))
C
	   CALL REMOTE_READ( IACT )
C
		DO II = 1,7
C
		   IOUT= STR_COMPARE( LBUFFER, ACTION(II), ACTLEN(II))
		   IF (IOUT .NE. 0) IFND = II
C
		ENDDO
C
	   LOOP = LOOP + 1
C
	   IF (( ((LOOP/5)*5) .EQ. LOOP) .AND. (IFND .EQ. 0 )) THEN
C
		CALL WRITE_BYTE(CR, 1)
		CALL WAITABIT( SHRT_WAIT )
C
	   ENDIF
C
	END DO
C
        ICON = LOOP
C
	IF (IFND .LE. 0) RETURN
C
	ICON = 0
C
	IF (IFND .EQ. 2) RETURN
C
	ICON = -IFND
C
	RETURN
	END
C
