$!			FORD AEROSPACE & COMMUNICATION CORP.
$!
$!			IN COOPERATION WITH:
$!
$!			NASA/JSC BUILDING 37,
$!			LIFE SCIENCES MEDICAL OPERATIONS
$!			HOUSTON, TEXAS  77058.
$!
$!
$!			ATTENTION:
$!
$!			WILLIAM BAKER
$!			SYSTEM MANAGER
$!
$!			713-483-7273
$!			713-335-6318
$!
$!
$!	COMMAND PROCEDURE FOR VERSION 2.2 OF TELESEND.
$!
$!----------------------------------------------------------------------------
$!	ENTER TELESEND READ BATCH PROGRAM.
$!		SET BAUD RATE FOR SENDING MAIL TO TELEMAIL.
$!		SET ERROR CONDITION SUCH THAT WE DON'T KILL JOB WHEN
$!		AN ERROR OCCURS THAT IS PLANNED FOR.
$!		DEFINE THE USERNAME OF THE CURRENT PROCESS.
$!	SET UP DEFAULT CONDITIONS:
$!		SET PROCESS NAME, SO WE CAN IDENTIFY THE JOB EASILY.
$!		SET MESSAGE LEVEL SO WE KNOW WHAT THE ERROR MESSAGES MEAN.
$!		SET DEFAULT DIRECTORY SO WE KNOW WHERE WE ARE.
$!		TELL ME USER NAME OF TELEMAIL SYSTEM MANAGER.
$!		SET NASA/PSCN USERNAME AND PASSWORD.
$!----------------------------------------------------------------------------
$!
$	SET NOON
$!
$	REMOTE_SPEED := "9600"
$!
$	RFMTMAIL :== $ROOT_TMAIL:[SEND]RFMTMAIL
$!
$	LONGNAME =  F$GETJPI("", "USERNAME")
$	USRNM    =  F$EDIT(LONGNAME, "COMPRESS,TRIM")
$	IF P4 .NES. "" THEN USRNM = "''P4'"
$!
$	IF P3 .NES. "" THEN ALT_SERVICE = "''P3'"
$!
$	SET PROCESS/NAME=TSND_'F$EXTRACT(0,7,USRNM)'
$!
$	SET NOVERIFY
$!
$	SET MESSAGE/SEV/ID/TEXT/FAC
$!
$	SET DEFAULT 'P1'
$!
$	PORT_STP = 0
$	TMAILMGR :== "SYSTEM"
$!
$	PSCNUSER :== "JSCGP"
$	PSCNPASS :== "PSCN"
$!
$	TELL_FILE = F$EDIT(P2,"UPCASE")
$	TELSENDF = "''TELL_FILE'" - ".TELL" + ".LOG"
$	SHOW SYM TELSENDF
$!
$!----------------------------------------------------------------------------
$!	VERIFY TELESEND INFORMATION FILE HAS DATA.
$!		VERIFY THAT FILE EXIST BY OPENING AND CLOSING.
$!		REFORMAT TELESEND INFORMATION FILE.
$!		OPEN REFORMATTED TELESEND INFORMATION FILE.
$!		READ EACH OF FIRST SIX LINES TO VERIFY DATA
$!			IS IN LINES 1-3 AND 6.  ALSO VERIFIES
$!			NUMBER OF LINES IN MINIMALLY CORRECT.
$!			LOOP ON LINES 3-6 FOR VERIFICATION OF
$!			EXISTANCE OF MESSAGE FILE.
$!		CLOSE THE TELESEND INFORMATION FILE.
$!----------------------------------------------------------------------------
$!
$	OPEN/READ/ERROR=FAIL_MSG	TSEND	'P2'
$	CLOSE TSEND
$!
$	EDIT 'P2'
EXIT
$!
$	PURGE/NOLOG 'P2'
$!
$	OPEN/READ/END_OF_FILE=BAD_FILE	TSEND	'P2'
$!
$	READ/END_OF_FILE=BAD_FILE	TSEND	LSND	!USERS TELEMAIL USERNAME
$	CHKSND = F$EDIT("''LSND'","COMPRESS,TRIM")
$	IF "''CHKSND'" .EQS. "" THEN GOTO BAD_FILE
$!
$	READ/END_OF_FILE=BAD_FILE	TSEND	LSND	!USERS TELEMAIL PASSWORD
$	CHKSND = F$EDIT("''LSND'","COMPRESS,TRIM")
$	IF "''CHKSND'" .EQS. "" THEN GOTO BAD_FILE
$!
$	READ/END_OF_FILE=BAD_FILE	TSEND	LSND	!FILE TO BE SENT:
$	CHKSND = F$EDIT("''LSND'","COMPRESS,TRIM")
$	IF "''CHKSND'" .EQS. "" THEN GOTO BAD_FILE
$	IF F$SEARCH(CHKSND) .EQS. "" THEN GOTO BAD_FILE
$!
$	READ/END_OF_FILE=BAD_FILE	TSEND	LSND	!TO: LIST FOR MESSAGE
$	CHKSND = F$EDIT("''LSND'","COMPRESS,TRIM")
$	IF "''CHKSND'" .EQS. "" THEN GOTO BAD_FILE
$!
$	READ/END_OF_FILE=BAD_FILE	TSEND	LSND	!CC: LIST FOR MESSAGE
$!
$	READ/END_OF_FILE=BAD_FILE	TSEND	TMLSBJ	!SUBJECT OF MESSAGE
$!
$	READ/END_OF_FILE=BAD_FILE	TSEND	LSND	!HOW TO SEND
$!
$!
$!----------------------------------------------------------------------------
$!	SET COUNTER, AND DEFINE USER.
$!		INITIALIZE THE COUNTER FOR NUMBER OF TIMES TELESEND TRIES.
$!----------------------------------------------------------------------------
$!
$	CLOSE TSEND
$!
$	REMOTE_PORT = ""
$!
$	CNTR = 0
$!
$!----------------------------------------------------------------------------
$!	DEFINE THE DIAL-OUT PORT THE PROGRAM WILL USE.
$!		OPEN THE TELEPORT.LIS FILE WHICH CONTAINS THE PORT DEFINITIONS.
$!		READ THE TEMPLATE LINE, AND THE FIRST PORT IN THE FILE.
$!		SET UP SYMBOLS CONTAINING THE PORT DEFINITIONS.
$!		LOOP AS NEEDED TO OBTAIN ALL PORT DEFINITIONS.
$!----------------------------------------------------------------------------
$!
$!
$	OPEN/READ/ERROR=NO_PORTS   PORTS    ROOT_TMAIL:[SEND]TELEPORT.LIS
$!
$	READ			   PORTS    LINEOUT
$!
$	PORTCNT = 0
$!
$	READ/END_OF_FILE=NO_PORTS  PORTS    LINEOUT
$!
$ PORT_LOOP:
$!
$	PORTCNT = PORTCNT + 1
$!
$	INPRT = F$EXTRACT(0,8,"''LINEOUT'")
$	CUR_PORT'PORTCNT' = F$EDIT("''INPRT'","COMPRESS,TRIM")
$!
$	INTYP = F$EXTRACT(10,5,"''LINEOUT'")
$	CUR_TYPE'PORTCNT' = F$EDIT("''INTYP'","COMPRESS,TRIM")
$!
$	READ/END_OF_FILE=PORT_EXIT  PORTS    LINEOUT
$!
$	GOTO PORT_LOOP
$!
$ PORT_EXIT:
$!
$!----------------------------------------------------------------------------
$!		CLOSE TELEPORT.LIS FILE
$!		INCREMENT COUNTER TO SET PORT
$!		CHECK PORT COUNTER AND RESET IF NEEDED.
$!----------------------------------------------------------------------------
$!
$	CLOSE PORTS
$!
$ INTLZ:
$!
$	NOCONTEL    :== ""
$!
$ NEXT_PORT:
$!
$	PORT_STP = PORT_STP + 1
$!
$	IF PORT_STP .GT. PORTCNT THEN WAIT 00:15
$	IF PORT_STP .GT. PORTCNT THEN PORT_STP = 1
$!
$!----------------------------------------------------------------------------
$!	FINAL DIAL-OUT PORT CONDITIONS SET.
$!		DEFINE THE SYMBOLS FOR THE PORTS TO USED BY THE TELEMAIL READ.
$!----------------------------------------------------------------------------
$!
$	REMOTE_PORT = CUR_PORT'PORT_STP'
$!
$	MODEM_TYPE = CUR_TYPE'PORT_STP'
$!
$!----------------------------------------------------------------------------
$!	PREPARE TO RUN PROGRAM TELESEND.
$!		ALLOCATE REMOTE PORT TO PROCESS.
$!		ASSIGN INFORMATION FILE TO PROGRAM LOGICAL.
$!----------------------------------------------------------------------------
$!
$	ALLOCATE 'REMOTE_PORT'
$	IF .NOT. $STATUS THEN GOTO NEXT_PORT
$!
$	ASSIGN 'P2'	SENDFILE
$!
$!----------------------------------------------------------------------------
$!	RUN PROGRAM TELESEND.
$!----------------------------------------------------------------------------
$!
$	RUN ROOT_TMAIL:[SEND]SENDTELE
$	IF .NOT. $STATUS THEN GOTO FAIL_MSG
$!
$	SHOW SYM NOCONTEL
$!
$!----------------------------------------------------------------------------
$!	POST PROGRAM STATUS DETECTION.
$!		DEALLOCATE REMOTE PORT FROM PROCESS.
$!		DETERMINE IF PROGRAM CONNECTED TO TELEMAIL OR NOT.
$!			BRANCH IF NO CONNECTION MADE.
$!		IF WAS LAST PORT IN LIST BEING USED THEN BRANCH TO RETRY
$!----------------------------------------------------------------------------
$!
$	DEALLOCATE 'REMOTE_PORT'
$!
$	IF ("''NOCONTEL'" .EQS. "TMAILDOWN") THEN GOTO TMAILDOWN
$!
$	IF ("''NOCONTEL'" .EQS. "NOCONNECT") .AND. -
           ("''FIRST_PORT'" .EQS. "Y") THEN GOTO NEXT_PORT
$!
$	IF ("''NOCONTEL'" .EQS. "NOCONNECT") THEN GOTO RETRY
$!
$!----------------------------------------------------------------------------
$!	PROGRAM SUCCESSFULLY SENT MESSAGE TO TELEMAIL.
$!		DETERMINE CURRENT DATE AND TIME.
$!		SEND MESSAGE TO USER INDICATING MESSAGE WAS MAILED.
$!		REMOVE THE TELESEND INFORMATION FILE.
$!		EXIT THE COMMAND PROCEDURE.
$!----------------------------------------------------------------------------
$!
$	DATE = F$TIME()
$!
$	EDIT 'TELSENDF'
SUB /
/ /1:999
SUB /Send?/ /1:999
SUB /Correct, Omit, or Hold:  O/ /1:999
SUB /Command? / /1:999
SUB /./ /1:999
EXIT
$!
$!
$	MAIL/SUBJECT="RE: TELEMAIL SENT:  ''TMLSBJ'" -
	'TELSENDF'	'USRNM'
$!
$	WAIT 00:00:05
$!
$	DELETE/LOG 'P2';*
$	DELETE/LOG 'TELSENDF';*
$	PURGE/LOG  TELESEND.LOG/KEEP=2
$!
$	IF P5 .EQS. "0" THEN DELETE/LOG 'P6';*
$!
$	EXIT
$!
$!
$ RETRY:
$ WAITAWHILE:
$!
$!----------------------------------------------------------------------------
$!	LET'S WAIT AWHILE FOR TELEMAIL PORT TO CLEAR UP MAYBE.
$!		INCREMENT COUNTER FOR NUMBER OF MAJOR RETRIES OF TELESEND.
$!		CLOSE THE PORTS DATA FILE.
$!		CHECK IF THE COUNTER IS OVER MAXIMUM NUMBER OF MAJOR RETRIES.
$!		WAIT FOR AN HOUR.
$!		GOTO TO REMOTE PORT INITIALIZATION POINT IN PROCEDURE.
$!----------------------------------------------------------------------------
$!
$	CNTR = CNTR + 1
$!
$	IF CNTR .GT. 4 THEN GOTO NOT_SENT
$!
$	WAIT 00:30
$!
$	NOCONTEL    :== ""
$!
$	GOTO INTLZ
$!
$ TMAILDOWN:
$!
$!----------------------------------------------------------------------------
$!	LET'S WAIT AWHILE FOR TELEMAIL TO COME BACK UP ON LINE, THEN TRY.
$!----------------------------------------------------------------------------
$!
$	MAIL/SUBJ="TELEMAIL SYSTEM NOT AVAILABLE?" NL: 'TMAILMGR'
$!
$	WAIT 02:00
$!
$	NOCONTEL    :== ""
$!
$	GOTO INTLZ
$!
$ BAD_FILE:
$ FAIL_MSG:
$!
$!----------------------------------------------------------------------------
$!	MAIL MESSAGE INDICATING PROGRAM FAILED WHILE TRYING TO SEND MESSAGE,
$!	OR BECAUSE OF A PRE-CONDITION NOT BEING SATISFIED.
$!----------------------------------------------------------------------------
$!
$	MAIL/SUBJECT="TMAIL, TRANSMISSION ERROR:  ''TMLSBJ'" -
		ROOT_TMAIL:[TEXT]FAILSEND.TXT   "''USRNM',''TMAILMGR'"
$!
$	EXIT
$!
$ NOT_SENT:
$!
$!----------------------------------------------------------------------------
$!	MAIL MESSAGE INDICATING PROGRAM FAILED TO CONNECT TO TELEMAIL SYSTEM.
$!----------------------------------------------------------------------------
$!
$	MAIL/SUBJECT="TMAIL, CONNECTION NOT MADE:  ''TMLSBJ'" -
		ROOT_TMAIL:[TEXT]FAILSEND.TXT   "''USRNM',''TMAILMGR'"
$!
$	EXIT
$!
$ NO_PORTS:
$!
$!----------------------------------------------------------------------------
$!	NO DIAL-OUT PORTS WERE DEFINED FOR PROGRAM.
$!		ISSUE MESSAGE TO SYS$OUTPUT.  SO MESSAGE IS IN LOG FILE.
$!		SEND MAIL TO SYSTEM MANAGER.
$!		EXIT BATCH JOB.
$!----------------------------------------------------------------------------
$!
$	OUT :== WRITE SYS$OUTPUT
$!
$	OUT "YOU HAVE NOT DEFINED YOUR DIAL OUT PORTS IN THE FILE"
$	OUT "ROOT_TMAIL:[SEND]TELEPORT.LIS.  YOU MUST DEFINE AT"
$	OUT "LEAST ONE DIALOUT PORT IN THIS FILE FOR THE TELEMAIL"
$	OUT "READ PROGRAM TO PROPERLY FUNCTION."
$!
$	MAIL/SUBJECT="TELEMAIL DIAL-OUT PORTS NOT DEFINED.  ''DATE'" -
	NL:	'TMAILMGR'
$!
$	EXIT
$!
