$ V = F$VERIFY(0)
$ DEAS SYS$INPUT
$! --------------------------------------------------------------------
$! The editor remembers the file specification of the last edited file.
$! If no file was given upon invocation of this procedure, try using
$! the previous file specification (if any).
$! --------------------------------------------------------------------
$ IF P1 .NES. ""                     THEN GOTO con2
$ IF F$TYPE (LAST_EDT_FILE) .NES. "" THEN GOTO con1
$top:
$ INQUIRE P1 "Please enter file name to be edited"
$ IF P1 .EQS. "" THEN GOTO out
$ GOTO con2
$con1:
$ P1:='LAST_EDT_FILE
$con2:
$ DEVDEPEND2=F$GETDVI("TT","DEVDEPEND2")
$! -----------------------------------------------------------------------
$! The user may utilize his/her own private version of EDTEM. That version
$! is created when custom learned functions are saved, and it is placed
$! into the user's SYS$LOGIN directory.
$! -----------------------------------------------------------------------
$ FIRST_SECTION_FILE = F$SEARCH ("SYS$LOGIN:EDTEM.TPU$SECTION")
$!
$ IF FIRST_SECTION_FILE .NES. "" THEN -
                                 WORKING_SECTION = FIRST_SECTION_FILE
$ IF FIRST_SECTION_FILE .EQS. "" THEN -
                                 WORKING_SECTION = "SYS_MANAGER:EDTEM"
$! ----------------------------------------------------------------------
$! This procedure remembers the file type of the last edited file.
$! If the user has not specified a file type, and there has been
$! at least one previous EDTEM session, default to that file's file type.
$! Note that a null file type (e.g., X.;) is remembered as such.
$! ----------------------------------------------------------------------
$ CURRENT_FTYPE = F$PARSE (P1,,,"type")
$ IF CURRENT_FTYPE .NES. "." THEN GOTO now
$!
$ IF F$LOCATE (".",P1)+1 .EQ. F$LENGTH (P1) THEN GOTO now
$ FTYPE = F$TYPE (LAST_EDTEM_FILE_TYPE_)
$ IF FTYPE .NES. "" THEN GOTO almost_almost_now
$ BELL[0,7] = 7
$ WRITE SYS$OUTPUT BELL
$ WRITE SYS$OUTPUT "Incomplete file specification..."
$ GOTO top
$almost_almost_now:
$ P1 = P1 + LAST_EDTEM_FILE_TYPE_
$! ----------------------------------------------------------------------
$! Temporarily modify our DCL prompt so that if we spawn a DCL subprocess
$! from the editor, the modified prompt will be our clue (and also a
$! reminder) that we are at that level.
$! ----------------------------------------------------------------------
$now:
$ CURRENT_PROMPT = F$ENVIRONMENT ("prompt")
$ NEW_PROMPT     = "#" + CURRENT_PROMPT
$ SET PROMPT     = "''F$EDIT (NEW_PROMPT, "lowercase")'"
$! -----------------------------------------------------------------------
$! This definition points the spelling checker to the directory containing
$! the dictionary files
$! -----------------------------------------------------------------------
$ DEFINE /USER	TPU$CALLUSER	COMMON$DICTIONARY:TPU_CALLUSER.EXE
$!
$ ON CONTROL_Y THEN GOTO abort
$ ON ERROR     THEN GOTO abort
$ EDIT /TPU /SECTION='WORKING_SECTION 'P1 'P2 'P3 'P4 'P5 'P6 'P7 'P8
$abort:
$ SET PROMPT = "''CURRENT_PROMPT'"
$ ON CONTROL_Y THEN GOTO out
$ ON ERROR     THEN GOTO out
$!
$ LAST_EDTEM_FILE_TYPE_ == F$PARSE (P1,,,"type")
$ LAST_EDT_FILE         == P1
$! -------------------------------------------------------------------------
$! If the user has saved some learned functions, here is where you would
$! insert additional logic to purge the older versions, copy the new version
$! to a backup computer, etc.
$! -------------------------------------------------------------------------
$ SECOND_SECTION_FILE = F$SEARCH ("SYS$LOGIN:EDTEM.TPU$SECTION")
$ IF FIRST_SECTION_FILE .EQS. SECOND_SECTION_FILE THEN GOTO almost_done
$ PURGE /LOG SYS$LOGIN:EDTEM.TPU$SECTION
$! -------------------------------
$! Enable application keypad mode?
$! -------------------------------
$almost_done:
$ IF (DEVDEPEND2.AND.%X800000) .EQ. 0 THEN GOTO out
$ ESC[0,7] = 27
$ WRITE SYS$OUTPUT ESC + "="
$out:
$ V = F$VERIFY(V)
$ EXIT
$! --------------------------------------------------------------------------
$! SYS_MANAGER:EDTEM.COM
$! ---------------------
$!
$! TPU EDT emulator editor (with PPL enhancements) session control proceedure
$! This version is used at the process level
$!
$! DECUS Distribution Version
$! Mike Latshaw <> Pacific Power & Light Company
$! --------------------------------------------------------------------------
