$ V = F$VERIFY(0)
$ DEASSIGN SYS$INPUT
$ LAST_FILE = ""
$start:
$! ----------------------------------------------
$! Decide which editor section file we should use
$! ----------------------------------------------
$ FIRST_SECTION_FILE = F$SEARCH ("SYS$LOGIN:EDTEM.TPU$SECTION")
$!
$ IF FIRST_SECTION_FILE .NES. "" THEN -
                                 WORKING_SECTION = FIRST_SECTION_FILE
$ IF FIRST_SECTION_FILE .EQS. "" THEN -
                                 WORKING_SECTION = "SYS_MANAGER:EDTEM"
$!
$! ------------------------------------------
$! Figure out which file we are going to edit
$! ------------------------------------------
$ INQUIRE FILE_NAME "Enter file name, < to exit, or LOGOUT to abort"
$ IF FILE_NAME .NES. "" THEN GOTO checks
$!
$ FILE_NAME = LAST_FILE
$ GOTO edit_file
$!
$! -----------------------------------------------------
$! Return to the parent, but keep this subprocess alive?
$! -----------------------------------------------------
$checks:
$ IF FILE_NAME .NES. "<" THEN GOTO last_check
$!
$ ATTACH /ID='F$GETJPI("0","MASTER_PID")
$ GOTO start
$!
$! -------------------------------------------------------
$! Does the user wish to terminate the editing subprocess?
$! -------------------------------------------------------
$last_check:
$ FILE_NAME = F$EDIT (FILE_NAME,"upcase")
$ IF FILE_NAME .EQS. "LOGOUT" THEN LOGOUT
$!
$! ------------------------------------------------------------
$! Get into the same default directory and device as our parent
$! ------------------------------------------------------------
$ PRESENT_DEFAULT_SPECIFICATION = F$TRNLNM("LATEST_DEFAULT_SPECIFICATION")
$ SET DEFAULT 'PRESENT_DEFAULT_SPECIFICATION
$!
$! ----------------------------------------------------------------
$! Remember its name so that we can go back to it without having it
$! be necessary for the user to re-enter the name in a subsequent
$! pass
$! ----------------------------------------------------------------
$ LAST_FILE = FILE_NAME
$!
$! ---------------------------------------------
$! Invoke the PP&L-enhanced EDT emulation of TPU
$! ---------------------------------------------
$edit_file:
$ EDIT /TPU /SECTION='WORKING_SECTION 'FILE_NAME
$! ------------------------------------------------------------
$! If the user made a new copy of his section file, purge, etc.
$! ------------------------------------------------------------
$ SECOND_SECTION_FILE = F$SEARCH ("SYS$LOGIN:EDTEM.TPU$SECTION")
$ IF FIRST_SECTION_FILE .EQS. SECOND_SECTION_FILE THEN GOTO start
$ PURGE /LOG SYS$LOGIN:EDTEM.TPU$SECTION
$ GOTO start
$!
$! -----------------------------------------------------------------------
$! SYS_MANAGER:EDTEM_SUBP.COM
$! --------------------------
$!
$! TPU EDT emulator editor (with PPL enhancements) edit control proceedure
$!
$! DECUS Distribution Version
$! Mike Latshaw <> Pacific Power and Light Company
$! -----------------------------------------------------------------------
